/*==========================================================================*/
/* MsgTestFile.c contains the file management routines.                     */
/*==========================================================================*/
/* (C) Copyright Tim Armstrong 2003, 2004, 2005, 2006, 2007, 2008           */
/*==========================================================================*/
/* Includes                                                                 */
/*==========================================================================*/
#ifndef __TJAINC_MSGTEST_H
#include "MsgTest.h"
#endif /* __TJAINC_MSGTEST_H */

/*==========================================================================*/
/* Static variables                                                         */
/*==========================================================================*/
/* Value keywords */
static char* kpszNONE =               "NONE\0";
#ifdef WIN32
static char* kpszDirFileConcat =      "\\\0";
#else
static char* kpszDirFileConcat =      "/\0";
#endif /* WIN32 */

static char* kpszLOG =                ".log\0";
static char* kpszRPT =                ".rpt\0";
static char* kpszDOT =                ".";

#ifdef WIN32
static char* kpszXMLDEF =                "<?xml version=\"1.0\"?>\r\n\0";
static char* kpszBEGINMQMD =             "<MQMD>\r\n\0";
static char* kpszENDMQMD =               "</MQMD>\r\n\0";
static char* kpszENDVERSION =            "</Version>\r\n\0";
static char* kpszENDREPORT =             "</Report>\r\n\0";
static char* kpszENDMSGTYPE =            "</MsgType>\r\n\0";
static char* kpszENDEXPIRY =             "</Expiry>\r\n\0";
static char* kpszENDFEEDBACK =           "</Feedback>\r\n\0";
static char* kpszENDENCODING =           "</Encoding>\r\n\0";
static char* kpszENDCCSID =              "</CodedCharSetId>\r\n\0";
static char* kpszENDFORMAT =             "</Format>\r\n\0";
static char* kpszENDPRIORITY =           "</Priority>\r\n\0";
static char* kpszENDPERSISTENCE =        "</Persistence>\r\n\0";
static char* kpszENDMSGID =              "</MsgId>\r\n\0";
static char* kpszENDCORRELID =           "</CorrelId>\r\n\0";
static char* kpszENDBACKOUTCOUNT =       "</BackoutCount>\r\n\0";
static char* kpszENDREPLYTOQ =           "</ReplyToQ>\r\n\0";
static char* kpszENDREPLYTOQMGR =        "</ReplyToQMgr>\r\n\0";
static char* kpszENDUSERIDENTIFIER =     "</UserIdentifier>\r\n\0";
static char* kpszENDACCOUNTINGTOKEN =    "</AccountingToken>\r\n\0";
static char* kpszENDAPPLIDENTITYDATA =   "</ApplIdentityData>\r\n\0";
static char* kpszENDPUTAPPLTYPE =        "</PutApplType>\r\n\0";
static char* kpszENDPUTAPPLNAME =        "</PutApplName>\r\n\0";
static char* kpszENDPUTDATE =            "</PutDate>\r\n\0";
static char* kpszENDPUTTIME =            "</PutTime>\r\n\0";
static char* kpszENDAPPLORIGINDATA =     "</ApplOriginData>\r\n\0";
static char* kpszENDGROUPID =            "</GroupId>\r\n\0";
static char* kpszENDMSGSEQNUMBER =       "</MsgSeqNumber>\r\n\0";
static char* kpszENDOFFSET =             "</Offset>\r\n\0";
static char* kpszENDMSGFLAGS =           "</MsgFlags>\r\n\0";
static char* kpszENDORIGINALLENGTH =     "</OriginalLength>\r\n\0";
static char* kpszBEGINMQRFH2 =           "<MQRFH2>\r\n\0";
static char* kpszENDMQRFH2 =             "</MQRFH2>\r\n\0";
static char* kpszBEGINFOLDER =           "    <Folder><![CDATA[\0";
static char* kpszENDFOLDER =             "]]></Folder>\r\n\0";
#else
static char* kpszXMLDEF =                "<?xml version=\"1.0\"?>\r\n\0";
static char* kpszBEGINMQMD =             "<MQMD>\n\0";
static char* kpszENDMQMD =               "</MQMD>\n\0";
static char* kpszENDVERSION =            "</Version>\n\0";
static char* kpszENDREPORT =             "</Report>\n\0";
static char* kpszENDMSGTYPE =            "</MsgType>\n\0";
static char* kpszENDEXPIRY =             "</Expiry>\n\0";
static char* kpszENDFEEDBACK =           "</Feedback>\n\0";
static char* kpszENDENCODING =           "</Encoding>\n\0";
static char* kpszENDCCSID =              "</CodedCharSetId>\n\0";
static char* kpszENDFORMAT =             "</Format>\n\0";
static char* kpszENDPRIORITY =           "</Priority>\n\0";
static char* kpszENDPERSISTENCE =        "</Persistence>\n\0";
static char* kpszENDMSGID =              "</MsgId>\n\0";
static char* kpszENDCORRELID =           "</CorrelId>\n\0";
static char* kpszENDBACKOUTCOUNT =       "</BackoutCount>\n\0";
static char* kpszENDREPLYTOQ =           "</ReplyToQ>\n\0";
static char* kpszENDREPLYTOQMGR =        "</ReplyToQMgr>\n\0";
static char* kpszENDUSERIDENTIFIER =     "</UserIdentifier>\n\0";
static char* kpszENDACCOUNTINGTOKEN =    "</AccountingToken>\n\0";
static char* kpszENDAPPLIDENTITYDATA =   "</ApplIdentityData>\n\0";
static char* kpszENDPUTAPPLTYPE =        "</PutApplType>\n\0";
static char* kpszENDPUTAPPLNAME =        "</PutApplName>\n\0";
static char* kpszENDPUTDATE =            "</PutDate>\n\0";
static char* kpszENDPUTTIME =            "</PutTime>\n\0";
static char* kpszENDAPPLORIGINDATA =     "</ApplOriginData>\n\0";
static char* kpszENDGROUPID =            "</GroupId>\n\0";
static char* kpszENDMSGSEQNUMBER =       "</MsgSeqNumber>\n\0";
static char* kpszENDOFFSET =             "</Offset>\n\0";
static char* kpszENDMSGFLAGS =           "</MsgFlags>\n\0";
static char* kpszENDORIGINALLENGTH =     "</OriginalLength>\n\0";
static char* kpszBEGINMQRFH2 =           "<MQRFH2>\n\0";
static char* kpszENDMQRFH2 =             "</MQRFH2>\n\0";
static char* kpszBEGINFOLDER =           "    <Folder><![CDATA[\0";
static char* kpszENDFOLDER =             "]]></Folder>\n\0";
#endif /* WIN32 */

static char* kpszBEGINVERSION =          "    <Version>\0";
static char* kpszBEGINREPORT =           "    <Report>\0";
static char* kpszBEGINMSGTYPE =          "    <MsgType>\0";
static char* kpszBEGINEXPIRY =           "    <Expiry>\0";
static char* kpszBEGINFEEDBACK =         "    <Feedback>\0";
static char* kpszBEGINENCODING =         "    <Encoding>\0";
static char* kpszBEGINCCSID =            "    <CodedCharSetId>\0";
static char* kpszBEGINFORMAT =           "    <Format>\0";
static char* kpszBEGINPRIORITY =         "    <Priority>\0";
static char* kpszBEGINPERSISTENCE =      "    <Persistence>\0";
static char* kpszBEGINMSGID =            "    <MsgId>\0";
static char* kpszBEGINCORRELID =         "    <CorrelId>\0";
static char* kpszBEGINBACKOUTCOUNT =     "    <BackoutCount>\0";
static char* kpszBEGINREPLYTOQ =         "    <ReplyToQ>\0";
static char* kpszBEGINREPLYTOQMGR =      "    <ReplyToQMgr>\0";
static char* kpszBEGINUSERIDENTIFIER =   "    <UserIdentifier>\0";
static char* kpszBEGINACCOUNTINGTOKEN =  "    <AccountingToken>\0";
static char* kpszBEGINAPPLIDENTITYDATA = "    <ApplIdentityData>\0";
static char* kpszBEGINPUTAPPLTYPE =      "    <PutApplType>\0";
static char* kpszBEGINPUTAPPLNAME =      "    <PutApplName>\0";
static char* kpszBEGINPUTDATE =          "    <PutDate>\0";
static char* kpszBEGINPUTTIME =          "    <PutTime>\0";
static char* kpszBEGINAPPLORIGINDATA =   "    <ApplOriginData>\0";
static char* kpszBEGINGROUPID =          "    <GroupId>\0";
static char* kpszBEGINMSGSEQNUMBER =     "    <MsgSeqNumber>\0";
static char* kpszBEGINOFFSET =           "    <Offset>\0";
static char* kpszBEGINMSGFLAGS =         "    <MsgFlags>\0";
static char* kpszBEGINORIGINALLENGTH =   "    <OriginalLength>\0";


/*==========================================================================*/
/* FUNCTION:                                                                */
/*     LoadFile                                                             */
/*                                                                          */
/* PURPOSE:                                                                 */
/*     Check the file by trying to open it. If it exists find out its       */
/*     length, allocate a buffer to load its content into and load it.      */
/*                                                                          */
/* INPUT PARAMETERS                                                         */
/*     lpszFileName Pointer to the file name to be loaded                   */
/*     lplpszBuff   Pointer to variable to receive the buffer pointer       */
/*     lplBuffLen   Pointer to variable to receive the buffer length        */
/*     lplDataLen   Pointer to variable to receive the data length          */
/*     bSuppress... Flag indicating fopen() error message suppression       */
/*                                                                          */
/* RETURN VALUE                                                             */
/*     SUCCESS or FAILURE                                                   */
/*==========================================================================*/
long
LoadFile(char* lpszFileName, char** lplpszBuff, long* lplBuffLen,
         long* lplDataLen, long bLogError)
{
    FILE*   lpFile;
    long    lFReadResult;

    /* Initialise return values */
    *lplDataLen = 0;
    *lplBuffLen = 0;

    /* If buffer was previously allocated free it */
    if(*lplpszBuff)
    {
        free(*lplpszBuff);
        *lplpszBuff = NULL;
    }

    /* Open the  file */
    kpMCB->lFileErrno = 0;
    lpFile = fopen(lpszFileName, "rb");
    if(! lpFile)
    {
        kpMCB->lFileErrno = errno;
        /* Check to see if calling routine intends to issue its own error */
        /* or otherwise handle the absence of the file                    */
        if(bLogError)
        {
            LogMsg(5, "LoadFile", lpszFileName, kpMCB->lFileErrno);
        }
        return FAILURE;
    }

    /* Move to the end of the file so we can use the ftell function */
    if(0 != fseek(lpFile, 0, SEEK_END))
    {
        kpMCB->lFileErrno = errno;
        LogMsg(6, lpszFileName);
        return FAILURE;
    }

    /* Use ftell to determine how long the file is */
    *lplDataLen = ftell(lpFile);
    if(0 > *lplDataLen)
    {
        kpMCB->lFileErrno = errno;
        LogMsg(7, lpszFileName, kpMCB->lFileErrno);
        return FAILURE;
    }

    /* Allocate the  file buffer on a 256 byte boundary */
    /* rounding up by at least 256 bytes                      */
    *lplBuffLen = (((*lplDataLen + 256) / 256) + 1) * 256;
    *lplpszBuff = malloc(*lplBuffLen + 8);
    if(*lplpszBuff)
    {
        memset(*lplpszBuff, 0x00, *lplBuffLen + 8);
    }
    else
    {
        LogMsg(8, *lplBuffLen, "File");
        return FAILURE;
    }

    /* Reposition to the start of the file so we can read it */
    if(0 != fseek(lpFile, 0, SEEK_SET))
    {
        kpMCB->lFileErrno = errno;
        LogMsg(9, lpszFileName);
        return FAILURE;
    }

    /* Opened the file, know how long its is and are  */
    /* repositioned at the start so time to read it   */
    fread(*lplpszBuff, sizeof(char), *lplDataLen, lpFile);

    /* Did the file read succeed */
    lFReadResult = ferror(lpFile);
    if(0 != lFReadResult)
    {
        kpMCB->lFileErrno = errno;
        LogMsg(11, lpszFileName, lFReadResult);
        return FAILURE;
    }

    /* Finally close the file as we have finished with it */
    fclose(lpFile);

    return SUCCESS;
}


/*==========================================================================*/
/* FUNCTION:                                                                */
/*     SaveFile                                                             */
/*                                                                          */
/* PURPOSE:                                                                 */
/*     Save the contents of a buffer into a file                            */
/*                                                                          */
/* INPUT PARAMETERS                                                         */
/*     lpszFileName Pointer to the file name to be loaded                   */
/*     lpszBuff     Pointer to the buffer                                   */
/*     lDataLen     Length of the data and hence the files contents         */
/*     bSuppress... Flag indicating fopen() error message suppression       */
/*     bAppend      Flag indicating file should be opened for appending     */
/*                                                                          */
/* RETURN VALUE                                                             */
/*     SUCCESS or FAILURE                                                   */
/*==========================================================================*/
long
SaveFile(char* lpszFileName, char* lpszBuff, long lDataLen,
         long bSuppress_fopen_Error, long bAppend)
{
    FILE*   lpFile;
    long    lFWriteResult;

    /* Open the  file */
    if(TRUE == bAppend)
    {
        lpFile = fopen(lpszFileName, "ab");
    }
    else
    {
        lpFile = fopen(lpszFileName, "wb");
    }
    if(! lpFile)
    {
        kpMCB->lFileErrno = errno;
        /* Check to see if calling routine intends to issue its own error */
        if(! bSuppress_fopen_Error)
        {
            LogMsg(5, "SaveFile", lpszFileName, errno);
        }
        return FAILURE;
    }

    /* Opened the file so its time to write it out  */
    fwrite(lpszBuff, sizeof(char), lDataLen, lpFile);

    /* Did the file write succeed */
    lFWriteResult = ferror(lpFile);
    if(0 != lFWriteResult)
    {
        kpMCB->lFileErrno = errno;
        LogMsg(53, lpszFileName, lFWriteResult);
        return FAILURE;
    }

    /* Finally close the file as we have finished with it */
    fclose(lpFile);

    return SUCCESS;
}

/*==========================================================================*/
/* FUNCTION:                                                                */
/*     FileExists                                                           */
/*                                                                          */
/* PURPOSE:                                                                 */
/*     Determine if a file exists                                           */
/*                                                                          */
/* INPUT PARAMETERS                                                         */
/*     lpszFileName Pointer to the file to be checked                       */
/*                                                                          */
/* RETURN VALUE                                                             */
/*     SUCCESS or FAILURE                                                   */
/*==========================================================================*/
long FileExists(char* lpszFileName)
{
    FILE*   lpFile;

    lpFile = fopen(lpszFileName, "r");
    if(! lpFile)
    {
        return FAILURE;
    }

    /* Finally close the file as we have finished with it */
    fclose(lpFile);

    return SUCCESS;
}


/*==========================================================================*/
/* FUNCTION:                                                                */
/*     PFSaveFileMQMD                                                       */
/*                                                                          */
/* PURPOSE:                                                                 */
/*     Save MQMD information to a file on behalf of a PutFile command       */
/*                                                                          */
/* INPUT PARAMETERS                                                         */
/*     lpTIB          Test info block pointer                               */
/*     lpPFB          PutFile command block pointer                         */
/*                                                                          */
/* RETURN VALUE                                                             */
/*     SUCCESS or FAILURE                                                   */
/*==========================================================================*/
long
PFSaveFileMQMD(TestInfoBlk* lpTIB, PutFileBlk* lpPFB)
{
    VarInfoBlk*     lpVIB;
    MQMDInfoBlk*    lpMIB;
    char            lpszExtraInfo1[EXTRA_MSG_INFO_LEN + 4];
    char            lpszDirAndFile[FILE_BUFF_LEN + 4];
    char*           lpszMQMDBuff;
    char*           lpszMQMDBuffCurr;
    char*           lpszTrimVal;
    long            lMQMDBuffLen;
    long            lMQMDDataLen;
    long            lXMLDEFLen;
    long            lBEGINMQMDLen;
    long            lENDMQMDLen;
    long            lBEGINVERSIONLen;
    long            lENDVERSIONLen;
    long            lVersionLen;
    long            lBEGINREPORTLen;
    long            lENDREPORTLen;
    long            lReportLen;
    long            lBEGINMSGTYPELen;
    long            lENDMSGTYPELen;
    long            lMsgTypeLen;
    long            lBEGINEXPIRYLen;
    long            lENDEXPIRYLen;
    long            lExpiryLen;
    long            lBEGINFEEDBACKLen;
    long            lENDFEEDBACKLen;
    long            lFeedbackLen;
    long            lBEGINENCODINGLen;
    long            lENDENCODINGLen;
    long            lEncodingLen;
    long            lBEGINCCSIDLen;
    long            lENDCCSIDLen;
    long            lCCSIDLen;
    long            lBEGINFORMATLen;
    long            lENDFORMATLen;
    long            lFormatLen;
    long            lBEGINPRIORITYLen;
    long            lENDPRIORITYLen;
    long            lPriorityLen;
    long            lBEGINPERSISTENCELen;
    long            lENDPERSISTENCELen;
    long            lPersistenceLen;
    long            lBEGINMSGIDLen;
    long            lENDMSGIDLen;
    long            lMsgIdLen;
    long            lBEGINCORRELIDLen;
    long            lENDCORRELIDLen;
    long            lCorrelIdLen;
    long            lBEGINBACKOUTCOUNTLen;
    long            lENDBACKOUTCOUNTLen;
    long            lBackoutCountLen;
    long            lBEGINREPLYTOQLen;
    long            lENDREPLYTOQLen;
    long            lReplyToQLen;
    long            lBEGINREPLYTOQMGRLen;
    long            lENDREPLYTOQMGRLen;
    long            lReplyToQMgrLen;
    long            lBEGINUSERIDENTIFIERLen;
    long            lENDUSERIDENTIFIERLen;
    long            lUserIdentifierLen;
    long            lBEGINACCOUNTINGTOKENLen;
    long            lENDACCOUNTINGTOKENLen;
    long            lAccountingTokenLen;
    long            lBEGINAPPLIDENTITYDATALen;
    long            lENDAPPLIDENTITYDATALen;
    long            lApplIdentityDataLen;
    long            lBEGINPUTAPPLTYPELen;
    long            lENDPUTAPPLTYPELen;
    long            lPutApplTypeLen;
    long            lBEGINPUTAPPLNAMELen;
    long            lENDPUTAPPLNAMELen;
    long            lPutApplNameLen;
    long            lBEGINPUTDATELen;
    long            lENDPUTDATELen;
    long            lPutDateLen;
    long            lBEGINPUTTIMELen;
    long            lENDPUTTIMELen;
    long            lPutTimeLen;
    long            lBEGINAPPLORIGINDATALen;
    long            lENDAPPLORIGINDATALen;
    long            lApplOriginDataLen;
    long            lBEGINGROUPIDLen;
    long            lENDGROUPIDLen;
    long            lGroupIdLen;
    long            lBEGINMSGSEQNUMBERLen;
    long            lENDMSGSEQNUMBERLen;
    long            lMsgSeqNumberLen;
    long            lBEGINOFFSETLen;
    long            lENDOFFSETLen;
    long            lOffsetLen;
    long            lBEGINMSGFLAGSLen;
    long            lENDMSGFLAGSLen;
    long            lMsgFlagsLen;
    long            lBEGINORIGINALLENGTHLen;
    long            lENDORIGINALLENGTHLen;
    long            lOriginalLengthLen;
    long            bSaveFile;

    /* Generate full path file name for saving */
    memset(lpszDirAndFile, 0x00, FILE_BUFF_LEN + 4);
    strncpy(lpszDirAndFile, lpPFB->lpszResDir, FILE_BUFF_LEN);
    strcat(lpszDirAndFile, kpszDirFileConcat);
    strncat(lpszDirAndFile, lpPFB->lpszResMQMDFileName, FILE_BUFF_LEN);

    /* Get the VIB for the MQMD control block */
    lpVIB = FindVarInfoBlk(lpTIB->lpVIBHead, lpPFB->lpszResMQMDVarName);
    if(! lpVIB)
    {
        LogMsg(81, lpTIB->lTestNum, lpPFB->lpszResMQMDVarName);
        sprintf(lpszExtraInfo1, "Unable to save MQMDFile=%s\0",
                lpszDirAndFile);
        LogMsg(TEST_EXTRA_LINE_ERR, lpTIB->lTestNum, lpszExtraInfo1);
        lpPFB->eCommandState = S_FAILURE;
        return FAILURE;
    }

    /* Is it really an MQMD VIB */
    if(V_MQMD != lpVIB->eVarType)
    {
        LogMsg(82, lpTIB->lTestNum, lpPFB->lpszResMQMDVarName);
        sprintf(lpszExtraInfo1, "Unable to save MQMDFile=%s\0",
                lpszDirAndFile);
        LogMsg(TEST_EXTRA_LINE_ERR, lpTIB->lTestNum, lpszExtraInfo1);
        lpPFB->eCommandState = S_FAILURE;
        return FAILURE;
    }

    /* Get the MIB variable pointer if available */
    lpMIB = lpVIB->lpCtrlBlk;

    /* Check to see if we have a MIB attached */
    if(! lpMIB)
    {
        LogMsg(76, lpTIB->lTestNum);
        sprintf(lpszExtraInfo1, "Unable to save MQMDFile=%s\0",
                lpszDirAndFile);
        LogMsg(TEST_EXTRA_LINE_ERR, lpTIB->lTestNum, lpszExtraInfo1);
        lpPFB->eCommandState = S_FAILURE;
        return FAILURE;
    }

    /* Calculate the buffer size for saving the MQMD info */
    lXMLDEFLen = strlen(kpszXMLDEF);
    lBEGINMQMDLen = strlen(kpszBEGINMQMD);
    lENDMQMDLen = strlen(kpszENDMQMD);
    lBEGINVERSIONLen = strlen(kpszBEGINVERSION);
    lENDVERSIONLen = strlen(kpszENDVERSION);
    lVersionLen = StrlenNull(lpMIB->lpszVersion);
    lBEGINREPORTLen = strlen(kpszBEGINREPORT);
    lENDREPORTLen = strlen(kpszENDREPORT);
    lReportLen = StrlenNull(lpMIB->lpszReport);
    lBEGINMSGTYPELen = strlen(kpszBEGINMSGTYPE);
    lENDMSGTYPELen = strlen(kpszENDMSGTYPE);
    lMsgTypeLen = StrlenNull(lpMIB->lpszMsgType);
    lBEGINEXPIRYLen = strlen(kpszBEGINEXPIRY);
    lENDEXPIRYLen = strlen(kpszENDEXPIRY);
    lExpiryLen = StrlenNull(lpMIB->lpszExpiry);
    lBEGINFEEDBACKLen = strlen(kpszBEGINFEEDBACK);
    lENDFEEDBACKLen = strlen(kpszENDFEEDBACK);
    lFeedbackLen = StrlenNull(lpMIB->lpszFeedback);
    lBEGINENCODINGLen = strlen(kpszBEGINENCODING);
    lENDENCODINGLen = strlen(kpszENDENCODING);
    lEncodingLen = StrlenNull(lpMIB->lpszEncoding);
    lBEGINCCSIDLen = strlen(kpszBEGINCCSID);
    lENDCCSIDLen = strlen(kpszENDCCSID);
    lCCSIDLen = StrlenNull(lpMIB->lpszCodedCharSetId);
    lBEGINFORMATLen = strlen(kpszBEGINFORMAT);
    lENDFORMATLen = strlen(kpszENDFORMAT);
    lFormatLen = StrlenNull(lpMIB->lpszFormat);
    lBEGINPRIORITYLen = strlen(kpszBEGINPRIORITY);
    lENDPRIORITYLen = strlen(kpszENDPRIORITY);
    lPriorityLen = StrlenNull(lpMIB->lpszPriority);
    lBEGINPERSISTENCELen = strlen(kpszBEGINPERSISTENCE);
    lENDPERSISTENCELen = strlen(kpszENDPERSISTENCE);
    lPersistenceLen = StrlenNull(lpMIB->lpszPersistence);
    lBEGINMSGIDLen = strlen(kpszBEGINMSGID);
    lENDMSGIDLen = strlen(kpszENDMSGID);
    lMsgIdLen = StrlenNull(lpMIB->lpszMsgId);
    lBEGINCORRELIDLen = strlen(kpszBEGINCORRELID);
    lENDCORRELIDLen = strlen(kpszENDCORRELID);
    lCorrelIdLen = StrlenNull(lpMIB->lpszCorrelId);
    lBEGINBACKOUTCOUNTLen = strlen(kpszBEGINBACKOUTCOUNT);
    lENDBACKOUTCOUNTLen = strlen(kpszENDBACKOUTCOUNT);
    lBackoutCountLen = StrlenNull(lpMIB->lpszBackoutCount);
    lBEGINREPLYTOQLen = strlen(kpszBEGINREPLYTOQ);
    lENDREPLYTOQLen = strlen(kpszENDREPLYTOQ);
    lReplyToQLen = StrlenNull(lpMIB->lpszReplyToQ);
    lBEGINREPLYTOQMGRLen = strlen(kpszBEGINREPLYTOQMGR);
    lENDREPLYTOQMGRLen = strlen(kpszENDREPLYTOQMGR);
    lReplyToQMgrLen = StrlenNull(lpMIB->lpszReplyToQMgr);
    lBEGINUSERIDENTIFIERLen = strlen(kpszBEGINUSERIDENTIFIER);
    lENDUSERIDENTIFIERLen = strlen(kpszENDUSERIDENTIFIER);
    lUserIdentifierLen = StrlenNull(lpMIB->lpszUserIdentifier);
    lBEGINACCOUNTINGTOKENLen = strlen(kpszBEGINACCOUNTINGTOKEN);
    lENDACCOUNTINGTOKENLen = strlen(kpszENDACCOUNTINGTOKEN);
    lAccountingTokenLen = StrlenNull(lpMIB->lpszAccountingToken);
    lBEGINAPPLIDENTITYDATALen = strlen(kpszBEGINAPPLIDENTITYDATA);
    lENDAPPLIDENTITYDATALen = strlen(kpszENDAPPLIDENTITYDATA);
    lApplIdentityDataLen = StrlenNull(lpMIB->lpszApplIdentityData);
    lBEGINPUTAPPLTYPELen = strlen(kpszBEGINPUTAPPLTYPE);
    lENDPUTAPPLTYPELen = strlen(kpszENDPUTAPPLTYPE);
    lPutApplTypeLen = StrlenNull(lpMIB->lpszPutApplType);
    lBEGINPUTAPPLNAMELen = strlen(kpszBEGINPUTAPPLNAME);
    lENDPUTAPPLNAMELen = strlen(kpszENDPUTAPPLNAME);
    lPutApplNameLen = StrlenNull(lpMIB->lpszPutApplName);
    lBEGINPUTDATELen = strlen(kpszBEGINPUTDATE);
    lENDPUTDATELen = strlen(kpszENDPUTDATE);
    lPutDateLen = StrlenNull(lpMIB->lpszPutDate);
    lBEGINPUTTIMELen = strlen(kpszBEGINPUTTIME);
    lENDPUTTIMELen = strlen(kpszENDPUTTIME);
    lPutTimeLen = StrlenNull(lpMIB->lpszPutTime);
    lBEGINAPPLORIGINDATALen = strlen(kpszBEGINAPPLORIGINDATA);
    lENDAPPLORIGINDATALen = strlen(kpszENDAPPLORIGINDATA);
    lApplOriginDataLen = StrlenNull(lpMIB->lpszApplOriginData);
    lBEGINGROUPIDLen = strlen(kpszBEGINGROUPID);
    lENDGROUPIDLen = strlen(kpszENDGROUPID);
    lGroupIdLen = StrlenNull(lpMIB->lpszGroupId);
    lBEGINMSGSEQNUMBERLen = strlen(kpszBEGINMSGSEQNUMBER);
    lENDMSGSEQNUMBERLen = strlen(kpszENDMSGSEQNUMBER);
    lMsgSeqNumberLen = StrlenNull(lpMIB->lpszMsgSeqNumber);
    lBEGINOFFSETLen = strlen(kpszBEGINOFFSET);
    lENDOFFSETLen = strlen(kpszENDOFFSET);
    lOffsetLen = StrlenNull(lpMIB->lpszOffset);
    lBEGINMSGFLAGSLen = strlen(kpszBEGINMSGFLAGS);
    lENDMSGFLAGSLen = strlen(kpszENDMSGFLAGS);
    lMsgFlagsLen = StrlenNull(lpMIB->lpszMsgFlags);
    lBEGINORIGINALLENGTHLen = strlen(kpszBEGINORIGINALLENGTH);
    lENDORIGINALLENGTHLen = strlen(kpszENDORIGINALLENGTH);
    lOriginalLengthLen = StrlenNull(lpMIB->lpszOriginalLength);
    lMQMDBuffLen = lXMLDEFLen;
    lMQMDBuffLen += lBEGINMQMDLen;
    lMQMDBuffLen += lENDMQMDLen;
    lMQMDBuffLen += lBEGINVERSIONLen;
    lMQMDBuffLen += lENDVERSIONLen;
    lMQMDBuffLen += lVersionLen;
    lMQMDBuffLen += lBEGINREPORTLen;
    lMQMDBuffLen += lENDREPORTLen;
    lMQMDBuffLen += lReportLen;
    lMQMDBuffLen += lBEGINMSGTYPELen;
    lMQMDBuffLen += lENDMSGTYPELen;
    lMQMDBuffLen += lMsgTypeLen;
    lMQMDBuffLen += lBEGINEXPIRYLen;
    lMQMDBuffLen += lENDEXPIRYLen;
    lMQMDBuffLen += lExpiryLen;
    lMQMDBuffLen += lBEGINFEEDBACKLen;
    lMQMDBuffLen += lENDFEEDBACKLen;
    lMQMDBuffLen += lFeedbackLen;
    lMQMDBuffLen += lBEGINENCODINGLen;
    lMQMDBuffLen += lENDENCODINGLen;
    lMQMDBuffLen += lEncodingLen;
    lMQMDBuffLen += lBEGINCCSIDLen;
    lMQMDBuffLen += lENDCCSIDLen;
    lMQMDBuffLen += lCCSIDLen;
    lMQMDBuffLen += lBEGINFORMATLen;
    lMQMDBuffLen += lENDFORMATLen;
    lMQMDBuffLen += lFormatLen;
    lMQMDBuffLen += lBEGINPRIORITYLen;
    lMQMDBuffLen += lENDPRIORITYLen;
    lMQMDBuffLen += lPriorityLen;
    lMQMDBuffLen += lBEGINPERSISTENCELen;
    lMQMDBuffLen += lENDPERSISTENCELen;
    lMQMDBuffLen += lPersistenceLen;
    lMQMDBuffLen += lBEGINMSGIDLen;
    lMQMDBuffLen += lENDMSGIDLen;
    lMQMDBuffLen += lMsgIdLen;
    lMQMDBuffLen += lBEGINCORRELIDLen;
    lMQMDBuffLen += lENDCORRELIDLen;
    lMQMDBuffLen += lCorrelIdLen;
    lMQMDBuffLen += lBEGINBACKOUTCOUNTLen;
    lMQMDBuffLen += lENDBACKOUTCOUNTLen;
    lMQMDBuffLen += lBackoutCountLen;
    lMQMDBuffLen += lBEGINREPLYTOQLen;
    lMQMDBuffLen += lENDREPLYTOQLen;
    lMQMDBuffLen += lENDREPLYTOQLen;
    lMQMDBuffLen += lReplyToQLen;
    lMQMDBuffLen += lBEGINREPLYTOQMGRLen;
    lMQMDBuffLen += lENDREPLYTOQMGRLen;
    lMQMDBuffLen += lReplyToQMgrLen;
    lMQMDBuffLen += lBEGINUSERIDENTIFIERLen;
    lMQMDBuffLen += lENDUSERIDENTIFIERLen;
    lMQMDBuffLen += lUserIdentifierLen;
    lMQMDBuffLen += lBEGINACCOUNTINGTOKENLen;
    lMQMDBuffLen += lENDACCOUNTINGTOKENLen;
    lMQMDBuffLen += lAccountingTokenLen;
    lMQMDBuffLen += lBEGINAPPLIDENTITYDATALen;
    lMQMDBuffLen += lENDAPPLIDENTITYDATALen;
    lMQMDBuffLen += lApplIdentityDataLen;
    lMQMDBuffLen += lBEGINPUTAPPLTYPELen;
    lMQMDBuffLen += lENDPUTAPPLTYPELen;
    lMQMDBuffLen += lPutApplTypeLen;
    lMQMDBuffLen += lBEGINPUTAPPLNAMELen;
    lMQMDBuffLen += lENDPUTAPPLNAMELen;
    lMQMDBuffLen += lPutApplNameLen;
    lMQMDBuffLen += lBEGINPUTDATELen;
    lMQMDBuffLen += lENDPUTDATELen;
    lMQMDBuffLen += lPutDateLen;
    lMQMDBuffLen += lBEGINPUTTIMELen;
    lMQMDBuffLen += lENDPUTTIMELen;
    lMQMDBuffLen += lPutTimeLen;
    lMQMDBuffLen += lBEGINAPPLORIGINDATALen;
    lMQMDBuffLen += lENDAPPLORIGINDATALen;
    lMQMDBuffLen += lApplOriginDataLen;
    lMQMDBuffLen += lBEGINGROUPIDLen;
    lMQMDBuffLen += lENDGROUPIDLen;
    lMQMDBuffLen += lGroupIdLen;
    lMQMDBuffLen += lBEGINMSGSEQNUMBERLen;
    lMQMDBuffLen += lENDMSGSEQNUMBERLen;
    lMQMDBuffLen += lMsgSeqNumberLen;
    lMQMDBuffLen += lBEGINOFFSETLen;
    lMQMDBuffLen += lENDOFFSETLen;
    lMQMDBuffLen += lOffsetLen;
    lMQMDBuffLen += lBEGINMSGFLAGSLen;
    lMQMDBuffLen += lENDMSGFLAGSLen;
    lMQMDBuffLen += lMsgFlagsLen;
    lMQMDBuffLen += lBEGINORIGINALLENGTHLen;
    lMQMDBuffLen += lENDORIGINALLENGTHLen;
    lMQMDBuffLen += lOriginalLengthLen;

    lMQMDBuffLen = (((lMQMDBuffLen + 16) / 16) + 1) * 16;

    /* Allocate the buffer and check the result */
    lpszMQMDBuff = malloc(lMQMDBuffLen);
    if(! lpszMQMDBuff)
    {
        ConsoleMsg(3, sizeof(lMQMDBuffLen), "MQMD Folder Save", __LINE__, __FILE__);
        kpMCB->lProcessing = FAILURE;
        lpPFB->eCommandState = S_FAILURE;
        return FAILURE;
    }
    memset(lpszMQMDBuff, 0x00, lMQMDBuffLen);

    /* Create the buffer content to save to the MQMDFile */
    lpszMQMDBuffCurr = lpszMQMDBuff;
    memset(lpszMQMDBuffCurr, 0x00, lMQMDBuffLen);

    /* Prefix the file with the XML definition element */
    sprintf(lpszMQMDBuffCurr, "%s", kpszXMLDEF);
    lpszMQMDBuffCurr += lXMLDEFLen;

    /* Open <MQMD> element */
    sprintf(lpszMQMDBuffCurr, "%s", kpszBEGINMQMD);
    lpszMQMDBuffCurr += lBEGINMQMDLen;

    /* <Version> if present */
    if(0 < lVersionLen)
    {
        sprintf(lpszMQMDBuffCurr, kpszBEGINVERSION);
        lpszMQMDBuffCurr += lBEGINVERSIONLen;
        sprintf(lpszMQMDBuffCurr, lpMIB->lpszVersion);
        lpszMQMDBuffCurr += lVersionLen;
        sprintf(lpszMQMDBuffCurr, kpszENDVERSION);
        lpszMQMDBuffCurr += lENDVERSIONLen;
    }

    /* <Report> if present */
    if(0 < lReportLen)
    {
        sprintf(lpszMQMDBuffCurr, kpszBEGINREPORT);
        lpszMQMDBuffCurr += lBEGINREPORTLen;
        sprintf(lpszMQMDBuffCurr, lpMIB->lpszReport);
        lpszMQMDBuffCurr += lReportLen;
        sprintf(lpszMQMDBuffCurr, kpszENDREPORT);
        lpszMQMDBuffCurr += lENDREPORTLen;
    }

    /* <MsgType> if present */
    if(0 < lMsgTypeLen)
    {
        sprintf(lpszMQMDBuffCurr, kpszBEGINMSGTYPE);
        lpszMQMDBuffCurr += lBEGINMSGTYPELen;
        sprintf(lpszMQMDBuffCurr, lpMIB->lpszMsgType);
        lpszMQMDBuffCurr += lMsgTypeLen;
        sprintf(lpszMQMDBuffCurr, kpszENDMSGTYPE);
        lpszMQMDBuffCurr += lENDMSGTYPELen;
    }

    /* <Expiry> if present */
    if(0 < lExpiryLen)
    {
        sprintf(lpszMQMDBuffCurr, kpszBEGINEXPIRY);
        lpszMQMDBuffCurr += lBEGINEXPIRYLen;
        sprintf(lpszMQMDBuffCurr, lpMIB->lpszExpiry);
        lpszMQMDBuffCurr += lExpiryLen;
        sprintf(lpszMQMDBuffCurr, kpszENDEXPIRY);
        lpszMQMDBuffCurr += lENDEXPIRYLen;
    }

    /* <Feedback> if present */
    if(0 < lFeedbackLen)
    {
        sprintf(lpszMQMDBuffCurr, kpszBEGINFEEDBACK);
        lpszMQMDBuffCurr += lBEGINFEEDBACKLen;
        sprintf(lpszMQMDBuffCurr, lpMIB->lpszFeedback);
        lpszMQMDBuffCurr += lFeedbackLen;
        sprintf(lpszMQMDBuffCurr, kpszENDFEEDBACK);
        lpszMQMDBuffCurr += lENDFEEDBACKLen;
    }

    /* <Encoding> if present */
    if(0 < lEncodingLen)
    {
        sprintf(lpszMQMDBuffCurr, kpszBEGINENCODING);
        lpszMQMDBuffCurr += lBEGINENCODINGLen;
        sprintf(lpszMQMDBuffCurr, lpMIB->lpszEncoding);
        lpszMQMDBuffCurr += lEncodingLen;
        sprintf(lpszMQMDBuffCurr, kpszENDENCODING);
        lpszMQMDBuffCurr += lENDENCODINGLen;
    }

    /* <CodedCharSetId> if present */
    if(0 < lCCSIDLen)
    {
        sprintf(lpszMQMDBuffCurr, kpszBEGINCCSID);
        lpszMQMDBuffCurr += lBEGINCCSIDLen;
        sprintf(lpszMQMDBuffCurr, lpMIB->lpszCodedCharSetId);
        lpszMQMDBuffCurr += lCCSIDLen;
        sprintf(lpszMQMDBuffCurr, kpszENDCCSID);
        lpszMQMDBuffCurr += lENDCCSIDLen;
    }

    /* <Format> if present */
    if(0 < lFormatLen)
    {
        sprintf(lpszMQMDBuffCurr, kpszBEGINFORMAT);
        lpszMQMDBuffCurr += lBEGINFORMATLen;
        lpszTrimVal = TrimString(lpMIB->lpszFormat);
        lFormatLen = StrlenNull(lpszTrimVal);
        sprintf(lpszMQMDBuffCurr, lpszTrimVal);
        lpszMQMDBuffCurr += lFormatLen;
        FreeIfNotNull((void**)&lpszTrimVal);
        sprintf(lpszMQMDBuffCurr, kpszENDFORMAT);
        lpszMQMDBuffCurr += lENDFORMATLen;
    }

    /* <Priority> if present */
    if(0 < lPriorityLen)
    {
        sprintf(lpszMQMDBuffCurr, kpszBEGINPRIORITY);
        lpszMQMDBuffCurr += lBEGINPRIORITYLen;
        sprintf(lpszMQMDBuffCurr, lpMIB->lpszPriority);
        lpszMQMDBuffCurr += lPriorityLen;
        sprintf(lpszMQMDBuffCurr, kpszENDPRIORITY);
        lpszMQMDBuffCurr += lENDPRIORITYLen;
    }

    /* <Persistence> if present */
    if(0 < lPersistenceLen)
    {
        sprintf(lpszMQMDBuffCurr, kpszBEGINPERSISTENCE);
        lpszMQMDBuffCurr += lBEGINPERSISTENCELen;
        sprintf(lpszMQMDBuffCurr, lpMIB->lpszPersistence);
        lpszMQMDBuffCurr += lPersistenceLen;
        sprintf(lpszMQMDBuffCurr, kpszENDPERSISTENCE);
        lpszMQMDBuffCurr += lENDPERSISTENCELen;
    }

    /* <MsgId> if present */
    if(0 < lMsgIdLen)
    {
        sprintf(lpszMQMDBuffCurr, kpszBEGINMSGID);
        lpszMQMDBuffCurr += lBEGINMSGIDLen;
        sprintf(lpszMQMDBuffCurr, lpMIB->lpszMsgId);
        lpszMQMDBuffCurr += lMsgIdLen;
        sprintf(lpszMQMDBuffCurr, kpszENDMSGID);
        lpszMQMDBuffCurr += lENDMSGIDLen;
    }

    /* <CorrelId> if present */
    if(0 < lCorrelIdLen)
    {
        sprintf(lpszMQMDBuffCurr, kpszBEGINCORRELID);
        lpszMQMDBuffCurr += lBEGINCORRELIDLen;
        sprintf(lpszMQMDBuffCurr, lpMIB->lpszCorrelId);
        lpszMQMDBuffCurr += lCorrelIdLen;
        sprintf(lpszMQMDBuffCurr, kpszENDCORRELID);
        lpszMQMDBuffCurr += lENDCORRELIDLen;
    }

    /* <BackoutCount> if present */
    if(0 < lBackoutCountLen)
    {
        sprintf(lpszMQMDBuffCurr, kpszBEGINBACKOUTCOUNT);
        lpszMQMDBuffCurr += lBEGINBACKOUTCOUNTLen;
        sprintf(lpszMQMDBuffCurr, lpMIB->lpszBackoutCount);
        lpszMQMDBuffCurr += lBackoutCountLen;
        sprintf(lpszMQMDBuffCurr, kpszENDBACKOUTCOUNT);
        lpszMQMDBuffCurr += lENDBACKOUTCOUNTLen;
    }

    /* <ReplyToQ> if present */
    if(0 < lReplyToQLen)
    {
        sprintf(lpszMQMDBuffCurr, kpszBEGINREPLYTOQ);
        lpszMQMDBuffCurr += lBEGINREPLYTOQLen;
        lpszTrimVal = TrimString(lpMIB->lpszReplyToQ);
        lReplyToQLen = StrlenNull(lpszTrimVal);
        sprintf(lpszMQMDBuffCurr, lpszTrimVal);
        lpszMQMDBuffCurr += lReplyToQLen;
        FreeIfNotNull((void**)&lpszTrimVal);
        sprintf(lpszMQMDBuffCurr, kpszENDREPLYTOQ);
        lpszMQMDBuffCurr += lENDREPLYTOQLen;
    }

    /* <ReplyToQMgr> if present */
    if(0 < lReplyToQMgrLen)
    {
        sprintf(lpszMQMDBuffCurr, kpszBEGINREPLYTOQMGR);
        lpszMQMDBuffCurr += lBEGINREPLYTOQMGRLen;
        lpszTrimVal = TrimString(lpMIB->lpszReplyToQMgr);
        lReplyToQMgrLen = StrlenNull(lpszTrimVal);
        sprintf(lpszMQMDBuffCurr, lpszTrimVal);
        lpszMQMDBuffCurr += lReplyToQMgrLen;
        FreeIfNotNull((void**)&lpszTrimVal);
        sprintf(lpszMQMDBuffCurr, kpszENDREPLYTOQMGR);
        lpszMQMDBuffCurr += lENDREPLYTOQMGRLen;
    }

    /* <UserIdentifier> if present */
    if(0 < lUserIdentifierLen)
    {
        sprintf(lpszMQMDBuffCurr, kpszBEGINUSERIDENTIFIER);
        lpszMQMDBuffCurr += lBEGINUSERIDENTIFIERLen;
        sprintf(lpszMQMDBuffCurr, lpMIB->lpszUserIdentifier);
        lpszMQMDBuffCurr += lUserIdentifierLen;
        sprintf(lpszMQMDBuffCurr, kpszENDUSERIDENTIFIER);
        lpszMQMDBuffCurr += lENDUSERIDENTIFIERLen;
    }

    /* <AccountingToken> if present */
    if(0 < lAccountingTokenLen)
    {
        sprintf(lpszMQMDBuffCurr, kpszBEGINACCOUNTINGTOKEN);
        lpszMQMDBuffCurr += lBEGINACCOUNTINGTOKENLen;
        sprintf(lpszMQMDBuffCurr, lpMIB->lpszAccountingToken);
        lpszMQMDBuffCurr += lAccountingTokenLen;
        sprintf(lpszMQMDBuffCurr, kpszENDACCOUNTINGTOKEN);
        lpszMQMDBuffCurr += lENDACCOUNTINGTOKENLen;
    }

    /* <ApplIdentityData> if present */
    if(0 < lApplIdentityDataLen)
    {
        sprintf(lpszMQMDBuffCurr, kpszBEGINAPPLIDENTITYDATA);
        lpszMQMDBuffCurr += lBEGINAPPLIDENTITYDATALen;
        sprintf(lpszMQMDBuffCurr, lpMIB->lpszApplIdentityData);
        lpszMQMDBuffCurr += lApplIdentityDataLen;
        sprintf(lpszMQMDBuffCurr, kpszENDAPPLIDENTITYDATA);
        lpszMQMDBuffCurr += lENDAPPLIDENTITYDATALen;
    }

    /* <PutApplType> if present */
    if(0 < lPutApplTypeLen)
    {
        sprintf(lpszMQMDBuffCurr, kpszBEGINPUTAPPLTYPE);
        lpszMQMDBuffCurr += lBEGINPUTAPPLTYPELen;
        sprintf(lpszMQMDBuffCurr, lpMIB->lpszPutApplType);
        lpszMQMDBuffCurr += lPutApplTypeLen;
        sprintf(lpszMQMDBuffCurr, kpszENDPUTAPPLTYPE);
        lpszMQMDBuffCurr += lENDPUTAPPLTYPELen;
    }

    /* <PutApplName> if present */
    if(0 < lPutApplNameLen)
    {
        sprintf(lpszMQMDBuffCurr, kpszBEGINPUTAPPLNAME);
        lpszMQMDBuffCurr += lBEGINPUTAPPLNAMELen;
        sprintf(lpszMQMDBuffCurr, lpMIB->lpszPutApplName);
        lpszMQMDBuffCurr += lPutApplNameLen;
        sprintf(lpszMQMDBuffCurr, kpszENDPUTAPPLNAME);
        lpszMQMDBuffCurr += lENDPUTAPPLNAMELen;
    }

    /* <PutDate> if present */
    if(0 < lPutDateLen)
    {
        sprintf(lpszMQMDBuffCurr, kpszBEGINPUTDATE);
        lpszMQMDBuffCurr += lBEGINPUTDATELen;
        sprintf(lpszMQMDBuffCurr, lpMIB->lpszPutDate);
        lpszMQMDBuffCurr += lPutDateLen;
        sprintf(lpszMQMDBuffCurr, kpszENDPUTDATE);
        lpszMQMDBuffCurr += lENDPUTDATELen;
    }

    /* <PutTime> if present */
    if(0 < lPutTimeLen)
    {
        sprintf(lpszMQMDBuffCurr, kpszBEGINPUTTIME);
        lpszMQMDBuffCurr += lBEGINPUTTIMELen;
        sprintf(lpszMQMDBuffCurr, lpMIB->lpszPutTime);
        lpszMQMDBuffCurr += lPutTimeLen;
        sprintf(lpszMQMDBuffCurr, kpszENDPUTTIME);
        lpszMQMDBuffCurr += lENDPUTTIMELen;
    }

    /* <ApplOriginData> if present */
    if(0 < lApplOriginDataLen)
    {
        sprintf(lpszMQMDBuffCurr, kpszBEGINAPPLORIGINDATA);
        lpszMQMDBuffCurr += lBEGINAPPLORIGINDATALen;
        sprintf(lpszMQMDBuffCurr, lpMIB->lpszApplOriginData);
        lpszMQMDBuffCurr += lApplOriginDataLen;
        sprintf(lpszMQMDBuffCurr, kpszENDAPPLORIGINDATA);
        lpszMQMDBuffCurr += lENDAPPLORIGINDATALen;
    }

    /* <GroupId> if present */
    if(0 < lGroupIdLen)
    {
        sprintf(lpszMQMDBuffCurr, kpszBEGINGROUPID);
        lpszMQMDBuffCurr += lBEGINGROUPIDLen;
        sprintf(lpszMQMDBuffCurr, lpMIB->lpszGroupId);
        lpszMQMDBuffCurr += lGroupIdLen;
        sprintf(lpszMQMDBuffCurr, kpszENDGROUPID);
        lpszMQMDBuffCurr += lENDGROUPIDLen;
    }

    /* <MsgSeqNumber> if present */
    if(0 < lMsgSeqNumberLen)
    {
        sprintf(lpszMQMDBuffCurr, kpszBEGINMSGSEQNUMBER);
        lpszMQMDBuffCurr += lBEGINMSGSEQNUMBERLen;
        sprintf(lpszMQMDBuffCurr, lpMIB->lpszMsgSeqNumber);
        lpszMQMDBuffCurr += lMsgSeqNumberLen;
        sprintf(lpszMQMDBuffCurr, kpszENDMSGSEQNUMBER);
        lpszMQMDBuffCurr += lENDMSGSEQNUMBERLen;
    }

    /* <Offset> if present */
    if(0 < lOffsetLen)
    {
        sprintf(lpszMQMDBuffCurr, kpszBEGINOFFSET);
        lpszMQMDBuffCurr += lBEGINOFFSETLen;
        sprintf(lpszMQMDBuffCurr, lpMIB->lpszOffset);
        lpszMQMDBuffCurr += lOffsetLen;
        sprintf(lpszMQMDBuffCurr, kpszENDOFFSET);
        lpszMQMDBuffCurr += lENDOFFSETLen;
    }

    /* <MsgFlags> if present */
    if(0 < lMsgFlagsLen)
    {
        sprintf(lpszMQMDBuffCurr, kpszBEGINMSGFLAGS);
        lpszMQMDBuffCurr += lBEGINMSGFLAGSLen;
        sprintf(lpszMQMDBuffCurr, lpMIB->lpszMsgFlags);
        lpszMQMDBuffCurr += lMsgFlagsLen;
        sprintf(lpszMQMDBuffCurr, kpszENDMSGFLAGS);
        lpszMQMDBuffCurr += lENDMSGFLAGSLen;
    }

    /* <OriginalLength> if present */
    if(0 < lOriginalLengthLen)
    {
        sprintf(lpszMQMDBuffCurr, kpszBEGINORIGINALLENGTH);
        lpszMQMDBuffCurr += lBEGINORIGINALLENGTHLen;
        sprintf(lpszMQMDBuffCurr, lpMIB->lpszOriginalLength);
        lpszMQMDBuffCurr += lOriginalLengthLen;
        sprintf(lpszMQMDBuffCurr, kpszENDORIGINALLENGTH);
        lpszMQMDBuffCurr += lENDORIGINALLENGTHLen;
    }

    /* Close <MQMD> element */
    sprintf(lpszMQMDBuffCurr, "%s", kpszENDMQMD);
    lpszMQMDBuffCurr += lENDMQMDLen;
    lMQMDDataLen = lpszMQMDBuffCurr - lpszMQMDBuff;

    /* Try to save the MQMDFile reporting the result */
    bSaveFile = SaveFile(lpszDirAndFile, lpszMQMDBuff,
                         lMQMDDataLen, TRUE, lpPFB->bAppend);
    if(FAILURE == bSaveFile)
    {
        sprintf(lpszExtraInfo1, "Failed to put MQMDFile=%s\0",
                lpszDirAndFile);
        LogMsg(TEST_EXTRA_LINE_ERR, lpTIB->lTestNum, lpszExtraInfo1);
        /* All done with the buffer */
        FreeIfNotNull((void**)&lpszMQMDBuff);
        return FAILURE;
    }

    /* Log information about the file that was saved */
    sprintf(lpszExtraInfo1, "Put MQMDFile=%s\0", lpszDirAndFile);
    LogMsg(TEST_EXTRA_LINE, lpTIB->lTestNum, lpszExtraInfo1);

    /* All done with the buffer */
    FreeIfNotNull((void**)&lpszMQMDBuff);

    return SUCCESS;
}


/*==========================================================================*/
/* FUNCTION:                                                                */
/*     PFSaveFileRFH2                                                       */
/*                                                                          */
/* PURPOSE:                                                                 */
/*     Save RFH2 information to a file on behalf of a PutFile command       */
/*                                                                          */
/* INPUT PARAMETERS                                                         */
/*     lpTIB          Test info block pointer                               */
/*     lpPFB          PutFile command block pointer                         */
/*                                                                          */
/* RETURN VALUE                                                             */
/*     SUCCESS or FAILURE                                                   */
/*==========================================================================*/
long
PFSaveFileRFH2(TestInfoBlk* lpTIB, PutFileBlk* lpPFB)
{
    VarInfoBlk*     lpVIB;
    FolderInfoBlk*  lpFIB;
    RFH2InfoBlk*    lpRIB;
    char            lpszExtraInfo1[EXTRA_MSG_INFO_LEN + 4];
    char            lpszDirAndFile[FILE_BUFF_LEN + 4];
    char*           lpszRFH2Buff;
    char*           lpszRFH2BuffCurr;
    char*           lpszTrimVal;
    long            lRFH2BuffLen;
    long            lRFH2DataLen;
    long            lXMLDEFLen;
    long            lBEGINMQRFH2Len;
    long            lENDMQRFH2Len;
    long            lBEGINFOLDERLen;
    long            lENDFOLDERLen;
    long            lBEGINFORMATLen;
    long            lENDFORMATLen;
    long            lFormatLen;
    long            lFolderDataLen;
    long            bSaveFile;

    /* Generate full path file name for saving */
    memset(lpszDirAndFile, 0x00, FILE_BUFF_LEN + 4);
    strncpy(lpszDirAndFile, lpPFB->lpszResDir, FILE_BUFF_LEN);
    strcat(lpszDirAndFile, kpszDirFileConcat);
    strncat(lpszDirAndFile, lpPFB->lpszResRFH2FileName, FILE_BUFF_LEN);

    /* Get the VIB for the RFH2 control block */
    lpVIB = FindVarInfoBlk(lpTIB->lpVIBHead, lpPFB->lpszResRFH2VarName);
    if(! lpVIB)
    {
        LogMsg(79, lpTIB->lTestNum, lpPFB->lpszResRFH2VarName);
        sprintf(lpszExtraInfo1, "Unable to save RFH2File=%s\0",
                lpszDirAndFile);
        LogMsg(TEST_EXTRA_LINE_ERR, lpTIB->lTestNum, lpszExtraInfo1);
        lpPFB->eCommandState = S_FAILURE;
        return FAILURE;
    }

    /* Is it really an RFH2 VIB */
    if(V_RFH2 != lpVIB->eVarType)
    {
        LogMsg(80, lpTIB->lTestNum, lpPFB->lpszResRFH2VarName);
        sprintf(lpszExtraInfo1, "Unable to save RFH2File=%s\0",
                lpszDirAndFile);
        LogMsg(TEST_EXTRA_LINE_ERR, lpTIB->lTestNum, lpszExtraInfo1);
        lpPFB->eCommandState = S_FAILURE;
        return FAILURE;
    }

    /* Get the RIB variable pointer if available */
    lpRIB = lpVIB->lpCtrlBlk;

    /* Check to see if we have a RIB attached */
    if(! lpRIB)
    {
        LogMsg(73, lpTIB->lTestNum);
        sprintf(lpszExtraInfo1, "Unable to save RFH2File=%s\0",
                lpszDirAndFile);
        LogMsg(TEST_EXTRA_LINE_ERR, lpTIB->lTestNum, lpszExtraInfo1);
        lpPFB->eCommandState = S_FAILURE;
        return FAILURE;
    }

    /* Calculate the buffer size for saving the RFH2 Folder info */
    lXMLDEFLen = strlen(kpszXMLDEF);
    lBEGINMQRFH2Len = strlen(kpszBEGINMQRFH2);
    lENDMQRFH2Len = strlen(kpszENDMQRFH2);
    lBEGINFOLDERLen = strlen(kpszBEGINFOLDER);
    lENDFOLDERLen = strlen(kpszENDFOLDER);
    lBEGINFORMATLen = strlen(kpszBEGINFORMAT);
    lENDFORMATLen = strlen(kpszENDFORMAT);
    lFormatLen = StrlenNull(lpRIB->lpszFormat);
    lRFH2BuffLen = lXMLDEFLen;
    lRFH2BuffLen += lBEGINMQRFH2Len + lENDMQRFH2Len;
    lRFH2BuffLen += lBEGINFOLDERLen * lpRIB->lRFH2FolderCount;
    lRFH2BuffLen += lENDFOLDERLen * lpRIB->lRFH2FolderCount;
    lRFH2BuffLen += lpRIB->lRFH2FolderDataLen;
    lRFH2BuffLen += lBEGINFORMATLen;
    lRFH2BuffLen += lENDFORMATLen;
    lRFH2BuffLen += lFormatLen;
    lRFH2BuffLen = (((lRFH2BuffLen + 16) / 16) + 1) * 16;

    /* Allocate the buffer and check the result */
    lpszRFH2Buff = malloc(lRFH2BuffLen);
    if(! lpszRFH2Buff)
    {
        ConsoleMsg(3, sizeof(lRFH2BuffLen), "RFH2 Folder Save", __LINE__, __FILE__);
        kpMCB->lProcessing = FAILURE;
        lpPFB->eCommandState = S_FAILURE;
        return FAILURE;
    }
    memset(lpszRFH2Buff, 0x00, lRFH2BuffLen);

    /*---------------------------------------------------*/
    /* Create the buffer content to save to the RFH2File */
    /*---------------------------------------------------*/
    lpszRFH2BuffCurr = lpszRFH2Buff;
    memset(lpszRFH2BuffCurr, 0x00, lRFH2BuffLen);

    /* Prefix the file with the XML definition element */
    sprintf(lpszRFH2BuffCurr, "%s", kpszXMLDEF);
    lpszRFH2BuffCurr += lXMLDEFLen;
    
    /* Open <MQRFH2> element */
    sprintf(lpszRFH2BuffCurr, "%s", kpszBEGINMQRFH2);
    lpszRFH2BuffCurr += lBEGINMQRFH2Len;
    
    /* <Format> if present */
    if(0 < lFormatLen)
    {
        sprintf(lpszRFH2BuffCurr, kpszBEGINFORMAT);
        lpszRFH2BuffCurr += lBEGINFORMATLen;
        lpszTrimVal = TrimString(lpRIB->lpszFormat);
        lFormatLen = StrlenNull(lpszTrimVal);
        sprintf(lpszRFH2BuffCurr, lpszTrimVal);
        lpszRFH2BuffCurr += lFormatLen;
        FreeIfNotNull((void**)&lpszTrimVal);
        sprintf(lpszRFH2BuffCurr, kpszENDFORMAT);
        lpszRFH2BuffCurr += lENDFORMATLen;
    }

    /* Process <Folder>'s */
    lpFIB = lpRIB->lpFIBHead;
    while(NULL != lpFIB)
    {
        /* Open <Folder> element */
        sprintf(lpszRFH2BuffCurr, "%s", kpszBEGINFOLDER);
        lpszRFH2BuffCurr += lBEGINFOLDERLen;
        /* Folder contents */
        lpszTrimVal = TrimString(lpFIB->lpszFolderData);
        lFolderDataLen = StrlenNull(lpszTrimVal);
        sprintf(lpszRFH2BuffCurr, "%s", lpszTrimVal);
        lpszRFH2BuffCurr += lFolderDataLen;
        FreeIfNotNull((void**)&lpszTrimVal);
        /* Close <Folder> element */
        sprintf(lpszRFH2BuffCurr, "%s", kpszENDFOLDER);
        lpszRFH2BuffCurr += lENDFOLDERLen;
        /* Next Folder info block */
        lpFIB = (FolderInfoBlk*)lpFIB->lpFIBNext;
    }
    
    /* Close <MQRFH2> element */
    sprintf(lpszRFH2BuffCurr, "%s", kpszENDMQRFH2);
    lpszRFH2BuffCurr += lENDMQRFH2Len;
    lRFH2DataLen = lpszRFH2BuffCurr - lpszRFH2Buff;

    /*-----------------------------------------------*/
    /* Try to save the RFH2File reporting the result */
    /*-----------------------------------------------*/
    bSaveFile = SaveFile(lpszDirAndFile, lpszRFH2Buff,
                         lRFH2DataLen, TRUE, lpPFB->bAppend);
    if(FAILURE == bSaveFile)
    {
        sprintf(lpszExtraInfo1, "Failed to put RFH2File=%s\0",
                lpszDirAndFile);
        LogMsg(TEST_EXTRA_LINE_ERR, lpTIB->lTestNum, lpszExtraInfo1);
        /* All done with the buffer */
        FreeIfNotNull((void**)&lpszRFH2Buff);
        return FAILURE;
    }

    /* Log information about the file that was saved */
    sprintf(lpszExtraInfo1, "Put RFH2File=%s\0", lpszDirAndFile);
    LogMsg(TEST_EXTRA_LINE, lpTIB->lTestNum, lpszExtraInfo1);
    sprintf(lpszExtraInfo1, "RFH2FolderCount=%d RFH2FolderDataLen=%d RFH2Len=%d\0",
            lpRIB->lRFH2FolderCount,
            lpRIB->lRFH2FolderDataLen,
            lpRIB->lRFH2FolderDataLen + MQRFH_STRUC_LENGTH_FIXED_2);
    LogMsg(TEST_EXTRA_LINE, lpTIB->lTestNum, lpszExtraInfo1);

    /* All done with the buffer */
    FreeIfNotNull((void**)&lpszRFH2Buff);
    return SUCCESS;
}


/*==========================================================================*/
/* FUNCTION:                                                                */
/*     LoadXMLFile                                                          */
/*                                                                          */
/* PURPOSE:                                                                 */
/*     Load an XML file removing excess whitespace from between the tags    */
/*                                                                          */
/* INPUT PARAMETERS                                                         */
/*     lpszXMLFileName String pointer to name of XML file to load           */
/*     lplpszXMLBuff   Pointer to pointer for returning loaded buff pointer */
/*     lplXMLDataLen   Pointer to long for returning buffer data length     */
/*     bLogMsgs        Flag on whether to write messages to the log file    */
/*                                                                          */
/* RETURN VALUE                                                             */
/*     SUCCESS or FAILURE                                                   */
/*==========================================================================*/
long
LoadXMLFile(char* lpszXMLFileName, char** lplpszXMLBuff,
            long* lplXMLDataLen, long bLogMsgs)
{
    long    lXMLBuffLen;
    long    lXMLFileLen;
    long    bLoadFile;

    /* Call the file loader and check the result */
    bLoadFile = LoadFile(lpszXMLFileName, lplpszXMLBuff,
                         &lXMLBuffLen, &lXMLFileLen, bLogMsgs);
    if(FAILURE == bLoadFile)
    {
        return FAILURE;
    }

    RemoveXmlWhiteSpace(lplpszXMLBuff, lplXMLDataLen, lXMLFileLen);
    
    /* Tell the world what we did if allowed to */
    if(bLogMsgs)
    {
        if(kpMCB->lpCIB->lpTestLogFile)
        {
            LogMsg(12, lpszXMLFileName, lXMLFileLen, *lplXMLDataLen);
        }
        else
        {
            ConsoleMsg(12, lpszXMLFileName, lXMLFileLen, *lplXMLDataLen);
        }
    }
    return SUCCESS;
}


/*==========================================================================*/
/* FUNCTION:                                                                */
/*     LoadLIBFromFile                                                      */
/*                                                                          */
/* PURPOSE:                                                                 */
/*     Load a LIB from an ListFile.                                         */
/*                                                                          */
/* INPUT PARAMETERS                                                         */
/*     lpTIB         Pointer to a Test Info block                           */ 
/*     lplpLIB       Pointer to a pointer to a LIB                          */
/*     lpszFileName  Pointer to the name of the file containing the List    */
/*     lpszDir       Pointer to the name of the files directory             */
/*                                                                          */
/* RETURN VALUE                                                             */
/*     SUCCESS or FAILURE                                                   */
/*==========================================================================*/
void
LoadLIBFromFile(TestInfoBlk* lpTIB, ListInfoBlk** lplpLIB,
                char* lpszFileName, char* lpszDir)
{
    char  lpszExtraInfo[EXTRA_MSG_INFO_LEN + 4];
    char  lpszDirAndFile[FILE_BUFF_LEN + 4];
    char* lpszLIBBuff;
    char* lpszStartOfLine;
    char* lpszCurrChar;
    char* lpszMax;
    long  lCurrLineLen;
    long  lLIBBuffLen;
    long  lLIBDataLen;
    long  bLoadFile;

    /* If we already have a LIB then free it */
    if(*lplpLIB)
    {
        FreeLIB(&(*lplpLIB));
    }

    /* Clear the pointer until file is successfully loaded */
    *lplpLIB = NULL;

    /* Generate full path file name for loading */
    memset(lpszDirAndFile, 0x00, FILE_BUFF_LEN + 4);
    strncpy(lpszDirAndFile, lpszDir, FILE_BUFF_LEN);
    strcat(lpszDirAndFile, kpszDirFileConcat);
    strncat(lpszDirAndFile, lpszFileName, FILE_BUFF_LEN);

    /* See if we can load the file */
    lpszLIBBuff = NULL;
    bLoadFile = LoadFile(lpszDirAndFile, &lpszLIBBuff, &lLIBBuffLen,
                         &lLIBDataLen, FALSE);
    if(FAILURE == bLoadFile)
    {
        sprintf(lpszExtraInfo, "Get ListFile=%s failed\0", lpszDirAndFile);
        LogMsg(TEST_EXTRA_LINE_ERR, lpTIB->lTestNum, lpszExtraInfo);
        lpTIB->bCmdResult = FAILURE;
        return;
    }

    /* Got the List data file */
    sprintf(lpszExtraInfo, "List data loaded. File=%s\0", lpszDirAndFile);
    LogMsg(TEST_EXTRA_LINE, lpTIB->lTestNum, lpszExtraInfo);

    /* Now extract the list elements from it */
    /* Initialise various pointers and counters */
    lpszStartOfLine = lpszLIBBuff;
    lpszCurrChar = lpszLIBBuff;
    lpszMax = lpszLIBBuff + lLIBDataLen;
    lCurrLineLen = 0;

    /* Process the buffer character by character until we run out */
    while(lpszCurrChar < lpszMax)
    {
        /* Got a CR or a LF then we have reached the end of the line */
        if(('\r' == *lpszCurrChar) ||
           ('\n' == *lpszCurrChar))
        {
            *lpszCurrChar = '\0';
            if(0 < lCurrLineLen)
            {
                AddLEB(kpMCB->lpLIB, lpszStartOfLine);
            }
            lpszStartOfLine = lpszCurrChar + 1;
            lCurrLineLen = 0;
        }
        else
        {
            lCurrLineLen++;
        }
        lpszCurrChar++;
    }
    if(0 < lCurrLineLen)
    {
        AddLEB(kpMCB->lpLIB, lpszStartOfLine);
    }

    /* All ok so far so create the List info block */
    *lplpLIB = CreateListInfoBlk(TRUE);
}


/*==========================================================================*/
/* FUNCTION:                                                                */
/*     LoadMIBFromFile                                                      */
/*                                                                          */
/* PURPOSE:                                                                 */
/*     Load a MIB from an MQMDFile.                                         */
/*                                                                          */
/* INPUT PARAMETERS                                                         */
/*     lpTIB         Pointer to a Test Info block                           */ 
/*     lplpMIB       Pointer to a pointer to a MIB                          */
/*     lpszFileName  Pointer to the name of the file containing and MQMD    */
/*     lpszDir       Pointer to the name of the files directory             */
/*                                                                          */
/* RETURN VALUE                                                             */
/*     SUCCESS or FAILURE                                                   */
/*==========================================================================*/
void
LoadMIBFromFile(TestInfoBlk* lpTIB, MQMDInfoBlk** lplpMIB,
                char* lpszFileName, char* lpszDir)
{
    char            lpszExtraInfo[EXTRA_MSG_INFO_LEN + 4];
    char            lpszDirAndFile[FILE_BUFF_LEN + 4];
    long            bLoadFile;
    long            bParseFile;

    /* If we already have a MIB then free it */
    if(*lplpMIB)
    {
        FreeMIB(&(*lplpMIB));
    }

    /* Clear the pointer until file is successfully loaded */
    *lplpMIB = NULL;

    /* Generate full path file name for loading */
    memset(lpszDirAndFile, 0x00, FILE_BUFF_LEN + 4);
    strncpy(lpszDirAndFile, lpszDir, FILE_BUFF_LEN);
    strcat(lpszDirAndFile, kpszDirFileConcat);
    strncat(lpszDirAndFile, lpszFileName, FILE_BUFF_LEN);

    /* See if we can load the file */
    bLoadFile = LoadXMLFile(lpszDirAndFile,
                            &kpMCB->lpSPB->lpszCtrlBlkBuff,
                            &kpMCB->lpSPB->lCtrlBlkXmlLen, FALSE);
    if(FAILURE == bLoadFile)
    {
        sprintf(lpszExtraInfo, "Get MQMDFile=%s failed\0", lpszDirAndFile);
        LogMsg(TEST_EXTRA_LINE_ERR, lpTIB->lTestNum, lpszExtraInfo);
        lpTIB->bCmdResult = FAILURE;
        return;
    }

    /* Got the MQMD data file */
    sprintf(lpszExtraInfo, "MQMD data loaded. File=%s\0", lpszDirAndFile);
    LogMsg(TEST_EXTRA_LINE, lpTIB->lTestNum, lpszExtraInfo);

    /* Clean up any memory assigned to control block file name */
    /* before setting its value                                */
    FreeIfNotNull((void**)&kpMCB->lpSPB->lpszCtrlBlkFileName);
    kpMCB->lpSPB->lpszCtrlBlkFileName = CloneString(lpszFileName);

    /* Now parse it */
    bParseFile = ParseCtrlBlk(lpTIB, "MQMD\0");
    if((FAILURE == bParseFile) || (FAILURE == lpTIB->bCmdResult))
    {
        sprintf(lpszExtraInfo, "Parse of MQMD data failed. File=%s\0", lpszDirAndFile);
        LogMsg(TEST_EXTRA_LINE_ERR, lpTIB->lTestNum, lpszExtraInfo);
        lpTIB->bCmdResult = FAILURE;
        return;
    }

    /* All ok so far so create the MQMD info block */
    *lplpMIB = CreateMQMDInfoBlk(TRUE);
}


/*==========================================================================*/
/* FUNCTION:                                                                */
/*     LoadRIBFromFile                                                      */
/*                                                                          */
/* PURPOSE:                                                                 */
/*     Load a RIB from an RFH2File.                                         */
/*                                                                          */
/* INPUT PARAMETERS                                                         */
/*     lpTIB         Pointer to a Test Info block                           */ 
/*     lplpRIB       Pointer to a pointer to a RIB                          */
/*     lpszFileName  Pointer to the name of the file containing and RFH2    */
/*     lpszDir       Pointer to the name of the files directory             */
/*                                                                          */
/* RETURN VALUE                                                             */
/*     SUCCESS or FAILURE                                                   */
/*==========================================================================*/
void
LoadRIBFromFile(TestInfoBlk* lpTIB, RFH2InfoBlk** lplpRIB,
                char* lpszFileName, char* lpszDir)
{
    char            lpszExtraInfo[EXTRA_MSG_INFO_LEN + 4];
    char            lpszDirAndFile[FILE_BUFF_LEN + 4];
    long            bLoadFile;
    long            bParseFile;

    /* If we already have a RIB then free it */
    if(*lplpRIB)
    {
        FreeRIB(&(*lplpRIB));
    }

    /* Clear the pointer until file is successfully loaded */
    *lplpRIB = NULL;

    /* Generate full path file name for loading */
    memset(lpszDirAndFile, 0x00, FILE_BUFF_LEN + 4);
    strncpy(lpszDirAndFile, lpszDir, FILE_BUFF_LEN);
    strcat(lpszDirAndFile, kpszDirFileConcat);
    strncat(lpszDirAndFile, lpszFileName, FILE_BUFF_LEN);

    /* See if we can load the file */
    bLoadFile = LoadXMLFile(lpszDirAndFile,
                            &kpMCB->lpSPB->lpszCtrlBlkBuff,
                            &kpMCB->lpSPB->lCtrlBlkXmlLen, FALSE);
    if(FAILURE == bLoadFile)
    {
        sprintf(lpszExtraInfo, "Get RFH2File=%s failed\0", lpszDirAndFile);
        LogMsg(TEST_EXTRA_LINE_ERR, lpTIB->lTestNum, lpszExtraInfo);
        lpTIB->bCmdResult = FAILURE;
        return;
    }

    /* Got the RFH2 data file */
    sprintf(lpszExtraInfo, "RFH2 data loaded. File=%s\0", lpszDirAndFile);
    LogMsg(TEST_EXTRA_LINE, lpTIB->lTestNum, lpszExtraInfo);

    /* Clean up any memory assigned to control block file name */
    /* before setting its value                                */
    FreeIfNotNull((void**)&kpMCB->lpSPB->lpszCtrlBlkFileName);
    kpMCB->lpSPB->lpszCtrlBlkFileName = CloneString(lpszFileName);

    /* Now parse it */
    bParseFile = ParseCtrlBlk(lpTIB, "RFH2\0");
    if((FAILURE == bParseFile) || (FAILURE == lpTIB->bCmdResult))
    {
        sprintf(lpszExtraInfo, "Parse of RFH2 data failed. File=%s\0", lpszDirAndFile);
        LogMsg(TEST_EXTRA_LINE_ERR, lpTIB->lTestNum, lpszExtraInfo);
        lpTIB->bCmdResult = FAILURE;
        return;
    }

    /* All ok so far so create the RFH2 info block */
    *lplpRIB = CreateRFH2InfoBlk(TRUE, NULL);
}


/*==========================================================================*/
/* FUNCTION:                                                                */
/*     OpenLogFile                                                          */
/*                                                                          */
/* PURPOSE:                                                                 */
/*     Open the log file.                                                   */
/*                                                                          */
/* INPUT PARAMETERS                                                         */
/*     N/A                                                                  */
/*                                                                          */
/* RETURN VALUE                                                             */
/*     SUCCESS or FAILURE                                                   */
/*==========================================================================*/
long
OpenLogFile()
{
    ControlInfoBlk* lpCIB;
    char*           lpszLogFileName;
    long            lLogFileNameLen;

    /* Initialise local variables */
    lpCIB = kpMCB->lpCIB;
    lpszLogFileName = NULL;
    lLogFileNameLen = 0;

    /* If the user specified a test log file name of NONE */
    /* then logging is to be suppressed                   */
    if(0 == memcmp(lpCIB->lpszTestLogFileName, kpszNONE, strlen(kpszNONE) + 1))
    {
        ConsoleMsg(27);
        return SUCCESS;
    }

    /* Concatenate directory and log names so we can open the file */
    lLogFileNameLen = StrlenNull(lpCIB->lpszTestLogDir) +
                      StrlenNull(lpCIB->lpszTestLogFileName) + 8;
    lpszLogFileName = malloc(lLogFileNameLen);
    if(! lpszLogFileName)
    {
        ConsoleMsg(3, lLogFileNameLen, "LogFileName", __LINE__, __FILE__);
        kpMCB->lProcessing = FAILURE;
        return FAILURE;
    }
    memset(lpszLogFileName, 0x00, lLogFileNameLen);
    if(0 < StrlenNull(lpCIB->lpszTestLogDir))
    {
        strcpy(lpszLogFileName, lpCIB->lpszTestLogDir);
        strcat(lpszLogFileName, kpszDirFileConcat);
    }
    strcat(lpszLogFileName, lpCIB->lpszTestLogFileName);

    /* Attempt to open the log file */
    if(TRUE == lpCIB->bTestLogAppend)
    {
        lpCIB->lpTestLogFile = fopen(lpszLogFileName, "a+");
    }
    else
    {
        lpCIB->lpTestLogFile = fopen(lpszLogFileName, "w+");
    }
    if(! lpCIB->lpTestLogFile)
    {
        /* Failed so tell the world */
        ConsoleMsg(5, "TestLog.File", lpszLogFileName, errno);
        FreeIfNotNull((void**)&lpszLogFileName);
        return FAILURE;
    }

    /* Succeeded so tell the world and write the initialisation */
    /* message to the report file */
    LogMsg(1, kpMCB->lpszTimeBuff, __DATE__, __TIME__);
    ConsoleMsg(28, lpszLogFileName);
    LogMsg(28, lpszLogFileName);
    FreeIfNotNull((void**)&lpszLogFileName);
    return SUCCESS;
}


/*==========================================================================*/
/* FUNCTION:                                                                */
/*     OpenReportFile                                                       */
/*                                                                          */
/* PURPOSE:                                                                 */
/*     Open the Report file.                                                */
/*                                                                          */
/* INPUT PARAMETERS                                                         */
/*     N/A                                                                  */
/*                                                                          */
/* RETURN VALUE                                                             */
/*     SUCCESS or FAILURE                                                   */
/*==========================================================================*/
long
OpenReportFile()
{
    ControlInfoBlk* lpCIB;
    char*           lpszReportFileName;
    long            lReportFileNameLen;

    /* Initialise local variables */
    lpCIB = kpMCB->lpCIB;
    lpszReportFileName = NULL;
    lReportFileNameLen = 0;

    /* If the user specified a test report file name of NONE */
    /* then reporting is to be suppressed                    */
    if(0 == memcmp(lpCIB->lpszTestReportFileName, kpszNONE, strlen(kpszNONE) + 1))
    {
        ConsoleMsg(238);
        return SUCCESS;
    }

    /* Concatenate directory and report names so we can open the file */
    lReportFileNameLen = StrlenNull(lpCIB->lpszTestReportDir) +
                         StrlenNull(lpCIB->lpszTestReportFileName) + 8;
    lpszReportFileName = malloc(lReportFileNameLen);
    if(! lpszReportFileName)
    {
        ConsoleMsg(3, lReportFileNameLen, "ReportFileName", __LINE__, __FILE__);
        kpMCB->lProcessing = FAILURE;
        return FAILURE;
    }
    memset(lpszReportFileName, 0x00, lReportFileNameLen);
    if(0 < StrlenNull(lpCIB->lpszTestReportDir))
    {
        strcpy(lpszReportFileName, lpCIB->lpszTestReportDir);
        strcat(lpszReportFileName, kpszDirFileConcat);
    }
    strcat(lpszReportFileName, lpCIB->lpszTestReportFileName);

    /* Attempt to open the report file */
    if(TRUE == lpCIB->bTestReportAppend)
    {
        lpCIB->lpTestReportFile = fopen(lpszReportFileName, "a+");
    }
    else
    {
        lpCIB->lpTestReportFile = fopen(lpszReportFileName, "w+");
    }
    if(! lpCIB->lpTestReportFile)
    {
        /* Failed so tell the world */
        ConsoleMsg(5, "TestReport.File", lpszReportFileName, errno);
        FreeIfNotNull((void**)&lpszReportFileName);
        return FAILURE;
    }

    /* Succeeded so tell the world and write the initialisation */
    /* message to the report file */
    ReportMsg(1, kpMCB->lpszTimeBuff, __DATE__, __TIME__);
    ConsoleMsg(30, lpszReportFileName);
    LogMsg(30, lpszReportFileName);
    ReportMsg(30, lpszReportFileName);
    FreeIfNotNull((void**)&lpszReportFileName);
    return SUCCESS;
}


/*==========================================================================*/
/* FUNCTION:                                                                */
/*     OpenUserLogFile                                                      */
/*                                                                          */
/* PURPOSE:                                                                 */
/*     Open the user log file if there is one.                              */
/*                                                                          */
/* INPUT PARAMETERS                                                         */
/*     N/A                                                                  */
/*                                                                          */
/* RETURN VALUE                                                             */
/*     SUCCESS or FAILURE                                                   */
/*==========================================================================*/
long
OpenUserLogFile()
{
    ControlInfoBlk* lpCIB;
    char*           lpszUserLogFileName;
    long            lUserLogFileNameLen;

    /* Initialise local variables */
    lpCIB = kpMCB->lpCIB;
    lpszUserLogFileName = NULL;
    lUserLogFileNameLen = 0;

    /* If there is no user log file directory or file then */
    /* User logging which is optional is not required for  */
    /* execution of this script                            */
    if((NULL == lpCIB->lpszTestUserLogDir) ||
       (NULL == lpCIB->lpszTestUserLogFileName))
    {
        return SUCCESS;
    }

    /* If the user specified a test user log file name of NONE */
    /* then logging is to be suppressed                   */
    if(0 == memcmp(lpCIB->lpszTestUserLogFileName, kpszNONE, strlen(kpszNONE) + 1))
    {
        ConsoleMsg(157);
        return SUCCESS;
    }

    /* Concatenate directory and log names so we can open the file */
    lUserLogFileNameLen = StrlenNull(lpCIB->lpszTestUserLogDir) +
                      StrlenNull(lpCIB->lpszTestUserLogFileName) + 8;
    lpszUserLogFileName = malloc(lUserLogFileNameLen);
    if(! lpszUserLogFileName)
    {
        ConsoleMsg(3, lUserLogFileNameLen, "UserLogFileName", __LINE__, __FILE__);
        kpMCB->lProcessing = FAILURE;
        return FAILURE;
    }
    memset(lpszUserLogFileName, 0x00, lUserLogFileNameLen);
    strcpy(lpszUserLogFileName, lpCIB->lpszTestUserLogDir);
    strcat(lpszUserLogFileName, kpszDirFileConcat);
    strcat(lpszUserLogFileName, lpCIB->lpszTestUserLogFileName);

    /* Attempt to open the log file */
    if(TRUE == lpCIB->bTestUserLogAppend)
    {
        lpCIB->lpTestUserLogFile = fopen(lpszUserLogFileName, "a+");
    }
    else
    {
        lpCIB->lpTestUserLogFile = fopen(lpszUserLogFileName, "w+");
    }
    if(! lpCIB->lpTestUserLogFile)
    {
        /* Failed so tell the world */
        ConsoleMsg(5, "TestUserLog.File", lpszUserLogFileName, errno);
        FreeIfNotNull((void**)&lpszUserLogFileName);
        return FAILURE;
    }

    /* Succeeded so tell the world and write the initialisation */
    /* message to the report file */
    UserLogMsg(1, kpMCB->lpszTimeBuff, __DATE__, __TIME__);
    ConsoleMsg(158, lpszUserLogFileName);
    LogMsg(158, lpszUserLogFileName);
    FreeIfNotNull((void**)&lpszUserLogFileName);
    return SUCCESS;
}


/*==========================================================================*/
/* FUNCTION:                                                                */
/*     OpenIntervalFile                                                     */
/*                                                                          */
/* PURPOSE:                                                                 */
/*     Open the interval file.                                              */
/*                                                                          */
/* INPUT PARAMETERS                                                         */
/*     lpIIB Pointer to the interval info block                             */
/*                                                                          */
/* RETURN VALUE                                                             */
/*     SUCCESS or FAILURE                                                   */
/*==========================================================================*/
long
OpenIntervalFile(IntervalInfoBlk* lpIIB)
{
    ControlInfoBlk* lpCIB;
    char*           lpszIntervalFileName;
    long            lIntervalFileNameLen;

    /* Initialise local variables */
    lpCIB = kpMCB->lpCIB;
    lpszIntervalFileName = NULL;
    lIntervalFileNameLen = 0;

    /* If the user specified a test interval file name prefix of NONE   */
    /* then the writing of interval records to file is to be suppressed */
    if(0 == memcmp(lpCIB->lpszTestIntervalFilePrefix, kpszNONE, strlen(kpszNONE) + 1))
    {
        ConsoleMsg(121);
        return SUCCESS;
    }

    /* Concatenate directory and Interval names so we can open the file */
    lIntervalFileNameLen = StrlenNull(lpCIB->lpszTestIntervalDir) +
                           StrlenNull(lpCIB->lpszTestIntervalFilePrefix) + 
                           StrlenNull(lpIIB->lpszIntervalName) +
                           StrlenNull(lpCIB->lpszTestIntervalFileExtension) + 16;
    lpszIntervalFileName = malloc(lIntervalFileNameLen);
    if(! lpszIntervalFileName)
    {
        ConsoleMsg(3, lIntervalFileNameLen, "IntervalFileName", __LINE__, __FILE__);
        kpMCB->lProcessing = FAILURE;
        return FAILURE;
    }
    memset(lpszIntervalFileName, 0x00, lIntervalFileNameLen);
    strcpy(lpszIntervalFileName, lpCIB->lpszTestIntervalDir);
    strcat(lpszIntervalFileName, kpszDirFileConcat);
    strcat(lpszIntervalFileName, lpCIB->lpszTestIntervalFilePrefix);
    strcat(lpszIntervalFileName, lpIIB->lpszIntervalName);
    strcat(lpszIntervalFileName, kpszDOT);
    strcat(lpszIntervalFileName, lpCIB->lpszTestIntervalFileExtension);

    /* Attempt to open the Interval file */
    if(TRUE == lpCIB->bTestIntervalAppend)
    {
        lpIIB->lpIntervalFile = fopen(lpszIntervalFileName, "a+");
    }
    else
    {
        lpIIB->lpIntervalFile = fopen(lpszIntervalFileName, "w+");
    }
    if(! lpIIB->lpIntervalFile)
    {
        /* Failed so tell the world */
        ConsoleMsg(5, "TestInterval.File", lpszIntervalFileName, errno);
        FreeIfNotNull((void**)&lpszIntervalFileName);
        kpMCB->lProcessing = FAILURE;
        return FAILURE;
    }
    lpIIB->bHaveIntervalFile = TRUE;

    /* Succeeded so tell the world */
    /* message to the report file */
    ConsoleMsg(122, lpszIntervalFileName);
    LogMsg(122, lpszIntervalFileName);
    FreeIfNotNull((void**)&lpszIntervalFileName);
    return SUCCESS;
}


/*==========================================================================*/
/* FUNCTION:                                                                */
/*     WriteIntervalRecord                                                  */
/*                                                                          */
/* PURPOSE:                                                                 */
/*     Write an interval record out to the file                             */
/*                                                                          */
/* INPUT PARAMETERS                                                         */
/*     lpIIB Pointer to the interval info block                             */
/*                                                                          */
/* RETURN VALUE                                                             */
/*     SUCCESS or FAILURE                                                   */
/*==========================================================================*/
long
WriteIntervalRecord(IntervalInfoBlk* lpIIB, IntervalInfoRec* lpIIR)
{
    ControlInfoBlk* lpCIB;
    long            lFPrintfResult;
    double          dStart;
    double          dEnd;
    double          dInterval;
    double          dRunSeconds;
    double          dRemainder;
    time_t          oCurrentTime;
    struct tm*      poTimeTm ;
    char            lpszTimeBuff[TIME_BUFF_LEN + 4];
    char            lpszRemainderBuff[TIME_BUFF_LEN + 4];
    char*           lpszDelim;
    
    /* Initialise local variables */
    lpCIB = kpMCB->lpCIB;
    lpszDelim = lpCIB->lpszTestIntervalDelimiter;

    /* Calculate interval information */
    CalcInterval(lpIIR, &dStart, &dEnd, &dInterval, &dRunSeconds);

    /* Calculate current time using dRunSeconds */
    oCurrentTime = kpMCB->oRunStart + (long)floor(dRunSeconds);
    poTimeTm = localtime(&oCurrentTime);
    memset(lpszTimeBuff, 0x00, TIME_BUFF_LEN + 4);
    strftime(lpszTimeBuff, TIME_BUFF_LEN, "%H:%M:%S.", poTimeTm);

    /* Calculate the remainder and append it to the time */
    dRemainder = dRunSeconds - floor(dRunSeconds);
    memset(lpszRemainderBuff, 0x00, TIME_BUFF_LEN + 4);
    sprintf(lpszRemainderBuff, "%0.3lf", dRemainder);
    strcat(lpszTimeBuff, lpszRemainderBuff + 2);

    /* Now write the formatted message into the actual interval file */
    fprintf(lpIIB->lpIntervalFile, "%s%s%lf%s%lf%s%lf\n", lpszTimeBuff, lpszDelim, dStart, lpszDelim, dEnd, lpszDelim, dInterval);

    /* Check to see if an error occured */
    lFPrintfResult = ferror(lpIIB->lpIntervalFile);
    if(0 != lFPrintfResult)
    {
        LogMsg(124, lpIIB->lpszIntervalName, lFPrintfResult);
        kpMCB->lProcessing = FAILURE;
        return FAILURE;
    }

    /* Make sure the file buffer is flushed before returning */
    fflush(lpIIB->lpIntervalFile);
    return SUCCESS;
}

