/*==========================================================================*/
/* nlinfo.c Display the local code page name                                */
/*==========================================================================*/
/* (C) Copyright Tim Armstrong 2005, 2006, 2007                             */
/*==========================================================================*/
/* Includes                                                                 */
/*==========================================================================*/
#ifndef __TJAINC_NLINFO_H

#ifdef WIN32
#include <wtypes.h>
#include <winbase.h>
#else
#include <unistd.h>
#include <locale.h>
#include <langinfo.h>
#endif /* WIN32 */

#ifndef __TJAINC_CTYPE_H
#define __TJAINC_CTYPE_H
#include <ctype.h>
#endif /* __TJAINC_CTYPE_H */

#ifndef __TJAINC_STDIO_H
#define __TJAINC_STDIO_H
#include <stdio.h>
#endif /* __TJAINC_STDIO_H */

#ifndef __TJAINC_STDLIB_H
#define __TJAINC_STDLIB_H
#include <stdlib.h>
#endif /* __TJAINC_STDLIB_H */

#ifndef __TJAINC_STRING_H
#define __TJAINC_STRING_H
#include <string.h>
#endif /* __TJAINC_STRING_H */

#endif /* __TJAINC_NLINFO_H */

/*==========================================================================*/
/* Defines                                                                  */
/*==========================================================================*/
#define CODESET_BUFF_LEN      32


/*==========================================================================*/
/* Mainline:                                                                */
/* Display the name of the local code page/s                                */
/*==========================================================================*/
int
main(int argc, char** argv)
{
    char    lpszCodeSetBuff[CODESET_BUFF_LEN + 4];
	
    /* Initialise local variables and buffers */
    memset(lpszCodeSetBuff, 0x00, CODESET_BUFF_LEN + 4);
	
    /* Now get the character form of the local code page setting */
#ifdef WIN32
    GetLocaleInfo(LOCALE_SYSTEM_DEFAULT, LOCALE_IDEFAULTCODEPAGE, lpszCodeSetBuff, CODESET_BUFF_LEN);
    printf("System CodePage=\"%s\"\n", lpszCodeSetBuff);
    memset(lpszCodeSetBuff, 0x00, CODESET_BUFF_LEN + 4);
    GetLocaleInfo(LOCALE_USER_DEFAULT, LOCALE_IDEFAULTCODEPAGE, lpszCodeSetBuff, CODESET_BUFF_LEN);
    printf("User CodePage=\"%s\"\n", lpszCodeSetBuff);
#else
    setlocale(LC_CTYPE, "");
    printf("CodePage=\"%s\"\n", nl_langinfo(CODESET));
#endif /* WIN32 */
	
    return 0;
}
