/*==========================================================================*/
/* MsgTestRun.c contains the test and command execution routines.           */
/*==========================================================================*/
/* (C) Copyright Tim Armstrong 2003, 2004, 2005, 2006, 2007, 2008           */
/*==========================================================================*/
/* Includes                                                                 */
/*==========================================================================*/
#ifndef __TJAINC_MSGTEST_H
#include "MsgTest.h"
#endif /* __TJAINC_MSGTEST_H */

#ifndef __TJAINC_MSGTESTSTATICAV_H
#include "MsgTestStaticAV.h"
#endif /* __TJAINC_MSGTESTSTATICAV_H */

#ifndef __TJAINC_MSGTESTSTATICMD_H
#include "MsgTestStaticMD.h"
#endif /* __TJAINC_MSGTESTSTATICMD_H */


/*==========================================================================*/
/* Static variables                                                         */
/*==========================================================================*/
/* Command names */
static char* kpszGETFILE =                  "GetFile\0";
static char* kpszPUTFILE =                  "PutFile\0";
static char* kpszINLINEDATA =               "InlineData\0";
static char* kpszOVERLAY =                  "Overlay\0";
static char* kpszEXTRACT =                  "Extract\0";
static char* kpszSUBSTRING =                "Substring\0";
static char* kpszGETMSG =                   "GetMsg\0";
static char* kpszPUTMSG =                   "PutMsg\0";
static char* kpszSELECT =                   "Select\0";
static char* kpszWAITONMSGDEPTH =           "WaitOnMsgDepth\0";
static char* kpszWAITONTIME =               "WaitOnTime\0";
static char* kpszCOMPARE =                  "Compare\0";
static char* kpszCOMMIT =                   "Commit\0";
static char* kpszBACKOUT =                  "Backout\0";
static char* kpszSYSTEM =                   "System\0";
static char* kpszMQSCCOMMAND =              "MqscCommand\0";
static char* kpszFORSTART =                 "For(Start)\0";
static char* kpszFOREVERSTART =             "ForEver(Start)\0";
static char* kpszFOREACHSTART =             "ForEach(Start)\0";
static char* kpszFOREND =                   "For(End)  \0";
static char* kpszFOREVEREND =               "ForEver(End)  \0";
static char* kpszFOREACHEND =               "ForEach(End)  \0";
static char* kpszFORUNKNOWN =               "UnknownForCmd\0";
static char* kpszIFSTART =                  "If(Start)\0";
static char* kpszELSEIF =                   "ElseIf\0";
static char* kpszELSE =                     "Else\0";
static char* kpszIFEND =                    "If(End)\0";
static char* kpszCONTINUE =                 "Continue\0";
static char* kpszBREAK =                    "Break\0";
static char* kpszEXITTEST =                 "ExitTest\0";
static char* kpszFAILTEST =                 "FailTest\0";
static char* kpszFINALLYSTART =             "FinallyStart\0";
static char* kpszFINALLYEND =               "FinallyEnd\0";
static char* kpszINTERVALSTART =            "IntervalStart\0";
static char* kpszINTERVALEND =              "IntervalEnd\0";
static char* kpszUNKNOWNVARCMD =            "UnknownVarCmd\0";
static char* kpszNUM =                      "Num\0";
static char* kpszDOUBLE =                   "Double\0";
static char* kpszSTR =                      "Str\0";
static char* kpszRANDOMNUM =                "RandomNum\0";
static char* kpszLIST =                     "List\0";
static char* kpszRFH2 =                     "RFH2\0";
static char* kpszSTDIN =                    "StdIn\0";
static char* kpszSTDOUT =                   "StdOut\0";
static char* kpszUSERLOG =                  "UserLog\0";
static char* kpszADD =                      "Add\0";
static char* kpszSUBTRACT =                 "Subtract\0";
static char* kpszMULTIPLY =                 "Multiply\0";
static char* kpszDIVIDE =                   "Divide\0";
static char* kpszEVAL =                     "Eval\0";
static char* kpszLENGTH =                   "Length\0";
static char* kpszPOSITION =                 "Position\0";
static char* kpszEmptyString =              "\0";
static char* kpszFATAL =                    "FATAL";
static char* kpszSTRFMT =                   "%s\0";
static char* kpszMSGT =                     "MsgT\0";
static char* kpszADDOP =                    "+\0";
static char* kpszSUBTRACTOP =               "-\0";
static char* kpszMULTIPLYOP =               "*\0";
static char* kpszDIVIDEOP =                 "/\0";
static char* kpszEVALOP =                   "Eval\0";
static char* kpszTEMPDATAVARBUFF =          "TempDataVarBuffer\0";
static char* kpszNONE =                     "NONE\0";
static char* kpszNULLS =                    "\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0";
static char* kpszUNKNOWN =                  "Unknown\0";
static char* kpszVARIABLE =                 "Variable\0";
static char* kpszBUFFER =                   "Buffer\0";
static char* kpszLOGANDCONTINUESUPPRESS =   "Compare error suppressed. LogAndContinue specified\0";
static char* kpszData =                     "Data=\"";
static char* kpszDataAtOffset =             "DataAtOffset=\"";

#ifdef WIN32
static char* kpszDirFileConcat =          "\\\0";
#else
static char* kpszDirFileConcat =          "/\0";
#endif /* WIN32 */


/*==========================================================================*/
/* FUNCTION:                                                                */
/*     PCRECallout                                                          */
/*                                                                          */
/* PURPOSE:                                                                 */
/*     Callout function for PCRE. Helps find compare error offsets          */
/*                                                                          */
/* INPUT PARAMETERS                                                         */
/*     lpPCB              Pointer to PCRE Callout Block                     */
/*                                                                          */
/* RETURN VALUE                                                             */
/*     0 Indicates successful callout                                       */
/*==========================================================================*/
static int
PCRECallout(pcre_callout_block* lpPCB)
{
    CompareBlk*     lpCMB;

    lpCMB = (CompareBlk*)lpPCB->callout_data;

    lpCMB->bCallOutMade = TRUE;
    lpCMB->lSubjectCurrPos = lpPCB->current_position;
    lpCMB->lPatternCurrPos = lpPCB->pattern_position;
    lpCMB->lPatternCurrItemLen = lpPCB->next_item_length;

    return 0;
}


/*==========================================================================*/
/* FUNCTION:                                                                */
/*     RunTests                                                             */
/*                                                                          */
/* PURPOSE:                                                                 */
/*     Run the tests                                                        */
/*                                                                          */
/* INPUT PARAMETERS                                                         */
/*     N/A                                                                  */
/*                                                                          */
/* RETURN VALUE                                                             */
/*     N/A                                                                  */
/*==========================================================================*/
void
RunTests()
{
    TestInfoBlk*      lpTIB;
    TestInfoBlk*      lpTIBNew;
    TestInfoBlk*      lpTIBNext;
    ForEndBlk*        lpFEB;
    time_t            oTimeT;
    struct tm*        poTimeTm ;
    char              lpszTimeBuff[TIME_BUFF_LEN + 4];

    /* Initialisation is now complete */
    kpMCB->bInitComplete = TRUE;

    /* If logging has been suppressed set a flag indicating this so info level */
    /* log information formatting can be bypassed where appropriate            */
    if(0 == kpMCB->lpCIB->lpTestLogFile)
    {
        kpMCB->bLoggingSuppressed = TRUE;
    }

    /* Spin until we are as near to the start of the next second as possible */
    /* then get the high resolution clock value for interval timestamps      */
    time(&oTimeT);
    time(&kpMCB->oRunStart);
    while(oTimeT == kpMCB->oRunStart)
    {
        time(&kpMCB->oRunStart);
        /* Keep handing control back to the operating sytem */
        /* rather than sitting in a full on loop            */
        SleepMillis(0);
    }
    GetClockCount(&kpMCB->i64RunStart);

    /* Generate the start time */
    memset(lpszTimeBuff, 0x00, TIME_BUFF_LEN + 4);
    time(&kpMCB->oRunStart);
    poTimeTm = localtime(&kpMCB->oRunStart);
    strftime(lpszTimeBuff, LOG_BUFF_LEN, "%H:%M:%S", poTimeTm );

    /* Let the user know testing has started */
    ConsoleMsg(75, lpszTimeBuff);
    if(NULL != kpMCB->lpCIB->lpTestLogFile)
    {
        LogMsg(75, lpszTimeBuff);
    }
    if(NULL != kpMCB->lpCIB->lpTestReportFile)
    {
        ReportMsg(75, lpszTimeBuff);
    }
    ReportMsg(107);

    /* Process each test on the active list replenishing it */
    /* from the ready list as each test completes           */
    kpMCB->bConcurrencyWait = TRUE;
    lpTIB = kpMCB->lpTIBActiveHead;
    while(NULL != lpTIB)
    {
        /* If the test is not empty process the current command */
        if(lpTIB->lpCCBCurr)
        {
            /* Save the init time for the command */
            if(S_INIT == lpTIB->lpCCBCurr->eCommandState)
            {
                GetClockCount(&lpTIB->i64CommandInit);
            }

            /* Process the current command. */
            switch(lpTIB->lpCCBCurr->eCommandType)
            {
            case C_GETFILE:
                lpTIB->bCmdResult = ExecuteGetFileCmd(lpTIB, lpTIB->lpCCBCurr);
                break;
            case C_PUTFILE:
                lpTIB->bCmdResult = ExecutePutFileCmd(lpTIB, lpTIB->lpCCBCurr);
                break;
            case C_INLINEDATA:
                lpTIB->bCmdResult = ExecuteInlineDataCmd(lpTIB, lpTIB->lpCCBCurr);
                break;
            case C_OVERLAY:
                lpTIB->bCmdResult = ExecuteOverlayCmd(lpTIB, lpTIB->lpCCBCurr);
                break;
            case C_EXTRACT:
                lpTIB->bCmdResult = ExecuteExtractCmd(lpTIB, lpTIB->lpCCBCurr);
                break;
            case C_SUBSTRING:
                lpTIB->bCmdResult = ExecuteSubstringCmd(lpTIB, lpTIB->lpCCBCurr);
                break;
            case C_GETMSG:
                lpTIB->bCmdResult = ExecuteGetMsgCmd(lpTIB, lpTIB->lpCCBCurr);
                break;
            case C_PUTMSG:
                lpTIB->bCmdResult = ExecutePutMsgCmd(lpTIB, lpTIB->lpCCBCurr);
                break;
            case C_SELECT:
                lpTIB->bCmdResult = ExecuteSelectCmd(lpTIB, lpTIB->lpCCBCurr);
                break;
            case C_WAITONMSGDEPTH:
                lpTIB->bCmdResult = ExecuteWaitOnMsgDepthCmd(lpTIB, lpTIB->lpCCBCurr);
                break;
            case C_WAITONTIME:
                lpTIB->bCmdResult = ExecuteWaitOnTimeCmd(lpTIB, lpTIB->lpCCBCurr);
                break;
            case C_COMPARE:
                lpTIB->bCmdResult = ExecuteCompareCmd(lpTIB, lpTIB->lpCCBCurr);
                break;
            case C_COMMIT:
                lpTIB->bCmdResult = ExecuteCommitCmd(lpTIB, lpTIB->lpCCBCurr);
                break;
            case C_BACKOUT:
                lpTIB->bCmdResult = ExecuteBackoutCmd(lpTIB, lpTIB->lpCCBCurr);
                break;
            case C_SYSTEM:
                lpTIB->bCmdResult = ExecuteSystemCmd(lpTIB, lpTIB->lpCCBCurr);
                break;
            case C_MQSCCOMMAND:
                lpTIB->bCmdResult = ExecuteMqscCommandCmd(lpTIB, lpTIB->lpCCBCurr);
                break;
            case C_FORSTART:
                lpTIB->bCmdResult = ExecuteForStartCmd(lpTIB, lpTIB->lpCCBCurr);
                break;
            case C_FOREND:
                lpTIB->bCmdResult = ExecuteForEndCmd(lpTIB, lpTIB->lpCCBCurr);
                break;
            case C_IFSTART:
                lpTIB->bCmdResult = ExecuteIfStartCmd(lpTIB, lpTIB->lpCCBCurr);
                break;
            case C_ELSEIF:
                lpTIB->bCmdResult = ExecuteElseIfCmd(lpTIB, lpTIB->lpCCBCurr);
                break;
            case C_ELSE:
                lpTIB->bCmdResult = ExecuteElseCmd(lpTIB, lpTIB->lpCCBCurr);
                break;
            case C_IFEND:
                lpTIB->bCmdResult = ExecuteIfEndCmd(lpTIB, lpTIB->lpCCBCurr);
                break;
            case C_CONTINUE:
                lpTIB->bCmdResult = ExecuteContinueCmd(lpTIB, lpTIB->lpCCBCurr);
                break;
            case C_BREAK:
                lpTIB->bCmdResult = ExecuteBreakCmd(lpTIB, lpTIB->lpCCBCurr);
                break;
            case C_EXITTEST:
                lpTIB->bCmdResult = ExecuteExitTestCmd(lpTIB, lpTIB->lpCCBCurr);
                break;
            case C_FAILTEST:
                lpTIB->bCmdResult = ExecuteFailTestCmd(lpTIB, lpTIB->lpCCBCurr);
                break;
            case C_FINALLYSTART:
                lpTIB->bCmdResult = ExecuteFinallyStartCmd(lpTIB, lpTIB->lpCCBCurr);
                break;
            case C_FINALLYEND:
                lpTIB->bCmdResult = ExecuteFinallyEndCmd(lpTIB, lpTIB->lpCCBCurr);
                break;
            case C_INTERVALSTART:
                lpTIB->bCmdResult = ExecuteIntervalStartCmd(lpTIB, lpTIB->lpCCBCurr);
                break;
            case C_INTERVALEND:
                lpTIB->bCmdResult = ExecuteIntervalEndCmd(lpTIB, lpTIB->lpCCBCurr);
                break;
            case C_VAR:
                lpTIB->bCmdResult = ExecuteVarCmd(lpTIB, lpTIB->lpCCBCurr);
                break;
            case C_MATH:
                lpTIB->bCmdResult = ExecuteMathCmd(lpTIB, lpTIB->lpCCBCurr);
                break;
            case C_LENGTH:
                lpTIB->bCmdResult = ExecuteLengthCmd(lpTIB, lpTIB->lpCCBCurr);
                break;
            case C_POSITION:
                lpTIB->bCmdResult = ExecutePositionCmd(lpTIB, lpTIB->lpCCBCurr);
                break;
            case C_STDIN:
                lpTIB->bCmdResult = ExecuteStdInCmd(lpTIB, lpTIB->lpCCBCurr);
                break;
            case C_STDOUT:
                lpTIB->bCmdResult = ExecuteStdOutCmd(lpTIB, lpTIB->lpCCBCurr);
                break;
            case C_USERLOG:
                lpTIB->bCmdResult = ExecuteUserLogCmd(lpTIB, lpTIB->lpCCBCurr);
                break;
            default:
                LogMsg(31, lpTIB->lpCCBCurr->eCommandType);
                kpMCB->lProcessing = FAILURE;
            }

            /* If something went seriously wrong stop any further processing */
            if(FAILURE == kpMCB->lProcessing)
            {
                LogMsg(37);
                ReportMsg(37);
                return;
            }

            /* Update the LastXXX automatic variables */
            SetAutoVar(lpTIB, lpTIB->lpVIBHead, kpszLASTCC, NULL);
            SetAutoVar(lpTIB, lpTIB->lpVIBHead, kpszLASTRC, NULL);
            SetAutoVar(lpTIB, lpTIB->lpVIBHead, kpszLASTDATALEN, NULL);
            SetAutoVar(lpTIB, lpTIB->lpVIBHead, kpszLASTFILE, NULL);
            SetAutoVar(lpTIB, lpTIB->lpVIBHead, kpszLASTDIR, NULL);
            SetAutoVar(lpTIB, lpTIB->lpVIBHead, kpszLASTQ, NULL);
            SetAutoVar(lpTIB, lpTIB->lpVIBHead, kpszLASTQMGR, NULL);

            /* Update the CurrentMessageRate automatic variable */
            SetAutoVar(lpTIB, lpTIB->lpVIBHead, kpszTESTCURRENTMSGRATE, NULL);

            /* Update the script and test basic statistics */
            SetAutoVar(lpTIB, lpTIB->lpVIBHead, kpszTESTTOTALGETFILE, NULL);
            SetAutoVar(lpTIB, lpTIB->lpVIBHead, kpszTESTSUCCESSFULGETFILE, NULL);
            SetAutoVar(lpTIB, lpTIB->lpVIBHead, kpszTESTFAILEDGETFILE, NULL);
            SetAutoVar(lpTIB, lpTIB->lpVIBHead, kpszTESTTOTALPUTFILE, NULL);
            SetAutoVar(lpTIB, lpTIB->lpVIBHead, kpszTESTSUCCESSFULPUTFILE, NULL);
            SetAutoVar(lpTIB, lpTIB->lpVIBHead, kpszTESTFAILEDPUTFILE, NULL);
            SetAutoVar(lpTIB, lpTIB->lpVIBHead, kpszTESTTOTALGETMSG, NULL);
            SetAutoVar(lpTIB, lpTIB->lpVIBHead, kpszTESTSUCCESSFULGETMSG, NULL);
            SetAutoVar(lpTIB, lpTIB->lpVIBHead, kpszTESTFAILEDGETMSG, NULL);
            SetAutoVar(lpTIB, lpTIB->lpVIBHead, kpszTESTTOTALPUTMSG, NULL);
            SetAutoVar(lpTIB, lpTIB->lpVIBHead, kpszTESTSUCCESSFULPUTMSG, NULL);
            SetAutoVar(lpTIB, lpTIB->lpVIBHead, kpszTESTFAILEDPUTMSG, NULL);
            SetAutoVar(lpTIB, lpTIB->lpVIBHead, kpszTESTTOTALCOMPARE, NULL);
            SetAutoVar(lpTIB, lpTIB->lpVIBHead, kpszTESTSUCCESSFULCOMPARE, NULL);
            SetAutoVar(lpTIB, lpTIB->lpVIBHead, kpszTESTFAILEDCOMPARE, NULL);
            SetAutoVar(lpTIB, lpTIB->lpVIBHead, kpszSCRIPTTOTALGETFILE, NULL);
            SetAutoVar(lpTIB, lpTIB->lpVIBHead, kpszSCRIPTSUCCESSFULGETFILE, NULL);
            SetAutoVar(lpTIB, lpTIB->lpVIBHead, kpszSCRIPTFAILEDGETFILE, NULL);
            SetAutoVar(lpTIB, lpTIB->lpVIBHead, kpszSCRIPTTOTALPUTFILE, NULL);
            SetAutoVar(lpTIB, lpTIB->lpVIBHead, kpszSCRIPTSUCCESSFULPUTFILE, NULL);
            SetAutoVar(lpTIB, lpTIB->lpVIBHead, kpszSCRIPTFAILEDPUTFILE, NULL);
            SetAutoVar(lpTIB, lpTIB->lpVIBHead, kpszSCRIPTTOTALGETMSG, NULL);
            SetAutoVar(lpTIB, lpTIB->lpVIBHead, kpszSCRIPTSUCCESSFULGETMSG, NULL);
            SetAutoVar(lpTIB, lpTIB->lpVIBHead, kpszSCRIPTFAILEDGETMSG, NULL);
            SetAutoVar(lpTIB, lpTIB->lpVIBHead, kpszSCRIPTTOTALPUTMSG, NULL);
            SetAutoVar(lpTIB, lpTIB->lpVIBHead, kpszSCRIPTSUCCESSFULPUTMSG, NULL);
            SetAutoVar(lpTIB, lpTIB->lpVIBHead, kpszSCRIPTFAILEDPUTMSG, NULL);
            SetAutoVar(lpTIB, lpTIB->lpVIBHead, kpszSCRIPTTOTALCOMPARE, NULL);
            SetAutoVar(lpTIB, lpTIB->lpVIBHead, kpszSCRIPTSUCCESSFULCOMPARE, NULL);
            SetAutoVar(lpTIB, lpTIB->lpVIBHead, kpszSCRIPTFAILEDCOMPARE, NULL);

            /* Check the state of the current command */
            switch(lpTIB->lpCCBCurr->eCommandState)
            {
            /* If the command has completed move on to the next command */
            /* or if the command and hence the test failed simulate     */
            /* reaching the end of the tests command list               */
            case S_NEXT:
                if(SUCCESS == lpTIB->bCmdResult)
                {
                    lpTIB->lpCCBCurr->eCommandState = S_INIT; /* Reset for loops */
                    lpTIB->lpCCBCurr = (CommandCtrlBlk*)lpTIB->lpCCBCurr->lpCCBNext;
                }
                else
                {
                    IfNextCmdIsUserLogThenExecute(lpTIB);
                    lpTIB->lpCCBCurr = FindFinallyCmd(lpTIB);
                }
                break;
            /* If the command failed check whether or not to terminate */
            /* all tests                                               */
            case S_FAILURE:
                if(0 == memcmp(kpMCB->lpCIB->lpszOnError, kpszFATAL, strlen(kpszFATAL) + 1))
                {
                    LogMsg(64, kpMCB->lpCIB->lpszOnError);
                    kpMCB->lFailedTests++;
                    kpMCB->lIncompleteTests--;
                    kpMCB->lProcessing = FAILURE;
                    return;
                }
                break;
            /* If its a Break or BreakOnRC condition and we are in a loop */
            /* complete the loop otherwise complete the test              */
            case S_BREAK:
                if(lpTIB->lpBreakContinueFSB)
                {
                    IfNextCmdIsUserLogThenExecute(lpTIB);
                    lpTIB->lpCCBCurr->eCommandState = S_INIT; /* Reset for loops */
                    lpFEB = (ForEndBlk*)lpTIB->lpBreakContinueFSB->lpForEndCmd;
                    lpFEB->eCommandState = S_COMPLETE;
                    lpTIB->lpCCBCurr = (CommandCtrlBlk*)lpFEB;
                }
                else
                {
                    IfNextCmdIsUserLogThenExecute(lpTIB);
                    lpTIB->lpCCBCurr = FindFinallyCmd(lpTIB);
                }
                break;
            /* If its a Continue or ContinueOnRC condition and we are in a loop */
            /* skip to the end of the loop otherwise complete the test          */
            case S_CONTINUE:
                if(lpTIB->lpBreakContinueFSB)
                {
                    IfNextCmdIsUserLogThenExecute(lpTIB);
                    lpTIB->lpCCBCurr->eCommandState = S_INIT; /* Reset for loops */
                    lpFEB = (ForEndBlk*)lpTIB->lpBreakContinueFSB->lpForEndCmd;
                    lpFEB->eCommandState = S_RUN;
                    lpTIB->lpCCBCurr = (CommandCtrlBlk*)lpFEB;
                }
                else
                {
                    IfNextCmdIsUserLogThenExecute(lpTIB);
                    lpTIB->lpCCBCurr = FindFinallyCmd(lpTIB);
                }
                break;
            }
        }

        /* Clear the TIB FSB pointer */
        lpTIB->lpBreakContinueFSB = NULL;

        /* Hold the pointer to the next test in case we free this TIB */
        lpTIBNext = (TestInfoBlk*)lpTIB->lpTIBNext;

        /* If there are no more commands for the current test */
        /* remove the test from the active list and get the   */
        /* next test from the read list                       */
        if(! lpTIB->lpCCBCurr)
        {
            /* Remove the test from the active list */
            RemoveFromList((LinkedListBlk**)&kpMCB->lpTIBActiveHead,
                           (LinkedListBlk**)&kpMCB->lpTIBActiveTail,
                           (LinkedListBlk*)lpTIB);
            /* Report the test basic statistics */
            if(TRUE == lpTIB->bTestHasGetFile)
            {
                LogMsg(162, lpTIB->lTestNum, lpTIB->lTestTotalGetFile,
                       lpTIB->lTestSuccessfulGetFile, lpTIB->lTestFailedGetFile);
                ReportMsg(162, lpTIB->lTestNum, lpTIB->lTestTotalGetFile,
                          lpTIB->lTestSuccessfulGetFile, lpTIB->lTestFailedGetFile);
            }
            if(TRUE == lpTIB->bTestHasPutFile)
            {
                LogMsg(164, lpTIB->lTestNum, lpTIB->lTestTotalPutFile,
                       lpTIB->lTestSuccessfulPutFile, lpTIB->lTestFailedPutFile);
                ReportMsg(164, lpTIB->lTestNum, lpTIB->lTestTotalPutFile,
                          lpTIB->lTestSuccessfulPutFile, lpTIB->lTestFailedPutFile);
            }
            if(TRUE == lpTIB->bTestHasGetMsg)
            {
                LogMsg(166, lpTIB->lTestNum, lpTIB->lTestTotalGetMsg,
                       lpTIB->lTestSuccessfulGetMsg, lpTIB->lTestFailedGetMsg);
                ReportMsg(166, lpTIB->lTestNum, lpTIB->lTestTotalGetMsg,
                          lpTIB->lTestSuccessfulGetMsg, lpTIB->lTestFailedGetMsg);
            }
            if(TRUE == lpTIB->bTestHasPutMsg)
            {
                LogMsg(168, lpTIB->lTestNum, lpTIB->lTestTotalPutMsg,
                       lpTIB->lTestSuccessfulPutMsg, lpTIB->lTestFailedPutMsg);
                ReportMsg(168, lpTIB->lTestNum, lpTIB->lTestTotalPutMsg,
                          lpTIB->lTestSuccessfulPutMsg, lpTIB->lTestFailedPutMsg);
            }
            if(TRUE == lpTIB->bTestHasCompare)
            {
                LogMsg(170, lpTIB->lTestNum, lpTIB->lTestTotalCompare,
                       lpTIB->lTestSuccessfulCompare, lpTIB->lTestFailedCompare);
                ReportMsg(170, lpTIB->lTestNum, lpTIB->lTestTotalCompare,
                          lpTIB->lTestSuccessfulCompare, lpTIB->lTestFailedCompare);
            }
            /* If a failed test result was reset for a <Finally> clause  */
            /* then change it back again for the final message and stats */
            if(TRUE == lpTIB->bFinallyResetFailedTest)
            {
                lpTIB->bCmdResult = FAILURE;
            }
            /* Log the result of the test */
            if(SUCCESS == lpTIB->bCmdResult)
            {
                LogMsg(36, lpTIB->lTestNum, lpTIB->lpszTestName);
                ReportMsg(36, lpTIB->lTestNum, lpTIB->lpszTestName);
                kpMCB->lSuccessfulTests++;
                kpMCB->lIncompleteTests--;
            }
            else
            {
                LogMsg(50, lpTIB->lTestNum, lpTIB->lpszTestName);
                ReportMsg(50, lpTIB->lTestNum, lpTIB->lpszTestName);
                kpMCB->lFailedTests++;
                kpMCB->lIncompleteTests--;
            }

            /* Free memory allocated to the test now its finished    */
            FreeTIB(&lpTIB);

            /* Get the next test if there is one from the ready list */
            /* and add it to the active list                         */
            lpTIBNew = kpMCB->lpTIBReadyHead;
            if(lpTIBNew)
            {
                RemoveFromList((LinkedListBlk**)&kpMCB->lpTIBReadyHead,
                               (LinkedListBlk**)&kpMCB->lpTIBReadyTail,
                               (LinkedListBlk*)lpTIBNew);
                AddToTailOfList((LinkedListBlk**)&kpMCB->lpTIBActiveHead,
                                (LinkedListBlk**)&kpMCB->lpTIBActiveTail,
                                (LinkedListBlk*)lpTIBNew);
                InitTimePidAutoVars(lpTIBNew, lpTIBNew->lpVIBHead);

                /* Test has been activated both log and report it */
                LogMsg(35, lpTIBNew->lTestNum, lpTIBNew->lpszTestName);
                ReportMsg(35, lpTIBNew->lTestNum, lpTIBNew->lpszTestName);
            }
        }

        /* Next test */
        lpTIB = lpTIBNext;

        /* Reached the end of the active list */
        if(! lpTIB)
        {
            /* Yes so start again */
            lpTIB = kpMCB->lpTIBActiveHead;
            /* If still nothing we've finished */
            if(! lpTIB)
            {
                break; /* while(NULL != lpTIB) */
            }
            /* Check the ConcurrencyWait flag if its still */
            /* TRUE then all the commands in all the tests */
            /* are waiting for some external event like    */
            /* the arrival of a file or a message.         */
            if(TRUE == kpMCB->bConcurrencyWait)
            {
                SleepMillis(kpMCB->lpCIB->lConcurrencyWait);
                kpMCB->lWaitTotal += kpMCB->lpCIB->lConcurrencyWait;
            }
            /* Reset the flag to true for the next round   */
            kpMCB->bConcurrencyWait = TRUE;
        }
    }
}


/*--------------------------------------------------------------------------*/
/* Command processing routines.                                             */
/*--------------------------------------------------------------------------*/
/* Although some commands can complete at once we deliberately progress     */
/* through all states to best imitate a threading environment. Also this    */
/* prevents apparently missing log entries for the different commands.      */
/*--------------------------------------------------------------------------*/
/* Most of the commands have similar processing requirements so only the    */
/* ExecuteGetFileCmd function has been fully documented. Where there is     */
/* significant variance in the other functions it is documented there.      */
/*--------------------------------------------------------------------------*/
long
ExecuteGetFileCmd(TestInfoBlk* lpTIB, CommandCtrlBlk* lpCCB)
{
    ControlInfoBlk* lpCIB;
    GetFileBlk*     lpGFB;
    MQMDInfoBlk*    lpMIB;
    RFH2InfoBlk*    lpRIB;
    VarInfoBlk*     lpVIB;
    IfStartBlk*     lpIFSCheck;
    CommandCtrlBlk* lpCCBCheckIf;
    char*           lpszCurrCmdName;
    char            lpszExtraInfo[EXTRA_MSG_INFO_LEN + 4];
    char            lpszDirAndFile[FILE_BUFF_LEN + 4];
    long            bLoadFile;
    long            lFileRC;
    long            lCmdMaxWait;
    time_t          oCurrTime;

    /* Initialise common use local variables */
    lpCIB = kpMCB->lpCIB;
    lpGFB = (GetFileBlk*)lpCCB;
    lpszCurrCmdName = kpszGETFILE;
    memset(lpszExtraInfo, 0x00, EXTRA_MSG_INFO_LEN + 4);

    /* Process according to current command state */
    switch(lpGFB->eCommandState)
    {
    case S_INIT:
        /* Tell the user we are intialising the GetFile command block */
        LogMsg(44, lpTIB->lTestNum, lpszCurrCmdName, "\0");

        /* Update test and script basic statistics for GetFile */
        lpTIB->lLastDataLen = 0;
        lpTIB->lTestTotalGetFile++;
        kpMCB->lScriptTotalGetFile++;

        /* Running an initialisation so set concurrency wait false. */
        kpMCB->bConcurrencyWait = FALSE;

        /* The ResolveValue function is called to handle any parameters */
        /* that might contain a variable e.g. the buffer name string    */
        /* might contain a substitutable portion %Buff%                 */
        ResolveValue(lpTIB, &lpGFB->lpszResBuffName, &lpGFB->lpszBuffName, TRUE);

        /* Problems with variable resolution time to give up     */
        if(FAILURE == lpTIB->bCmdResult)
        {
            SetTIBCodes(lpTIB, MTCC_FAIL, MTRC_INIT_RESOLVE_FAIL);
            lpTIB->lTestFailedGetFile++;
            kpMCB->lScriptFailedGetFile++;
            lpGFB->eCommandState = S_FAILURE;
            return FAILURE;
        }

        /* Get a pointer to a new/existing buffer information block */ 
        lpGFB->lpBIB = CheckAndAddBIB(lpTIB, lpGFB->lpszResBuffName);

        /* Had problems obtaining a BIB or its buffer so fail */
        if(! lpGFB->lpBIB)
        {
            sprintf(lpszExtraInfo, "Unable to locate/allocate BIB Buffer=%s\0",
                    lpGFB->lpszResBuffName);
            LogMsg(TEST_EXTRA_LINE_ERR, lpTIB->lTestNum, lpszExtraInfo);
            SetTIBCodes(lpTIB, MTCC_FAIL, MTRC_INIT_BUFF_FAIL);
            lpTIB->lTestFailedGetFile++;
            kpMCB->lScriptFailedGetFile++;
            lpGFB->eCommandState = S_FAILURE;
            return FAILURE;
        }

        /* Resolve variables */
        ResolveValue(lpTIB, &lpGFB->lpszResFileName, 
                     &lpGFB->lpszFileName, TRUE);
        ResolveValue(lpTIB, &lpGFB->lpszResMQMDFileName,
                     &lpGFB->lpszMQMDFileName, TRUE);
        ResolveValue(lpTIB, &lpGFB->lpszResRFH2FileName,
                     &lpGFB->lpszRFH2FileName, TRUE);
        ResolveValue(lpTIB, &lpGFB->lpszResDir,
                     &lpGFB->lpszDir, TRUE);
        ResolveValue(lpTIB, &lpGFB->lpszResCmdMaxWait,
                     &lpGFB->lpszCmdMaxWait, TRUE);

        /* Problems with variable resolution time to give up     */
        if(FAILURE == lpTIB->bCmdResult)
        {
            SetTIBCodes(lpTIB, MTCC_FAIL, MTRC_INIT_RESOLVE_FAIL);
            lpTIB->lTestFailedGetFile++;
            kpMCB->lScriptFailedGetFile++;
            lpGFB->eCommandState = S_FAILURE;
            return FAILURE;
        }

        /* Describe the file and its buffer */
        if(FALSE == kpMCB->bLoggingSuppressed)
        {
            sprintf(lpszExtraInfo, "Dir=%s File=%s\0",
                    lpGFB->lpszResDir,
                    lpGFB->lpszResFileName);
            LogMsg(TEST_EXTRA_LINE, lpTIB->lTestNum, lpszExtraInfo);
            sprintf(lpszExtraInfo, "Buffer=%s\0", lpGFB->lpszResBuffName);
            LogMsg(TEST_EXTRA_LINE, lpTIB->lTestNum, lpszExtraInfo);
        }

        /* Update the last file referenced internal value */
        lpTIB->lpszLastFile = CloneString(lpGFB->lpszResFileName);
        lpTIB->lpszLastDir = CloneString(lpGFB->lpszResDir);

        /* Set the time values. oNextLogMsgTime is initially set to   */
        /* be the same as oStartTime so we get an I045 message in     */
        /* the log the first time we reach S_RUN command state        */
        /* If <CmdMaxWait> was not specified then it is given a value */
        /* of -1 and we should use the <TestMaxWait> instead          */
        lCmdMaxWait = ConvNum(lpTIB, lpGFB->lpszResCmdMaxWait, "CmdMaxWait");
        if(FAILURE == lpTIB->bCmdResult)
        {
            sprintf(lpszExtraInfo, "CmdMaxWait=%s not numeric\0",
                    lpGFB->lpszResCmdMaxWait);
            LogMsg(TEST_EXTRA_LINE_ERR, lpTIB->lTestNum, lpszExtraInfo);
            SetTIBCodes(lpTIB, MTCC_FAIL, MTRC_INIT_CONVNUM_FAIL);
            lpTIB->lTestFailedGetFile++;
            kpMCB->lScriptFailedGetFile++;
            lpGFB->eCommandState = S_FAILURE;
            return FAILURE;
        }
        if(-1 == lCmdMaxWait)
        {
            lpGFB->lMaxWait = lpCIB->lTestMaxWait;
        }
        else
        {
            lpGFB->lMaxWait = lCmdMaxWait;
        }
        time(&lpGFB->oStartTime);
        lpGFB->oExpiryTime = lpGFB->oStartTime + lpGFB->lMaxWait;
        lpGFB->oNextLogMsgTime = lpGFB->oStartTime;

        /* Resolve the variable names */
        ResolveSubscript(lpTIB, &lpGFB->lpszResMQMDVarName, &lpGFB->lpszMQMDVarName, TRUE);
        ResolveSubscript(lpTIB, &lpGFB->lpszResRFH2VarName, &lpGFB->lpszRFH2VarName, TRUE);
        if(FAILURE == lpTIB->bCmdResult)
        {
            SetTIBCodes(lpTIB, MTCC_FAIL, MTRC_INIT_RESOLVE_FAIL);
            lpTIB->lTestFailedGetFile++;
            kpMCB->lScriptFailedGetFile++;
            lpGFB->eCommandState = S_FAILURE;
            return FAILURE;
        }

        /* Ready to run */
        SetTIBCodes(lpTIB, MTCC_OK, MTRC_NONE);
        lpGFB->eCommandState = S_RUN;
        return SUCCESS;
        break;

    case S_RUN:
        /* Work out how much time has elapsed as all log messages   */
        /* for the GetFile command include this information         */
        time(&oCurrTime);
        sprintf(lpszExtraInfo, " MaxWait=%d:%d\0", lpGFB->lMaxWait,
                oCurrTime - lpGFB->oStartTime);

        /* Generate full path file name for loading */
        memset(lpszDirAndFile, 0x00, FILE_BUFF_LEN + 4);
        strncpy(lpszDirAndFile, lpGFB->lpszResDir, FILE_BUFF_LEN);
        strcat(lpszDirAndFile, kpszDirFileConcat);
        strncat(lpszDirAndFile, lpGFB->lpszResFileName, FILE_BUFF_LEN);

        /* See if we can load the file */
        bLoadFile = LoadFile(lpszDirAndFile, &lpGFB->lpBIB->lpszBuff,
                             &lpGFB->lpBIB->lBuffLen, &lpGFB->lpBIB->lDataLen, FALSE);

        /* FileRC code is the same as the errno */
        lFileRC = kpMCB->lFileErrno;

        /* Check current reason code against BreakOnRC reason codes */
        if(0 < lpGFB->lBreakOnRCCount)
        {
            if(TRUE == FindRC(lpGFB->lBreakOnRCCount, lpGFB->lBreakOnRC, lFileRC))
            {
                LogMsg(45, lpTIB->lTestNum, lpszCurrCmdName, lpszExtraInfo);
                if(lpGFB->lpBreakContinueFSB)
                {
                    LogMsg(118, lpTIB->lTestNum, kpszGETFILE, 0, lFileRC, "Ending For/ForEver/ForEach loop Name=\0", lpGFB->lpBreakContinueFSB->lpszForName);
                }
                else
                {
                    LogMsg(118, lpTIB->lTestNum, kpszGETFILE, 0, lFileRC, "Ending Test Name=\0", lpTIB->lpszTestName);
                }
                lpGFB->lpBIB->lDataLen = 0;
                lpTIB->lpBreakContinueFSB = lpGFB->lpBreakContinueFSB;
                kpMCB->bConcurrencyWait = FALSE;
                SetTIBCodes(lpTIB, MTCC_FAIL, lFileRC);
                lpGFB->eCommandState = S_BREAK;
                return SUCCESS;
            }
        }

        /* Check current reason code against ContinueOnRC reason codes */
        if(0 < lpGFB->lContinueOnRCCount)
        {
            if(TRUE == FindRC(lpGFB->lContinueOnRCCount, lpGFB->lContinueOnRC, lFileRC))
            {
                LogMsg(45, lpTIB->lTestNum, lpszCurrCmdName, lpszExtraInfo);
                if(lpGFB->lpBreakContinueFSB)
                {
                    LogMsg(119, lpTIB->lTestNum, kpszGETFILE, 0, lFileRC, "Continuing For/ForEver/ForEach loop Name=\0", lpGFB->lpBreakContinueFSB->lpszForName);
                }
                else
                {
                    LogMsg(119, lpTIB->lTestNum, kpszGETFILE, 0, lFileRC, "Ending Test Name=\0", lpTIB->lpszTestName);
                }
                lpGFB->lpBIB->lDataLen = 0;
                lpTIB->lpBreakContinueFSB = lpGFB->lpBreakContinueFSB;
                kpMCB->bConcurrencyWait = FALSE;
                SetTIBCodes(lpTIB, MTCC_FAIL, lFileRC);
                lpGFB->eCommandState = S_CONTINUE;
                return SUCCESS;
            }
        }

        /* Check the current reason code against the suppression list */
        /* Suppression is done last as it changes the reason code     */
        if(0 < lpGFB->lSuppressRCCount)
        {
            if(TRUE == FindRC(lpGFB->lSuppressRCCount, lpGFB->lSuppressRC, lFileRC))
            {
                LogMsg(117, lpTIB->lTestNum, kpszGETFILE, 0, lFileRC);
                lpGFB->lpBIB->lDataLen = 0;
                bLoadFile = SUCCESS;
                lFileRC = 0;
            }
        }

        if(FAILURE == bLoadFile)
        {
            /* If the test maximum wait interval has expired then tell the */
            /* user we couldn't get the file and fail the test             */
            if(lpGFB->oExpiryTime <= oCurrTime)
            {
                LogMsg(45, lpTIB->lTestNum, lpszCurrCmdName, lpszExtraInfo);
                sprintf(lpszExtraInfo, "Get file=%s failed errno=%d\0", lpszDirAndFile, kpMCB->lFileErrno);
                LogMsg(TEST_EXTRA_LINE_ERR, lpTIB->lTestNum, lpszExtraInfo);
                sprintf(lpszExtraInfo, "MaxWait interval=%d expired\0",
                        lpGFB->lMaxWait);
                LogMsg(TEST_EXTRA_LINE_ERR, lpTIB->lTestNum, lpszExtraInfo);
                SetTIBCodes(lpTIB, MTCC_FAIL, lFileRC);
                lpTIB->lTestFailedGetFile++;
                kpMCB->lScriptFailedGetFile++;
                /* If the next command is an <If...> that contains a check of either */
                /* LastCC or LastRC then do not fail this command. Instead permit    */
                /* processing to contine at the <If...>                              */
                if(NULL != lpCCB->lpCCBNext)
                {
                    lpCCBCheckIf = (CommandCtrlBlk*)lpCCB->lpCCBNext;
                    if(C_IFSTART == lpCCBCheckIf->eCommandType)
                    {
                        lpIFSCheck = (IfStartBlk*) lpCCBCheckIf;
                        if((TRUE == lpIFSCheck->bACondChecksLastCC) || (TRUE == lpIFSCheck->bACondChecksLastRC))
                        {
                            lpGFB->eCommandState = S_COMPLETE;
                            return SUCCESS;
                        }
                    }
                }
                lpGFB->eCommandState = S_FAILURE;
                return FAILURE;
            }
            /* If its time to write a log message do so and then reset the */
            /* time that the next log message is due to be written         */
            else if(lpGFB->oNextLogMsgTime <= oCurrTime)
            {
                if(FALSE == kpMCB->bLoggingSuppressed)
                {
                    LogMsg(45, lpTIB->lTestNum, lpszCurrCmdName, lpszExtraInfo);
                    sprintf(lpszExtraInfo, "Waiting for file=%s errno=%d\0",
                            lpszDirAndFile, kpMCB->lFileErrno);
                    LogMsg(TEST_EXTRA_LINE, lpTIB->lTestNum, lpszExtraInfo);
                }
                lpGFB->oNextLogMsgTime = oCurrTime + lpCIB->lNextLogMsgInterval;
            }
            SetTIBCodes(lpTIB, MTCC_FAIL, lFileRC);
            /* Keep waiting */
            return SUCCESS;
        }

        /* Yep got it so we have successfully completed this command */
        if(FALSE == kpMCB->bLoggingSuppressed)
        {
            LogMsg(45, lpTIB->lTestNum, lpszCurrCmdName, lpszExtraInfo);
            sprintf(lpszExtraInfo, "Got file=%s\0", lpszDirAndFile);
            LogMsg(TEST_EXTRA_LINE, lpTIB->lTestNum, lpszExtraInfo);
            sprintf(lpszExtraInfo, "Buffer=%s BuffLen=%d DataLen=%d\0",
                    lpGFB->lpBIB->lpszBuffName,
                    lpGFB->lpBIB->lBuffLen,
                    lpGFB->lpBIB->lDataLen);
            LogMsg(TEST_EXTRA_LINE, lpTIB->lTestNum, lpszExtraInfo);
            DisplayData(kpszData, lpszExtraInfo, EXTRA_MSG_INFO_LEN, 
                        lpGFB->lpBIB->lpszBuff, lpGFB->lpBIB->lDataLen);
            LogMsg(TEST_EXTRA_LINE, lpTIB->lTestNum, lpszExtraInfo);
        }


        /* Got the main file now process any related files */
        /* Load the MQMD values from a file if requested   */
        lpMIB = NULL;
        if(0 < StrlenNull(lpGFB->lpszResMQMDFileName))
        {
            /* See if we can find the VIB on the TIB chain if not */
            /* then we need to create one                         */
            lpVIB = CheckAndAddVIB(lpTIB, V_MQMD,
                                   lpGFB->lpszMQMDVarName,
                                   lpGFB->lpszResMQMDVarName,
                                   NULL);
            if(FAILURE == lpTIB->bCmdResult)
            {
                SetTIBCodes(lpTIB, MTCC_FAIL, MTRC_RUN_FAIL);
                lpTIB->lTestFailedGetFile++;
                kpMCB->lScriptFailedGetFile++;
                lpGFB->eCommandState = S_FAILURE;
                return FAILURE;
            }

            /* Load the MIB from the MQMDFile */
            LoadMIBFromFile(lpTIB, &lpMIB,
                            lpGFB->lpszResMQMDFileName,
                            lpGFB->lpszResDir);
            if(FAILURE == lpTIB->bCmdResult)
            {
                SetTIBCodes(lpTIB, MTCC_FAIL, MTRC_RUN_FAIL);
                lpTIB->lTestFailedGetFile++;
                kpMCB->lScriptFailedGetFile++;
                lpGFB->eCommandState = S_FAILURE;
                return FAILURE;
            }

            /* Free the existing MIB if any and replace it */
            FreeMIB((MQMDInfoBlk**)&lpVIB->lpCtrlBlk);
            lpVIB->lpCtrlBlk = lpMIB;
        }

        /* Load the RFH2 values from a file if requested */
        lpRIB = NULL;
        if(0 < StrlenNull(lpGFB->lpszResRFH2FileName))
        {
            /* See if we can find the VIB on the TIB chain if not */
            /* then we need to create one                         */
            lpVIB = CheckAndAddVIB(lpTIB, V_RFH2,
                                   lpGFB->lpszRFH2VarName,
                                   lpGFB->lpszResRFH2VarName,
                                   NULL);
            if(FAILURE == lpTIB->bCmdResult)
            {
                SetTIBCodes(lpTIB, MTCC_FAIL, MTRC_RUN_FAIL);
                lpTIB->lTestFailedGetFile++;
                kpMCB->lScriptFailedGetFile++;
                lpGFB->eCommandState = S_FAILURE;
                return FAILURE;
            }

            /* Load the RIB from the RFH2File */
            LoadRIBFromFile(lpTIB, &lpRIB,
                            lpGFB->lpszResRFH2FileName,
                            lpGFB->lpszResDir);
            if(FAILURE == lpTIB->bCmdResult)
            {
                SetTIBCodes(lpTIB, MTCC_FAIL, MTRC_RUN_FAIL);
                lpTIB->lTestFailedGetFile++;
                kpMCB->lScriptFailedGetFile++;
                lpGFB->eCommandState = S_FAILURE;
                return FAILURE;
            }

            /* Free the existing RIB if any and replace it */
            FreeRIB((RFH2InfoBlk**)&lpVIB->lpCtrlBlk);
            lpVIB->lpCtrlBlk = lpRIB;
        }

        /* If an MQMDFile was loaded say so */
        if(lpMIB)
        {
            if(FALSE == kpMCB->bLoggingSuppressed)
            {
                sprintf(lpszExtraInfo, "MQMDFile values have been loaded\0");
                LogMsg(TEST_EXTRA_LINE, lpTIB->lTestNum, lpszExtraInfo);
            }
        }

        /* If an RFH2File was loaded say so */
        if(lpRIB)
        {
            if(FALSE == kpMCB->bLoggingSuppressed)
            {
                sprintf(lpszExtraInfo, "RFH2FolderCount=%d RFH2FolderDataLen=%d RFH2Len=%d\0",
                        lpRIB->lRFH2FolderCount,
                        lpRIB->lRFH2FolderDataLen,
                        lpRIB->lRFH2FolderDataLen + MQRFH_STRUC_LENGTH_FIXED_2);
                LogMsg(TEST_EXTRA_LINE, lpTIB->lTestNum, lpszExtraInfo);
            }
        }

        /* All done */
        kpMCB->bConcurrencyWait = FALSE;
        SetTIBCodes(lpTIB, MTCC_OK, MTRC_NONE);
        lpTIB->lLastDataLen = lpGFB->lpBIB->lDataLen;
        lpTIB->lTestSuccessfulGetFile++;
        kpMCB->lScriptSuccessfulGetFile++;
        lpGFB->eCommandState = S_COMPLETE;
        return SUCCESS;
        break;
    case S_COMPLETE:
        LogMsg(38, lpTIB->lTestNum, lpszCurrCmdName, CalcCmdExecTime(lpTIB));
        kpMCB->bConcurrencyWait = FALSE;
        lpGFB->eCommandState = S_NEXT;
        return SUCCESS;
        break;
    case S_FAILURE:
        LogMsg(51, lpTIB->lTestNum, lpszCurrCmdName, CalcCmdExecTime(lpTIB));
        kpMCB->bConcurrencyWait = FALSE;
        lpGFB->eCommandState = S_NEXT;
        return FAILURE;
        break;
    }
    /* Should never get here so its a logic error terminate immediately */
    SetTIBCodes(lpTIB, MTCC_FAIL, MTRC_LOGIC_FAIL);
    lpGFB->eCommandState = S_FAILURE;
    lpTIB->lTestFailedGetFile++;
    kpMCB->lScriptFailedGetFile++;
    kpMCB->lProcessing = FAILURE;
    LogMsg(69, lpTIB->lTestNum, "ExecuteGetFileCmd\0");
    return FAILURE;
}


/*--------------------------------------------------------------------------*/
long
ExecutePutFileCmd(TestInfoBlk* lpTIB, CommandCtrlBlk* lpCCB)
{
    ControlInfoBlk* lpCIB;
    PutFileBlk*     lpPFB;
    VarInfoBlk*     lpVIBDataVar;
    IfStartBlk*     lpIFSCheck;
    CommandCtrlBlk* lpCCBCheckIf;
    char*           lpszCurrCmdName;
    char            lpszExtraInfo[EXTRA_MSG_INFO_LEN + 4];
    char            lpszDirAndFile[FILE_BUFF_LEN + 4];
    long            bSaveFile;
    long            bSaveFileRFH2;
    long            bSaveFileMQMD;

    /* Initialise common use local variables */
    lpCIB = kpMCB->lpCIB;
    lpPFB = (PutFileBlk*)lpCCB;
    lpszCurrCmdName = kpszPUTFILE;
    memset(lpszExtraInfo, 0x00, EXTRA_MSG_INFO_LEN + 4);

    /* Process according to current command state */
    switch(lpPFB->eCommandState)
    {
    case S_INIT:
        LogMsg(44, lpTIB->lTestNum, lpszCurrCmdName, "\0");
        lpTIB->lLastDataLen = 0;
        lpTIB->lTestTotalPutFile++;
        kpMCB->lScriptTotalPutFile++;
        time(&lpPFB->oStartTime);
        lpPFB->oExpiryTime = lpPFB->oStartTime;
        lpPFB->oNextLogMsgTime = lpPFB->oStartTime;

        /* Running an initialisation so set concurrency wait false. */
        kpMCB->bConcurrencyWait = FALSE;

        /* Resolve buffer name */
        ResolveValue(lpTIB, &lpPFB->lpszResBuffName,
                     &lpPFB->lpszBuffName, TRUE);
        if(FAILURE == lpTIB->bCmdResult)
        {
            SetTIBCodes(lpTIB, MTCC_FAIL, MTRC_INIT_RESOLVE_FAIL);
            lpTIB->lTestFailedPutFile++;
            kpMCB->lScriptFailedPutFile++;
            lpPFB->eCommandState = S_FAILURE;
            return FAILURE;
        }

        /* Obtain a pointer to the buffer info block for this command use */
        /* the specified or default buffer unless a DataVar override has  */
        /* been specified in which case create a temporary DataVar BIB    */
        if(NULL == lpPFB->lpszDataVarName)
        {
            lpPFB->lpBIB = FindBuffInfoBlk(lpTIB->lpBIBHead, lpPFB->lpszResBuffName);
            if(! lpPFB->lpBIB)
            {
                /* No buffer to put the file from. Report the problem and fail */
                sprintf(lpszExtraInfo, "Unable to locate/allocate Buffer=%s\0",
                        lpPFB->lpszResBuffName);
                LogMsg(TEST_EXTRA_LINE_ERR, lpTIB->lTestNum, lpszExtraInfo);
                SetTIBCodes(lpTIB, MTCC_FAIL, MTRC_INIT_BUFF_FAIL);
                lpTIB->lTestFailedPutMsg++;
                kpMCB->lScriptFailedPutMsg++;
                lpPFB->eCommandState = S_FAILURE;
                return FAILURE;
            }
        }
        else
        {
            /* Resolve the DataVar variable name */
            ResolveSubscript(lpTIB, &lpPFB->lpszResDataVarName, &lpPFB->lpszDataVarName, TRUE);
            if(FAILURE == lpTIB->bCmdResult)
            {
                SetTIBCodes(lpTIB, MTCC_FAIL, MTRC_INIT_RESOLVE_FAIL);
                lpTIB->lTestFailedPutMsg++;
                kpMCB->lScriptFailedPutMsg++;
                lpPFB->eCommandState = S_FAILURE;
                return FAILURE;
            }
            /* Now see if we can find it */
            lpVIBDataVar = FindVarInfoBlk(lpTIB->lpVIBHead, lpPFB->lpszResDataVarName);
            if(NULL == lpVIBDataVar)
            {
                LogMsg(184, lpTIB->lTestNum, lpPFB->lpszResDataVarName);
                SetTIBCodes(lpTIB, MTCC_FAIL, MTRC_INIT_FAIL);
                lpTIB->lTestFailedPutMsg++;
                kpMCB->lScriptFailedPutMsg++;
                lpPFB->eCommandState = S_FAILURE;
                return FAILURE;
            }
            /* Free up any previous temporary DataVar BIB */
            /* As all pointers in the BIB reference data under the  */
            /* primary control of other control blocks or data that */
            /* is static we only need to free the actual control    */
            /* block not its contents                               */
            FreeIfNotNull((void**)&lpPFB->lpTempDataVarBIB);

            /* Ok so far now create the temporary DataVar BIB */
            lpPFB->lpTempDataVarBIB = malloc(sizeof(BuffInfoBlk));
            if(NULL != lpPFB->lpTempDataVarBIB)
            {
                memset(lpPFB->lpTempDataVarBIB, 0x00, sizeof(BuffInfoBlk));
                lpPFB->lpTempDataVarBIB->lpBIBNext = NULL;
                lpPFB->lpTempDataVarBIB->lpBIBPrev = NULL;
                lpPFB->lpTempDataVarBIB->lpszBuffName = kpszTEMPDATAVARBUFF;
                lpPFB->lpTempDataVarBIB->lpszBuff = lpVIBDataVar->lpszCurrStrValue;
                lpPFB->lpTempDataVarBIB->lBuffLen = StrlenNull(lpVIBDataVar->lpszCurrStrValue);
                lpPFB->lpTempDataVarBIB->lDataLen = lpPFB->lpTempDataVarBIB->lBuffLen;
            }
            else
            {
                LogMsg(3, sizeof(BuffInfoBlk), "BuffInfoBlk", __LINE__, __FILE__);
                lpTIB->bCmdResult = FAILURE;
                lpPFB->eCommandState = S_FAILURE;
                SetTIBCodes(lpTIB, MTCC_FAIL, MTRC_LOGIC_FAIL);
                kpMCB->lProcessing = FAILURE;
                return FAILURE;
            }
            /* Now point the normal BIB pointer at the temp BIB */
            lpPFB->lpBIB = lpPFB->lpTempDataVarBIB;
        }

        ResolveValue(lpTIB, &lpPFB->lpszResFileName,
                     &lpPFB->lpszFileName, TRUE);
        ResolveValue(lpTIB, &lpPFB->lpszResMQMDFileName,
                     &lpPFB->lpszMQMDFileName, TRUE);
        ResolveValue(lpTIB, &lpPFB->lpszResRFH2FileName,
                     &lpPFB->lpszRFH2FileName, TRUE);
        ResolveValue(lpTIB, &lpPFB->lpszResDir,
                     &lpPFB->lpszDir, TRUE);

        /* Problems with variable resolution time to give up     */
        if(FAILURE == lpTIB->bCmdResult)
        {
            SetTIBCodes(lpTIB, MTCC_FAIL, MTRC_INIT_RESOLVE_FAIL);
            lpTIB->lTestFailedPutFile++;
            kpMCB->lScriptFailedPutFile++;
            lpPFB->eCommandState = S_FAILURE;
            return FAILURE;
        }

        /* Update the last file referenced internal value */
        if(0 < StrlenNull(lpPFB->lpszResFileName))
        {
            lpTIB->lpszLastFile = CloneString(lpPFB->lpszResFileName);
            lpTIB->lpszLastDir = CloneString(lpPFB->lpszResDir);
        }
        else
        {
            lpTIB->lpszLastFile = CloneString(kpszNONE);
            lpTIB->lpszLastDir = CloneString(lpPFB->lpszResDir);
        }

        /* Resolve the variable names */
        ResolveSubscript(lpTIB, &lpPFB->lpszResMQMDVarName, &lpPFB->lpszMQMDVarName, TRUE);
        ResolveSubscript(lpTIB, &lpPFB->lpszResRFH2VarName, &lpPFB->lpszRFH2VarName, TRUE);
        if(FAILURE == lpTIB->bCmdResult)
        {
            SetTIBCodes(lpTIB, MTCC_FAIL, MTRC_INIT_RESOLVE_FAIL);
            lpTIB->lTestFailedPutFile++;
            kpMCB->lScriptFailedPutFile++;
            lpPFB->eCommandState = S_FAILURE;
            return FAILURE;
        }

        /* Describe directory, file and buffer */
        if(FALSE == kpMCB->bLoggingSuppressed)
        {
            sprintf(lpszExtraInfo, "Dir=%s File=%s\0",
                    lpPFB->lpszResDir,
                    lpPFB->lpszResFileName);
            LogMsg(TEST_EXTRA_LINE, lpTIB->lTestNum, lpszExtraInfo);
            sprintf(lpszExtraInfo, "Buffer=%s BuffLen=%d DataLen=%d\0",
                    lpPFB->lpszResBuffName,
                    lpPFB->lpBIB->lBuffLen,
                    lpPFB->lpBIB->lDataLen);
            LogMsg(TEST_EXTRA_LINE, lpTIB->lTestNum, lpszExtraInfo);
        }

        /* Ready to run */
        SetTIBCodes(lpTIB, MTCC_OK, MTRC_NONE);
        lpPFB->eCommandState = S_RUN;
        return SUCCESS;
        break;
    case S_RUN:
        LogMsg(45, lpTIB->lTestNum, lpszCurrCmdName, "\0");
        memset(lpszDirAndFile, 0x00, FILE_BUFF_LEN + 4);
        strncpy(lpszDirAndFile, lpPFB->lpszResDir, FILE_BUFF_LEN);
        strcat(lpszDirAndFile, kpszDirFileConcat);
        strncat(lpszDirAndFile, lpPFB->lpszResFileName, FILE_BUFF_LEN);

        /* If the filename exists save to it otherwise save the MQMD */
        /* or RFH2 information only as requested                     */
        if(0 < StrlenNull(lpPFB->lpszResFileName))
        {
            /* Try to save the file reporting the result */
            bSaveFile = SaveFile(lpszDirAndFile, lpPFB->lpBIB->lpszBuff,
                                 lpPFB->lpBIB->lDataLen, TRUE, lpPFB->bAppend);

            /* Check the result against the BreakOnRC, ContinueOnRC and SuppressRC */
            /* reason codes if any                                                 */
            if(TRUE == BCSPutFile(lpTIB, lpPFB, &bSaveFile))
            {
                return SUCCESS;
            }

            if(FAILURE == bSaveFile)
            {
                sprintf(lpszExtraInfo, "Failed to put file=%s errno=%d\0",
                        lpszDirAndFile, kpMCB->lFileErrno);
                LogMsg(TEST_EXTRA_LINE_ERR, lpTIB->lTestNum, lpszExtraInfo);
                SetTIBCodes(lpTIB, MTCC_FAIL, kpMCB->lFileErrno);
                lpTIB->lTestFailedPutFile++;
                kpMCB->lScriptFailedPutFile++;
                /* If the next command is an <If...> that contains a check of either */
                /* LastCC or LastRC then do not fail this command. Instead permit    */
                /* processing to continue at the <If...>                             */
                if(NULL != lpCCB->lpCCBNext)
                {
                    lpCCBCheckIf = (CommandCtrlBlk*)lpCCB->lpCCBNext;
                    if(C_IFSTART == lpCCBCheckIf->eCommandType)
                    {
                        lpIFSCheck = (IfStartBlk*) lpCCBCheckIf;
                        if((TRUE == lpIFSCheck->bACondChecksLastCC) || (TRUE == lpIFSCheck->bACondChecksLastRC))
                        {
                            lpPFB->eCommandState = S_COMPLETE;
                            return SUCCESS;
                        }
                    }
                }
                lpPFB->eCommandState = S_FAILURE;
                return FAILURE;
            }

            /* Log information about the file that was saved */
            if(FALSE == kpMCB->bLoggingSuppressed)
            {
                sprintf(lpszExtraInfo, "Put file=%s\0", lpszDirAndFile);
                LogMsg(TEST_EXTRA_LINE, lpTIB->lTestNum, lpszExtraInfo);
                sprintf(lpszExtraInfo, "Buffer=%s BuffLen=%d DataLen=%d\0",
                        lpPFB->lpBIB->lpszBuffName,
                        lpPFB->lpBIB->lBuffLen,
                        lpPFB->lpBIB->lDataLen);
                LogMsg(TEST_EXTRA_LINE, lpTIB->lTestNum, lpszExtraInfo);
                DisplayData(kpszData, lpszExtraInfo, EXTRA_MSG_INFO_LEN, 
                            lpPFB->lpBIB->lpszBuff, lpPFB->lpBIB->lDataLen);
                LogMsg(TEST_EXTRA_LINE, lpTIB->lTestNum, lpszExtraInfo);
            }
        }
        else
        {
            /* Log information about the file that was saved */
            if(FALSE == kpMCB->bLoggingSuppressed)
            {
                sprintf(lpszExtraInfo, "No buffer to file operation executed. The <File> element of <PutFile> was not specified\0", lpszDirAndFile);
                LogMsg(TEST_EXTRA_LINE, lpTIB->lTestNum, lpszExtraInfo);
            }
        }

        /* Save the MQMD attachments if necessary */
        if(0 < StrlenNull(lpPFB->lpszResMQMDFileName))
        {
            bSaveFileMQMD = PFSaveFileMQMD(lpTIB, lpPFB);

            /* Check the result against the BreakOnRC, ContinueOnRC and SuppressRC */
            /* reason codes if any                                                 */
            if(TRUE == BCSPutFile(lpTIB, lpPFB, &bSaveFileMQMD))
            {
                return SUCCESS;
            }

            if(FAILURE == bSaveFileMQMD)
            {
                SetTIBCodes(lpTIB, MTCC_FAIL, kpMCB->lFileErrno);
                lpTIB->lTestFailedPutFile++;
                kpMCB->lScriptFailedPutFile++;
                lpPFB->eCommandState = S_FAILURE;
                return FAILURE;
            }
        }

        /* Save the RFH2 attachments if necessary */
        if(0 < StrlenNull(lpPFB->lpszResRFH2FileName))
        {
            bSaveFileRFH2 = PFSaveFileRFH2(lpTIB, lpPFB);

            /* Check the result against the BreakOnRC, ContinueOnRC and SuppressRC */
            /* reason codes if any                                                 */
            if(TRUE == BCSPutFile(lpTIB, lpPFB, &bSaveFileRFH2))
            {
                return SUCCESS;
            }

            if(FAILURE == bSaveFileRFH2)
            {
                SetTIBCodes(lpTIB, MTCC_FAIL, kpMCB->lFileErrno);
                lpTIB->lTestFailedPutFile++;
                kpMCB->lScriptFailedPutFile++;
                lpPFB->eCommandState = S_FAILURE;
                return FAILURE;
            }
        }

        /* All done */
        kpMCB->bConcurrencyWait = FALSE;
        SetTIBCodes(lpTIB, MTCC_OK, MTRC_NONE);
        lpTIB->lLastDataLen = lpPFB->lpBIB->lDataLen;
        lpTIB->lTestSuccessfulPutFile++;
        kpMCB->lScriptSuccessfulPutFile++;
        lpPFB->eCommandState = S_COMPLETE;
        return SUCCESS;
        break;
    case S_COMPLETE:
        LogMsg(38, lpTIB->lTestNum, lpszCurrCmdName, CalcCmdExecTime(lpTIB));
        kpMCB->bConcurrencyWait = FALSE;
        lpPFB->eCommandState = S_NEXT;
        return SUCCESS;
        break;
    case S_FAILURE:
        LogMsg(51, lpTIB->lTestNum, lpszCurrCmdName, CalcCmdExecTime(lpTIB));
        kpMCB->bConcurrencyWait = FALSE;
        lpPFB->eCommandState = S_NEXT;
        return FAILURE;
        break;
    }
    /* Should never get here so its a logic error terminate immediately */
    SetTIBCodes(lpTIB, MTCC_FAIL, MTRC_LOGIC_FAIL);
    lpPFB->eCommandState = S_FAILURE;
    kpMCB->lProcessing = FAILURE;
    LogMsg(69, lpTIB->lTestNum, "ExecutePutFileCmd\0");
    return FAILURE;
}

long
BCSPutFile(TestInfoBlk* lpTIB, PutFileBlk* lpPFB, long* bSaveFile)
{
    long lFileRC;

    /* FileRC code is the same as the errno */
    lFileRC = kpMCB->lFileErrno;

    /* Check current reason code against BreakOnRC reason codes */
    if(0 < lpPFB->lBreakOnRCCount)
    {
        if(TRUE == FindRC(lpPFB->lBreakOnRCCount, lpPFB->lBreakOnRC, lFileRC))
        {
            if(lpPFB->lpBreakContinueFSB)
            {
                LogMsg(118, lpTIB->lTestNum, kpszPUTFILE, 0, lFileRC, "Ending For/ForEver/ForEach loop Name=\0", lpPFB->lpBreakContinueFSB->lpszForName);
            }
            else
            {
                LogMsg(118, lpTIB->lTestNum, kpszPUTFILE, 0, lFileRC, "Ending Test Name=\0", lpTIB->lpszTestName);
            }
            lpTIB->lpBreakContinueFSB = lpPFB->lpBreakContinueFSB;
            kpMCB->bConcurrencyWait = FALSE;
            SetTIBCodes(lpTIB, MTCC_FAIL, lFileRC);
            lpPFB->eCommandState = S_BREAK;
            return TRUE;
        }
    }

    /* Check current reason code against ContinueOnRC reason codes */
    if(0 < lpPFB->lContinueOnRCCount)
    {
        if(TRUE == FindRC(lpPFB->lContinueOnRCCount, lpPFB->lContinueOnRC, lFileRC))
        {
            if(lpPFB->lpBreakContinueFSB)
            {
                LogMsg(119, lpTIB->lTestNum, kpszPUTFILE, 0, lFileRC, "Continuing For/ForEver/ForEach loop Name=\0", lpPFB->lpBreakContinueFSB->lpszForName);
            }
            else
            {
                LogMsg(119, lpTIB->lTestNum, kpszPUTFILE, 0, lFileRC, "Ending Test Name=\0", lpTIB->lpszTestName);
            }
            lpTIB->lpBreakContinueFSB = lpPFB->lpBreakContinueFSB;
            kpMCB->bConcurrencyWait = FALSE;
            SetTIBCodes(lpTIB, MTCC_FAIL, lFileRC);
            lpPFB->eCommandState = S_CONTINUE;
            return TRUE;
        }
    }

    /* Check the current reason code against the suppression list */
    /* Suppression is done last as it changes the reason code     */
    if(0 < lpPFB->lSuppressRCCount)
    {
        if(TRUE == FindRC(lpPFB->lSuppressRCCount, lpPFB->lSuppressRC, lFileRC))
        {
            LogMsg(117, lpTIB->lTestNum, kpszPUTFILE, 0, lFileRC);
            *bSaveFile = SUCCESS;
            lFileRC = 0;
        }
    }

    return FALSE;
}

/*--------------------------------------------------------------------------*/
long
ExecuteInlineDataCmd(TestInfoBlk* lpTIB, CommandCtrlBlk* lpCCB)
{
    ControlInfoBlk* lpCIB;
    InlineDataBlk*  lpIDB;
    char*           lpszCurrCmdName;
    char            lpszExtraInfo[EXTRA_MSG_INFO_LEN + 4];

    /* Initialise common use local variables */
    lpCIB = kpMCB->lpCIB;
    lpIDB = (InlineDataBlk*)lpCCB;
    lpszCurrCmdName = kpszINLINEDATA;
    memset(lpszExtraInfo, 0x00, EXTRA_MSG_INFO_LEN + 4);

    /* Process according to current command state */
    switch(lpIDB->eCommandState)
    {
    case S_INIT:
        LogMsg(44, lpTIB->lTestNum, lpszCurrCmdName, "\0");
        lpTIB->lLastDataLen = 0;
        time(&lpIDB->oStartTime);
        lpIDB->oExpiryTime = lpIDB->oStartTime;
        lpIDB->oNextLogMsgTime = lpIDB->oStartTime;

        /* Running an initialisation so set concurrency wait false. */
        kpMCB->bConcurrencyWait = FALSE;

        /* Resolve buffer name */
        ResolveValue(lpTIB, &lpIDB->lpszResBuffName,
                     &lpIDB->lpszBuffName, TRUE);
        if(FAILURE == lpTIB->bCmdResult)
        {
            SetTIBCodes(lpTIB, MTCC_FAIL, MTRC_INIT_RESOLVE_FAIL);
            lpIDB->eCommandState = S_FAILURE;
            return FAILURE;
        }

        lpIDB->lpBIB = CheckAndAddBIB(lpTIB, lpIDB->lpszResBuffName);
        if(! lpIDB->lpBIB)
        {
            /* Problem locating/creating the BIB report it and fail the test  */
            sprintf(lpszExtraInfo, "Unable to locate/allocate BIB Buffer=%s\0",
                    lpIDB->lpszResBuffName);
            LogMsg(TEST_EXTRA_LINE_ERR, lpTIB->lTestNum, lpszExtraInfo);
            SetTIBCodes(lpTIB, MTCC_FAIL, MTRC_INIT_BUFF_FAIL);
            lpIDB->eCommandState = S_FAILURE;
            return FAILURE;
        }

        /* If we already have a buffer then free it */
        if(NULL != lpIDB->lpBIB->lpszBuff)
        {
            FreeIfNotNull((void**)&lpIDB->lpBIB->lpszBuff);
            if(FALSE == kpMCB->bLoggingSuppressed)
            {
                sprintf(lpszExtraInfo, "Buffer=%s BuffLen=%d bytes freed\0",
                        lpIDB->lpBIB->lpszBuffName,
                        lpIDB->lpBIB->lBuffLen);
                LogMsg(TEST_EXTRA_LINE, lpTIB->lTestNum, lpszExtraInfo);
            }
        }

        /* Allocate a new buffer on a 16 byte boundary */
        /* rounding up by at least 16 bytes            */
        lpIDB->lpBIB->lDataLen = StrlenNull(lpIDB->lpszData);
        lpIDB->lpBIB->lBuffLen = (((lpIDB->lpBIB->lDataLen + 16) / 16) + 1) * 16;
        lpIDB->lpBIB->lpszBuff = malloc(lpIDB->lpBIB->lBuffLen + 8);
        if(! lpIDB->lpBIB->lpszBuff)
        {
            /* Couldn't get a buffer report the problem and fail the test */
            sprintf(lpszExtraInfo, "Buffer=%s BuffLen=%d malloc() failed.\0",
                    lpIDB->lpBIB->lpszBuffName,
                    lpIDB->lpBIB->lBuffLen);
            LogMsg(TEST_EXTRA_LINE_ERR, lpTIB->lTestNum, lpszExtraInfo);
            SetTIBCodes(lpTIB, MTCC_FAIL, MTRC_INIT_BUFF_FAIL);
            lpIDB->eCommandState = S_FAILURE;
            return FAILURE;
        }

        /* Clear the new buffer and report its allocation */
        memset(lpIDB->lpBIB->lpszBuff, 0x00, lpIDB->lpBIB->lBuffLen + 8);
        if(FALSE == kpMCB->bLoggingSuppressed)
        {
            sprintf(lpszExtraInfo, "Buffer=%s BuffLen=%d bytes allocated\0",
                    lpIDB->lpBIB->lpszBuffName,
                    lpIDB->lpBIB->lBuffLen);
            LogMsg(TEST_EXTRA_LINE, lpTIB->lTestNum, lpszExtraInfo);
        }

        /* Ready to run */
        SetTIBCodes(lpTIB, MTCC_OK, MTRC_NONE);
        lpIDB->eCommandState = S_RUN;
        return SUCCESS;
        break;
    case S_RUN:
        LogMsg(45, lpTIB->lTestNum, lpszCurrCmdName, "\0");
        /* Copy the data into the buffer */
        memcpy(lpIDB->lpBIB->lpszBuff, lpIDB->lpszData,
               lpIDB->lpBIB->lDataLen);

        /* Log information about the data just loaded */
        if(FALSE == kpMCB->bLoggingSuppressed)
        {
            sprintf(lpszExtraInfo, "Buffer=%s BuffLen=%d DataLen=%d data loaded\0",
                    lpIDB->lpBIB->lpszBuffName,
                    lpIDB->lpBIB->lBuffLen,
                    lpIDB->lpBIB->lDataLen);
            LogMsg(TEST_EXTRA_LINE, lpTIB->lTestNum, lpszExtraInfo);
            DisplayData(kpszData, lpszExtraInfo, EXTRA_MSG_INFO_LEN, 
                        lpIDB->lpBIB->lpszBuff, lpIDB->lpBIB->lDataLen);
            LogMsg(TEST_EXTRA_LINE, lpTIB->lTestNum, lpszExtraInfo);
        }
        kpMCB->bConcurrencyWait = FALSE;
        SetTIBCodes(lpTIB, MTCC_OK, MTRC_NONE);
        lpTIB->lLastDataLen = lpIDB->lpBIB->lDataLen;
        lpIDB->eCommandState = S_COMPLETE;
        return SUCCESS;
        break;
    case S_COMPLETE:
        LogMsg(38, lpTIB->lTestNum, lpszCurrCmdName, CalcCmdExecTime(lpTIB));
        kpMCB->bConcurrencyWait = FALSE;
        lpIDB->eCommandState = S_NEXT;
        return SUCCESS;
        break;
    case S_FAILURE:
        LogMsg(51, lpTIB->lTestNum, lpszCurrCmdName, CalcCmdExecTime(lpTIB));
        kpMCB->bConcurrencyWait = FALSE;
        lpIDB->eCommandState = S_NEXT;
        return FAILURE;
        break;
    }
    /* Should never get here so its a logic error terminate immediately */
    SetTIBCodes(lpTIB, MTCC_FAIL, MTRC_LOGIC_FAIL);
    lpIDB->eCommandState = S_FAILURE;
    kpMCB->lProcessing = FAILURE;
    LogMsg(69, lpTIB->lTestNum, "ExecuteInlineDataCmd\0");
    return FAILURE;
}


/*--------------------------------------------------------------------------*/
long
ExecuteOverlayCmd(TestInfoBlk* lpTIB, CommandCtrlBlk* lpCCB)
{
    ControlInfoBlk* lpCIB;
    OverlayBlk*     lpOVB;
    char*           lpszCurrCmdName;
    char*           lpszOldBuff;
    long            lMaxLen;
    long            lDataLen;
    long            lBuffMax;
    long            lCopyMax;
    long            lOldDataLen;
    char            lpszExtraInfo[EXTRA_MSG_INFO_LEN + 4];

    /* Initialise common use local variables */
    lpCIB = kpMCB->lpCIB;
    lpOVB = (OverlayBlk*)lpCCB;
    lpszCurrCmdName = kpszOVERLAY;
    memset(lpszExtraInfo, 0x00, EXTRA_MSG_INFO_LEN + 4);

    /* Process according to current command state */
    switch(lpOVB->eCommandState)
    {
    case S_INIT:
        LogMsg(44, lpTIB->lTestNum, lpszCurrCmdName, "\0");
        lpTIB->lLastDataLen = 0;
        time(&lpOVB->oStartTime);
        lpOVB->oExpiryTime = lpOVB->oStartTime;
        lpOVB->oNextLogMsgTime = lpOVB->oStartTime;

        /* Running an initialisation so set concurrency wait false. */
        kpMCB->bConcurrencyWait = FALSE;

        /* Resolve buffer name */
        ResolveValue(lpTIB, &lpOVB->lpszResBuffName,
                     &lpOVB->lpszBuffName, TRUE);
        ResolveValue(lpTIB, &lpOVB->lpszResPos,
                     &lpOVB->lpszPos, TRUE);
        ResolveValue(lpTIB, &lpOVB->lpszResLen,
                     &lpOVB->lpszLen, TRUE);
        if(FAILURE == lpTIB->bCmdResult)
        {
            SetTIBCodes(lpTIB, MTCC_FAIL, MTRC_INIT_RESOLVE_FAIL);
            lpOVB->eCommandState = S_FAILURE;
            return FAILURE;
        }

        lpOVB->lPos = ConvNum(lpTIB, lpOVB->lpszResPos, "Pos");
        lpOVB->lLen = ConvNum(lpTIB, lpOVB->lpszResLen, "Len");
        if(FAILURE == lpTIB->bCmdResult)
        {
            LogMsg(134, lpTIB->lTestNum, lpOVB->lpszResPos, lpOVB->lpszResLen);
            SetTIBCodes(lpTIB, MTCC_FAIL, MTRC_INIT_CONVNUM_FAIL);
            lpOVB->eCommandState = S_FAILURE;
            return FAILURE;
        }

        /* ???TA validate pos as being > 0 depending on replies */

        /* Obtain a pointer to the buffer info block for this command */
        lpOVB->lpBIB = CheckAndAddBIB(lpTIB, lpOVB->lpszResBuffName);
        if(! lpOVB->lpBIB)
        {
            /* No buffer to put the message from. Report the problem and fail */
            sprintf(lpszExtraInfo, "Unable to locate/allocate Buffer=%s\0",
                    lpOVB->lpszResBuffName);
            LogMsg(TEST_EXTRA_LINE_ERR, lpTIB->lTestNum, lpszExtraInfo);
            SetTIBCodes(lpTIB, MTCC_FAIL, MTRC_INIT_BUFF_FAIL);
            lpOVB->eCommandState = S_FAILURE;
            return FAILURE;
        }

        /* Resolve the data value */
        ResolveValue(lpTIB, &lpOVB->lpszResData, &lpOVB->lpszData, TRUE);
        if(FAILURE == lpTIB->bCmdResult)
        {
            SetTIBCodes(lpTIB, MTCC_FAIL, MTRC_INIT_RESOLVE_FAIL);
            lpOVB->eCommandState = S_FAILURE;
            return FAILURE;
        }

        /* Ready to run */
        SetTIBCodes(lpTIB, MTCC_OK, MTRC_NONE);
        lpOVB->eCommandState = S_RUN;
        return SUCCESS;
        break;
    case S_RUN:
        LogMsg(45, lpTIB->lTestNum, lpszCurrCmdName, "\0");

        /* Calculate length values for overlay operations */
        lDataLen = StrlenNull(lpOVB->lpszResData);
        if(0 == lpOVB->lLen)
        {
            lMaxLen = lDataLen; 
        }
        else
        {
            lMaxLen = lpOVB->lLen;
            if(lDataLen > lMaxLen)
            {
                lDataLen = lMaxLen;
            }
        }

        /* Check to see if we will overflow maximum allowed position */
        /* of 4 bytes from the end of the current buffer             */
        lCopyMax = lpOVB->lPos + lMaxLen;
        lBuffMax = lpOVB->lpBIB->lBuffLen - 4;
        if(lCopyMax > lBuffMax)
        {
            /* Retain a pointer to the buffer if it existed */
            lpszOldBuff = lpOVB->lpBIB->lpszBuff;
            lOldDataLen = lpOVB->lpBIB->lDataLen;

            /* Allocate a new buffer on a 16 byte boundary */
            /* rounding up by at least 16 bytes            */
            lpOVB->lpBIB->lDataLen = lCopyMax - 1;
            lpOVB->lpBIB->lBuffLen = (((lpOVB->lpBIB->lDataLen + 16) / 16) + 1) * 16;
            lpOVB->lpBIB->lpszBuff = malloc(lpOVB->lpBIB->lBuffLen + 8);
            if(! lpOVB->lpBIB->lpszBuff)
            {
                /* Couldn't get a buffer report the problem and fail the test */
                sprintf(lpszExtraInfo, "Buffer=%s BuffLen=%d malloc() failed.\0",
                        lpOVB->lpBIB->lpszBuffName,
                        lpOVB->lpBIB->lBuffLen);
                LogMsg(TEST_EXTRA_LINE_ERR, lpTIB->lTestNum, lpszExtraInfo);
                SetTIBCodes(lpTIB, MTCC_FAIL, MTRC_RUN_BUFF_FAIL);
                lpOVB->eCommandState = S_FAILURE;
                return FAILURE;
            }
            
            /* Clear the new buffer and report its allocation */
            memset(lpOVB->lpBIB->lpszBuff, 0x00, lpOVB->lpBIB->lBuffLen + 8);
            if(FALSE == kpMCB->bLoggingSuppressed)
            {
                sprintf(lpszExtraInfo, "Buffer=%s BuffLen=%d bytes reallocated\0",
                        lpOVB->lpBIB->lpszBuffName,
                        lpOVB->lpBIB->lBuffLen);
                LogMsg(TEST_EXTRA_LINE, lpTIB->lTestNum, lpszExtraInfo);
            }
    
            /* If we already had a buffer then copy any data it contained */
            /* before freeing it                                          */
            if(NULL != lpszOldBuff)
            {
                memcpy(lpOVB->lpBIB->lpszBuff, lpszOldBuff, lOldDataLen);
                FreeIfNotNull((void**)&lpszOldBuff);
            }
        }
        else
        {
            /* Only update if we've increased the data length */
            if(lpOVB->lpBIB->lDataLen < (lCopyMax - 1))
            {
                lpOVB->lpBIB->lDataLen = lCopyMax - 1;
            }
        }

        /* Copy the overlay data into the buffer */
        memcpy(lpOVB->lpBIB->lpszBuff + lpOVB->lPos - 1, lpOVB->lpszResData, lDataLen);

        /* Log information about the overlay data */
        if(FALSE == kpMCB->bLoggingSuppressed)
        {
            sprintf(lpszExtraInfo, "Buffer=%s overlay at Pos=%d Len=%d CalcLen=%d BuffDataLen=%d \0",
                    lpOVB->lpBIB->lpszBuffName,
                    lpOVB->lPos, lpOVB->lLen, lDataLen, lpOVB->lpBIB->lDataLen);
            LogMsg(TEST_EXTRA_LINE, lpTIB->lTestNum, lpszExtraInfo);
            DisplayData(kpszData, lpszExtraInfo, EXTRA_MSG_INFO_LEN, 
                        lpOVB->lpBIB->lpszBuff + lpOVB->lPos - 1, lDataLen);
            LogMsg(TEST_EXTRA_LINE, lpTIB->lTestNum, lpszExtraInfo);
        }

        /* All done */
        kpMCB->bConcurrencyWait = FALSE;
        SetTIBCodes(lpTIB, MTCC_OK, MTRC_NONE);
        lpTIB->lLastDataLen = lpOVB->lpBIB->lDataLen;
        lpOVB->eCommandState = S_COMPLETE;
        return SUCCESS;
        break;
    case S_COMPLETE:
        LogMsg(38, lpTIB->lTestNum, lpszCurrCmdName, CalcCmdExecTime(lpTIB));
        kpMCB->bConcurrencyWait = FALSE;
        lpOVB->eCommandState = S_NEXT;
        return SUCCESS;
        break;
    case S_FAILURE:
        LogMsg(51, lpTIB->lTestNum, lpszCurrCmdName, CalcCmdExecTime(lpTIB));
        kpMCB->bConcurrencyWait = FALSE;
        lpOVB->eCommandState = S_NEXT;
        return FAILURE;
        break;
    }
    /* Should never get here so its a logic error terminate immediately */
    SetTIBCodes(lpTIB, MTCC_FAIL, MTRC_LOGIC_FAIL);
    lpOVB->eCommandState = S_FAILURE;
    kpMCB->lProcessing = FAILURE;
    LogMsg(69, lpTIB->lTestNum, "ExecuteOverlayCmd\0");
    return FAILURE;
}


/*--------------------------------------------------------------------------*/
long
ExecuteExtractCmd(TestInfoBlk* lpTIB, CommandCtrlBlk* lpCCB)
{
    ControlInfoBlk* lpCIB;
    ExtractBlk*     lpEXB;
    VarInfoBlk*     lpVIB;
    char*           lpszCurrCmdName;
    char            lpszExtraInfo[EXTRA_MSG_INFO_LEN + 4];
    char            lpszExtractBuff[RESOLVE_BUFF_LEN + 4];
    char            lpszFmtBuff[RESOLVE_BUFF_LEN + 4];
    char            lpszVarValueFmtBuff[WORK_BUFF_LEN + 4];
    long            lExtractEnd;
    long            lNewNum;
    double          dNewDouble;

    /* Initialise common use local variables */
    lpCIB = kpMCB->lpCIB;
    lpEXB = (ExtractBlk*)lpCCB;
    lpszCurrCmdName = kpszEXTRACT;
    memset(lpszExtraInfo, 0x00, EXTRA_MSG_INFO_LEN + 4);

    /* Process according to current command state */
    switch(lpEXB->eCommandState)
    {
    case S_INIT:
        LogMsg(44, lpTIB->lTestNum, lpszCurrCmdName, "\0");
        lpTIB->lLastDataLen = 0;
        time(&lpEXB->oStartTime);
        lpEXB->oExpiryTime = lpEXB->oStartTime;
        lpEXB->oNextLogMsgTime = lpEXB->oStartTime;

        /* Running an initialisation so set concurrency wait false. */
        kpMCB->bConcurrencyWait = FALSE;

        /* Resolve any variable name subscripts before proceeding */
        ResolveSubscript(lpTIB, &lpEXB->lpszResVarName,
                         &lpEXB->lpszVarName, TRUE);
        ResolveValue(lpTIB, &lpEXB->lpszResPos,
                     &lpEXB->lpszPos, TRUE);
        ResolveValue(lpTIB, &lpEXB->lpszResLen,
                     &lpEXB->lpszLen, TRUE);
        if(FAILURE == lpTIB->bCmdResult)
        {
            SetTIBCodes(lpTIB, MTCC_FAIL, MTRC_INIT_FAIL);
            lpEXB->eCommandState = S_FAILURE;
            return FAILURE;
        }

        /* See if we can find the VIB on the TIB chain if not */
        /* then create a new string variable                  */
        lpEXB->lpVIB = FindVarInfoBlk(lpTIB->lpVIBHead,
                                      lpEXB->lpszResVarName);
        if(NULL == lpEXB->lpVIB)
        {
            lpEXB->lpVIB = CheckAndAddVIB(lpTIB, V_STR,
                                          lpEXB->lpszVarName,
                                          lpEXB->lpszResVarName,
                                          kpszSTRFMT);
            if(FAILURE == lpTIB->bCmdResult)
            {
                SetTIBCodes(lpTIB, MTCC_FAIL, MTRC_INIT_FAIL);
                lpEXB->eCommandState = S_FAILURE;
                return FAILURE;
            }

        }

        /* Convert position and length values to their numeric counterparts */
        lpEXB->lPos = ConvNum(lpTIB, lpEXB->lpszResPos, "Pos");
        lpEXB->lLen = ConvNum(lpTIB, lpEXB->lpszResLen, "Len");
        if(FAILURE == lpTIB->bCmdResult)
        {
            LogMsg(172, lpTIB->lTestNum, lpEXB->lpszResVarName, lpEXB->lpszResPos, lpEXB->lpszResLen);
            SetTIBCodes(lpTIB, MTCC_FAIL, MTRC_INIT_CONVNUM_FAIL);
            lpEXB->eCommandState = S_FAILURE;
            return FAILURE;
        }

        /* Resolve buffer name */
        ResolveValue(lpTIB, &lpEXB->lpszResBuffName,
                     &lpEXB->lpszBuffName, TRUE);
        if(FAILURE == lpTIB->bCmdResult)
        {
            SetTIBCodes(lpTIB, MTCC_FAIL, MTRC_INIT_RESOLVE_FAIL);
            lpEXB->eCommandState = S_FAILURE;
            return FAILURE;
        }

        /* Obtain a pointer to the buffer info block for this command */
        lpEXB->lpBIB = FindBuffInfoBlk(lpTIB->lpBIBHead, lpEXB->lpszResBuffName);
        if(! lpEXB->lpBIB)
        {
            /* No buffer to extract data from. Report the problem and fail */
            sprintf(lpszExtraInfo, "Unable to locate/allocate Buffer=%s\0",
                    lpEXB->lpszResBuffName);
            LogMsg(TEST_EXTRA_LINE_ERR, lpTIB->lTestNum, lpszExtraInfo);
            SetTIBCodes(lpTIB, MTCC_FAIL, MTRC_INIT_BUFF_FAIL);
            lpEXB->eCommandState = S_FAILURE;
            return FAILURE;
        }

        /* Now check to see if we have enough data to satisfy the request */
        lExtractEnd = lpEXB->lPos + lpEXB->lLen - 1;
        if(lExtractEnd > lpEXB->lpBIB->lDataLen)
        {
            LogMsg(173, lpTIB->lTestNum, lpEXB->lpszResVarName, lpEXB->lpszResPos,
                   lpEXB->lpszResLen, lpEXB->lpszResBuffName, lpEXB->lpBIB->lDataLen);
            SetTIBCodes(lpTIB, MTCC_FAIL, MTRC_INIT_FAIL);
            lpEXB->eCommandState = S_FAILURE;
            return FAILURE;
        }

        /* Now check we have not exceeded maxmimum work area length */
        if(lpEXB->lLen > RESOLVE_BUFF_LEN)
        {
            LogMsg(174, lpTIB->lTestNum, lpEXB->lpszResVarName,
                   lpEXB->lpszResPos, lpEXB->lpszResLen, RESOLVE_BUFF_LEN);
            SetTIBCodes(lpTIB, MTCC_FAIL, MTRC_INIT_FAIL);
            lpEXB->eCommandState = S_FAILURE;
            return FAILURE;
        }

        /* Ready to run */
        SetTIBCodes(lpTIB, MTCC_OK, MTRC_NONE);
        lpEXB->eCommandState = S_RUN;
        return SUCCESS;
        break;
    case S_RUN:
        LogMsg(45, lpTIB->lTestNum, lpszCurrCmdName, "\0");

        /* Clear the buffers */
        memset(lpszExtractBuff, 0x00, lpEXB->lLen + 4);
        memset(lpszFmtBuff, 0x00, RESOLVE_BUFF_LEN + 4);

        /* Copy the VIB pointer for local use */
        lpVIB = lpEXB->lpVIB;

        /* Copy the requested information to the data extract work buffer */
        memcpy(lpszExtractBuff, lpEXB->lpBIB->lpszBuff + lpEXB->lPos - 1, lpEXB->lLen);

        switch(lpVIB->eVarType)
        {
        case V_NUM:
            /* Check the number is numeric by calling ConvNum */
            lNewNum = ConvNum(lpTIB, lpszExtractBuff, lpVIB->lpszVarName);
            if(FAILURE == lpTIB->bCmdResult)
            {
                LogMsg(175, lpTIB->lTestNum, lpEXB->lpszResVarName,
                       lpEXB->lpszResPos, lpEXB->lpszResLen, lpszExtractBuff);
                SetTIBCodes(lpTIB, MTCC_FAIL, MTRC_RUN_FAIL);
                lpEXB->eCommandState = S_FAILURE;
                return FAILURE;
            }

            /* Release the old value if any */
            FreeIfNotNull((void**)&lpVIB->lpszCurrStrValue);
            
            /* Format the new value */
            sprintf(lpszFmtBuff, lpVIB->lpszVarFormat, lNewNum);
            
            /* Copy the new value to the VIB */
            lpVIB->lpszCurrStrValue = CloneString(lpszFmtBuff);
            
            /* Now log what we have done */
            if(FALSE == kpMCB->bLoggingSuppressed)
            {
                memset(lpszExtraInfo, 0x00, EXTRA_MSG_INFO_LEN + 4);
                memset(lpszVarValueFmtBuff, 0x00, WORK_BUFF_LEN + 4);
                strcpy(lpszVarValueFmtBuff, "%%%s%% number was assigned the value \"");
                strcat(lpszVarValueFmtBuff, lpVIB->lpszVarFormat);
                strcat(lpszVarValueFmtBuff, "\" Format=\"%s\"\0");
                sprintf(lpszExtraInfo, lpszVarValueFmtBuff, lpVIB->lpszVarName,
                        lNewNum, lpVIB->lpszVarFormat);
                LogMsg(176, lpTIB->lTestNum, lpEXB->lpszResVarName,
                       lpEXB->lpszResPos, lpEXB->lpszResLen, lpszExtraInfo);
            }
            break;
        case V_DOUBLE:
            /* Check the number is numeric by calling ConvDouble */
            dNewDouble = ConvDouble(lpTIB, lpszExtractBuff, lpVIB->lpszVarName);
            if(FAILURE == lpTIB->bCmdResult)
            {
                LogMsg(175, lpTIB->lTestNum, lpEXB->lpszResVarName,
                       lpEXB->lpszResPos, lpEXB->lpszResLen, lpszExtractBuff);
                SetTIBCodes(lpTIB, MTCC_FAIL, MTRC_RUN_FAIL);
                lpEXB->eCommandState = S_FAILURE;
                return FAILURE;
            }

            /* Release the old value if any */
            FreeIfNotNull((void**)&lpVIB->lpszCurrStrValue);
            
            /* Format the new value */
            sprintf(lpszFmtBuff, lpVIB->lpszVarFormat, dNewDouble);
            
            /* Copy the new value to the VIB */
            lpVIB->lpszCurrStrValue = CloneString(lpszFmtBuff);
            
            /* Now log what we have done */
            if(FALSE == kpMCB->bLoggingSuppressed)
            {
                memset(lpszExtraInfo, 0x00, EXTRA_MSG_INFO_LEN + 4);
                memset(lpszVarValueFmtBuff, 0x00, WORK_BUFF_LEN + 4);
                strcpy(lpszVarValueFmtBuff, "%%%s%% number was assigned the value \"");
                strcat(lpszVarValueFmtBuff, lpVIB->lpszVarFormat);
                strcat(lpszVarValueFmtBuff, "\" Format=\"%s\"\0");
                sprintf(lpszExtraInfo, lpszVarValueFmtBuff, lpVIB->lpszVarName,
                        dNewDouble, lpVIB->lpszVarFormat);
                LogMsg(176, lpTIB->lTestNum, lpEXB->lpszVarName,
                       lpEXB->lpszResPos, lpEXB->lpszResLen, lpszExtraInfo);
            }
            break;
        case V_STR:
            /* Release the old value if any */
            FreeIfNotNull((void**)&lpVIB->lpszCurrStrValue);
            /* Format the new value */
            sprintf(lpszFmtBuff, lpVIB->lpszVarFormat, lpszExtractBuff);
            /* Copy the new value to the VIB */
            lpVIB->lpszCurrStrValue = CloneString(lpszFmtBuff);
            /* Now log what we have done */
            if(FALSE == kpMCB->bLoggingSuppressed)
            {
                memset(lpszExtraInfo, 0x00, EXTRA_MSG_INFO_LEN + 4);
                sprintf(lpszExtraInfo, "%%%s%% string was assigned the value \"%s\"\0",
                        lpVIB->lpszVarName,
                        lpVIB->lpszCurrStrValue);
                LogMsg(176, lpTIB->lTestNum, lpEXB->lpszVarName,
                       lpEXB->lpszResPos, lpEXB->lpszResLen, lpszExtraInfo);
            }
            break;
        }

        /* All done */
        kpMCB->bConcurrencyWait = FALSE;
        SetTIBCodes(lpTIB, MTCC_OK, MTRC_NONE);
        lpEXB->eCommandState = S_COMPLETE;
        return SUCCESS;
        break;
    case S_COMPLETE:
        LogMsg(38, lpTIB->lTestNum, lpszCurrCmdName, CalcCmdExecTime(lpTIB));
        kpMCB->bConcurrencyWait = FALSE;
        lpEXB->eCommandState = S_NEXT;
        return SUCCESS;
        break;
    case S_FAILURE:
        LogMsg(51, lpTIB->lTestNum, lpszCurrCmdName, CalcCmdExecTime(lpTIB));
        kpMCB->bConcurrencyWait = FALSE;
        lpEXB->eCommandState = S_NEXT;
        return FAILURE;
        break;
    }
    /* Should never get here so its a logic error terminate immediately */
    SetTIBCodes(lpTIB, MTCC_FAIL, MTRC_LOGIC_FAIL);
    lpEXB->eCommandState = S_FAILURE;
    kpMCB->lProcessing = FAILURE;
    LogMsg(69, lpTIB->lTestNum, "ExecuteExtractCmd\0");
    return FAILURE;
}


/*--------------------------------------------------------------------------*/
long
ExecuteSubstringCmd(TestInfoBlk* lpTIB, CommandCtrlBlk* lpCCB)
{
    ControlInfoBlk* lpCIB;
    SubstringBlk*   lpSSB;
    VarInfoBlk*     lpVIB;
    char*           lpszCurrCmdName;
    char            lpszExtraInfo[EXTRA_MSG_INFO_LEN + 4];
    char            lpszSubstringBuff[RESOLVE_BUFF_LEN + 4];
    char            lpszFmtBuff[RESOLVE_BUFF_LEN + 4];
    char            lpszVarValueFmtBuff[WORK_BUFF_LEN + 4];
    long            lSubstringEnd;
    long            lFromVarLen;
    long            lNewNum;
    double          dNewDouble;

    /* Initialise common use local variables */
    lpCIB = kpMCB->lpCIB;
    lpSSB = (SubstringBlk*)lpCCB;
    lpszCurrCmdName = kpszSUBSTRING;
    memset(lpszExtraInfo, 0x00, EXTRA_MSG_INFO_LEN + 4);

    /* Process according to current command state */
    switch(lpSSB->eCommandState)
    {
    case S_INIT:
        LogMsg(44, lpTIB->lTestNum, lpszCurrCmdName, "\0");
        lpTIB->lLastDataLen = 0;
        time(&lpSSB->oStartTime);
        lpSSB->oExpiryTime = lpSSB->oStartTime;
        lpSSB->oNextLogMsgTime = lpSSB->oStartTime;

        /* Running an initialisation so set concurrency wait false. */
        kpMCB->bConcurrencyWait = FALSE;

        /* Resolve any variable name subscripts before proceeding */
        ResolveSubscript(lpTIB, &lpSSB->lpszResVarName,
                         &lpSSB->lpszVarName, TRUE);
        ResolveSubscript(lpTIB, &lpSSB->lpszResFromVarName,
                         &lpSSB->lpszFromVarName, TRUE);
        ResolveValue(lpTIB, &lpSSB->lpszResPos,
                     &lpSSB->lpszPos, TRUE);
        ResolveValue(lpTIB, &lpSSB->lpszResLen,
                     &lpSSB->lpszLen, TRUE);
        if(FAILURE == lpTIB->bCmdResult)
        {
            lpSSB->eCommandState = S_FAILURE;
            return FAILURE;
        }

        /* See if we can find the VIB on the TIB chain if not */
        /* then create a new string variable                  */
        lpSSB->lpVIB = FindVarInfoBlk(lpTIB->lpVIBHead,
                                      lpSSB->lpszResVarName);
        if(NULL == lpSSB->lpVIB)
        {
            lpSSB->lpVIB = CheckAndAddVIB(lpTIB, V_STR,
                                          lpSSB->lpszVarName,
                                          lpSSB->lpszResVarName,
                                          kpszSTRFMT);
            if(FAILURE == lpTIB->bCmdResult)
            {
                SetTIBCodes(lpTIB, MTCC_FAIL, MTRC_INIT_FAIL);
                lpSSB->eCommandState = S_FAILURE;
                return FAILURE;
            }

        }

        /* Obtain a pointer to the from var info block for this command */
        lpSSB->lpVIBFrom = FindVarInfoBlk(lpTIB->lpVIBHead, lpSSB->lpszResFromVarName);
        if(! lpSSB->lpVIBFrom)
        {
            /* No variable to substring data from. Report the problem and fail */
            sprintf(lpszExtraInfo, "Unable to locate variable From=%s\0",
                    lpSSB->lpszResFromVarName);
            LogMsg(TEST_EXTRA_LINE_ERR, lpTIB->lTestNum, lpszExtraInfo);
            SetTIBCodes(lpTIB, MTCC_FAIL, MTRC_INIT_BUFF_FAIL);
            lpSSB->eCommandState = S_FAILURE;
            return FAILURE;
        }

        /* Convert position and length values to their numeric counterparts */
        lpSSB->lPos = ConvNum(lpTIB, lpSSB->lpszResPos, "Pos");
        lpSSB->lLen = ConvNum(lpTIB, lpSSB->lpszResLen, "Len");
        if(FAILURE == lpTIB->bCmdResult)
        {
            LogMsg(186, lpTIB->lTestNum, lpSSB->lpszResVarName, lpSSB->lpszResFromVarName,
                   lpSSB->lpszResPos, lpSSB->lpszResLen);
            SetTIBCodes(lpTIB, MTCC_FAIL, MTRC_INIT_CONVNUM_FAIL);
            lpSSB->eCommandState = S_FAILURE;
            return FAILURE;
        }

        /* Now check to see if we have enough data to satisfy the request */
        lSubstringEnd = lpSSB->lPos + lpSSB->lLen - 1;
        lFromVarLen = StrlenNull(lpSSB->lpVIBFrom->lpszCurrStrValue);
        if(lSubstringEnd > lFromVarLen)
        {
            LogMsg(187, lpTIB->lTestNum, lpSSB->lpszResVarName, lpSSB->lpszResFromVarName,
                   lpSSB->lpszResPos, lpSSB->lpszResLen, lpSSB->lpszResFromVarName, lFromVarLen);
            SetTIBCodes(lpTIB, MTCC_FAIL, MTRC_INIT_FAIL);
            lpSSB->eCommandState = S_FAILURE;
            return FAILURE;
        }

        /* Now check we have not exceeded maxmimum work area length */
        if(lpSSB->lLen > RESOLVE_BUFF_LEN)
        {
            LogMsg(188, lpTIB->lTestNum, lpSSB->lpszResVarName, lpSSB->lpszResFromVarName, 
                   lpSSB->lpszResPos, lpSSB->lpszResLen, RESOLVE_BUFF_LEN);
            SetTIBCodes(lpTIB, MTCC_FAIL, MTRC_INIT_FAIL);
            lpSSB->eCommandState = S_FAILURE;
            return FAILURE;
        }

        /* Ready to run */
        SetTIBCodes(lpTIB, MTCC_OK, MTRC_NONE);
        lpSSB->eCommandState = S_RUN;
        return SUCCESS;
        break;
    case S_RUN:
        LogMsg(45, lpTIB->lTestNum, lpszCurrCmdName, "\0");

        /* Clear the buffers */
        memset(lpszSubstringBuff, 0x00, lpSSB->lLen + 4);
        memset(lpszFmtBuff, 0x00, RESOLVE_BUFF_LEN + 4);

        /* Copy the VIB pointer for local use */
        lpVIB = lpSSB->lpVIB;

        /* Copy the requested information to the data substring work buffer */
        memcpy(lpszSubstringBuff, lpSSB->lpVIBFrom->lpszCurrStrValue + lpSSB->lPos - 1, lpSSB->lLen);

        switch(lpVIB->eVarType)
        {
        case V_NUM:
            /* Check the number is numeric by calling ConvNum */
            lNewNum = ConvNum(lpTIB, lpszSubstringBuff, lpVIB->lpszVarName);
            if(FAILURE == lpTIB->bCmdResult)
            {
                LogMsg(189, lpTIB->lTestNum, lpSSB->lpszResVarName, lpSSB->lpszResFromVarName,
                       lpSSB->lpszResPos, lpSSB->lpszResLen, lpszSubstringBuff);
                SetTIBCodes(lpTIB, MTCC_FAIL, MTRC_RUN_FAIL);
                lpSSB->eCommandState = S_FAILURE;
                return FAILURE;
            }

            /* Release the old value if any */
            FreeIfNotNull((void**)&lpVIB->lpszCurrStrValue);
            
            /* Format the new value */
            sprintf(lpszFmtBuff, lpVIB->lpszVarFormat, lNewNum);
            
            /* Copy the new value to the VIB */
            lpVIB->lpszCurrStrValue = CloneString(lpszFmtBuff);
            
            /* Now log what we have done */
            if(FALSE == kpMCB->bLoggingSuppressed)
            {
                memset(lpszExtraInfo, 0x00, EXTRA_MSG_INFO_LEN + 4);
                memset(lpszVarValueFmtBuff, 0x00, WORK_BUFF_LEN + 4);
                strcpy(lpszVarValueFmtBuff, "%%%s%% number was assigned the value \"");
                strcat(lpszVarValueFmtBuff, lpVIB->lpszVarFormat);
                strcat(lpszVarValueFmtBuff, "\" Format=\"%s\"\0");
                sprintf(lpszExtraInfo, lpszVarValueFmtBuff, lpVIB->lpszVarName,
                        lNewNum, lpVIB->lpszVarFormat);
                LogMsg(190, lpTIB->lTestNum, lpSSB->lpszResVarName, lpSSB->lpszResFromVarName, 
                       lpSSB->lpszResPos, lpSSB->lpszResLen, lpszExtraInfo);
            }
            break;
        case V_DOUBLE:
            /* Check the number is numeric by calling ConvDouble */
            dNewDouble = ConvDouble(lpTIB, lpszSubstringBuff, lpVIB->lpszVarName);
            if(FAILURE == lpTIB->bCmdResult)
            {
                LogMsg(189, lpTIB->lTestNum, lpSSB->lpszResVarName, lpSSB->lpszResFromVarName,
                       lpSSB->lpszResPos, lpSSB->lpszResLen, lpszSubstringBuff);
                SetTIBCodes(lpTIB, MTCC_FAIL, MTRC_RUN_FAIL);
                lpSSB->eCommandState = S_FAILURE;
                return FAILURE;
            }

            /* Release the old value if any */
            FreeIfNotNull((void**)&lpVIB->lpszCurrStrValue);
            
            /* Format the new value */
            sprintf(lpszFmtBuff, lpVIB->lpszVarFormat, dNewDouble);
            
            /* Copy the new value to the VIB */
            lpVIB->lpszCurrStrValue = CloneString(lpszFmtBuff);
            
            /* Now log what we have done */
            if(FALSE == kpMCB->bLoggingSuppressed)
            {
                memset(lpszExtraInfo, 0x00, EXTRA_MSG_INFO_LEN + 4);
                memset(lpszVarValueFmtBuff, 0x00, WORK_BUFF_LEN + 4);
                strcpy(lpszVarValueFmtBuff, "%%%s%% number was assigned the value \"");
                strcat(lpszVarValueFmtBuff, lpVIB->lpszVarFormat);
                strcat(lpszVarValueFmtBuff, "\" Format=\"%s\"\0");
                sprintf(lpszExtraInfo, lpszVarValueFmtBuff, lpVIB->lpszVarName,
                        dNewDouble, lpVIB->lpszVarFormat);
                LogMsg(190, lpTIB->lTestNum, lpSSB->lpszResVarName, lpSSB->lpszResFromVarName,
                       lpSSB->lpszResPos, lpSSB->lpszResLen, lpszExtraInfo);
            }
            break;
        case V_STR:
            /* Release the old value if any */
            FreeIfNotNull((void**)&lpVIB->lpszCurrStrValue);
            /* Format the new value */
            sprintf(lpszFmtBuff, lpVIB->lpszVarFormat, lpszSubstringBuff);
            /* Copy the new value to the VIB */
            lpVIB->lpszCurrStrValue = CloneString(lpszFmtBuff);
            /* Now log what we have done */
            if(FALSE == kpMCB->bLoggingSuppressed)
            {
                memset(lpszExtraInfo, 0x00, EXTRA_MSG_INFO_LEN + 4);
                sprintf(lpszExtraInfo, "%%%s%% string was assigned the value \"%s\"\0",
                        lpVIB->lpszVarName,
                        lpVIB->lpszCurrStrValue);
                LogMsg(190, lpTIB->lTestNum, lpSSB->lpszResVarName, lpSSB->lpszResFromVarName,
                       lpSSB->lpszResPos, lpSSB->lpszResLen, lpszExtraInfo);
            }
            break;
        }

        /* All done */
        kpMCB->bConcurrencyWait = FALSE;
        SetTIBCodes(lpTIB, MTCC_OK, MTRC_NONE);
        lpSSB->eCommandState = S_COMPLETE;
        return SUCCESS;
        break;
    case S_COMPLETE:
        LogMsg(38, lpTIB->lTestNum, lpszCurrCmdName, CalcCmdExecTime(lpTIB));
        kpMCB->bConcurrencyWait = FALSE;
        lpSSB->eCommandState = S_NEXT;
        return SUCCESS;
        break;
    case S_FAILURE:
        LogMsg(51, lpTIB->lTestNum, lpszCurrCmdName, CalcCmdExecTime(lpTIB));
        kpMCB->bConcurrencyWait = FALSE;
        lpSSB->eCommandState = S_NEXT;
        return FAILURE;
        break;
    }
    /* Should never get here so its a logic error terminate immediately */
    SetTIBCodes(lpTIB, MTCC_FAIL, MTRC_LOGIC_FAIL);
    lpSSB->eCommandState = S_FAILURE;
    kpMCB->lProcessing = FAILURE;
    LogMsg(69, lpTIB->lTestNum, "ExecuteSubstringCmd\0");
    return FAILURE;
}


/*--------------------------------------------------------------------------*/
long
ExecuteGetMsgCmd(TestInfoBlk* lpTIB, CommandCtrlBlk* lpCCB)
{
    ControlInfoBlk*   lpCIB;
    GetMsgBlk*        lpGMB;
    VarInfoBlk*       lpVIBMQMD;
    VarInfoBlk*       lpVIBRFH2;
    RFH2InfoBlk*      lpRIB;
    IntervalInfoRec*  lpIIR;
    IfStartBlk*       lpIFSCheck;
    CommandCtrlBlk*   lpCCBCheckIf;
    char*             lpszCurrCmdName;
    char              lpszExtraInfo[EXTRA_MSG_INFO_LEN + 4];
    char              lpszWorkBuff[WORK_BUFF_LEN + 4];
    char              lpszFormatBuff[MQ_FORMAT_LENGTH + 4];
    MQMD              oMsgDesc;
    MQGMO             oGetOpts = {MQGMO_DEFAULT};
    long              lGmoNone = MQGMO_NONE;
    long              lMatchNone = MQMO_NONE;
    MQLONG            lCC;
    MQLONG            lRC;
    MQLONG            lGetDataLen;
    long              lCmdMaxWait;
    long              lGmoWait;
    time_t            oCurrTime;
    MQRFH2*           lpoRFH2;
    long              lRFH2DataLen;
    long              lRFH2WorkLen;
    long              lRFH2FolderLen;
    long*             lplFolderLen;
    char*             lpszFolderData;
    char*             lpszIntervalIn;
    long              lPCDBuffLen;
    long              lMsgLen;
    long              lCreateMIBResult;
    long              bDisplayMsg61;
    long              bMsg45Done;
    long              lMsgIntegerEncoding;
    long              lLogMsgRFH2CCSID;
    long              lLogMsgRFH2Encoding;
    MQLONG            holdVersion;
    char*             lpszMsgData;
    MQDLH*            lpDLH;
    MQXQH*            lpXQH;
    MQMDE*            lpMDE;

    /* Initialise common use local variables */
    lpCIB = kpMCB->lpCIB;
    lpGMB = (GetMsgBlk*)lpCCB;
    lpszCurrCmdName = kpszGETMSG;
    memset(lpszExtraInfo, 0x00, EXTRA_MSG_INFO_LEN + 4);
    lRFH2DataLen = 0;
    lMsgLen = 0;

    /* Process according to current command state */
    switch(lpGMB->eCommandState)
    {
    case S_INIT:
        LogMsg(44, lpTIB->lTestNum, lpszCurrCmdName, "\0");
        lpTIB->lLastDataLen = 0;
        lpTIB->lTestTotalGetMsg++;
        kpMCB->lScriptTotalGetMsg++;

        /* Running an initialisation so set concurrency wait false. */
        kpMCB->bConcurrencyWait = FALSE;

        /* Resolve buffer name */
        ResolveValue(lpTIB, &lpGMB->lpszResBuffName,
                     &lpGMB->lpszBuffName, TRUE);
        if(FAILURE == lpTIB->bCmdResult)
        {
            SetTIBCodes(lpTIB, MTCC_FAIL, MTRC_INIT_RESOLVE_FAIL);
            lpTIB->lTestFailedGetMsg++;
            kpMCB->lScriptFailedGetMsg++;
            lpGMB->eCommandState = S_FAILURE;
            return FAILURE;
        }

        /* Obtain a pointer to the buffer info block for this command */
        lpGMB->lpBIB = CheckAndAddBIB(lpTIB, lpGMB->lpszResBuffName);
        if(! lpGMB->lpBIB)
        {
            /* No buffer to get the message into. Report the problem and fail */
            sprintf(lpszExtraInfo, "Unable to locate/allocate Buffer=%s\0",
                    lpGMB->lpszResBuffName);
            LogMsg(TEST_EXTRA_LINE_ERR, lpTIB->lTestNum, lpszExtraInfo);
            SetTIBCodes(lpTIB, MTCC_FAIL, MTRC_INIT_BUFF_FAIL);
            lpTIB->lTestFailedGetMsg++;
            kpMCB->lScriptFailedGetMsg++;
            lpGMB->eCommandState = S_FAILURE;
            return FAILURE;
        }

        /* If we dont yet have a buffer allocate one */
        if(! lpGMB->lpBIB->lpszBuff)
        {
            lpGMB->lpBIB->lpszBuff = malloc(INITIAL_BUFF_LEN + 8);
            if(lpGMB->lpBIB->lpszBuff)
            {
                /* Clear the new buffer and report its allocation */
                memset(lpGMB->lpBIB->lpszBuff, 0x00, INITIAL_BUFF_LEN + 8);
                lpGMB->lpBIB->lDataLen = 0;
                lpGMB->lpBIB->lBuffLen = INITIAL_BUFF_LEN;
                if(FALSE == kpMCB->bLoggingSuppressed)
                {
                    sprintf(lpszExtraInfo, "Buffer=%s BuffLen=%d bytes allocated\0",
                            lpGMB->lpBIB->lpszBuffName,
                            lpGMB->lpBIB->lBuffLen);
                    LogMsg(TEST_EXTRA_LINE, lpTIB->lTestNum, lpszExtraInfo);
                }
            }
            else
            {
                /* Couldn't get a buffer log the problem and fail the test */
                sprintf(lpszExtraInfo, "Buffer=%s BuffLen=%d malloc() failed.\0",
                        lpGMB->lpBIB->lpszBuffName,
                        INITIAL_BUFF_LEN);
                LogMsg(TEST_EXTRA_LINE_ERR, lpTIB->lTestNum, lpszExtraInfo);
                SetTIBCodes(lpTIB, MTCC_FAIL, MTRC_INIT_BUFF_FAIL);
                lpTIB->lTestFailedGetMsg++;
                kpMCB->lScriptFailedGetMsg++;
                lpGMB->eCommandState = S_FAILURE;
                return FAILURE;
            }
        }

        /* Resolve the queue name and command max wait values */
        ResolveValue(lpTIB, &lpGMB->lpszResQName,
                     &lpGMB->lpszQName, TRUE);
        ResolveValue(lpTIB, &lpGMB->lpszResCmdMaxWait,
                     &lpGMB->lpszCmdMaxWait, TRUE);
        ResolveValue(lpTIB, &lpGMB->lpszResGmoWait,
                     &lpGMB->lpszGmoWait, TRUE);

        /* Free resolved MsgId, CorrelId, GroupId and MsgSeqNumber */
        /* as need to make sure they are NULL                      */
        FreeIfNotNull((void**)&lpGMB->lpszResMsgId);
        FreeIfNotNull((void**)&lpGMB->lpszResCorrelId);
        FreeIfNotNull((void**)&lpGMB->lpszResGroupId);
        FreeIfNotNull((void**)&lpGMB->lpszResMsgSeqNumber);

        /* If we have a command level MsgId or CorrelId then resolve them */
        if(lpGMB->lpszMsgId)
        {
            ResolveValue(lpTIB, &lpGMB->lpszResMsgId,
                         &lpGMB->lpszMsgId, TRUE);
        }
        if(lpGMB->lpszCorrelId)
        {
            ResolveValue(lpTIB, &lpGMB->lpszResCorrelId,
                         &lpGMB->lpszCorrelId, TRUE);
        }
        if(lpGMB->lpszGroupId)
        {
            ResolveValue(lpTIB, &lpGMB->lpszResGroupId,
                         &lpGMB->lpszGroupId, TRUE);
        }
        if(lpGMB->lpszMsgSeqNumber)
        {
            ResolveValue(lpTIB, &lpGMB->lpszResMsgSeqNumber,
                         &lpGMB->lpszMsgSeqNumber, TRUE);
        }

        /* Problems with variable resolution time to give up     */
        if(FAILURE == lpTIB->bCmdResult)
        {
            SetTIBCodes(lpTIB, MTCC_FAIL, MTRC_INIT_RESOLVE_FAIL);
            lpTIB->lTestFailedGetMsg++;
            kpMCB->lScriptFailedGetMsg++;
            lpGMB->eCommandState = S_FAILURE;
            return FAILURE;
        }

        /* Determine the maximum wait time */
        lCmdMaxWait = ConvNum(lpTIB, lpGMB->lpszResCmdMaxWait, "CmdMaxWait");
        if(FAILURE == lpTIB->bCmdResult)
        {
            sprintf(lpszExtraInfo, "CmdMaxWait=%s not numeric\0",
                    lpGMB->lpszResCmdMaxWait);
            LogMsg(TEST_EXTRA_LINE_ERR, lpTIB->lTestNum, lpszExtraInfo);
            SetTIBCodes(lpTIB, MTCC_FAIL, MTRC_INIT_CONVNUM_FAIL);
            lpTIB->lTestFailedGetMsg++;
            kpMCB->lScriptFailedGetMsg++;
            lpGMB->eCommandState = S_FAILURE;
            return FAILURE;
        }
        if(-1 == lCmdMaxWait)
        {
            lpGMB->lMaxWait = lpCIB->lTestMaxWait;
        }
        else
        {
            lpGMB->lMaxWait = lCmdMaxWait;
        }
        time(&lpGMB->oStartTime);
        lpGMB->oExpiryTime = lpGMB->oStartTime + lpGMB->lMaxWait;
        lpGMB->oNextLogMsgTime = lpGMB->oStartTime;

        /* Determine the GMO wait time */
        lGmoWait = ConvNum(lpTIB, lpGMB->lpszResGmoWait, "GmoWait");
        if(FAILURE == lpTIB->bCmdResult)
        {
            sprintf(lpszExtraInfo, "GmoWait=%s not numeric\0",
                    lpGMB->lpszResGmoWait);
            LogMsg(TEST_EXTRA_LINE_ERR, lpTIB->lTestNum, lpszExtraInfo);
            SetTIBCodes(lpTIB, MTCC_FAIL, MTRC_INIT_CONVNUM_FAIL);
            lpTIB->lTestFailedGetMsg++;
            kpMCB->lScriptFailedGetMsg++;
            lpGMB->eCommandState = S_FAILURE;
            return FAILURE;
        }
        lpGMB->lGmoWait = lGmoWait;

        /* Resolve the MQMD and RFH2 variable names */
        ResolveSubscript(lpTIB, &lpGMB->lpszResMQMDVarName, &lpGMB->lpszMQMDVarName, TRUE);
        ResolveSubscript(lpTIB, &lpGMB->lpszResRFH2VarName, &lpGMB->lpszRFH2VarName, TRUE);
        ResolveValue(lpTIB, &lpGMB->lpszResConnectionName, &lpGMB->lpszConnectionName, TRUE);
        if(FAILURE == lpTIB->bCmdResult)
        {
            SetTIBCodes(lpTIB, MTCC_FAIL, MTRC_INIT_RESOLVE_FAIL);
            lpTIB->lTestFailedGetMsg++;
            kpMCB->lScriptFailedGetMsg++;
            lpGMB->eCommandState = S_FAILURE;
            return FAILURE;
        }

        /* Update the last queue and queue manager referenced internal values */
        lpTIB->lpszLastQ = CloneString(lpGMB->lpszResQName);
        lpTIB->lpszLastQMgr = CloneString(kpszEmptyString);

        /* Locate the connection definition block for this command */
        lpGMB->lpCDB = FindConnectionDefBlk(kpMCB->lpCDBHead, lpGMB->lpszResConnectionName);
        if(NULL == lpGMB->lpCDB)
        {
            LogMsg(194, lpGMB->lpszResConnectionName);
            SetTIBCodes(lpTIB, MTCC_FAIL, MTRC_INIT_FAIL);
            lpTIB->lTestFailedGetMsg++;
            kpMCB->lScriptFailedGetMsg++;
            lpGMB->eCommandState = S_FAILURE;
            return FAILURE;
        }

        /* Got a buffer now try to open the queue */
        lpGMB->lpQIB = OpenQueue(lpTIB, lpGMB->lpCDB, lpTIB->lpQIBHead,
                                 lpGMB->lpszResQName, kpszEmptyString,
                                 kpszEmptyString, FALSE);
        if(! lpGMB->lpQIB)
        {
            /* Couldn't open the queue log the problem and fail the test */
            sprintf(lpszExtraInfo, "TargQ=\"%s\" TargQMgr=\"%s\" ConnQMgr=\"%s\" open failed\0",
                    lpGMB->lpszResQName,
                    kpszEmptyString,
                    lpGMB->lpCDB->lpszConnQMgrName);
            LogMsg(TEST_EXTRA_LINE_ERR, lpTIB->lTestNum, lpszExtraInfo);
            lpTIB->lTestFailedGetMsg++;
            kpMCB->lScriptFailedGetMsg++;
            /* If the next command is an <If...> that contains a check of either */
            /* LastCC or LastRC then do not fail this command. Instead permit    */
            /* processing to continue at the <If...>                             */
            if(NULL != lpCCB->lpCCBNext)
            {
                lpCCBCheckIf = (CommandCtrlBlk*)lpCCB->lpCCBNext;
                if(C_IFSTART == lpCCBCheckIf->eCommandType)
                {
                    lpIFSCheck = (IfStartBlk*) lpCCBCheckIf;
                    if((TRUE == lpIFSCheck->bACondChecksLastCC) || (TRUE == lpIFSCheck->bACondChecksLastRC))
                    {
                        lpGMB->eCommandState = S_COMPLETE;
                        return SUCCESS;
                    }
                }
            }
            lpGMB->eCommandState = S_FAILURE;
            return FAILURE;
        }

        /* Copacetic. Ready to run */
        lpGMB->bRunDoneOnce = FALSE;
        SetTIBCodes(lpTIB, MTCC_OK, MTRC_NONE);
        lpGMB->eCommandState = S_RUN;
        return SUCCESS;
        break;
    case S_RUN:
        /* Work out how much time has elapsed as all log messages   */
        /* for the GetMsg command include this information          */
        time(&oCurrTime);
        sprintf(lpszExtraInfo, " MaxWait=%d:%d\0", lpGMB->lMaxWait,
                oCurrTime - lpGMB->oStartTime);
        bMsg45Done = FALSE;
        /* Only display header and variable resolution messages once */
        if(lpGMB->bRunDoneOnce)
        {
            bDisplayMsg61 = FALSE;
        }
        else
        {
            bDisplayMsg61 = TRUE;
            lpGMB->bRunDoneOnce = TRUE;
            LogMsg(45, lpTIB->lTestNum, lpszCurrCmdName, lpszExtraInfo);
            bMsg45Done = TRUE;
        }

        /* Get a pointer to the VIB for the MQMD. See if we can find the */
        /* VIB on the TIB chain if not then we need to create one        */
        lpVIBMQMD = CheckAndAddVIB(lpTIB, V_MQMD,
                                   lpGMB->lpszMQMDVarName,
                                   lpGMB->lpszResMQMDVarName,
                                   NULL);
        if(FAILURE == lpTIB->bCmdResult)
        {
            SetTIBCodes(lpTIB, MTCC_FAIL, MTRC_RUN_FAIL);
            lpTIB->lTestFailedGetMsg++;
            kpMCB->lScriptFailedGetMsg++;
            lpGMB->eCommandState = S_FAILURE;
            return FAILURE;
        }

        /* Set up the MQMD prior to calling MQGET */
        SetMQMDFromMIB(lpTIB, lpVIBMQMD->lpCtrlBlk,
                       lpGMB->lpszResMsgId, lpGMB->lpszResCorrelId,
                       lpGMB->lpszResGroupId, lpGMB->lpszResMsgSeqNumber,
                       NULL, &oMsgDesc, TRUE, bDisplayMsg61);

        /* Problems with setting the MQMD time to give up */
        if(FAILURE == lpTIB->bCmdResult)
        {
            SetTIBCodes(lpTIB, MTCC_FAIL, MTRC_RUN_FAIL);
            lpTIB->lTestFailedGetMsg++;
            kpMCB->lScriptFailedGetMsg++;
            lpGMB->eCommandState = S_FAILURE;
            return FAILURE;
        }

        /* Process get message options */
        if(0 < StrlenNull(lpGMB->lpszGmoOptions))
        {
            /* If the first two characters are 0x the GmoOptions value is in hex */
            if(0 == memcmp(lpGMB->lpszGmoOptions, "0x", 2))
            {
                HexToLong(&oGetOpts.Options, lpGMB->lpszGmoOptions + 2);
            }
            else
            {
                TranslateToValue(lpTIB, &oGetOpts.Options, &lGmoNone, lpGMB->lpszGmoOptions, Q_MQGMO);
            }
        }
        else
        {
            /* Set the syncpointing option */
            if(FALSE == lpGMB->bSyncpoint)
            {
                oGetOpts.Options = MQGMO_NO_SYNCPOINT | MQGMO_FAIL_IF_QUIESCING;
            }
            else
            {
                oGetOpts.Options = MQGMO_SYNCPOINT | MQGMO_FAIL_IF_QUIESCING;
            }

            /* Set the GMO convert option */
            if(TRUE == lpGMB->bConvert)
            {
                oGetOpts.Options |= MQGMO_CONVERT;
            }
        }

        /* The GmoWait and Browse options always work. As it becomes too complicated */
        /* to try and provide these capabilities with even more switches             */

        /* If we have a GMO wait then set the time value and option bit    */
        if(0 != lpGMB->lGmoWait)
        {
            oGetOpts.Options |= MQGMO_WAIT;
            oGetOpts.WaitInterval = lpGMB->lGmoWait;
        }

        /* Now handle browsing options if any */
        switch(lpGMB->eBrowseType)
        {
        case B_BROWSEFIRST:
            oGetOpts.Options |= MQGMO_BROWSE_FIRST;
            break;
        case B_BROWSENEXT:
            oGetOpts.Options |= MQGMO_BROWSE_NEXT;
            break;
        case B_BROWSEAUTO:
            /* If the current for loop value is equal to the from value then */
            /* for our purposes this is the first iteration of the loop      */
            if(lpGMB->lpBreakContinueFSB)
            {
                if(lpGMB->lpBreakContinueFSB->lCurrent == lpGMB->lpBreakContinueFSB->lFrom)
                {
                    oGetOpts.Options |= MQGMO_BROWSE_FIRST;
                }
                else
                {
                    oGetOpts.Options |= MQGMO_BROWSE_NEXT;
                }
            }
            else
            {
                /* No <For> loop so just use browse first */
                oGetOpts.Options |= MQGMO_BROWSE_FIRST;
            }
            break;
        }

        /* Process the match options for the get message options */
        if(0 < StrlenNull(lpGMB->lpszGmoMatchOptions))
        {
            /* Match options require the use of a version 2 MQGMO */
            oGetOpts.Version = MQGMO_VERSION_2;
            /* If the first two characters are 0x the PmoOptions value is in hex */
            if(0 == memcmp(lpGMB->lpszGmoMatchOptions, "0x", 2))
            {
                HexToLong(&oGetOpts.MatchOptions, lpGMB->lpszGmoMatchOptions + 2);
            }
            else
            {
                TranslateToValue(lpTIB, &oGetOpts.MatchOptions, &lMatchNone, lpGMB->lpszGmoMatchOptions, Q_MQMO);
            }

        }

        /* Ok lets do it */
        lGetDataLen = 0;
        MQGET(lpGMB->lpQIB->hConn, lpGMB->lpQIB->hQ, &oMsgDesc, &oGetOpts,
              lpGMB->lpBIB->lBuffLen, lpGMB->lpBIB->lpszBuff,
              &lGetDataLen, &lCC, &lRC);
        /* If the buffer was too small increase its size */
        if(MQRC_TRUNCATED_MSG_FAILED == lRC)
        {
            if(! bMsg45Done)
            {
                LogMsg(45, lpTIB->lTestNum, lpszCurrCmdName, lpszExtraInfo);
                bMsg45Done = TRUE;
            }
            /* Free the current buffer */
            FreeIfNotNull((void**)&lpGMB->lpBIB->lpszBuff);
            if(FALSE == kpMCB->bLoggingSuppressed)
            {
                sprintf(lpszExtraInfo, "Buffer=%s BuffLen=%d bytes freed\0",
                        lpGMB->lpBIB->lpszBuffName,
                        lpGMB->lpBIB->lBuffLen);
                LogMsg(TEST_EXTRA_LINE, lpTIB->lTestNum, lpszExtraInfo);
            }

            /* Re-Allocate a buffer for the MQGET on a 1k boundary */
            lpGMB->lpBIB->lDataLen = 0;
            lpGMB->lpBIB->lBuffLen = ((lGetDataLen / 1024) + 1) * 1024;
            lpGMB->lpBIB->lpszBuff = malloc(lpGMB->lpBIB->lBuffLen + 8);
            if(! lpGMB->lpBIB->lpszBuff)
            {
                /* Couldnt get a buffer report the problem and fail the test */
                sprintf(lpszExtraInfo, "Buffer=%s BuffLen=%d malloc() failed.\0",
                        lpGMB->lpBIB->lpszBuffName,
                        lpGMB->lpBIB->lBuffLen);
                LogMsg(TEST_EXTRA_LINE_ERR, lpTIB->lTestNum, lpszExtraInfo);
                SetTIBCodes(lpTIB, MTCC_FAIL, MTRC_RUN_BUFF_FAIL);
                lpTIB->lTestFailedGetMsg++;
                kpMCB->lScriptFailedGetMsg++;
                lpGMB->eCommandState = S_FAILURE;
                return FAILURE;
            }

            /* Clear the new buffer and report its allocation */
            memset(lpGMB->lpBIB->lpszBuff, 0x00, lpGMB->lpBIB->lBuffLen + 8);
            if(FALSE == kpMCB->bLoggingSuppressed)
            {
                sprintf(lpszExtraInfo, "Buffer=%s BuffLen=%d bytes allocated\0",
                        lpGMB->lpBIB->lpszBuffName,
                        lpGMB->lpBIB->lBuffLen);
                LogMsg(TEST_EXTRA_LINE, lpTIB->lTestNum, lpszExtraInfo);
            }

            /* Set up the MQMD prior to calling MQGET */
            SetMQMDFromMIB(lpTIB, lpVIBMQMD->lpCtrlBlk,
                           lpGMB->lpszResMsgId, lpGMB->lpszResCorrelId,
                           lpGMB->lpszResGroupId, lpGMB->lpszResMsgSeqNumber,
                           NULL, &oMsgDesc, TRUE, bDisplayMsg61);

            /* Problems with setting the MQMD time to give up */
            if(FAILURE == lpTIB->bCmdResult)
            {
                SetTIBCodes(lpTIB, MTCC_FAIL, MTRC_RUN_FAIL);
                lpTIB->lTestFailedGetMsg++;
                kpMCB->lScriptFailedGetMsg++;
                lpGMB->eCommandState = S_FAILURE;
                return FAILURE;
            }

            /* Get the message again */
            lGetDataLen = 0;
            MQGET(lpGMB->lpQIB->hConn, lpGMB->lpQIB->hQ, &oMsgDesc, &oGetOpts,
                  lpGMB->lpBIB->lBuffLen, lpGMB->lpBIB->lpszBuff,
                  &lGetDataLen, &lCC, &lRC);
        }

        /* If a conversion error occured log the fact, and if it recognisably */
        /* has an RFH2 header then check the encoding to see if we need to    */
        /* handle a big-endian vs little-endian conversion of the lengths     */
        if((MQRC_FORMAT_ERROR == lRC) ||
           (MQRC_NOT_CONVERTED == lRC))
        {
            /* Copy the format from the MQMD for display and checking */
            memset(lpszFormatBuff, 0x00, MQ_FORMAT_LENGTH + 4);
            memcpy(lpszFormatBuff, &oMsgDesc.Format, MQ_FORMAT_LENGTH);
            LogMsg(110, lCC, lRC, lpszFormatBuff, kpszMQMD, oMsgDesc.CodedCharSetId, oMsgDesc.Encoding);
            /* Check to see if the common error of format names  */
            /* with trailing nulls instead of blanks has occured */
            if(0x00 == lpszFormatBuff[7])
            {
                LogMsg(111, lpszFormatBuff, kpszMQMD);
            }
            /* If we have an RFH2 header extract information from it */
            if(0 == memcmp(&oMsgDesc.Format, MQFMT_RF_HEADER_2, MQ_FORMAT_LENGTH))
            {
                lpoRFH2 = (MQRFH2*)lpGMB->lpBIB->lpszBuff;
                lLogMsgRFH2CCSID = lpoRFH2->CodedCharSetId;
                lLogMsgRFH2Encoding = lpoRFH2->Encoding;
                /* If the integer encoding is different reverse the CCSID and Encoding */
                /* values in the RFH2 header for use in the log message                */
                lMsgIntegerEncoding = oMsgDesc.Encoding & MQENC_INTEGER_MASK;
                if(lMsgIntegerEncoding != kpMCB->lLocalIntegerEncoding)
                {
                    ReverseLong(&lLogMsgRFH2CCSID);
                    ReverseLong(&lLogMsgRFH2Encoding);
                }
                /* ???TA Long term need to translate lpszFormatBuff */
                memset(lpszFormatBuff, 0x00, MQ_FORMAT_LENGTH + 4);
                memcpy(lpszFormatBuff, &lpoRFH2->Format, MQ_FORMAT_LENGTH);
                LogMsg(110, lCC, lRC, lpszFormatBuff, kpszRFH2, lLogMsgRFH2CCSID, lLogMsgRFH2Encoding);
                /* Check to see if the common error of format names  */
                /* with trailing nulls instead of blanks has occured */
                if(0x00 == lpszFormatBuff[7])
                {
                    LogMsg(111, lpszFormatBuff, kpszRFH2);
                }
            }
        }

        /* Check current reason code against BreakOnRC reason codes */
        if(0 < lpGMB->lBreakOnRCCount)
        {
            if(TRUE == FindRC(lpGMB->lBreakOnRCCount, lpGMB->lBreakOnRC, lRC))
            {
                LogMsgCorrelAndGroupIds(lpTIB, &oMsgDesc);
                if(lpGMB->lpBreakContinueFSB)
                {
                    LogMsg(118, lpTIB->lTestNum, kpszGETMSG, lCC, lRC, "Ending For/ForEver/ForEach loop Name=\0", lpGMB->lpBreakContinueFSB->lpszForName);
                }
                else
                {
                    LogMsg(118, lpTIB->lTestNum, kpszGETMSG, lCC, lRC, "Ending Test Name=\0", lpTIB->lpszTestName);
                }
                lpGMB->lpBIB->lDataLen = 0;
                lpTIB->lpBreakContinueFSB = lpGMB->lpBreakContinueFSB;
                kpMCB->bConcurrencyWait = FALSE;
                SetTIBCodes(lpTIB, lCC, lRC);
                lpGMB->eCommandState = S_BREAK;
                return SUCCESS;
            }
        }

        /* Check current reason code against ContinueOnRC reason codes */
        if(0 < lpGMB->lContinueOnRCCount)
        {
            if(TRUE == FindRC(lpGMB->lContinueOnRCCount, lpGMB->lContinueOnRC, lRC))
            {
                LogMsgCorrelAndGroupIds(lpTIB, &oMsgDesc);

                if(lpGMB->lpBreakContinueFSB)
                {
                    LogMsg(119, lpTIB->lTestNum, kpszGETMSG, lCC, lRC, "Continuing For/ForEver/ForEach loop Name=\0", lpGMB->lpBreakContinueFSB->lpszForName);
                }
                else
                {
                    LogMsg(119, lpTIB->lTestNum, kpszGETMSG, lCC, lRC, "Ending Test Name=\0", lpTIB->lpszTestName);
                }
                lpGMB->lpBIB->lDataLen = 0;
                lpTIB->lpBreakContinueFSB = lpGMB->lpBreakContinueFSB;
                kpMCB->bConcurrencyWait = FALSE;
                SetTIBCodes(lpTIB, lCC, lRC);
                lpGMB->eCommandState = S_CONTINUE;
                return SUCCESS;
            }
        }

        /* Check the current reason code against the suppression list */
        /* Suppression is done last as it changes the reason code     */
        if(0 < lpGMB->lSuppressRCCount)
        {
            if(TRUE == FindRC(lpGMB->lSuppressRCCount, lpGMB->lSuppressRC, lRC))
            {
                LogMsg(117, lpTIB->lTestNum, kpszGETMSG, lCC, lRC);
                /* If it was a full on failure rather than a warning then */
                /* no data was obtained so set the length accordingly     */
                if(MQCC_FAILED == lCC)
                {
                    lGetDataLen = 0;
                }
                lCC = 0;
                lRC = 0;
            }
        }

        /* Check the result of the MQGET */
        if(MQRC_NONE == lRC)
        {
            /* Only attempt to manipulate headers if lGetDataLen has not been */
            /* set to zero by ReasonCode suppression                          */
            if(0 < lGetDataLen)
            {
                /* Have we been requested to remove Dead Letter Headers if present */
                if(TRUE == lpGMB->bRemoveDLH)
                {
                    if(0 == memcmp(MQFMT_DEAD_LETTER_HEADER, oMsgDesc.Format, MQ_FORMAT_LENGTH))
                    {
                        /* Copy original message information from the dead letter header */
                        /* in particularer the values for Encoding, CCSID and Format     */
                        lpDLH = (MQDLH*)lpGMB->lpBIB->lpszBuff;
                        oMsgDesc.Encoding = lpDLH->Encoding;
                        oMsgDesc.CodedCharSetId = lpDLH->CodedCharSetId;
                        memcpy(oMsgDesc.Format, lpDLH->Format, MQ_FORMAT_LENGTH);

                        /* Adjust data length and pointer past the Dead Letter Header */
                        lGetDataLen -= sizeof(MQDLH);
                        lpszMsgData = lpGMB->lpBIB->lpszBuff + sizeof(MQDLH);
                        if(FALSE == kpMCB->bLoggingSuppressed)
                        {
                            LogMsg(253, lpTIB->lTestNum, "Dead Letter Header(MQDLH)\0", sizeof(MQDLH));
                        }

                        /* Finally shift the data in the buffer */
                        memcpy(lpGMB->lpBIB->lpszBuff, lpszMsgData, lGetDataLen);
                    }
                }

                /* Have we been requested to remove Transmit Queue Headers if present */
                if(TRUE == lpGMB->bRemoveXQH)
                {
                    /* Is there actually a Transmit Queue Header present */
                    if(0 == memcmp(MQFMT_XMIT_Q_HEADER, oMsgDesc.Format, MQ_FORMAT_LENGTH))
                    {
                        /* Point to the Transmit Queue Header */
                        lpXQH = (MQXQH*)lpGMB->lpBIB->lpszBuff;
                    
                        /* Hold the version under which the message was read then copy the V1 */
                        /* MQMD that forms part of the MQXQH into our message descriptor      */
                        holdVersion = oMsgDesc.Version;
                        memcpy(&oMsgDesc, &lpXQH->MsgDesc, sizeof(MQMD1));
                        oMsgDesc.Version = holdVersion;
                    
                        /* Adjust data length and pointer past the Transmit Queue Header */
                        lGetDataLen -= sizeof(MQXQH);
                        lpszMsgData = lpGMB->lpBIB->lpszBuff + sizeof(MQXQH);
                        if(FALSE == kpMCB->bLoggingSuppressed)
                        {
                            LogMsg(253, lpTIB->lTestNum, "Transmit Queue Header(MQXQH)\0", sizeof(MQXQH));
                        }

                        /* Is there also a Message Descriptor Extension present */
                        if(0 == memcmp(MQFMT_MD_EXTENSION, oMsgDesc.Format, MQ_FORMAT_LENGTH))
                        {
                            /* Point to the Message Descriptor Extension */
                            lpMDE = (MQMDE*)lpszMsgData;
                    
                            /* Now copy the relevant elements of the Message Descriptor Extension */
                            oMsgDesc.Encoding = lpMDE->Encoding;
                            oMsgDesc.CodedCharSetId = lpMDE->CodedCharSetId;
                            memcpy(&oMsgDesc.Format, &lpMDE->Format, MQ_FORMAT_LENGTH);
                            memcpy(&oMsgDesc.GroupId, &lpMDE->GroupId, MQ_GROUP_ID_LENGTH);
                            oMsgDesc.MsgSeqNumber = lpMDE->MsgSeqNumber;
                            oMsgDesc.Offset = lpMDE->Offset;
                            oMsgDesc.MsgFlags = lpMDE->MsgFlags;
                            oMsgDesc.OriginalLength = lpMDE->OriginalLength;
                    
                            /* Adjust data length and pointer past the transmit queue header */
                            lGetDataLen -= sizeof(MQMDE);
                            lpszMsgData += sizeof(MQMDE);
                            if(FALSE == kpMCB->bLoggingSuppressed)
                            {
                                LogMsg(253, lpTIB->lTestNum, "Message Descriptor Extension(MQMDE)\0", sizeof(MQMDE));
                            }
                        }

                        /* Finally shift the data in the buffer */
                        memcpy(lpGMB->lpBIB->lpszBuff, lpszMsgData, lGetDataLen);
                    }
                }
            }

            /* Are expecting interval information in the MsgId */
            if(lpGMB->bIntervalInMsgId)
            {
                /* Check its actually one of our message id's */
                if(0 == memcmp((char*)&oMsgDesc.MsgId[0], kpszMSGT, 4))
                {
                    /* Add an Interval Info record to the Interval Info block */
                    if(lpGMB->lpIIB)
                    {
                        /* Create an Interval Info record */
                        lpIIR = CreateAndAddIntervalInfoRec(lpGMB->lpIIB);
                        if(! lpIIR)
                        {
                            SetTIBCodes(lpTIB, MTCC_FAIL, MTRC_RUN_FAIL);
                            lpTIB->lTestFailedGetMsg++;
                            kpMCB->lScriptFailedGetMsg++;
                            lpGMB->eCommandState = S_FAILURE;
                            return FAILURE;
                        }
                        /* Populate the Interval Info record */
                        lpszIntervalIn = (char*)&oMsgDesc.MsgId[0] + 16;
                        lpIIR->bHaveStart = TRUE;
                        memcpy(&lpIIR->i64IntervalStart, lpszIntervalIn, 8);
                        SetIntervalEnd(lpIIR);
                        if(TRUE == lpGMB->lpIIB->bHaveIntervalFile)
                        {
                            WriteIntervalRecord(lpGMB->lpIIB, lpIIR);
                            if(FAILURE == kpMCB->lProcessing)
                            {
                                SetTIBCodes(lpTIB, MTCC_FAIL, MTRC_RUN_FAIL);
                                lpTIB->lTestFailedGetMsg++;
                                kpMCB->lScriptFailedGetMsg++;
                                lpGMB->eCommandState = S_FAILURE;
                                return FAILURE;
                            }
                        }
                    }
                }
            }

            /* Are expecting interval information in the CorrelId */
            if(lpGMB->bIntervalInCorrelId)
            {
                /* Check its actually one of our correlation id's */
                if(0 == memcmp((char*)&oMsgDesc.CorrelId[0], kpszMSGT, 4))
                {
                    /* Add an Interval Info record to the Interval Info block */
                    if(lpGMB->lpIIB)
                    {
                        /* Create an Interval Info record */
                        lpIIR = CreateAndAddIntervalInfoRec(lpGMB->lpIIB);
                        if(! lpIIR)
                        {
                            SetTIBCodes(lpTIB, MTCC_FAIL, MTRC_RUN_FAIL);
                            lpTIB->lTestFailedGetMsg++;
                            kpMCB->lScriptFailedGetMsg++;
                            lpGMB->eCommandState = S_FAILURE;
                            return FAILURE;
                        }
                        /* Populate the Interval Info record */
                        lpszIntervalIn = (char*)&oMsgDesc.CorrelId[0] + 16;
                        lpIIR->bHaveStart = TRUE;
                        memcpy(&lpIIR->i64IntervalStart, lpszIntervalIn, 8);
                        SetIntervalEnd(lpIIR);
                        if(TRUE == lpGMB->lpIIB->bHaveIntervalFile)
                        {
                            WriteIntervalRecord(lpGMB->lpIIB, lpIIR);
                            if(FAILURE == kpMCB->lProcessing)
                            {
                                SetTIBCodes(lpTIB, MTCC_FAIL, MTRC_RUN_FAIL);
                                lpTIB->lTestFailedGetMsg++;
                                kpMCB->lScriptFailedGetMsg++;
                                lpGMB->eCommandState = S_FAILURE;
                                return FAILURE;
                            }
                        }
                    }
                }
            }

            /* Update the VIB's MIB */
            lCreateMIBResult = CreateMIBFromMQMD((MQMDInfoBlk**)&lpVIBMQMD->lpCtrlBlk,
                                                 &oMsgDesc);
            if(FAILURE == lCreateMIBResult)
            {
                kpMCB->bConcurrencyWait = FALSE;
                SetTIBCodes(lpTIB, MTCC_FAIL, MTRC_RUN_FAIL);
                lpTIB->lTestFailedGetMsg++;
                kpMCB->lScriptFailedGetMsg++;
                lpGMB->eCommandState = S_FAILURE;
                return FAILURE;
            }

            /* Update the MsgId, CorrelId and GroupId automatic variables */
            SetAutoVar(lpTIB, lpTIB->lpVIBHead, kpszMSGID, &oMsgDesc);
            SetAutoVar(lpTIB, lpTIB->lpVIBHead, kpszCORRELID, &oMsgDesc);
            SetAutoVar(lpTIB, lpTIB->lpVIBHead, kpszGROUPID, &oMsgDesc);
            SetAutoVar(lpTIB, lpTIB->lpVIBHead, kpszMSGSEQNUMBER, &oMsgDesc);

            /* Update the other MQMD related automatic variables */
            SetAutoVar(lpTIB, lpTIB->lpVIBHead, kpszREPLYTOQ, &oMsgDesc);
            SetAutoVar(lpTIB, lpTIB->lpVIBHead, kpszREPLYTOQMGR, &oMsgDesc);
            SetAutoVar(lpTIB, lpTIB->lpVIBHead, kpszMSGTYPE, &oMsgDesc);
            SetAutoVar(lpTIB, lpTIB->lpVIBHead, kpszPRIORITY, &oMsgDesc);
            SetAutoVar(lpTIB, lpTIB->lpVIBHead, kpszPERSISTENCE, &oMsgDesc);

            /* Hold the length of the data we just got. */
            /* Terminate message with trailing nulls.   */
            /* Should be safe as we do a malloc of +8   */
            /* which we dont let MQ know about.         */
            lMsgLen = lGetDataLen;
            memset(lpGMB->lpBIB->lpszBuff + lMsgLen, 0x00, 4);

            /* Initialise local RIB pointer to the NullRIB */
            lpRIB = kpMCB->lpNullRIB;

            /* If the message has an RFH2 header deal with it */
            if(0 == memcmp(&oMsgDesc.Format, MQFMT_RF_HEADER_2, MQ_FORMAT_LENGTH))
            {
                /* Get a pointer to the VIB for the RFH2. See if we can find the */
                /* VIB on the TIB chain if not then we need to create one        */
                lpVIBRFH2 = CheckAndAddVIB(lpTIB, V_RFH2,
                                           lpGMB->lpszRFH2VarName,
                                           lpGMB->lpszResRFH2VarName,
                                           NULL);
                if(FAILURE == lpTIB->bCmdResult)
                {
                    SetTIBCodes(lpTIB, MTCC_FAIL, MTRC_RUN_FAIL);
                    lpTIB->lTestFailedGetMsg++;
                    kpMCB->lScriptFailedGetMsg++;
                    lpGMB->eCommandState = S_FAILURE;
                    return FAILURE;
                }
                lpRIB = lpVIBRFH2->lpCtrlBlk;
                /* The first thing in the buffer is the RFH2 header */
                lpoRFH2 = (MQRFH2*)lpGMB->lpBIB->lpszBuff;
                CheckAndFixRFH2Longs(lpoRFH2, kpMCB->lLocalIntegerEncoding, oMsgDesc.Encoding, kpMCB->lLocalIntegerEncoding);
                /* Extract the length values */
                lRFH2DataLen = lpoRFH2->StrucLength;
                lRFH2WorkLen = lRFH2DataLen  - MQRFH_STRUC_LENGTH_FIXED_2;
                lpszFolderData = lpGMB->lpBIB->lpszBuff + MQRFH_STRUC_LENGTH_FIXED_2;
                while(0 < lRFH2WorkLen)
                {
                    lplFolderLen = (long*)lpszFolderData;
                    lRFH2FolderLen = *lplFolderLen;
                    lpszFolderData += 4; /* Skip past the length field  */
                    lRFH2WorkLen -= 4;

                    /* Got some data so allocate and initialise an area */
                    /* to copy it to                                    */
                    lPCDBuffLen = (((lRFH2FolderLen + 8) / 8) + 1) * 8;
                    kpMCB->lParseCharDataLen = lRFH2FolderLen;
                    kpMCB->lpszParseCharDataBuff = malloc(lPCDBuffLen);
                    if(! kpMCB->lpszParseCharDataBuff)
                    {
                        if(! bMsg45Done)
                        {
                            LogMsg(45, lpTIB->lTestNum, lpszCurrCmdName, lpszExtraInfo);
                            bMsg45Done = TRUE;
                        }
                        kpMCB->lParseCharDataLen = 0;
                        kpMCB->lpszParseCharDataBuff = NULL;
                        LogMsg(3, sizeof(lPCDBuffLen), "RFH2 Folder", __LINE__, __FILE__);
                        kpMCB->lProcessing = FAILURE;
                        SetTIBCodes(lpTIB, MTCC_FAIL, MTRC_RUN_FAIL);
                        lpTIB->lTestFailedGetMsg++;
                        kpMCB->lScriptFailedGetMsg++;
                        lpGMB->eCommandState = S_FAILURE;
                        return FAILURE;
                    }

                    /* Copy the data contained in the folder to our new buffer */
                    memset(kpMCB->lpszParseCharDataBuff, 0x00, lPCDBuffLen);
                    memcpy(kpMCB->lpszParseCharDataBuff,
                           lpszFolderData, lRFH2FolderLen);

                    /* Move on to the next folder in the RFH2 header       */
                    lRFH2WorkLen -= lRFH2FolderLen;
                    lpszFolderData += lRFH2FolderLen;

                    /* Finally create a Folder info block and attach it to */
                    /* the MCB for the call to CreateRFH2InfoBlk           */
                    CheckAndAddFIB(lpTIB, kpMCB->lpRIB, FALSE);
                    ClearPCDB();
                }
                /* Get the Format in the MQRFH2 header for our RIB         */
                memset(lpszWorkBuff, 0x00, WORK_BUFF_LEN + 4);
                strncpy(lpszWorkBuff, lpoRFH2->Format, MQ_FORMAT_LENGTH);
                kpMCB->lpRIB->lpszFormat = CloneString(lpszWorkBuff);

                /* Free any existing RFH2 info block and create a new one */
                if(lpVIBRFH2->lpCtrlBlk)
                {
                    FreeRIB((RFH2InfoBlk**)&lpVIBRFH2->lpCtrlBlk);
                }
                lpVIBRFH2->lpCtrlBlk = CreateRFH2InfoBlk(TRUE, lpoRFH2);
                lpRIB = lpVIBRFH2->lpCtrlBlk;

                /* Move the message in the buffer and adjust its length    */
                lGetDataLen -= lRFH2DataLen;
                memcpy(lpGMB->lpBIB->lpszBuff,
                       lpGMB->lpBIB->lpszBuff + lRFH2DataLen,
                       lGetDataLen);
                memset(lpGMB->lpBIB->lpszBuff + lGetDataLen,
                       0x00, lRFH2DataLen);
            }

            /* Set the data length for later commands */
            lpGMB->lpBIB->lDataLen = lGetDataLen;

            /* Got a message so log it and the command is complete */
            if(! bMsg45Done)
            {
                LogMsg(45, lpTIB->lTestNum, lpszCurrCmdName, lpszExtraInfo);
                bMsg45Done = TRUE;
            }
            if(FALSE == kpMCB->bLoggingSuppressed)
            {
                LogMsgCorrelAndGroupIds(lpTIB, &oMsgDesc);

                sprintf(lpszExtraInfo, "TargQ=\"%s\" TargQMgr=\"%s\" ConnQMgr=\"%s\" GMO.Options=0x%08x message get successful\0",
                        lpGMB->lpszResQName,
                        kpszEmptyString,
                        lpGMB->lpCDB->lpszConnQMgrName,
                        oGetOpts.Options);
                LogMsg(TEST_EXTRA_LINE, lpTIB->lTestNum, lpszExtraInfo);
                sprintf(lpszExtraInfo, "Buffer=%s BuffLen=%d DataLen=%d MsgLen=%d\0",
                        lpGMB->lpszResBuffName,
                        lpGMB->lpBIB->lBuffLen,
                        lpGMB->lpBIB->lDataLen,
                        lMsgLen);
                LogMsg(TEST_EXTRA_LINE, lpTIB->lTestNum, lpszExtraInfo);

                /* Report RFH2 details if any */
                if(0 < lRFH2DataLen)
                {
                    sprintf(lpszExtraInfo, "RFH2FolderCount=%d RFH2FolderDataLen=%d RFH2Len=%d\0",
                            lpRIB->lRFH2FolderCount,
                            lpRIB->lRFH2FolderDataLen,
                            lpRIB->lRFH2FolderDataLen + MQRFH_STRUC_LENGTH_FIXED_2);
                    LogMsg(TEST_EXTRA_LINE, lpTIB->lTestNum, lpszExtraInfo);
                }
                /* Data */
                DisplayData(kpszData, lpszExtraInfo, EXTRA_MSG_INFO_LEN, 
                            lpGMB->lpBIB->lpszBuff, lpGMB->lpBIB->lDataLen);
                LogMsg(TEST_EXTRA_LINE, lpTIB->lTestNum, lpszExtraInfo);
            }
            kpMCB->bConcurrencyWait = FALSE;
            SetTIBCodes(lpTIB, lCC, lRC);
            lpTIB->lLastDataLen = lpGMB->lpBIB->lDataLen;
            lpTIB->lTestSuccessfulGetMsg++;
            kpMCB->lScriptSuccessfulGetMsg++;
            lpGMB->eCommandState = S_COMPLETE;
            return SUCCESS;
        }
        else if(MQRC_NO_MSG_AVAILABLE == lRC)
        {
            /* If the test maximum wait interval has expired or the user specified a GmoWait */
            /* interval then tell them we couldn't get a message and fail the test           */
            if((lpGMB->oExpiryTime <= oCurrTime) || (TRUE == lpGMB->bGmoWait))
            {
                if(! bMsg45Done)
                {
                    LogMsg(45, lpTIB->lTestNum, lpszCurrCmdName, lpszExtraInfo);
                    bMsg45Done = TRUE;
                }
                LogMsgCorrelAndGroupIds(lpTIB, &oMsgDesc);

                sprintf(lpszExtraInfo, "TargQ=\"%s\" TargQMgr=\"%s\" ConnQMgr=\"%s\" GMO.Options=0x%08x message get failed\0",
                        lpGMB->lpszResQName,
                        kpszEmptyString,
                        lpGMB->lpCDB->lpszConnQMgrName,
                        oGetOpts.Options);
                LogMsg(TEST_EXTRA_LINE_ERR, lpTIB->lTestNum, lpszExtraInfo);
                sprintf(lpszExtraInfo, "MaxWait interval=%d expired\0",
                        lpGMB->lMaxWait);
                LogMsg(TEST_EXTRA_LINE_ERR, lpTIB->lTestNum, lpszExtraInfo);
                SetTIBCodes(lpTIB, lCC, lRC);
                lpTIB->lTestFailedGetMsg++;
                kpMCB->lScriptFailedGetMsg++;
                /* If the next command is an <If...> that contains a check of either */
                /* LastCC or LastRC then do not fail this command. Instead permit    */
                /* processing to continue at the <If...>                             */
                if(NULL != lpCCB->lpCCBNext)
                {
                    lpCCBCheckIf = (CommandCtrlBlk*)lpCCB->lpCCBNext;
                    if(C_IFSTART == lpCCBCheckIf->eCommandType)
                    {
                        lpIFSCheck = (IfStartBlk*) lpCCBCheckIf;
                        if((TRUE == lpIFSCheck->bACondChecksLastCC) || (TRUE == lpIFSCheck->bACondChecksLastRC))
                        {
                            lpGMB->eCommandState = S_COMPLETE;
                            return SUCCESS;
                        }
                    }
                }
                lpGMB->eCommandState = S_FAILURE;
                return FAILURE;
            }
            /* If its time to write a log message do so and then reset the */
            /* time that the next log message is due to be written         */
            else if(lpGMB->oNextLogMsgTime <= oCurrTime)
            {
                if(! bMsg45Done)
                {
                    LogMsg(45, lpTIB->lTestNum, lpszCurrCmdName, lpszExtraInfo);
                    bMsg45Done = TRUE;
                }
                if(FALSE == kpMCB->bLoggingSuppressed)
                {
                    LogMsgCorrelAndGroupIds(lpTIB, &oMsgDesc);

                    sprintf(lpszExtraInfo, "TargQ=\"%s\" TargQMgr=\"%s\" ConnQMgr=\"%s\" GMO.Options=0x%08x waiting for a message\0",
                            lpGMB->lpszResQName,
                            kpszEmptyString,
                            lpGMB->lpCDB->lpszConnQMgrName,
                            oGetOpts.Options);
                    LogMsg(TEST_EXTRA_LINE, lpTIB->lTestNum, lpszExtraInfo);
                }
                lpGMB->oNextLogMsgTime = oCurrTime + lpCIB->lNextLogMsgInterval;
            }
            SetTIBCodes(lpTIB, lCC, lRC);
            /* Keep waiting */
            return SUCCESS;
        }
        else
        {
            /* MQGET failed for some reason other than MQRC_NO_MSG_AVAILABLE */
            /* log it and fail the test                                      */
            if(! bMsg45Done)
            {
                LogMsg(45, lpTIB->lTestNum, lpszCurrCmdName, lpszExtraInfo);
                bMsg45Done = TRUE;
            }
            LogMsgCorrelAndGroupIds(lpTIB, &oMsgDesc);

            sprintf(lpszExtraInfo, "TargQ=\"%s\" TargQMgr=\"%s\" ConnQMgr=\"%s\" GMO.Options=0x%08x message get failed\0",
                    lpGMB->lpszResQName,
                    kpszEmptyString,
                    lpGMB->lpCDB->lpszConnQMgrName,
                    oGetOpts.Options);
            LogMsg(TEST_EXTRA_LINE_ERR, lpTIB->lTestNum, lpszExtraInfo);
            sprintf(lpszExtraInfo, "MQGET CC=%d RC=%d\0", lCC, lRC);
            LogMsg(TEST_EXTRA_LINE_ERR, lpTIB->lTestNum, lpszExtraInfo);
            kpMCB->bConcurrencyWait = FALSE;
            SetTIBCodes(lpTIB, lCC, lRC);
            lpTIB->lTestFailedGetMsg++;
            kpMCB->lScriptFailedGetMsg++;
            /* If the next command is an <If...> that contains a check of either */
            /* LastCC or LastRC then do not fail this command. Instead permit    */
            /* processing to continue at the <If...>                             */
            if(NULL != lpCCB->lpCCBNext)
            {
                lpCCBCheckIf = (CommandCtrlBlk*)lpCCB->lpCCBNext;
                if(C_IFSTART == lpCCBCheckIf->eCommandType)
                {
                    lpIFSCheck = (IfStartBlk*) lpCCBCheckIf;
                    if((TRUE == lpIFSCheck->bACondChecksLastCC) || (TRUE == lpIFSCheck->bACondChecksLastRC))
                    {
                        lpGMB->eCommandState = S_COMPLETE;
                        return SUCCESS;
                    }
                }
            }
            lpGMB->eCommandState = S_FAILURE;
            return FAILURE;
        }
        break;
    case S_COMPLETE:
        LogMsg(38, lpTIB->lTestNum, lpszCurrCmdName, CalcCmdExecTime(lpTIB));
        kpMCB->bConcurrencyWait = FALSE;
        lpGMB->eCommandState = S_NEXT;
        return SUCCESS;
        break;
    case S_FAILURE:
        LogMsg(51, lpTIB->lTestNum, lpszCurrCmdName, CalcCmdExecTime(lpTIB));
        kpMCB->bConcurrencyWait = FALSE;
        lpGMB->eCommandState = S_NEXT;
        return FAILURE;
        break;
    }
    /* Should never get here so its a logic error terminate immediately */
    SetTIBCodes(lpTIB, MTCC_FAIL, MTRC_LOGIC_FAIL);
    lpTIB->lTestFailedGetMsg++;
    kpMCB->lScriptFailedGetMsg++;
    lpGMB->eCommandState = S_FAILURE;
    kpMCB->lProcessing = FAILURE;
    LogMsg(69, lpTIB->lTestNum, "ExecuteGetMsgCmd\0");
    return FAILURE;
}


/*--------------------------------------------------------------------------*/
long
ExecutePutMsgCmd(TestInfoBlk* lpTIB, CommandCtrlBlk* lpCCB)
{
    ControlInfoBlk* lpCIB;
    PutMsgBlk*      lpPMB;
    VarInfoBlk*     lpVIBMQMD;
    VarInfoBlk*     lpVIBRFH2;
    VarInfoBlk*     lpVIBDataVar;
    FolderInfoBlk*  lpFIB;
    RFH2InfoBlk*    lpRIB;
    IfStartBlk*     lpIFSCheck;
    CommandCtrlBlk* lpCCBCheckIf;
    char*           lpszCurrCmdName;
    char            lpszExtraInfo[EXTRA_MSG_INFO_LEN + 4];
    MQRFH2          oRFH2Default = {MQRFH2_DEFAULT};
    MQRFH2*         lpoRFH2;
    MQMD            oMsgDesc = {MQMD_DEFAULT};
    MQPMO           oPutOpts = {MQPMO_DEFAULT};
    long            lPmoNone = MQPMO_NONE;
    MQLONG          lCC;
    MQLONG          lRC;
    char*           lpszLocalBuff;
    char*           lpszLocalBuffCurr;
    char*           lpszIntervalIn;
    long            lLocalBuffLen;
    long            lRFH2DataLen;
    long            lMsgLen;
    long            lCreateMIBResult;
    long            lFormatLen;

    /* Initialise common use local variables */
    lpCIB = kpMCB->lpCIB;
    lpPMB = (PutMsgBlk*)lpCCB;
    lpFIB = NULL;
    lpszCurrCmdName = kpszPUTMSG;
    memset(lpszExtraInfo, 0x00, EXTRA_MSG_INFO_LEN + 4);
    lpszLocalBuff = NULL;
    lpszLocalBuffCurr = NULL;
    lLocalBuffLen = 0;

    /* Process according to current command state */
    switch(lpPMB->eCommandState)
    {
    case S_INIT:
        LogMsg(44, lpTIB->lTestNum, lpszCurrCmdName, "\0");
        lpTIB->lLastDataLen = 0;
        lpTIB->lTestTotalPutMsg++;
        kpMCB->lScriptTotalPutMsg++;
        time(&lpPMB->oStartTime);
        lpPMB->oExpiryTime = lpPMB->oStartTime;
        lpPMB->oNextLogMsgTime = lpPMB->oStartTime;

        /* Running an initialisation so set concurrency wait false. */
        kpMCB->bConcurrencyWait = FALSE;

        /* Resolve buffer name */
        ResolveValue(lpTIB, &lpPMB->lpszResBuffName,
                     &lpPMB->lpszBuffName, TRUE);
        if(FAILURE == lpTIB->bCmdResult)
        {
            SetTIBCodes(lpTIB, MTCC_FAIL, MTRC_INIT_RESOLVE_FAIL);
            lpTIB->lTestFailedPutMsg++;
            kpMCB->lScriptFailedPutMsg++;
            lpPMB->eCommandState = S_FAILURE;
            return FAILURE;
        }

        /* Obtain a pointer to the buffer info block for this command use */
        /* the specified or default buffer unless a DataVar override has  */
        /* been specified in which case create a temporary DataVar BIB    */
        if(NULL == lpPMB->lpszDataVarName)
        {
            lpPMB->lpBIB = FindBuffInfoBlk(lpTIB->lpBIBHead, lpPMB->lpszResBuffName);
            if(! lpPMB->lpBIB)
            {
                /* No buffer to put the message from. Report the problem and fail */
                sprintf(lpszExtraInfo, "Unable to locate/allocate Buffer=%s\0",
                        lpPMB->lpszResBuffName);
                LogMsg(TEST_EXTRA_LINE_ERR, lpTIB->lTestNum, lpszExtraInfo);
                SetTIBCodes(lpTIB, MTCC_FAIL, MTRC_INIT_BUFF_FAIL);
                lpTIB->lTestFailedPutMsg++;
                kpMCB->lScriptFailedPutMsg++;
                lpPMB->eCommandState = S_FAILURE;
                return FAILURE;
            }
        }
        else
        {
            /* Resolve the DataVar variable name */
            ResolveSubscript(lpTIB, &lpPMB->lpszResDataVarName, &lpPMB->lpszDataVarName, TRUE);
            if(FAILURE == lpTIB->bCmdResult)
            {
                SetTIBCodes(lpTIB, MTCC_FAIL, MTRC_INIT_RESOLVE_FAIL);
                lpTIB->lTestFailedPutMsg++;
                kpMCB->lScriptFailedPutMsg++;
                lpPMB->eCommandState = S_FAILURE;
                return FAILURE;
            }
            /* Now see if we can find it */
            lpVIBDataVar = FindVarInfoBlk(lpTIB->lpVIBHead, lpPMB->lpszResDataVarName);
            if(NULL == lpVIBDataVar)
            {
                LogMsg(184, lpTIB->lTestNum, lpPMB->lpszResDataVarName);
                SetTIBCodes(lpTIB, MTCC_FAIL, MTRC_INIT_FAIL);
                lpTIB->lTestFailedPutMsg++;
                kpMCB->lScriptFailedPutMsg++;
                lpPMB->eCommandState = S_FAILURE;
                return FAILURE;
            }
            /* Free up any previous temporary DataVar BIB */
            /* As all pointers in the BIB reference data under the  */
            /* primary control of other control blocks or data that */
            /* is static we only need to free the actual control    */
            /* block not its contents                               */
            FreeIfNotNull((void**)&lpPMB->lpTempDataVarBIB);

            /* Ok so far now create the temporary DataVar BIB */
            lpPMB->lpTempDataVarBIB = malloc(sizeof(BuffInfoBlk));
            if(NULL != lpPMB->lpTempDataVarBIB)
            {
                memset(lpPMB->lpTempDataVarBIB, 0x00, sizeof(BuffInfoBlk));
                lpPMB->lpTempDataVarBIB->lpBIBNext = NULL;
                lpPMB->lpTempDataVarBIB->lpBIBPrev = NULL;
                lpPMB->lpTempDataVarBIB->lpszBuffName = kpszTEMPDATAVARBUFF;
                lpPMB->lpTempDataVarBIB->lpszBuff = lpVIBDataVar->lpszCurrStrValue;
                lpPMB->lpTempDataVarBIB->lBuffLen = StrlenNull(lpVIBDataVar->lpszCurrStrValue);
                lpPMB->lpTempDataVarBIB->lDataLen = lpPMB->lpTempDataVarBIB->lBuffLen;
            }
            else
            {
                LogMsg(3, sizeof(BuffInfoBlk), "BuffInfoBlk", __LINE__, __FILE__);
                lpTIB->bCmdResult = FAILURE;
                lpPMB->eCommandState = S_FAILURE;
                SetTIBCodes(lpTIB, MTCC_FAIL, MTRC_LOGIC_FAIL);
                kpMCB->lProcessing = FAILURE;
                return FAILURE;
            }
            /* Now point the normal BIB pointer at the temp BIB */
            lpPMB->lpBIB = lpPMB->lpTempDataVarBIB;
        }

        /* Resolve queue and queue manager names */
        ResolveValue(lpTIB, &lpPMB->lpszResQName,
                     &lpPMB->lpszQName, TRUE);
        ResolveValue(lpTIB, &lpPMB->lpszResQMgrName,
                     &lpPMB->lpszQMgrName, TRUE);

        /* Free resolved MsgId, CorrelId, GroupId, MsgSeqNumber and Format */
        /* as need to make sure they are NULL                              */
        FreeIfNotNull((void**)&lpPMB->lpszResMsgId);
        FreeIfNotNull((void**)&lpPMB->lpszResCorrelId);
        FreeIfNotNull((void**)&lpPMB->lpszResGroupId);
        FreeIfNotNull((void**)&lpPMB->lpszResMsgSeqNumber);
        FreeIfNotNull((void**)&lpPMB->lpszResFormat);

        /* If we have a MsgId, CorrelId or Format then resolve them */
        if(lpPMB->lpszMsgId)
        {
            ResolveValue(lpTIB, &lpPMB->lpszResMsgId,
                         &lpPMB->lpszMsgId, TRUE);
        }
        if(lpPMB->lpszCorrelId)
        {
            ResolveValue(lpTIB, &lpPMB->lpszResCorrelId,
                         &lpPMB->lpszCorrelId, TRUE);
        }
        if(lpPMB->lpszGroupId)
        {
            ResolveValue(lpTIB, &lpPMB->lpszResGroupId,
                         &lpPMB->lpszGroupId, TRUE);
        }
        if(lpPMB->lpszMsgSeqNumber)
        {
            ResolveValue(lpTIB, &lpPMB->lpszResMsgSeqNumber,
                         &lpPMB->lpszMsgSeqNumber, TRUE);
        }
        if(lpPMB->lpszFormat)
        {
            ResolveValue(lpTIB, &lpPMB->lpszResFormat,
                         &lpPMB->lpszFormat, TRUE);
        }

        /* Problems with variable resolution time to give up     */
        if(FAILURE == lpTIB->bCmdResult)
        {
            SetTIBCodes(lpTIB, MTCC_FAIL, MTRC_INIT_RESOLVE_FAIL);
            lpTIB->lTestFailedPutMsg++;
            kpMCB->lScriptFailedPutMsg++;
            lpPMB->eCommandState = S_FAILURE;
            return FAILURE;
        }

        /* Update the last queue and queue manager referenced internal values */
        lpTIB->lpszLastQ = CloneString(lpPMB->lpszResQName);
        lpTIB->lpszLastQMgr = CloneString(lpPMB->lpszResQMgrName);

        /* Resolve the MQMD and RFH2 variable names */
        ResolveSubscript(lpTIB, &lpPMB->lpszResMQMDVarName, &lpPMB->lpszMQMDVarName, TRUE);
        ResolveSubscript(lpTIB, &lpPMB->lpszResRFH2VarName, &lpPMB->lpszRFH2VarName, TRUE);
        ResolveValue(lpTIB, &lpPMB->lpszResConnectionName, &lpPMB->lpszConnectionName, TRUE);
        if(FAILURE == lpTIB->bCmdResult)
        {
            SetTIBCodes(lpTIB, MTCC_FAIL, MTRC_INIT_RESOLVE_FAIL);
            lpTIB->lTestFailedPutMsg++;
            kpMCB->lScriptFailedPutMsg++;
            lpPMB->eCommandState = S_FAILURE;
            return FAILURE;
        }

        /* Locate the connection definition block for this command */
        lpPMB->lpCDB = FindConnectionDefBlk(kpMCB->lpCDBHead, lpPMB->lpszResConnectionName);
        if(NULL == lpPMB->lpCDB)
        {
            LogMsg(194, lpPMB->lpszResConnectionName);
            SetTIBCodes(lpTIB, MTCC_FAIL, MTRC_INIT_FAIL);
            lpTIB->lTestFailedGetMsg++;
            kpMCB->lScriptFailedGetMsg++;
            lpPMB->eCommandState = S_FAILURE;
            return FAILURE;
        }

        /* Found a BIB now try to open the queue */
        lpPMB->lpQIB = OpenQueue(lpTIB, lpPMB->lpCDB, lpTIB->lpQIBHead,
                                 lpPMB->lpszResQName, lpPMB->lpszResQMgrName,
                                 kpszEmptyString, FALSE);
        if(! lpPMB->lpQIB)
        {
            sprintf(lpszExtraInfo, "TargQ=\"%s\" TargQMgr=\"%s\" ConnQMgr=\"%s\" open failed\0",
                    lpPMB->lpszResQName,
                    lpPMB->lpszResQMgrName,
                    lpPMB->lpCDB->lpszConnQMgrName);
            LogMsg(TEST_EXTRA_LINE_ERR, lpTIB->lTestNum, lpszExtraInfo);
            lpTIB->lTestFailedPutMsg++;
            kpMCB->lScriptFailedPutMsg++;
            /* If the next command is an <If...> that contains a check of either */
            /* LastCC or LastRC then do not fail this command. Instead permit    */
            /* processing to continue at the <If...>                             */
            if(NULL != lpCCB->lpCCBNext)
            {
                lpCCBCheckIf = (CommandCtrlBlk*)lpCCB->lpCCBNext;
                if(C_IFSTART == lpCCBCheckIf->eCommandType)
                {
                    lpIFSCheck = (IfStartBlk*) lpCCBCheckIf;
                    if((TRUE == lpIFSCheck->bACondChecksLastCC) || (TRUE == lpIFSCheck->bACondChecksLastRC))
                    {
                        lpPMB->eCommandState = S_COMPLETE;
                        return SUCCESS;
                    }
                }
            }
            lpPMB->eCommandState = S_FAILURE;
            return FAILURE;
        }

        /* Ready to run */
        SetTIBCodes(lpTIB, MTCC_OK, MTRC_NONE);
        lpPMB->eCommandState = S_RUN;
        return SUCCESS;
        break;
    case S_RUN:
        LogMsg(45, lpTIB->lTestNum, lpszCurrCmdName, "\0");
        /****** Send the request message ******/
        if(0 < StrlenNull(lpPMB->lpszPmoOptions))
        {
            /* If the first two characters are 0x the PmoOptions value is in hex */
            if(0 == memcmp(lpPMB->lpszPmoOptions, "0x", 2))
            {
                HexToLong(&oPutOpts.Options, lpPMB->lpszPmoOptions + 2);
            }
            else
            {
                TranslateToValue(lpTIB, &oPutOpts.Options, &lPmoNone, lpPMB->lpszPmoOptions, Q_MQPMO);
            }
        }
        else
        {
            if(FALSE == lpPMB->bSyncpoint)
            {
                oPutOpts.Options = MQPMO_NO_SYNCPOINT | MQPMO_FAIL_IF_QUIESCING;
            }
            else
            {
                oPutOpts.Options = MQPMO_SYNCPOINT | MQPMO_FAIL_IF_QUIESCING;
            }

            if(TRUE == lpPMB->bSetIdentityContext)
            {
                oPutOpts.Options |= MQPMO_SET_IDENTITY_CONTEXT;
            }

            if(TRUE == lpPMB->bSetAllContext)
            {
                oPutOpts.Options |= MQPMO_SET_ALL_CONTEXT;
            }
        }

        /* Get a pointer to the VIB for the MQMD. See if we can find the */
        /* VIB on the TIB chain if not then we need to create one        */
        lpVIBMQMD = CheckAndAddVIB(lpTIB, V_MQMD,
                                   lpPMB->lpszMQMDVarName,
                                   lpPMB->lpszResMQMDVarName,
                                   lpPMB->lpszResFormat);
        if(FAILURE == lpTIB->bCmdResult)
        {
            SetTIBCodes(lpTIB, MTCC_FAIL, MTRC_RUN_FAIL);
            lpTIB->lTestFailedPutMsg++;
            kpMCB->lScriptFailedPutMsg++;
            lpPMB->eCommandState = S_FAILURE;
            return FAILURE;
        }

        /* Set up the MQMD prior to calling MQPUT */
        SetMQMDFromMIB(lpTIB, lpVIBMQMD->lpCtrlBlk,
                       lpPMB->lpszResMsgId, lpPMB->lpszResCorrelId,
                       lpPMB->lpszResGroupId, lpPMB->lpszResMsgSeqNumber,
                       lpPMB->lpszResFormat, &oMsgDesc, FALSE, TRUE);

        /* Problems with setting the MQMD time to give up */
        if(FAILURE == lpTIB->bCmdResult)
        {
            SetTIBCodes(lpTIB, MTCC_FAIL, MTRC_RUN_FAIL);
            lpTIB->lTestFailedPutMsg++;
            kpMCB->lScriptFailedPutMsg++;
            lpPMB->eCommandState = S_FAILURE;
            return FAILURE;
        }

        /* Check to see if an RFH2 Info Block is needed and available */
        if(lpPMB->bSuppressRFH2)
        {
            lpRIB = NULL;
        }
        else
        {
            /* Get a pointer to the VIB for the RFH2. See if we can find the */
            /* VIB on the TIB chain if not then we need to create one        */
            lpVIBRFH2 = CheckAndAddVIB(lpTIB, V_RFH2,
                                       lpPMB->lpszRFH2VarName,
                                       lpPMB->lpszResRFH2VarName,
                                       lpPMB->lpszResFormat);
            if(FAILURE == lpTIB->bCmdResult)
            {
                SetTIBCodes(lpTIB, MTCC_FAIL, MTRC_RUN_FAIL);
                lpTIB->lTestFailedPutMsg++;
                kpMCB->lScriptFailedPutMsg++;
                lpPMB->eCommandState = S_FAILURE;
                return FAILURE;
            }
            lpRIB = lpVIBRFH2->lpCtrlBlk;
        }

        /* Process according to header requirements */
        if(lpRIB)
        {
            /* If we need to add an RFH2 header then we will have to  */
            /* allocate a new buffer big enough to contain the RFH2   */
            /* header its folders and the actual message data         */
            lRFH2DataLen = MQRFH_STRUC_LENGTH_FIXED_2;
            lRFH2DataLen += lpRIB->lRFH2FolderDataLen;
            lMsgLen = lRFH2DataLen + lpPMB->lpBIB->lDataLen;
            lLocalBuffLen = (((lMsgLen + 16) / 16) + 1) * 16;
            lpszLocalBuff = malloc(lLocalBuffLen);

            /* Check the result of the allocation */
            if(! lpszLocalBuff)
            {
                /* If we have run out of memory its fatal */
                LogMsg(3, lRFH2DataLen, "MsgWithRFH2Buffer", __LINE__, __FILE__);
                kpMCB->lProcessing = FAILURE;
                kpMCB->bConcurrencyWait = FALSE;
                SetTIBCodes(lpTIB, MTCC_FAIL, MTRC_RUN_BUFF_FAIL);
                lpTIB->lTestFailedPutMsg++;
                kpMCB->lScriptFailedPutMsg++;
                lpPMB->eCommandState = S_FAILURE;
                return FAILURE;
            }

            /* Clear the buffer */
            memset(lpszLocalBuff, 0x00, lLocalBuffLen);
            
            /* Initialise the current position pointer */
            lpszLocalBuffCurr = lpszLocalBuff;

            /* Copy the fixed length part of the RFH2 header */
            memcpy(lpszLocalBuffCurr, &oRFH2Default, MQRFH_STRUC_LENGTH_FIXED_2);
            lpoRFH2 = (MQRFH2*)lpszLocalBuffCurr;
            lpoRFH2->StrucLength = lRFH2DataLen;
            if(TRUE == lpRIB->bUseRIBEncodingAndCCSID)
            {
                lpoRFH2->Encoding = lpRIB->lEncoding;
                lpoRFH2->CodedCharSetId = lpRIB->lCodedCharSetId;
            }
            else
            {
                lpoRFH2->Encoding = MQENC_NATIVE;
                lpoRFH2->CodedCharSetId = MQCCSI_INHERIT;
            }
            lFormatLen = StrlenNull(lpRIB->lpszFormat);
            if(0 < lFormatLen)
            {
                if(MQ_FORMAT_LENGTH < lFormatLen)
                {
                    lFormatLen = MQ_FORMAT_LENGTH;
                }
                /* Make sure shorter format strings are padded with blanks */
                memset(lpoRFH2->Format, ' ', MQ_FORMAT_LENGTH);
                memcpy(lpoRFH2->Format, lpRIB->lpszFormat, lFormatLen);
            }
            lpszLocalBuffCurr += MQRFH_STRUC_LENGTH_FIXED_2;

            /* Now copy the folders setting their length prefixes */
            lpFIB = (FolderInfoBlk*)lpRIB->lpFIBHead;
            while(NULL != lpFIB)
            {
                memcpy(lpszLocalBuffCurr, &lpFIB->lFolderDataLen, sizeof(MQLONG));
                lpszLocalBuffCurr += sizeof(MQLONG);
                memcpy(lpszLocalBuffCurr, lpFIB->lpszFolderData, lpFIB->lFolderDataLen);
                lpszLocalBuffCurr += lpFIB->lFolderDataLen;
                lpFIB = (FolderInfoBlk*)lpFIB->lpFIBNext;
            }

            /* Check and fix the integer values in the RFH2 header if necessary */
            CheckAndFixRFH2Longs(lpoRFH2, kpMCB->lLocalIntegerEncoding, kpMCB->lLocalIntegerEncoding, oMsgDesc.Encoding);

            /* Finally copy the actual message data */
            memcpy(lpszLocalBuffCurr, lpPMB->lpBIB->lpszBuff, lpPMB->lpBIB->lDataLen);

            /* Set the MQMD format */
            memcpy(&oMsgDesc.Format, MQFMT_RF_HEADER_2, MQ_FORMAT_LENGTH);

            /* Check to see if we are controlling the message rate */
            if(lpPMB->lpMRB)
            {
                kpMCB->bConcurrencyWait = FALSE;
                ControlMessageRate(lpTIB, lpPMB->lpMRB);
                if(FAILURE == lpTIB->bCmdResult)
                {
                    SetTIBCodes(lpTIB, MTCC_FAIL, MTRC_RUN_FAIL);
                    lpTIB->lTestFailedPutMsg++;
                    kpMCB->lScriptFailedPutMsg++;
                    lpPMB->eCommandState = S_FAILURE;
                    return FAILURE;
                }
                if(TRUE == lpPMB->lpMRB->bIncrementalDone)
                {
                    /* Reset flags in case we are inside another loop */
                    lpPMB->lpMRB->bIncrementalDone = FALSE;
                    lpPMB->lpMRB->bInitForLoop = TRUE;
                    if(lpPMB->lpBreakContinueFSB)
                    {
                        LogMsg(133, lpTIB->lTestNum, lpPMB->lpMRB->lFrom, lpPMB->lpMRB->lTo, lpPMB->lpMRB->lIncr, "Ending For/ForEver/ForEach loop Name=\0", lpPMB->lpBreakContinueFSB->lpszForName);
                    }
                    lpPMB->lpBIB->lDataLen = 0;
                    lpTIB->lpBreakContinueFSB = lpPMB->lpBreakContinueFSB;
                    kpMCB->bConcurrencyWait = FALSE;
                    SetTIBCodes(lpTIB, MTCC_OK, MTRC_NONE);
                    lpPMB->eCommandState = S_BREAK;
                    return SUCCESS;
                }
            }

            /* Check to see if we are creating a special interval MsgId */
            if(lpPMB->bIntervalInMsgId)
            {
                lpszIntervalIn = (char*)&oMsgDesc.MsgId;
                memcpy(lpszIntervalIn, MQMI_NONE, MQ_MSG_ID_LENGTH);
                memcpy(lpszIntervalIn, kpszMSGT, 4);
                strncpy(lpszIntervalIn + 4, lpPMB->lpCDB->lpszConnQMgrName, 12);
                SetInterval(lpszIntervalIn + 16);
            }

            /* Check to see if we are creating a special interval CorrelId */
            if(lpPMB->bIntervalInCorrelId)
            {
                lpszIntervalIn = (char*)&oMsgDesc.CorrelId;
                memcpy(lpszIntervalIn, MQCI_NONE, MQ_CORREL_ID_LENGTH);
                memcpy(lpszIntervalIn, kpszMSGT, 4);
                strncpy(lpszIntervalIn + 4, lpPMB->lpCDB->lpszConnQMgrName, 12);
                SetInterval(lpszIntervalIn + 16);
            }

            /* Ok lets do it */
            MQPUT(lpPMB->lpQIB->hConn, lpPMB->lpQIB->hQ, &oMsgDesc, &oPutOpts, 
                  lMsgLen, lpszLocalBuff, &lCC, &lRC);

            /* Done with the buffer */
            FreeIfNotNull((void**)&lpszLocalBuff);

            /* Log the MsgId and CorrelId */
            LogMsgCorrelAndGroupIds(lpTIB, &oMsgDesc);

            /* Check current reason code against BreakOnRC reason codes */
            if(0 < lpPMB->lBreakOnRCCount)
            {
                if(TRUE == FindRC(lpPMB->lBreakOnRCCount, lpPMB->lBreakOnRC, lRC))
                {
                    if(lpPMB->lpBreakContinueFSB)
                    {
                        LogMsg(118, lpTIB->lTestNum, kpszPUTMSG, lCC, lRC, "Ending For/ForEver/ForEach loop Name=\0", lpPMB->lpBreakContinueFSB->lpszForName);
                    }
                    else
                    {
                        LogMsg(118, lpTIB->lTestNum, kpszPUTMSG, lCC, lRC, "Ending Test Name=\0", lpTIB->lpszTestName);
                    }
                    lpPMB->lpBIB->lDataLen = 0;
                    lpTIB->lpBreakContinueFSB = lpPMB->lpBreakContinueFSB;
                    kpMCB->bConcurrencyWait = FALSE;
                    SetTIBCodes(lpTIB, lCC, lRC);
                    lpPMB->eCommandState = S_BREAK;
                    return SUCCESS;
                }
            }

            /* Check current reason code against ContinueOnRC reason codes */
            if(0 < lpPMB->lContinueOnRCCount)
            {
                if(TRUE == FindRC(lpPMB->lContinueOnRCCount, lpPMB->lContinueOnRC, lRC))
                {
                    if(lpPMB->lpBreakContinueFSB)
                    {
                        LogMsg(119, lpTIB->lTestNum, kpszPUTMSG, lCC, lRC, "Continuing For/ForEver/ForEach loop Name=\0", lpPMB->lpBreakContinueFSB->lpszForName);
                    }
                    else
                    {
                        LogMsg(119, lpTIB->lTestNum, kpszPUTMSG, lCC, lRC, "Ending Test Name=\0", lpTIB->lpszTestName);
                    }
                    lpPMB->lpBIB->lDataLen = 0;
                    lpTIB->lpBreakContinueFSB = lpPMB->lpBreakContinueFSB;
                    kpMCB->bConcurrencyWait = FALSE;
                    SetTIBCodes(lpTIB, lCC, lRC);
                    lpPMB->eCommandState = S_CONTINUE;
                    return SUCCESS;
                }
            }

            /* Check the current reason code against the suppression list */
            /* Suppression is done last as it changes the reason code     */
            if(0 < lpPMB->lSuppressRCCount)
            {
                if(TRUE == FindRC(lpPMB->lSuppressRCCount, lpPMB->lSuppressRC, lRC))
                {
                    LogMsg(117, lpTIB->lTestNum, kpszPUTMSG, lCC, lRC);
                    lCC = 0;
                    lRC = 0;
                }
            }

            /* Check the result and log it */
            if(MQRC_NONE == lRC)
            {
                /* Update the VIB's MIB */
                lCreateMIBResult = CreateMIBFromMQMD((MQMDInfoBlk**)&lpVIBMQMD->lpCtrlBlk,
                                                     &oMsgDesc);
                if(FAILURE == lCreateMIBResult)
                {
                    kpMCB->bConcurrencyWait = FALSE;
                    SetTIBCodes(lpTIB, MTCC_FAIL, MTRC_RUN_FAIL);
                    lpTIB->lTestFailedPutMsg++;
                    kpMCB->lScriptFailedPutMsg++;
                    lpPMB->eCommandState = S_FAILURE;
                    return FAILURE;
                }

                /* Update the MsgId and CorrelId automatic variables */
                SetAutoVar(lpTIB, lpTIB->lpVIBHead, kpszMSGID, &oMsgDesc);
                SetAutoVar(lpTIB, lpTIB->lpVIBHead, kpszCORRELID, &oMsgDesc);
                SetAutoVar(lpTIB, lpTIB->lpVIBHead, kpszGROUPID, &oMsgDesc);
                SetAutoVar(lpTIB, lpTIB->lpVIBHead, kpszMSGSEQNUMBER, &oMsgDesc);

                /* Update the other MQMD related automatic variables */
                SetAutoVar(lpTIB, lpTIB->lpVIBHead, kpszREPLYTOQ, &oMsgDesc);
                SetAutoVar(lpTIB, lpTIB->lpVIBHead, kpszREPLYTOQMGR, &oMsgDesc);
                SetAutoVar(lpTIB, lpTIB->lpVIBHead, kpszMSGTYPE, &oMsgDesc);
                SetAutoVar(lpTIB, lpTIB->lpVIBHead, kpszPRIORITY, &oMsgDesc);
                SetAutoVar(lpTIB, lpTIB->lpVIBHead, kpszPERSISTENCE, &oMsgDesc);

                /* Log our success */
                sprintf(lpszExtraInfo, "TargQ=\"%s\" TargQMgr=\"%s\" ConnQMgr=\"%s\" PMO.Options=0x%08x message put successful\0",
                        lpPMB->lpszResQName,
                        lpPMB->lpszResQMgrName,
                        lpPMB->lpCDB->lpszConnQMgrName,
                        oPutOpts.Options);
                LogMsg(TEST_EXTRA_LINE, lpTIB->lTestNum, lpszExtraInfo);
                sprintf(lpszExtraInfo, "Buffer=%s BuffLen=%d DataLen=%d MsgLen=%d\0",
                        lpPMB->lpszResBuffName,
                        lpPMB->lpBIB->lBuffLen,
                        lpPMB->lpBIB->lDataLen,
                        lMsgLen);
                LogMsg(TEST_EXTRA_LINE, lpTIB->lTestNum, lpszExtraInfo);
                sprintf(lpszExtraInfo, "RFH2FolderCount=%d RFH2FolderDataLen=%d RFH2Len=%d\0",
                        lpRIB->lRFH2FolderCount,
                        lpRIB->lRFH2FolderDataLen,
                        lpRIB->lRFH2FolderDataLen + MQRFH_STRUC_LENGTH_FIXED_2);
                LogMsg(TEST_EXTRA_LINE, lpTIB->lTestNum, lpszExtraInfo);
                DisplayData(kpszData, lpszExtraInfo, EXTRA_MSG_INFO_LEN, 
                            lpPMB->lpBIB->lpszBuff, lpPMB->lpBIB->lDataLen);
                LogMsg(TEST_EXTRA_LINE, lpTIB->lTestNum, lpszExtraInfo);
                kpMCB->bConcurrencyWait = FALSE;
                SetTIBCodes(lpTIB, lCC, lRC);
                lpTIB->lLastDataLen = lMsgLen;
                lpTIB->lTestSuccessfulPutMsg++;
                kpMCB->lScriptSuccessfulPutMsg++;
                lpPMB->eCommandState = S_COMPLETE;
                return SUCCESS;
            }
            else
            {
                sprintf(lpszExtraInfo, "TargQ=\"%s\" TargQMgr=\"%s\" ConnQMgr=\"%s\" PMO.Options=0x%08x message put failed\0",
                        lpPMB->lpszResQName,
                        lpPMB->lpszResQMgrName,
                        lpPMB->lpCDB->lpszConnQMgrName,
                        oPutOpts.Options);
                LogMsg(TEST_EXTRA_LINE_ERR, lpTIB->lTestNum, lpszExtraInfo);
                sprintf(lpszExtraInfo, "MQPUT CC=%d RC=%d\0", lCC, lRC);
                LogMsg(TEST_EXTRA_LINE_ERR, lpTIB->lTestNum, lpszExtraInfo);
                sprintf(lpszExtraInfo, "Buffer=%s BuffLen=%d DataLen=%d\0",
                        lpPMB->lpszResBuffName,
                        lpPMB->lpBIB->lBuffLen,
                        lpPMB->lpBIB->lDataLen);
                LogMsg(TEST_EXTRA_LINE_ERR, lpTIB->lTestNum, lpszExtraInfo);
                sprintf(lpszExtraInfo, "RFH2FolderCount=%d RFH2FolderDataLen=%d RFH2Len=%d\0",
                        lpRIB->lRFH2FolderCount,
                        lpRIB->lRFH2FolderDataLen,
                        lpRIB->lRFH2FolderDataLen + MQRFH_STRUC_LENGTH_FIXED_2);
                LogMsg(TEST_EXTRA_LINE_ERR, lpTIB->lTestNum, lpszExtraInfo);
                kpMCB->bConcurrencyWait = FALSE;
                SetTIBCodes(lpTIB, lCC, lRC);
                lpTIB->lTestFailedPutMsg++;
                kpMCB->lScriptFailedPutMsg++;
                /* If the next command is an <If...> that contains a check of either */
                /* LastCC or LastRC then do not fail this command. Instead permit    */
                /* processing to continue at the <If...>                             */
                if(NULL != lpCCB->lpCCBNext)
                {
                    lpCCBCheckIf = (CommandCtrlBlk*)lpCCB->lpCCBNext;
                    if(C_IFSTART == lpCCBCheckIf->eCommandType)
                    {
                        lpIFSCheck = (IfStartBlk*) lpCCBCheckIf;
                        if((TRUE == lpIFSCheck->bACondChecksLastCC) || (TRUE == lpIFSCheck->bACondChecksLastRC))
                        {
                            lpPMB->eCommandState = S_COMPLETE;
                            return SUCCESS;
                        }
                    }
                }
                lpPMB->eCommandState = S_FAILURE;
                return FAILURE;
            }
        }
        else
        {
            /* Check to see if we are controlling the message rate */
            if(lpPMB->lpMRB)
            {
                kpMCB->bConcurrencyWait = FALSE;
                ControlMessageRate(lpTIB, lpPMB->lpMRB);
                if(FAILURE == lpTIB->bCmdResult)
                {
                    SetTIBCodes(lpTIB, MTCC_FAIL, MTRC_RUN_FAIL);
                    lpTIB->lTestFailedPutMsg++;
                    kpMCB->lScriptFailedPutMsg++;
                    lpPMB->eCommandState = S_FAILURE;
                    return FAILURE;
                }
                if(TRUE == lpPMB->lpMRB->bIncrementalDone)
                {
                    /* Reset flags in case we are inside another loop */
                    lpPMB->lpMRB->bIncrementalDone = FALSE;
                    lpPMB->lpMRB->bInitForLoop = TRUE;
                    if(lpPMB->lpBreakContinueFSB)
                    {
                        LogMsg(133, lpTIB->lTestNum, lpPMB->lpMRB->lFrom, lpPMB->lpMRB->lTo, lpPMB->lpMRB->lIncr, "Ending For/ForEver/ForEach loop Name=\0", lpPMB->lpBreakContinueFSB->lpszForName);
                    }
                    lpPMB->lpBIB->lDataLen = 0;
                    lpTIB->lpBreakContinueFSB = lpPMB->lpBreakContinueFSB;
                    kpMCB->bConcurrencyWait = FALSE;
                    SetTIBCodes(lpTIB, MTCC_OK, MTRC_NONE);
                    lpPMB->eCommandState = S_BREAK;
                    return SUCCESS;
                }
            }

            /* Check to see if we are creating a special interval MsgId */
            if(lpPMB->bIntervalInMsgId)
            {
                lpszIntervalIn = (char*)&oMsgDesc.MsgId;
                memcpy(lpszIntervalIn, MQMI_NONE, MQ_MSG_ID_LENGTH);
                memcpy(lpszIntervalIn, kpszMSGT, 4);
                strncpy(lpszIntervalIn + 4, lpPMB->lpCDB->lpszConnQMgrName, 12);
                SetInterval(lpszIntervalIn + 16);
            }

            /* Check to see if we are creating a special interval CorrelId */
            if(lpPMB->bIntervalInCorrelId)
            {
                lpszIntervalIn = (char*)&oMsgDesc.CorrelId;
                memcpy(lpszIntervalIn, MQCI_NONE, MQ_CORREL_ID_LENGTH);
                memcpy(lpszIntervalIn, kpszMSGT, 4);
                strncpy(lpszIntervalIn + 4, lpPMB->lpCDB->lpszConnQMgrName, 12);
                SetInterval(lpszIntervalIn + 16);
            }

            /* Ok lets do it */
            MQPUT(lpPMB->lpQIB->hConn, lpPMB->lpQIB->hQ, &oMsgDesc, &oPutOpts, 
                  lpPMB->lpBIB->lDataLen, lpPMB->lpBIB->lpszBuff, &lCC, &lRC);

            /* Log the MsgId and CorrelId */
            LogMsgCorrelAndGroupIds(lpTIB, &oMsgDesc);

            /* Check current reason code against BreakOnRC reason codes */
            if(0 < lpPMB->lBreakOnRCCount)
            {
                if(TRUE == FindRC(lpPMB->lBreakOnRCCount, lpPMB->lBreakOnRC, lRC))
                {
                    if(lpPMB->lpBreakContinueFSB)
                    {
                        LogMsg(118, lpTIB->lTestNum, kpszPUTMSG, lCC, lRC, "Ending For/ForEver/ForEach loop Name=\0", lpPMB->lpBreakContinueFSB->lpszForName);
                    }
                    else
                    {
                        LogMsg(118, lpTIB->lTestNum, kpszPUTMSG, lCC, lRC, "Ending Test Name=\0", lpTIB->lpszTestName);
                    }
                    lpPMB->lpBIB->lDataLen = 0;
                    lpTIB->lpBreakContinueFSB = lpPMB->lpBreakContinueFSB;
                    kpMCB->bConcurrencyWait = FALSE;
                    SetTIBCodes(lpTIB, lCC, lRC);
                    lpPMB->eCommandState = S_BREAK;
                    return SUCCESS;
                }
            }

            /* Check current reason code against ContinueOnRC reason codes */
            if(0 < lpPMB->lContinueOnRCCount)
            {
                if(TRUE == FindRC(lpPMB->lContinueOnRCCount, lpPMB->lContinueOnRC, lRC))
                {
                    if(lpPMB->lpBreakContinueFSB)
                    {
                        LogMsg(119, lpTIB->lTestNum, kpszPUTMSG, lCC, lRC, "Continuing For/ForEver/ForEach loop Name=\0", lpPMB->lpBreakContinueFSB->lpszForName);
                    }
                    else
                    {
                        LogMsg(119, lpTIB->lTestNum, kpszPUTMSG, lCC, lRC, "Ending Test Name=\0", lpTIB->lpszTestName);
                    }
                    lpPMB->lpBIB->lDataLen = 0;
                    lpTIB->lpBreakContinueFSB = lpPMB->lpBreakContinueFSB;
                    kpMCB->bConcurrencyWait = FALSE;
                    SetTIBCodes(lpTIB, lCC, lRC);
                    lpPMB->eCommandState = S_CONTINUE;
                    return SUCCESS;
                }
            }

            /* Check the current reason code against the suppression list */
            /* Suppression is done last as it changes the reason code     */
            if(0 < lpPMB->lSuppressRCCount)
            {
                if(TRUE == FindRC(lpPMB->lSuppressRCCount, lpPMB->lSuppressRC, lRC))
                {
                    LogMsg(117, lpTIB->lTestNum, kpszPUTMSG, lCC, lRC);
                    lCC = 0;
                    lRC = 0;
                }
            }

            /* Check the result and log it */
            if(MQRC_NONE == lRC)
            {
                /* Update the VIB's MIB */
                lCreateMIBResult = CreateMIBFromMQMD((MQMDInfoBlk**)&lpVIBMQMD->lpCtrlBlk,
                                                     &oMsgDesc);
                if(FAILURE == lCreateMIBResult)
                {
                    kpMCB->bConcurrencyWait = FALSE;
                    SetTIBCodes(lpTIB, MTCC_FAIL, MTRC_RUN_FAIL);
                    lpTIB->lTestFailedPutMsg++;
                    kpMCB->lScriptFailedPutMsg++;
                    lpPMB->eCommandState = S_FAILURE;
                    return FAILURE;
                }

                /* Log our success */
                if(FALSE == kpMCB->bLoggingSuppressed)
                {
                    sprintf(lpszExtraInfo, "TargQ=\"%s\" TargQMgr=\"%s\" ConnQMgr=\"%s\" PMO.Options=0x%08x message put successful\0",
                            lpPMB->lpszResQName,
                            lpPMB->lpszResQMgrName,
                            lpPMB->lpCDB->lpszConnQMgrName,
                            oPutOpts.Options);
                    LogMsg(TEST_EXTRA_LINE, lpTIB->lTestNum, lpszExtraInfo);
                    sprintf(lpszExtraInfo, "Buffer=%s BuffLen=%d DataLen=%d MsgLen=%d\0",
                            lpPMB->lpszResBuffName,
                            lpPMB->lpBIB->lBuffLen,
                            lpPMB->lpBIB->lDataLen,
                            lpPMB->lpBIB->lDataLen);
                    LogMsg(TEST_EXTRA_LINE, lpTIB->lTestNum, lpszExtraInfo);
                    DisplayData(kpszData, lpszExtraInfo, EXTRA_MSG_INFO_LEN, 
                                lpPMB->lpBIB->lpszBuff, lpPMB->lpBIB->lDataLen);
                    LogMsg(TEST_EXTRA_LINE, lpTIB->lTestNum, lpszExtraInfo);
                }

                /* Update the MsgId and CorrelId automatic variables */
                SetAutoVar(lpTIB, lpTIB->lpVIBHead, kpszMSGID, &oMsgDesc);
                SetAutoVar(lpTIB, lpTIB->lpVIBHead, kpszCORRELID, &oMsgDesc);
                SetAutoVar(lpTIB, lpTIB->lpVIBHead, kpszGROUPID, &oMsgDesc);
                SetAutoVar(lpTIB, lpTIB->lpVIBHead, kpszMSGSEQNUMBER, &oMsgDesc);

                /* Update the other MQMD related automatic variables */
                SetAutoVar(lpTIB, lpTIB->lpVIBHead, kpszREPLYTOQ, &oMsgDesc);
                SetAutoVar(lpTIB, lpTIB->lpVIBHead, kpszREPLYTOQMGR, &oMsgDesc);
                SetAutoVar(lpTIB, lpTIB->lpVIBHead, kpszMSGTYPE, &oMsgDesc);
                SetAutoVar(lpTIB, lpTIB->lpVIBHead, kpszPRIORITY, &oMsgDesc);
                SetAutoVar(lpTIB, lpTIB->lpVIBHead, kpszPERSISTENCE, &oMsgDesc);

                kpMCB->bConcurrencyWait = FALSE;
                SetTIBCodes(lpTIB, lCC, lRC);
                lpTIB->lLastDataLen = lpPMB->lpBIB->lDataLen;
                lpTIB->lTestSuccessfulPutMsg++;
                kpMCB->lScriptSuccessfulPutMsg++;
                lpPMB->eCommandState = S_COMPLETE;
                return SUCCESS;
            }
            else
            {
                sprintf(lpszExtraInfo, "TargQ=\"%s\" TargQMgr=\"%s\" ConnQMgr=\"%s\" PMO.Options=0x%08x message put failed\0",
                        lpPMB->lpszResQName,
                        lpPMB->lpszResQMgrName,
                        lpPMB->lpCDB->lpszConnQMgrName,
                        oPutOpts.Options);
                LogMsg(TEST_EXTRA_LINE_ERR, lpTIB->lTestNum, lpszExtraInfo);
                sprintf(lpszExtraInfo, "MQPUT CC=%d RC=%d\0", lCC, lRC);
                LogMsg(TEST_EXTRA_LINE_ERR, lpTIB->lTestNum, lpszExtraInfo);
                sprintf(lpszExtraInfo, "Buffer=%s BuffLen=%d DataLen=%d\0",
                        lpPMB->lpszResBuffName,
                        lpPMB->lpBIB->lBuffLen,
                        lpPMB->lpBIB->lDataLen);
                LogMsg(TEST_EXTRA_LINE_ERR, lpTIB->lTestNum, lpszExtraInfo);
                kpMCB->bConcurrencyWait = FALSE;
                SetTIBCodes(lpTIB, lCC, lRC);
                lpTIB->lTestFailedPutMsg++;
                kpMCB->lScriptFailedPutMsg++;
                /* If the next command is an <If...> that contains a check of either */
                /* LastCC or LastRC then do not fail this command. Instead permit    */
                /* processing to continue at the <If...>                             */
                if(NULL != lpCCB->lpCCBNext)
                {
                    lpCCBCheckIf = (CommandCtrlBlk*)lpCCB->lpCCBNext;
                    if(C_IFSTART == lpCCBCheckIf->eCommandType)
                    {
                        lpIFSCheck = (IfStartBlk*) lpCCBCheckIf;
                        if((TRUE == lpIFSCheck->bACondChecksLastCC) || (TRUE == lpIFSCheck->bACondChecksLastRC))
                        {
                            lpPMB->eCommandState = S_COMPLETE;
                            return SUCCESS;
                        }
                    }
                }
                lpPMB->eCommandState = S_FAILURE;
                return FAILURE;
            }
        }
        break;
    case S_COMPLETE:
        LogMsg(38, lpTIB->lTestNum, lpszCurrCmdName, CalcCmdExecTime(lpTIB));
        kpMCB->bConcurrencyWait = FALSE;
        lpPMB->eCommandState = S_NEXT;
        return SUCCESS;
        break;
    case S_FAILURE:
        LogMsg(51, lpTIB->lTestNum, lpszCurrCmdName, CalcCmdExecTime(lpTIB));
        kpMCB->bConcurrencyWait = FALSE;
        lpPMB->eCommandState = S_NEXT;
        return FAILURE;
        break;
    }
    /* Should never get here so its a logic error terminate immediately */
    lpPMB->eCommandState = S_FAILURE;
    SetTIBCodes(lpTIB, MTCC_FAIL, MTRC_LOGIC_FAIL);
    kpMCB->lProcessing = FAILURE;
    LogMsg(69, lpTIB->lTestNum, "ExecutePutMsgCmd\0");
    return FAILURE;
}


/*--------------------------------------------------------------------------*/
long
ExecuteSelectCmd(TestInfoBlk* lpTIB, CommandCtrlBlk* lpCCB)
{
    ControlInfoBlk* lpCIB;
    SelectBlk*      lpSLB;
    MsgSetTreeNode* lpCurrMsgSetTreeNode;
    VarInfoBlk*     lpVIBMQMD;
    MQMDInfoBlk*    lpMIB;
    char*           lpszCurrCmdName;
    long            lCC;
    long            lRC;
    char            lpszExtraInfo[EXTRA_MSG_INFO_LEN + 4];

    /* Initialise common use local variables */
    lpCIB = kpMCB->lpCIB;
    lpSLB = (SelectBlk*)lpCCB;
    lpszCurrCmdName = kpszSELECT;
    memset(lpszExtraInfo, 0x00, EXTRA_MSG_INFO_LEN + 4);

    /* Process according to current command state */
    switch(lpSLB->eCommandState)
    {
    case S_INIT:
        LogMsg(44, lpTIB->lTestNum, lpszCurrCmdName, "\0");
        lpTIB->lLastDataLen = 0;
        time(&lpSLB->oStartTime);
        lpSLB->oExpiryTime = lpSLB->oStartTime;
        lpSLB->oNextLogMsgTime = lpSLB->oStartTime;

        /* Running an initialisation so set concurrency wait false. */
        kpMCB->bConcurrencyWait = FALSE;

        LogMsg(226, lpTIB->lTestNum, lpSLB->lpszMsgSetName, lpSLB->lpszMsgNum);

        /* Resolve the MQMD variable names */
        ResolveSubscript(lpTIB, &lpSLB->lpszResMQMDVarName, &lpSLB->lpszMQMDVarName, TRUE);

        /* Resolve values */
        ResolveValue(lpTIB, &lpSLB->lpszResBuffName,
                     &lpSLB->lpszBuffName, TRUE);
        ResolveValue(lpTIB, &lpSLB->lpszResMsgSetName,
                     &lpSLB->lpszMsgSetName, TRUE);
        ResolveValue(lpTIB, &lpSLB->lpszResMsgNum,
                     &lpSLB->lpszMsgNum, TRUE);
        if(FAILURE == lpTIB->bCmdResult)
        {
            SetTIBCodes(lpTIB, MTCC_FAIL, MTRC_INIT_RESOLVE_FAIL);
            lpSLB->eCommandState = S_FAILURE;
            return FAILURE;
        }

        /* Try to convert the message number */
        lpSLB->lMsgNum = ConvNum(lpTIB, lpSLB->lpszResMsgNum, "MsgNum");
        if(FAILURE == lpTIB->bCmdResult)
        {
            SetTIBCodes(lpTIB, MTCC_FAIL, MTRC_INIT_CONVNUM_FAIL);
            lpSLB->eCommandState = S_FAILURE;
            return FAILURE;
        }
        /* Message indexes are zero based so correct the message number */
        lpSLB->lMsgNum--;

        /* See if we can find the message set */
        lpSLB->lpMsgSetHdr = FindMsgSetHdr(lpSLB->lpszResMsgSetName);
        if(NULL == lpSLB->lpMsgSetHdr)
        {
            LogMsg(227, lpTIB->lTestNum, lpSLB->lpszResMsgSetName);
            SetTIBCodes(lpTIB, MTCC_FAIL, MTRC_INIT_LOCATE_FAIL);
            lpSLB->eCommandState = S_FAILURE;
            return FAILURE;
        }

        /* Now locate or add a buffer info block with the right name */
        lpSLB->lpBIB = CheckAndAddBIB(lpTIB, lpSLB->lpszResBuffName);
        if(! lpSLB->lpBIB)
        {
            /* Problem locating/creating the BIB report it and fail the test  */
            sprintf(lpszExtraInfo, "Unable to locate/allocate BIB Buffer=%s\0",
                    lpSLB->lpszResBuffName);
            LogMsg(TEST_EXTRA_LINE_ERR, lpTIB->lTestNum, lpszExtraInfo);
            SetTIBCodes(lpTIB, MTCC_FAIL, MTRC_INIT_BUFF_FAIL);
            lpSLB->eCommandState = S_FAILURE;
            return FAILURE;
        }

        /* If we dont have a buffer allocate a new one */
        /* otherwise clear the existing one            */
        if(NULL == lpSLB->lpBIB->lpszBuff)
        {
            /* Allocate the new buffer */
            lpSLB->lpBIB->lDataLen = 0;
            lpSLB->lpBIB->lBuffLen = INITIAL_BUFF_LEN;
            lpSLB->lpBIB->lpszBuff = malloc(lpSLB->lpBIB->lBuffLen + 8);
            if(! lpSLB->lpBIB->lpszBuff)
            {
                /* Couldn't get a buffer report the problem and fail the test */
                sprintf(lpszExtraInfo, "Buffer=%s BuffLen=%d malloc() failed.\0",
                        lpSLB->lpBIB->lpszBuffName,
                        lpSLB->lpBIB->lBuffLen);
                LogMsg(TEST_EXTRA_LINE_ERR, lpTIB->lTestNum, lpszExtraInfo);
                SetTIBCodes(lpTIB, MTCC_FAIL, MTRC_INIT_BUFF_FAIL);
                lpSLB->eCommandState = S_FAILURE;
                return FAILURE;
            }

            /* Clear the new buffer and report its allocation */
            memset(lpSLB->lpBIB->lpszBuff, 0x00, lpSLB->lpBIB->lBuffLen + 8);
            if(FALSE == kpMCB->bLoggingSuppressed)
            {
                sprintf(lpszExtraInfo, "Buffer=%s BuffLen=%d bytes allocated\0",
                        lpSLB->lpBIB->lpszBuffName,
                        lpSLB->lpBIB->lBuffLen);
                LogMsg(TEST_EXTRA_LINE, lpTIB->lTestNum, lpszExtraInfo);
            }
        }
        else
        {
            /* Clear the buffer */
            memset(lpSLB->lpBIB->lpszBuff, 0x00, lpSLB->lpBIB->lDataLen + 4);
        }

        /* Ready to run */
        SetTIBCodes(lpTIB, MTCC_OK, MTRC_NONE);
        lpSLB->eCommandState = S_RUN;
        return SUCCESS;
        break;
    case S_RUN:
        LogMsg(45, lpTIB->lTestNum, lpszCurrCmdName, "\0");

        /* Get a pointer to the VIB for the MQMD. See if we can find the */
        /* VIB on the TIB chain if not then we need to create one        */
        lpVIBMQMD = CheckAndAddVIB(lpTIB, V_MQMD,
                                   lpSLB->lpszMQMDVarName,
                                   lpSLB->lpszResMQMDVarName,
                                   NULL);
        if(FAILURE == lpTIB->bCmdResult)
        {
            SetTIBCodes(lpTIB, MTCC_FAIL, MTRC_RUN_FAIL);
            lpTIB->lTestFailedPutMsg++;
            kpMCB->lScriptFailedPutMsg++;
            lpSLB->eCommandState = S_FAILURE;
            return FAILURE;
        }

        /* Initialise condition and reason codes. For simplicity re-use MQ values */
        lCC = MQCC_OK;
        lRC = MQRC_NONE;

        /* Point to the first message in the message set */
        lpCurrMsgSetTreeNode = (MsgSetTreeNode*)lpSLB->lpMsgSetHdr->lpOutRootNode->lpFirstChild;

        /* If the last time we did a select for a message we got a message */
        /* with a lower number than this one then we can start the search  */
        /* from where we left off                                          */
        if(NULL != lpSLB->lpLastMsgSetTreeNode)
        {
            if(lpSLB->lpLastMsgSetTreeNode->lIndexSameName < lpSLB->lMsgNum)
            {
                lpCurrMsgSetTreeNode = lpSLB->lpLastMsgSetTreeNode;
            }
            else
            {
                lpSLB->lpLastMsgSetTreeNode = NULL;
            }
        }

        /* See if we can find a message with the right number */
        while(NULL != lpCurrMsgSetTreeNode)
        {
            if(lpSLB->lMsgNum == lpCurrMsgSetTreeNode->lIndexSameName)
            {
                break; /* while(NULL != lpCurrMsgSetTreeNode) */
            }
            lpCurrMsgSetTreeNode = (MsgSetTreeNode*)lpCurrMsgSetTreeNode->lpNextSiblingSameName;
        }

        /* If we found a message then generate the buffers contents */
        /* otherwise set appropriate condition and reason codes     */
        if(NULL != lpCurrMsgSetTreeNode)
        {
            GenerateMsgInBuff(lpTIB, lpSLB->lpBIB, lpCurrMsgSetTreeNode, lpVIBMQMD);
            if((FAILURE == lpTIB->bCmdResult) ||
               (FAILURE == kpMCB->lProcessing))
            {
                lpSLB->eCommandState = S_FAILURE;
                return FAILURE;
            }
            lpMIB = lpVIBMQMD->lpCtrlBlk;
            lpSLB->lpLastMsgSetTreeNode = lpCurrMsgSetTreeNode;
        }
        else
        {
            lCC = MQCC_FAILED;
            lRC = MQRC_NO_MSG_AVAILABLE;
            lpSLB->lpLastMsgSetTreeNode = NULL;
        }

        /* Check current reason code against BreakOnRC reason codes */
        if(0 < lpSLB->lBreakOnRCCount)
        {
            if(TRUE == FindRC(lpSLB->lBreakOnRCCount, lpSLB->lBreakOnRC, lRC))
            {
                if(lpSLB->lpBreakContinueFSB)
                {
                    LogMsg(118, lpTIB->lTestNum, kpszSELECT, lCC, lRC, "Ending For/ForEver/ForEach loop Name=\0", lpSLB->lpBreakContinueFSB->lpszForName);
                }
                else
                {
                    LogMsg(118, lpTIB->lTestNum, kpszSELECT, lCC, lRC, "Ending Test Name=\0", lpTIB->lpszTestName);
                }
                lpSLB->lpBIB->lDataLen = 0;
                lpTIB->lpBreakContinueFSB = lpSLB->lpBreakContinueFSB;
                kpMCB->bConcurrencyWait = FALSE;
                SetTIBCodes(lpTIB, lCC, lRC);
                lpSLB->eCommandState = S_BREAK;
                return SUCCESS;
            }
        }

        /* Check current reason code against ContinueOnRC reason codes */
        if(0 < lpSLB->lContinueOnRCCount)
        {
            if(TRUE == FindRC(lpSLB->lContinueOnRCCount, lpSLB->lContinueOnRC, lRC))
            {
                if(lpSLB->lpBreakContinueFSB)
                {
                    LogMsg(119, lpTIB->lTestNum, kpszSELECT, lCC, lRC, "Continuing For/ForEver/ForEach loop Name=\0", lpSLB->lpBreakContinueFSB->lpszForName);
                }
                else
                {
                    LogMsg(119, lpTIB->lTestNum, kpszSELECT, lCC, lRC, "Ending Test Name=\0", lpTIB->lpszTestName);
                }
                lpSLB->lpBIB->lDataLen = 0;
                lpTIB->lpBreakContinueFSB = lpSLB->lpBreakContinueFSB;
                kpMCB->bConcurrencyWait = FALSE;
                SetTIBCodes(lpTIB, lCC, lRC);
                lpSLB->eCommandState = S_CONTINUE;
                return SUCCESS;
            }
        }

        /* Check the current reason code against the suppression list */
        /* Suppression is done last as it changes the reason code     */
        if(0 < lpSLB->lSuppressRCCount)
        {
            if(TRUE == FindRC(lpSLB->lSuppressRCCount, lpSLB->lSuppressRC, lRC))
            {
                LogMsg(117, lpTIB->lTestNum, kpszSELECT, lCC, lRC);
                lCC = 0;
                lRC = 0;
            }
        }

        /* Log information about the data just loaded */
        if(FALSE == kpMCB->bLoggingSuppressed)
        {
            sprintf(lpszExtraInfo, "Buffer=%s BuffLen=%d DataLen=%d data loaded\0",
                    lpSLB->lpBIB->lpszBuffName,
                    lpSLB->lpBIB->lBuffLen,
                    lpSLB->lpBIB->lDataLen);
            LogMsg(TEST_EXTRA_LINE, lpTIB->lTestNum, lpszExtraInfo);
            DisplayData(kpszData, lpszExtraInfo, EXTRA_MSG_INFO_LEN, 
                        lpSLB->lpBIB->lpszBuff, lpSLB->lpBIB->lDataLen);
            LogMsg(TEST_EXTRA_LINE, lpTIB->lTestNum, lpszExtraInfo);
        }
        kpMCB->bConcurrencyWait = FALSE;
        SetTIBCodes(lpTIB, MTCC_OK, MTRC_NONE);
        lpTIB->lLastDataLen = lpSLB->lpBIB->lDataLen;
        lpSLB->eCommandState = S_COMPLETE;
        return SUCCESS;
        break;
    case S_COMPLETE:
        LogMsg(38, lpTIB->lTestNum, lpszCurrCmdName, CalcCmdExecTime(lpTIB));
        kpMCB->bConcurrencyWait = FALSE;
        lpSLB->eCommandState = S_NEXT;
        return SUCCESS;
        break;
    case S_FAILURE:
        LogMsg(51, lpTIB->lTestNum, lpszCurrCmdName, CalcCmdExecTime(lpTIB));
        kpMCB->bConcurrencyWait = FALSE;
        lpSLB->eCommandState = S_NEXT;
        return FAILURE;
        break;
    }
    /* Should never get here so its a logic error terminate immediately */
    SetTIBCodes(lpTIB, MTCC_FAIL, MTRC_LOGIC_FAIL);
    lpSLB->eCommandState = S_FAILURE;
    kpMCB->lProcessing = FAILURE;
    LogMsg(69, lpTIB->lTestNum, "ExecuteSelectCmd\0");
    return FAILURE;
}


/*--------------------------------------------------------------------------*/
long
ExecuteWaitOnMsgDepthCmd(TestInfoBlk* lpTIB, CommandCtrlBlk* lpCCB)
{
    ControlInfoBlk* lpCIB;
    WaitDepthBlk*   lpWDB;
    IfStartBlk*     lpIFSCheck;
    CommandCtrlBlk* lpCCBCheckIf;
    char*           lpszCurrCmdName;
    char            lpszExtraInfo[EXTRA_MSG_INFO_LEN + 4];
    MQLONG          lSelector[1];
    MQLONG          lIntegerAttrValues[1];
    MQLONG          lCC;
    MQLONG          lRC;
    long            lCmdMaxWait;
    time_t          oCurrTime;

    /* Initialise common use local variables */
    lpCIB = kpMCB->lpCIB;
    lpWDB = (WaitDepthBlk*)lpCCB;
    lpszCurrCmdName = kpszWAITONMSGDEPTH;
    memset(lpszExtraInfo, 0x00, EXTRA_MSG_INFO_LEN + 4);

    /* Process according to current command state */
    switch(lpWDB->eCommandState)
    {
    case S_INIT:
        LogMsg(44, lpTIB->lTestNum, lpszCurrCmdName, "\0");

        /* Running an initialisation so set concurrency wait false. */
        kpMCB->bConcurrencyWait = FALSE;

        /* Resolve values */
        ResolveValue(lpTIB, &lpWDB->lpszResConnectionName,
                     &lpWDB->lpszConnectionName, TRUE);
        ResolveValue(lpTIB, &lpWDB->lpszResQName,
                     &lpWDB->lpszQName, TRUE);
        ResolveValue(lpTIB, &lpWDB->lpszResDepth,
                     &lpWDB->lpszDepth, TRUE);
        ResolveValue(lpTIB, &lpWDB->lpszResCmdMaxWait,
                     &lpWDB->lpszCmdMaxWait, TRUE);

        /* Problems with variable resolution time to give up     */
        if(FAILURE == lpTIB->bCmdResult)
        {
            SetTIBCodes(lpTIB, MTCC_FAIL, MTRC_INIT_RESOLVE_FAIL);
            lpWDB->eCommandState = S_FAILURE;
            return FAILURE;
        }

        /* Determine the maximum wait time */
        lCmdMaxWait = ConvNum(lpTIB, lpWDB->lpszResCmdMaxWait, "CmdMaxWait");
        if(FAILURE == lpTIB->bCmdResult)
        {
            sprintf(lpszExtraInfo, "CmdMaxWait=%s not numeric\0",
                    lpWDB->lpszResCmdMaxWait);
            LogMsg(TEST_EXTRA_LINE_ERR, lpTIB->lTestNum, lpszExtraInfo);
            SetTIBCodes(lpTIB, MTCC_FAIL, MTRC_INIT_CONVNUM_FAIL);
            lpWDB->eCommandState = S_FAILURE;
            return FAILURE;
        }
        if(-1 == lCmdMaxWait)
        {
            lpWDB->lMaxWait = 999999; /* 11.5 days */
        }
        else
        {
            lpWDB->lMaxWait = lCmdMaxWait;
        }
        time(&lpWDB->oStartTime);
        lpWDB->oExpiryTime = lpWDB->oStartTime + lpWDB->lMaxWait;
        lpWDB->oNextLogMsgTime = lpWDB->oStartTime;

        /* Update the last queue and queue manager referenced internal values */
        lpTIB->lpszLastQ = CloneString(lpWDB->lpszResQName);
        lpTIB->lpszLastQMgr = CloneString(kpszEmptyString);

        /* Locate the connection definition block for this command */
        lpWDB->lpCDB = FindConnectionDefBlk(kpMCB->lpCDBHead, lpWDB->lpszResConnectionName);
        if(NULL == lpWDB->lpCDB)
        {
            LogMsg(194, lpWDB->lpszResConnectionName);
            SetTIBCodes(lpTIB, MTCC_FAIL, MTRC_INIT_FAIL);
            lpTIB->lTestFailedGetMsg++;
            kpMCB->lScriptFailedGetMsg++;
            lpWDB->eCommandState = S_FAILURE;
            return FAILURE;
        }

        /* Try opening the MQ queue */
        lpWDB->lpQIB = OpenQueue(lpTIB, lpWDB->lpCDB, lpTIB->lpQIBHead,
                                 lpWDB->lpszResQName, kpszEmptyString,
                                 kpszEmptyString, FALSE);
        if(! lpWDB->lpQIB)
        {
            /* Couldn't open the queue log the problem and fail the test */
            sprintf(lpszExtraInfo, "TargQ=\"%s\" TargQMgr=\"%s\" ConnQMgr=\"%s\" open failed\0",
                    lpWDB->lpszResQName,
                    kpszEmptyString,
                    lpWDB->lpCDB->lpszConnQMgrName);
            LogMsg(TEST_EXTRA_LINE_ERR, lpTIB->lTestNum, lpszExtraInfo);
            /* If the next command is an <If...> that contains a check of either */
            /* LastCC or LastRC then do not fail this command. Instead permit    */
            /* processing to continue at the <If...>                             */
            if(NULL != lpCCB->lpCCBNext)
            {
                lpCCBCheckIf = (CommandCtrlBlk*)lpCCB->lpCCBNext;
                if(C_IFSTART == lpCCBCheckIf->eCommandType)
                {
                    lpIFSCheck = (IfStartBlk*) lpCCBCheckIf;
                    if((TRUE == lpIFSCheck->bACondChecksLastCC) || (TRUE == lpIFSCheck->bACondChecksLastRC))
                    {
                        lpWDB->eCommandState = S_COMPLETE;
                        return SUCCESS;
                    }
                }
            }
            lpWDB->eCommandState = S_FAILURE;
            return FAILURE;
        }

        /* Convert the depth to a binary value and display the result */
        lpWDB->lDepth = ConvNum(lpTIB, lpWDB->lpszResDepth, "Depth");
        if(SUCCESS == lpTIB->bCmdResult)
        {
            if(FALSE == kpMCB->bLoggingSuppressed)
            {
                sprintf(lpszExtraInfo, "Queue depth=%d\0",
                        lpWDB->lDepth);
                LogMsg(TEST_EXTRA_LINE, lpTIB->lTestNum, lpszExtraInfo);
            }
        }
        else
        {
            sprintf(lpszExtraInfo, "Queue depth=%s not numeric\0",
                    lpWDB->lpszResDepth);
            LogMsg(TEST_EXTRA_LINE_ERR, lpTIB->lTestNum, lpszExtraInfo);
            SetTIBCodes(lpTIB, MTCC_FAIL, MTRC_INIT_CONVNUM_FAIL);
            lpWDB->eCommandState = S_FAILURE;
            return FAILURE;
        }

        /* Ready to run */
        SetTIBCodes(lpTIB, MTCC_OK, MTRC_NONE);
        lpWDB->eCommandState = S_RUN;
        return SUCCESS;
        break;
    case S_RUN:
        /* Work out how much time has elapsed as all log messages   */
        /* for the WaitOnMsgDepth command include this information  */
        time(&oCurrTime);
        sprintf(lpszExtraInfo, " MaxWait=%d:%d\0", lpWDB->lMaxWait,
                oCurrTime - lpWDB->oStartTime);
        
        /* Call MQ to get the current q depth */
        lSelector[0] = MQIA_CURRENT_Q_DEPTH;
        MQINQ(lpWDB->lpQIB->hConn, lpWDB->lpQIB->hQ, 1, lSelector,
              1, lIntegerAttrValues, 0, NULL, &lCC, &lRC);
    
        /* Check the result of the MQINQ call */
        if(MQRC_NONE == lRC)
        {
            if(lpWDB->lDepth <= lIntegerAttrValues[0])
            {
                if(FALSE == kpMCB->bLoggingSuppressed)
                {
                    LogMsg(45, lpTIB->lTestNum, lpszCurrCmdName, lpszExtraInfo);
                    sprintf(lpszExtraInfo, "TargQ=\"%s\" TargQMgr=\"%s\" ConnQMgr=\"%s\" queue depth reached\0",
                            lpWDB->lpszResQName,
                            kpszEmptyString,
                            lpWDB->lpCDB->lpszConnQMgrName);
                    LogMsg(TEST_EXTRA_LINE, lpTIB->lTestNum, lpszExtraInfo);
                    sprintf(lpszExtraInfo, "Required depth=%d current depth=%d\0",
                            lpWDB->lDepth, lIntegerAttrValues[0]);
                    LogMsg(TEST_EXTRA_LINE, lpTIB->lTestNum, lpszExtraInfo);
                }
                kpMCB->bConcurrencyWait = FALSE;
                SetTIBCodes(lpTIB, MTCC_OK, MTRC_NONE);
                lpWDB->eCommandState = S_COMPLETE;
                return SUCCESS;
            }
            else
            {
                /* If the test maximum wait interval has expired then tell the user */
                /* the queue never eached the required depth and fail the test      */
                if(lpWDB->oExpiryTime <= oCurrTime)
                {
                    LogMsg(45, lpTIB->lTestNum, lpszCurrCmdName, lpszExtraInfo);
                    sprintf(lpszExtraInfo, "TargQ=\"%s\" TargQMgr=\"%s\" ConnQMgr=\"%s\" queue depth not reached\0",
                            lpWDB->lpszResQName,
                            kpszEmptyString,
                            lpWDB->lpCDB->lpszConnQMgrName);
                    LogMsg(TEST_EXTRA_LINE_ERR, lpTIB->lTestNum, lpszExtraInfo);
                    sprintf(lpszExtraInfo, "MaxWait interval=%d expired\0",
                            lpWDB->lMaxWait);
                    LogMsg(TEST_EXTRA_LINE_ERR, lpTIB->lTestNum, lpszExtraInfo);
                    SetTIBCodes(lpTIB, MTCC_FAIL, MTRC_RUN_FAIL);
                    /* If the next command is an <If...> that contains a check of either */
                    /* LastCC or LastRC then do not fail this command. Instead permit    */
                    /* processing to continue at the <If...>                             */
                    if(NULL != lpCCB->lpCCBNext)
                    {
                        lpCCBCheckIf = (CommandCtrlBlk*)lpCCB->lpCCBNext;
                        if(C_IFSTART == lpCCBCheckIf->eCommandType)
                        {
                            lpIFSCheck = (IfStartBlk*) lpCCBCheckIf;
                            if((TRUE == lpIFSCheck->bACondChecksLastCC) || (TRUE == lpIFSCheck->bACondChecksLastRC))
                            {
                                lpWDB->eCommandState = S_COMPLETE;
                                return SUCCESS;
                            }
                        }
                    }
                    lpWDB->eCommandState = S_FAILURE;
                    return FAILURE;
                }

                /* If its time to write a log message do so and then reset the */
                /* time that the next log message is due to be written         */
                else if(lpWDB->oNextLogMsgTime <= oCurrTime)
                {
                    if(FALSE == kpMCB->bLoggingSuppressed)
                    {
                        LogMsg(45, lpTIB->lTestNum, lpszCurrCmdName, lpszExtraInfo);
                        sprintf(lpszExtraInfo, "TargQ=\"%s\" TargQMgr=\"%s\" ConnQMgr=\"%s\" waiting on queue depth\0",
                                lpWDB->lpszResQName,
                                kpszEmptyString,
                                lpWDB->lpCDB->lpszConnQMgrName);
                        LogMsg(TEST_EXTRA_LINE, lpTIB->lTestNum, lpszExtraInfo);
                        sprintf(lpszExtraInfo, "Required depth=%d current depth=%d\0",
                                lpWDB->lDepth, lIntegerAttrValues[0]);
                        LogMsg(TEST_EXTRA_LINE, lpTIB->lTestNum, lpszExtraInfo);
                    }
                    lpWDB->oNextLogMsgTime = oCurrTime + lpCIB->lNextLogMsgInterval;
                }
                /* Keep waiting */
                SetTIBCodes(lpTIB, MTCC_OK, MTRC_NONE);
                return SUCCESS;
            }
        }
        else
        {
            /* MQINQ failed log the fact and fail the test */
            LogMsg(45, lpTIB->lTestNum, lpszCurrCmdName, lpszExtraInfo);
            sprintf(lpszExtraInfo, "TargQ=\"%s\" TargQMgr=\"%s\" ConnQMgr=\"%s\" queue depth inquiry failed\0",
                    lpWDB->lpszResQName,
                    kpszEmptyString,
                    lpWDB->lpCDB->lpszConnQMgrName);
            LogMsg(TEST_EXTRA_LINE_ERR, lpTIB->lTestNum, lpszExtraInfo);
            sprintf(lpszExtraInfo, "MQINQ CC=%d RC=%d\0", lCC, lRC);
            LogMsg(TEST_EXTRA_LINE_ERR, lpTIB->lTestNum, lpszExtraInfo);
            SetTIBCodes(lpTIB, lCC, lRC);
            /* If the next command is an <If...> that contains a check of either */
            /* LastCC or LastRC then do not fail this command. Instead permit    */
            /* processing to continue at the <If...>                             */
            if(NULL != lpCCB->lpCCBNext)
            {
                lpCCBCheckIf = (CommandCtrlBlk*)lpCCB->lpCCBNext;
                if(C_IFSTART == lpCCBCheckIf->eCommandType)
                {
                    lpIFSCheck = (IfStartBlk*) lpCCBCheckIf;
                    if((TRUE == lpIFSCheck->bACondChecksLastCC) || (TRUE == lpIFSCheck->bACondChecksLastRC))
                    {
                        lpWDB->eCommandState = S_COMPLETE;
                        return SUCCESS;
                    }
                }
            }
            lpWDB->eCommandState = S_FAILURE;
            return FAILURE;
        }
        break;
    case S_COMPLETE:
        LogMsg(38, lpTIB->lTestNum, lpszCurrCmdName, CalcCmdExecTime(lpTIB));
        kpMCB->bConcurrencyWait = FALSE;
        lpWDB->eCommandState = S_NEXT;
        return SUCCESS;
        break;
    case S_FAILURE:
        LogMsg(51, lpTIB->lTestNum, lpszCurrCmdName, CalcCmdExecTime(lpTIB));
        kpMCB->bConcurrencyWait = FALSE;
        lpWDB->eCommandState = S_NEXT;
        return FAILURE;
        break;
    }
    /* Should never get here so its a logic error terminate immediately */
    SetTIBCodes(lpTIB, MTCC_FAIL, MTRC_LOGIC_FAIL);
    lpWDB->eCommandState = S_FAILURE;
    kpMCB->lProcessing = FAILURE;
    LogMsg(69, lpTIB->lTestNum, "ExecuteWaitOnMsgDepthCmd\0");
    return FAILURE;
}


/*--------------------------------------------------------------------------*/
long
ExecuteWaitOnTimeCmd(TestInfoBlk* lpTIB, CommandCtrlBlk* lpCCB)
{
    ControlInfoBlk* lpCIB;
    WaitTimeBlk*    lpWTB;
    char*           lpszCurrCmdName;
    char            lpszExtraInfo[EXTRA_MSG_INFO_LEN + 4];
    char            lpszTimeBuff[LOG_BUFF_LEN + 4];
    time_t          oCurrTime;
    struct tm*      poCurrTimeTm ;

    /* Initialise common use local variables */
    lpCIB = kpMCB->lpCIB;
    lpWTB = (WaitTimeBlk*)lpCCB;
    lpszCurrCmdName = kpszWAITONTIME;
    memset(lpszExtraInfo, 0x00, EXTRA_MSG_INFO_LEN + 4);

    /* Process according to current command state */
    switch(lpWTB->eCommandState)
    {
    case S_INIT:
        /* Running an initialisation so set concurrency wait false. */
        kpMCB->bConcurrencyWait = FALSE;

        switch(lpWTB->eWaitType)
        {
        case W_INTERVAL:
            /* Initialise times. NOTE that the expiry time in this case is */
            /* the start time plus the <Interval> and that expiry is the   */
            /* desired result. TestMaxWait is not taken into account.       */
            ResolveValue(lpTIB, &lpWTB->lpszResInterval,
                         &lpWTB->lpszInterval, TRUE);
            if(FAILURE == lpTIB->bCmdResult)
            {
                SetTIBCodes(lpTIB, MTCC_FAIL, MTRC_INIT_RESOLVE_FAIL);
                lpWTB->eCommandState = S_FAILURE;
                return FAILURE;
            }

            lpWTB->lInterval = ConvNum(lpTIB, lpWTB->lpszResInterval, "Interval");
            /* Problems with numeric conversion time to give up     */
            if(FAILURE == lpTIB->bCmdResult)
            {
                sprintf(lpszExtraInfo, " Invalid interval=%s\0", lpWTB->lpszResInterval);
                LogMsg(44, lpTIB->lTestNum, lpszCurrCmdName, lpszExtraInfo);
                SetTIBCodes(lpTIB, MTCC_FAIL, MTRC_INIT_CONVNUM_FAIL);
                lpWTB->eCommandState = S_FAILURE;
                return FAILURE;
            }

            /* Set up start, expiry and next log message times */
            time(&lpWTB->oStartTime);
            lpWTB->oExpiryTime = lpWTB->oStartTime + lpWTB->lInterval;
            lpWTB->oNextLogMsgTime = lpWTB->oStartTime;
            if(FALSE == kpMCB->bLoggingSuppressed)
            {
                sprintf(lpszExtraInfo, " Interval=%d:%d\0", lpWTB->lInterval, 0);
                LogMsg(44, lpTIB->lTestNum, lpszCurrCmdName, lpszExtraInfo);
            }
            break;
        case W_INTERVALMILLIS:
            /* Initialise times. As <IntervalMillis> is a blocking call the */
            /* times are all set to the same value                          */
            time(&lpWTB->oStartTime);
            lpWTB->oExpiryTime = lpWTB->oStartTime;
            lpWTB->oNextLogMsgTime = lpWTB->oStartTime;

            /* Get the wait interval in milli-seconds */
            ResolveValue(lpTIB, &lpWTB->lpszResIntervalMillis,
                         &lpWTB->lpszIntervalMillis, TRUE);
            if(FAILURE == lpTIB->bCmdResult)
            {
                SetTIBCodes(lpTIB, MTCC_FAIL, MTRC_INIT_RESOLVE_FAIL);
                lpWTB->eCommandState = S_FAILURE;
                return FAILURE;
            }

            lpWTB->lIntervalMillis = ConvNum(lpTIB, lpWTB->lpszResIntervalMillis, "IntervalMillis");
            /* Problems with numeric conversion time to give up     */
            if(FAILURE == lpTIB->bCmdResult)
            {
                sprintf(lpszExtraInfo, " Invalid IntervalMillis=%s\0", lpWTB->lpszResIntervalMillis);
                LogMsg(44, lpTIB->lTestNum, lpszCurrCmdName, lpszExtraInfo);
                SetTIBCodes(lpTIB, MTCC_FAIL, MTRC_INIT_CONVNUM_FAIL);
                lpWTB->eCommandState = S_FAILURE;
                return FAILURE;
            }

            /* Log the value */
            if(FALSE == kpMCB->bLoggingSuppressed)
            {
                sprintf(lpszExtraInfo, " IntervalMillis=%d\0", lpWTB->lIntervalMillis);
                LogMsg(44, lpTIB->lTestNum, lpszCurrCmdName, lpszExtraInfo);
            }
            break;
        case W_TIME:
            /* Set up start, expiry and next log message times */
            time(&lpWTB->oStartTime);
            lpWTB->oExpiryTime = lpWTB->oStartTime;
            lpWTB->oNextLogMsgTime = lpWTB->oStartTime;

            /* Get the wait interval in milli-seconds */
            ResolveValue(lpTIB, &lpWTB->lpszResTime,
                         &lpWTB->lpszTime, TRUE);
            if(FAILURE == lpTIB->bCmdResult)
            {
                SetTIBCodes(lpTIB, MTCC_FAIL, MTRC_INIT_RESOLVE_FAIL);
                lpWTB->eCommandState = S_FAILURE;
                return FAILURE;
            }

            /* Log the value */
            if(FALSE == kpMCB->bLoggingSuppressed)
            {
                sprintf(lpszExtraInfo, " Time=%s\0", lpWTB->lpszResTime);
                LogMsg(44, lpTIB->lTestNum, lpszCurrCmdName, lpszExtraInfo);
            }
            break;
        }

        /* Ready to run */
        SetTIBCodes(lpTIB, MTCC_OK, MTRC_NONE);
        lpWTB->eCommandState = S_RUN;
        return SUCCESS;
        break;
    case S_RUN:
        time(&oCurrTime);
        switch(lpWTB->eWaitType)
        {
        case W_INTERVAL:
            sprintf(lpszExtraInfo, " Interval=%d:%d\0", lpWTB->lInterval,
                    oCurrTime - lpWTB->oStartTime);
        
            /* If the wait interval is complete write one last log message */
            /* and change command state to complete                        */
            if(lpWTB->oExpiryTime <= oCurrTime)
            {
                LogMsg(45, lpTIB->lTestNum, lpszCurrCmdName, lpszExtraInfo);
                kpMCB->bConcurrencyWait = FALSE;
                SetTIBCodes(lpTIB, MTCC_OK, MTRC_NONE);
                lpWTB->eCommandState = S_COMPLETE;
                return SUCCESS;
            }
            /* If its time to write a log message do so and then reset the */
            /* time that the next log message is due to be written         */
            if(lpWTB->oNextLogMsgTime <= oCurrTime)
            {
                lpWTB->oNextLogMsgTime = oCurrTime + lpCIB->lNextLogMsgInterval;
                LogMsg(45, lpTIB->lTestNum, lpszCurrCmdName, lpszExtraInfo);
            }
            break;
        case W_INTERVALMILLIS:
            sprintf(lpszExtraInfo, " IntervalMillis=%d\0", lpWTB->lIntervalMillis);
            LogMsg(45, lpTIB->lTestNum, lpszCurrCmdName, lpszExtraInfo);
            SleepMillis(lpWTB->lIntervalMillis); /* Currently implemented as a blocking call */
            kpMCB->bConcurrencyWait = FALSE;
            SetTIBCodes(lpTIB, MTCC_OK, MTRC_NONE);
            lpWTB->eCommandState = S_COMPLETE;
            return SUCCESS;
            break;
        case W_TIME:
            /* Use strftime to format the time value into our buffer   */
            memset(lpszTimeBuff, 0x00, TIME_BUFF_LEN + 4);
            poCurrTimeTm = localtime(&oCurrTime);
            strftime(lpszTimeBuff, TIME_BUFF_LEN, "%H%M%S ", poCurrTimeTm );

            /* Display the time we are waiting until and the current time */
            sprintf(lpszExtraInfo, " Time=%s-%s\0", lpWTB->lpszResTime, lpszTimeBuff);
        
            /* If the wait interval is complete write one last log message */
            /* and change command state to complete                        */
            if(0 >= strncmp(lpWTB->lpszResTime, lpszTimeBuff, 8))
            {
                LogMsg(45, lpTIB->lTestNum, lpszCurrCmdName, lpszExtraInfo);
                kpMCB->bConcurrencyWait = FALSE;
                SetTIBCodes(lpTIB, MTCC_OK, MTRC_NONE);
                lpWTB->eCommandState = S_COMPLETE;
                return SUCCESS;
            }
            /* If its time to write a log message do so and then reset the */
            /* time that the next log message is due to be written         */
            if(lpWTB->oNextLogMsgTime <= oCurrTime)
            {
                lpWTB->oNextLogMsgTime = oCurrTime + lpCIB->lNextLogMsgInterval;
                LogMsg(45, lpTIB->lTestNum, lpszCurrCmdName, lpszExtraInfo);
            }
            break;
        }
        
        /* Keep waiting */
        SetTIBCodes(lpTIB, MTCC_OK, MTRC_NONE);
        return SUCCESS;
        break;
    case S_COMPLETE:
        LogMsg(38, lpTIB->lTestNum, lpszCurrCmdName, CalcCmdExecTime(lpTIB));
        kpMCB->bConcurrencyWait = FALSE;
        lpWTB->eCommandState = S_NEXT;
        return SUCCESS;
        break;
    }
    /* Should never get here so its a logic error terminate immediately */
    SetTIBCodes(lpTIB, MTCC_FAIL, MTRC_LOGIC_FAIL);
    lpWTB->eCommandState = S_FAILURE;
    kpMCB->lProcessing = FAILURE;
    LogMsg(69, lpTIB->lTestNum, "ExecuteWaitOnTimeCmd\0");
    return FAILURE;
}


/*--------------------------------------------------------------------------*/
long
ExecuteCompareCmd(TestInfoBlk* lpTIB, CommandCtrlBlk* lpCCB)
{
    ControlInfoBlk* lpCIB;
    CompareBlk*     lpCMB;
    VarInfoBlk*     lpVIB1;
    VarInfoBlk*     lpVIB2;
    RFH2InfoBlk*    lpRIB1;
    RFH2InfoBlk*    lpRIB2;
    char*           lpszCurrCmdName;
    char            lpszExtraInfo[EXTRA_MSG_INFO_LEN + 4];
    char            lpszDirAndFile[FILE_BUFF_LEN + 4];
    long            bLoadFile;
    long            bDataMatches;
    long            bRIBMatches;
    long            lIdx;
    char*           lpszDataCurr;
    char*           lpszCompCurr;
    char*           lpszMaskCurr;
    char*           lpszPcreError;
    char*           lpszPcreMismatchError;
    long            lDisplayLen;
    long            lPcreErrorOffset;
    long            lPcreRC;

    /* Initialise common use local variables */
    lpCIB = kpMCB->lpCIB;
    lpCMB = (CompareBlk*)lpCCB;
    lpszCurrCmdName = kpszCOMPARE;
    memset(lpszExtraInfo, 0x00, EXTRA_MSG_INFO_LEN + 4);

    /* Process according to current command state */
    switch(lpCMB->eCommandState)
    {
    case S_INIT:
        LogMsg(44, lpTIB->lTestNum, lpszCurrCmdName, "\0");
        lpTIB->lTestTotalCompare++;
        kpMCB->lScriptTotalCompare++;
        time(&lpCMB->oStartTime);
        lpCMB->oExpiryTime = lpCMB->oStartTime;
        lpCMB->oNextLogMsgTime = lpCMB->oStartTime;

        /* Running an initialisation so set concurrency wait false. */
        kpMCB->bConcurrencyWait = FALSE;

        /* Resolve buffer name */
        ResolveValue(lpTIB, &lpCMB->lpszResBuffName,
                     &lpCMB->lpszBuffName, TRUE);

        if(FAILURE == lpTIB->bCmdResult)
        {
            SetTIBCodes(lpTIB, MTCC_FAIL, MTRC_INIT_RESOLVE_FAIL);
            lpTIB->lTestFailedCompare++;
            kpMCB->lScriptFailedCompare++;
            lpCMB->eCommandState = S_FAILURE;
            return FAILURE;
        }

        lpCMB->lpBIB = FindBuffInfoBlk(lpTIB->lpBIBHead, lpCMB->lpszResBuffName);
        if(! lpCMB->lpBIB)
        {
            /* No buffer to compare with. Report the problem and fail */
            sprintf(lpszExtraInfo, "Unable to locate/allocate Buffer=%s\0",
                    lpCMB->lpszResBuffName);
            LogMsg(TEST_EXTRA_LINE_ERR, lpTIB->lTestNum, lpszExtraInfo);
            SetTIBCodes(lpTIB, MTCC_FAIL, MTRC_INIT_BUFF_FAIL);
            lpTIB->lTestFailedCompare++;
            kpMCB->lScriptFailedCompare++;
            lpCMB->eCommandState = S_FAILURE;
            return FAILURE;
        }

        /* Resolve the compare file name, mask file name, regex file name and directory */
        ResolveValue(lpTIB, &lpCMB->lpszResCompFileName,
                     &lpCMB->lpszCompFileName, TRUE);
        ResolveValue(lpTIB, &lpCMB->lpszResCompMaskFileName,
                     &lpCMB->lpszCompMaskFileName, TRUE);
        ResolveValue(lpTIB, &lpCMB->lpszResCompRegexFileName,
                     &lpCMB->lpszCompRegexFileName, TRUE);
        ResolveValue(lpTIB, &lpCMB->lpszResDir,
                     &lpCMB->lpszDir, TRUE);

        /* Problems with variable resolution time to give up     */
        if(FAILURE == lpTIB->bCmdResult)
        {
            SetTIBCodes(lpTIB, MTCC_FAIL, MTRC_INIT_RESOLVE_FAIL);
            lpTIB->lTestFailedCompare++;
            kpMCB->lScriptFailedCompare++;
            lpCMB->eCommandState = S_FAILURE;
            return FAILURE;
        }

        /* Log info about the buffer and its data */
        if(FALSE == kpMCB->bLoggingSuppressed)
        {
            sprintf(lpszExtraInfo, "Buffer=%s BuffLen=%d DataLen=%d\0",
                    lpCMB->lpszResBuffName,
                    lpCMB->lpBIB->lBuffLen,
                    lpCMB->lpBIB->lDataLen);
            LogMsg(TEST_EXTRA_LINE, lpTIB->lTestNum, lpszExtraInfo);
        }

        /* If a comparison file has been requested load it */
        lpCMB->bGotCompFile = FALSE;
        if(0 < StrlenNull(lpCMB->lpszResCompFileName))
        {
            /* Generate full path file name for loading the comparison file */
            memset(lpszDirAndFile, 0x00, FILE_BUFF_LEN + 4);
            strncpy(lpszDirAndFile, lpCMB->lpszResDir, FILE_BUFF_LEN);
            strcat(lpszDirAndFile, kpszDirFileConcat);
            strncat(lpszDirAndFile, lpCMB->lpszResCompFileName, FILE_BUFF_LEN);

            /* See if we can load the file */
            bLoadFile = LoadFile(lpszDirAndFile, &lpCMB->lpszCompFileBuff,
                                 &lpCMB->lCompFileBuffLen, &lpCMB->lCompFileDataLen,
                                 FALSE);
            if(FAILURE == bLoadFile)
            {
                sprintf(lpszExtraInfo, "Load of comparison file=%s failed errno=%d\0",
                        lpszDirAndFile, kpMCB->lFileErrno);
                LogMsg(TEST_EXTRA_LINE_ERR, lpTIB->lTestNum, lpszExtraInfo);
                SetTIBCodes(lpTIB, MTCC_FAIL, kpMCB->lFileErrno);
                lpTIB->lTestFailedCompare++;
                kpMCB->lScriptFailedCompare++;
                lpCMB->eCommandState = S_FAILURE;
                return FAILURE;
            }

            /* Got the comparison file */
            lpCMB->bGotCompFile = TRUE;
            if(FALSE == kpMCB->bLoggingSuppressed)
            {
                sprintf(lpszExtraInfo, "Loaded comparison file=%s\0",
                        lpszDirAndFile);
                LogMsg(TEST_EXTRA_LINE, lpTIB->lTestNum, lpszExtraInfo);
                sprintf(lpszExtraInfo, "CompFileBuffLen=%d CompFileLen=%d\0",
                        lpCMB->lCompFileBuffLen,
                        lpCMB->lCompFileDataLen);
                LogMsg(TEST_EXTRA_LINE, lpTIB->lTestNum, lpszExtraInfo);
            }
        }

        /* If a mask file has been requested load it */
        lpCMB->bGotCompMask = FALSE;
        if(0 < StrlenNull(lpCMB->lpszResCompMaskFileName))
        {
            /* Generate full path file name for loading the mask file */
            memset(lpszDirAndFile, 0x00, FILE_BUFF_LEN + 4);
            strncpy(lpszDirAndFile, lpCMB->lpszResDir, FILE_BUFF_LEN);
            strcat(lpszDirAndFile, kpszDirFileConcat);
            strncat(lpszDirAndFile, lpCMB->lpszResCompMaskFileName, FILE_BUFF_LEN);
            /* See if we can load the file */
            bLoadFile = LoadFile(lpszDirAndFile,
                                 &lpCMB->lpszCompMaskBuff,
                                 &lpCMB->lCompMaskBuffLen,
                                 &lpCMB->lCompMaskDataLen,
                                 FALSE);
            if(FAILURE == bLoadFile)
            {
                sprintf(lpszExtraInfo, "Load of comparison mask file=%s failed errno=%d\0",
                        lpszDirAndFile, kpMCB->lFileErrno);
                LogMsg(TEST_EXTRA_LINE_ERR, lpTIB->lTestNum, lpszExtraInfo);
                SetTIBCodes(lpTIB, MTCC_FAIL, kpMCB->lFileErrno);
                lpTIB->lTestFailedCompare++;
                kpMCB->lScriptFailedCompare++;
                lpCMB->eCommandState = S_FAILURE;
                return FAILURE;
            }

            /* Got a comparison file flag the fact and log it */
            lpCMB->bGotCompMask = TRUE;
            if(FALSE == kpMCB->bLoggingSuppressed)
            {
                sprintf(lpszExtraInfo, "Loaded comparison mask file=%s\0",
                        lpszDirAndFile);
                LogMsg(TEST_EXTRA_LINE, lpTIB->lTestNum, lpszExtraInfo);
                sprintf(lpszExtraInfo, "CompMaskBuffLen=%d CompMaskLen=%d\0",
                        lpCMB->lCompMaskBuffLen,
                        lpCMB->lCompMaskDataLen);
                LogMsg(TEST_EXTRA_LINE, lpTIB->lTestNum, lpszExtraInfo);
            }
        }

        /* If a regex file has been requested load it */
        lpCMB->bGotCompRegex = FALSE;
        if(0 < StrlenNull(lpCMB->lpszResCompRegexFileName))
        {
            /* Generate full path file name for loading the regex file */
            memset(lpszDirAndFile, 0x00, FILE_BUFF_LEN + 4);
            strncpy(lpszDirAndFile, lpCMB->lpszResDir, FILE_BUFF_LEN);
            strcat(lpszDirAndFile, kpszDirFileConcat);
            strncat(lpszDirAndFile, lpCMB->lpszResCompRegexFileName, FILE_BUFF_LEN);
            /* See if we can load the file */
            bLoadFile = LoadFile(lpszDirAndFile,
                                 &lpCMB->lpszCompRegexBuff,
                                 &lpCMB->lCompRegexBuffLen,
                                 &lpCMB->lCompRegexDataLen,
                                 FALSE);
            if(FAILURE == bLoadFile)
            {
                sprintf(lpszExtraInfo, "Load of comparison regex file=%s failed errno=%d\0",
                        lpszDirAndFile, kpMCB->lFileErrno);
                LogMsg(TEST_EXTRA_LINE_ERR, lpTIB->lTestNum, lpszExtraInfo);
                SetTIBCodes(lpTIB, MTCC_FAIL, kpMCB->lFileErrno);
                lpTIB->lTestFailedCompare++;
                kpMCB->lScriptFailedCompare++;
                lpCMB->eCommandState = S_FAILURE;
                return FAILURE;
            }

            /* Got a regex comparison file flag the fact and log it */
            if(FALSE == kpMCB->bLoggingSuppressed)
            {
                sprintf(lpszExtraInfo, "Loaded comparison regex file=%s\0",
                        lpszDirAndFile);
                LogMsg(TEST_EXTRA_LINE, lpTIB->lTestNum, lpszExtraInfo);
                sprintf(lpszExtraInfo, "CompRegexBuffLen=%d CompRegexLen=%d\0",
                        lpCMB->lCompRegexBuffLen,
                        lpCMB->lCompRegexDataLen);
                LogMsg(TEST_EXTRA_LINE, lpTIB->lTestNum, lpszExtraInfo);
            }

            /* Now attempt to compile the regular expression */
            lpszPcreError = NULL;
            lPcreErrorOffset = 0;
            lpCMB->lpCompiledRegex = pcre_compile(lpCMB->lpszCompRegexBuff, PCRE_AUTO_CALLOUT, &lpszPcreError, (int*)&lPcreErrorOffset, NULL);
            if(NULL == lpCMB->lpCompiledRegex)
            {
                sprintf(lpszExtraInfo, "PCRE compilation failed at offset %d: %s\0",
                        lPcreErrorOffset, lpszPcreError);
                LogMsg(TEST_EXTRA_LINE_ERR, lpTIB->lTestNum, lpszExtraInfo);
                SetTIBCodes(lpTIB, MTCC_FAIL, kpMCB->lFileErrno);
                lpTIB->lTestFailedCompare++;
                kpMCB->lScriptFailedCompare++;
                lpCMB->eCommandState = S_FAILURE;
                return FAILURE;
            }
            else
            {
                lpCMB->bGotCompRegex = TRUE;
                sprintf(lpszExtraInfo, "Successfully compiled the comparison regex file=%s\0",
                        lpszDirAndFile);
                LogMsg(TEST_EXTRA_LINE_ERR, lpTIB->lTestNum, lpszExtraInfo);
            }
        }
        lpCMB->bCallOutMade = FALSE;

        /* Made it ready to run */
        kpMCB->bConcurrencyWait = FALSE;
        SetTIBCodes(lpTIB, MTCC_OK, MTRC_NONE);
        lpCMB->eCommandState = S_RUN;
        return SUCCESS;
        break;
    case S_RUN:
        LogMsg(45, lpTIB->lTestNum, lpszCurrCmdName, "\0");
        /* Compare RFH2 Info Blocks if requested */
        if(0 < strlen(lpCMB->lpszCompRFH2VarName1))
        {
            /* Find the VIB for the first RIB */
            lpVIB1 = FindVarInfoBlk(lpTIB->lpVIBHead, lpCMB->lpszCompRFH2VarName1);
            if(! lpVIB1)
            {
                LogMsg(79, lpTIB->lTestNum, lpCMB->lpszCompRFH2VarName1);
                kpMCB->bConcurrencyWait = FALSE;
                SetTIBCodes(lpTIB, MTCC_FAIL, MTRC_RUN_FAIL);
                lpTIB->lTestFailedCompare++;
                kpMCB->lScriptFailedCompare++;
                lpCMB->eCommandState = S_FAILURE;
                return FAILURE;
            }
            /* Find the VIB for the second RIB */
            lpVIB2 = FindVarInfoBlk(lpTIB->lpVIBHead, lpCMB->lpszCompRFH2VarName2);
            if(! lpVIB2)
            {
                LogMsg(79, lpTIB->lTestNum, lpCMB->lpszCompRFH2VarName2);
                kpMCB->bConcurrencyWait = FALSE;
                SetTIBCodes(lpTIB, MTCC_FAIL, MTRC_RUN_FAIL);
                lpTIB->lTestFailedCompare++;
                kpMCB->lScriptFailedCompare++;
                lpCMB->eCommandState = S_FAILURE;
                return FAILURE;
            }

            /* Got the VIB's so get the RIB pointers from them */
            lpRIB1 = lpVIB1->lpCtrlBlk;
            lpRIB2 = lpVIB2->lpCtrlBlk;

            /* Compare the RIB's and check the result */
            bRIBMatches = CompareRIBs(lpTIB, lpRIB1, lpRIB2);
            if(FAILURE == bRIBMatches)
            {
                sprintf(lpszExtraInfo, "RFH2=\"%s\" RFH2FolderCount=%d RFH2FolderDataLen=%d RFH2Len=%d\0",
                        lpVIB1->lpszVarName,
                        lpRIB1->lRFH2FolderCount,
                        lpRIB1->lRFH2FolderDataLen,
                        lpRIB1->lRFH2FolderDataLen + MQRFH_STRUC_LENGTH_FIXED_2);
                LogMsg(TEST_EXTRA_LINE_ERR, lpTIB->lTestNum, lpszExtraInfo);
                sprintf(lpszExtraInfo, "RFH2=\"%s\" RFH2FolderCount=%d RFH2FolderDataLen=%d RFH2Len=%d\0",
                        lpVIB2->lpszVarName,
                        lpRIB2->lRFH2FolderCount,
                        lpRIB2->lRFH2FolderDataLen,
                        lpRIB2->lRFH2FolderDataLen + MQRFH_STRUC_LENGTH_FIXED_2);
                LogMsg(TEST_EXTRA_LINE_ERR, lpTIB->lTestNum, lpszExtraInfo);
                kpMCB->bConcurrencyWait = FALSE;
                SetTIBCodes(lpTIB, MTCC_FAIL, MTRC_RUN_MATCH_FAIL);
                lpTIB->lTestFailedCompare++;
                kpMCB->lScriptFailedCompare++;
                if(TRUE == lpCMB->bLogAndContinue)
                {
                    LogMsg(TEST_EXTRA_LINE_ERR, lpTIB->lTestNum, kpszLOGANDCONTINUESUPPRESS);
                    lpCMB->eCommandState = S_COMPLETE;
                    return SUCCESS;
                }
                lpCMB->eCommandState = S_FAILURE;
                return FAILURE;
            }
            if(FALSE == kpMCB->bLoggingSuppressed)
            {
                sprintf(lpszExtraInfo, "RFH2 folder data matched\0");
                LogMsg(TEST_EXTRA_LINE, lpTIB->lTestNum, lpszExtraInfo);
                sprintf(lpszExtraInfo, "RFH2=\"%s\" RFH2FolderCount=%d RFH2FolderDataLen=%d RFH2Len=%d\0",
                        lpVIB1->lpszVarName,
                        lpRIB1->lRFH2FolderCount,
                        lpRIB1->lRFH2FolderDataLen,
                        lpRIB1->lRFH2FolderDataLen + MQRFH_STRUC_LENGTH_FIXED_2);
                LogMsg(TEST_EXTRA_LINE, lpTIB->lTestNum, lpszExtraInfo);
                sprintf(lpszExtraInfo, "RFH2=\"%s\" RFH2FolderCount=%d RFH2FolderDataLen=%d RFH2Len=%d\0",
                        lpVIB2->lpszVarName,
                        lpRIB2->lRFH2FolderCount,
                        lpRIB2->lRFH2FolderDataLen,
                        lpRIB2->lRFH2FolderDataLen + MQRFH_STRUC_LENGTH_FIXED_2);
                LogMsg(TEST_EXTRA_LINE, lpTIB->lTestNum, lpszExtraInfo);
            }
        }

        /* Compare the data */
        if(TRUE == lpCMB->bGotCompMask)
        {
            /* Process according to comparison mask file */
            if((lpCMB->lpBIB->lDataLen == lpCMB->lCompFileDataLen) &&
               (lpCMB->lpBIB->lDataLen == lpCMB->lCompMaskDataLen))
            {
                /* Initialise flag and pointers */
                bDataMatches = TRUE;
                lpszDataCurr = lpCMB->lpBIB->lpszBuff;
                lpszCompCurr = lpCMB->lpszCompFileBuff;
                lpszMaskCurr = lpCMB->lpszCompMaskBuff;
                /* Byte by byte comparison */
                for(lIdx = 0; lIdx < lpCMB->lpBIB->lDataLen; lIdx++)
                {
                    /* Bytes must match exactly */
                    if('=' == *lpszMaskCurr)
                    {
                        if(*lpszDataCurr != *lpszCompCurr)
                        {
                            bDataMatches = FALSE;
                            break; /* for(lIdx... */
                        }
                    }
                    /* Data byte must be numeric */
                    if('9' == *lpszMaskCurr)
                    {
                        if(! isdigit(*lpszDataCurr))
                        {
                            bDataMatches = FALSE;
                            break; /* for(lIdx... */
                        }
                    }
                    lpszDataCurr++;
                    lpszCompCurr++;
                    lpszMaskCurr++;
                }
                /* Check the result */
                if(! bDataMatches)
                {
                    sprintf(lpszExtraInfo, "Data mismatch. DataLen=%d CompFileLen=%d CompMaskLen=%d\0",
                            lpCMB->lpBIB->lDataLen,
                            lpCMB->lCompFileDataLen,
                            lpCMB->lCompMaskDataLen);
                    LogMsg(TEST_EXTRA_LINE_ERR, lpTIB->lTestNum, lpszExtraInfo);
                    sprintf(lpszExtraInfo, "At offset=%06d Data=\"%.32s\"\0",
                            lIdx, lpszDataCurr);
                    LogMsg(TEST_EXTRA_LINE_ERR, lpTIB->lTestNum, lpszExtraInfo);
                    sprintf(lpszExtraInfo, "                 Comp=\"%.32s\"\0",
                            lpszCompCurr);
                    LogMsg(TEST_EXTRA_LINE_ERR, lpTIB->lTestNum, lpszExtraInfo);
                    sprintf(lpszExtraInfo, "                 Mask=\"%.32s\"\0",
                            lpszMaskCurr);
                    LogMsg(TEST_EXTRA_LINE_ERR, lpTIB->lTestNum, lpszExtraInfo);
                    kpMCB->bConcurrencyWait = FALSE;
                    /* Set codes and increment counters to indicate the match failed */
                    SetTIBCodes(lpTIB, MTCC_FAIL, MTRC_RUN_MATCH_FAIL);
                    lpTIB->lTestFailedCompare++;
                    kpMCB->lScriptFailedCompare++;
                    /* If log and continue has been requested then command completion */
                    /* is regarded as successful with only the counts and codes       */
                    /* indicating otherwise                                           */
                    if(TRUE == lpCMB->bLogAndContinue)
                    {
                        LogMsg(TEST_EXTRA_LINE_ERR, lpTIB->lTestNum, kpszLOGANDCONTINUESUPPRESS);
                        lpCMB->eCommandState = S_COMPLETE;
                        return SUCCESS;
                    }
                    lpCMB->eCommandState = S_FAILURE;
                    return FAILURE;
                }

                /* Got a data match according to the mask */
                if(FALSE == kpMCB->bLoggingSuppressed)
                {
                    sprintf(lpszExtraInfo, "Data matched. DataLen=%d CompFileLen=%d CompMaskLen=%d\0",
                            lpCMB->lpBIB->lDataLen,
                            lpCMB->lCompFileDataLen,
                            lpCMB->lCompMaskDataLen);
                    LogMsg(TEST_EXTRA_LINE, lpTIB->lTestNum, lpszExtraInfo);
                }

            }
            else
            {
                sprintf(lpszExtraInfo, "Length error. DataLen=%d CompFileLen=%d CompMaskLen=%d\0",
                        lpCMB->lpBIB->lDataLen,
                        lpCMB->lCompFileDataLen,
                        lpCMB->lCompMaskDataLen);
                LogMsg(TEST_EXTRA_LINE_ERR, lpTIB->lTestNum, lpszExtraInfo);
                kpMCB->bConcurrencyWait = FALSE;
                SetTIBCodes(lpTIB, MTCC_FAIL, MTRC_RUN_MATCH_FAIL);
                lpTIB->lTestFailedCompare++;
                kpMCB->lScriptFailedCompare++;
                if(TRUE == lpCMB->bLogAndContinue)
                {
                    LogMsg(TEST_EXTRA_LINE_ERR, lpTIB->lTestNum, kpszLOGANDCONTINUESUPPRESS);
                    lpCMB->eCommandState = S_COMPLETE;
                    return SUCCESS;
                }
                lpCMB->eCommandState = S_FAILURE;
                return FAILURE;
            }
        }
        else if(TRUE == lpCMB->bGotCompFile)
        {
            /* Compare current buffer with the comparison file buffer */
            if(lpCMB->lpBIB->lDataLen == lpCMB->lCompFileDataLen)
            {
                /* Initialise flag and pointers */
                bDataMatches = TRUE;
                lpszDataCurr = lpCMB->lpBIB->lpszBuff;
                lpszCompCurr = lpCMB->lpszCompFileBuff;
                /* Byte by byte comparison */
                for(lIdx = 0; lIdx < lpCMB->lpBIB->lDataLen; lIdx++)
                {
                    if(*lpszDataCurr != *lpszCompCurr)
                    {
                        bDataMatches = FALSE;
                        break; /* for(lIdx... */
                    }
                    lpszDataCurr++;
                    lpszCompCurr++;
                }
                /* Check the result */
                if(! bDataMatches)
                {
                    sprintf(lpszExtraInfo, "Data mismatch. DataLen=%d CompFileLen=%d\0",
                            lpCMB->lpBIB->lDataLen,
                            lpCMB->lCompFileDataLen);
                    LogMsg(TEST_EXTRA_LINE_ERR, lpTIB->lTestNum, lpszExtraInfo);
                    sprintf(lpszExtraInfo, "At offset=%06d Data=\"%.32s\"\0",
                            lIdx, lpszDataCurr);
                    LogMsg(TEST_EXTRA_LINE_ERR, lpTIB->lTestNum, lpszExtraInfo);
                    sprintf(lpszExtraInfo, "                 Comp=\"%.32s\"\0",
                            lpszCompCurr);
                    LogMsg(TEST_EXTRA_LINE_ERR, lpTIB->lTestNum, lpszExtraInfo);
                    kpMCB->bConcurrencyWait = FALSE;
                    SetTIBCodes(lpTIB, MTCC_FAIL, MTRC_RUN_MATCH_FAIL);
                    lpTIB->lTestFailedCompare++;
                    kpMCB->lScriptFailedCompare++;
                    if(TRUE == lpCMB->bLogAndContinue)
                    {
                        LogMsg(TEST_EXTRA_LINE_ERR, lpTIB->lTestNum, kpszLOGANDCONTINUESUPPRESS);
                        lpCMB->eCommandState = S_COMPLETE;
                        return SUCCESS;
                    }
                    lpCMB->eCommandState = S_FAILURE;
                    return FAILURE;
                }

                /* Got a byte for byte data match */
                if(FALSE == kpMCB->bLoggingSuppressed)
                {
                    sprintf(lpszExtraInfo, "Data matched. DataLen=%d CompFileLen=%d\0",
                            lpCMB->lpBIB->lDataLen,
                            lpCMB->lCompFileDataLen);
                    LogMsg(TEST_EXTRA_LINE, lpTIB->lTestNum, lpszExtraInfo);
                }
            }
            else
            {
                sprintf(lpszExtraInfo, "Length error. DataLen=%d CompFileLen=%d\0",
                        lpCMB->lpBIB->lDataLen,
                        lpCMB->lCompFileDataLen);
                LogMsg(TEST_EXTRA_LINE_ERR, lpTIB->lTestNum, lpszExtraInfo);
                kpMCB->bConcurrencyWait = FALSE;
                SetTIBCodes(lpTIB, MTCC_FAIL, MTRC_RUN_MATCH_FAIL);
                lpTIB->lTestFailedCompare++;
                kpMCB->lScriptFailedCompare++;
                if(TRUE == lpCMB->bLogAndContinue)
                {
                    LogMsg(TEST_EXTRA_LINE_ERR, lpTIB->lTestNum, kpszLOGANDCONTINUESUPPRESS);
                    lpCMB->eCommandState = S_COMPLETE;
                    return SUCCESS;
                }
                lpCMB->eCommandState = S_FAILURE;
                return FAILURE;
            }
        }
        else if(TRUE == lpCMB->bGotCompRegex)
        {
            /* Set the address of the PCRE static callout routine */
            pcre_callout = PCRECallout;

            /* Try to match the regular expression */
            lPcreRC = pcre_exec(lpCMB->lpCompiledRegex, &lpCMB->oPcreExtra, lpCMB->lpBIB->lpszBuff, lpCMB->lpBIB->lDataLen, 0, 0, NULL, 0);
            if(0 <= lPcreRC)
            {
                /* Got a data match */
                if(FALSE == kpMCB->bLoggingSuppressed)
                {
                    sprintf(lpszExtraInfo, "Data matched the regular expression.\0");
                    LogMsg(TEST_EXTRA_LINE, lpTIB->lTestNum, lpszExtraInfo);
                }
            }
            else
            {
                if(PCRE_ERROR_NOMATCH == lPcreRC)
                {
                    sprintf(lpszExtraInfo, "Data mismatch. Data does not match the regular expression\0");
                    LogMsg(TEST_EXTRA_LINE_ERR, lpTIB->lTestNum, lpszExtraInfo);

                    if(TRUE == lpCMB->bCallOutMade)
                    {
                        sprintf(lpszExtraInfo, "Pattern element=\"\0");
                        lpszPcreMismatchError = lpszExtraInfo + 17;
                        for(lIdx = 0; lIdx < lpCMB->lPatternCurrItemLen; lIdx++)
                        {
                            sprintf(lpszPcreMismatchError, "%c\0", *(lpCMB->lpszCompRegexBuff + lpCMB->lPatternCurrPos + lIdx));
                            lpszPcreMismatchError++;
                        }
                        sprintf(lpszPcreMismatchError, "\" at offset=%d within the regular expression\0", lpCMB->lPatternCurrPos);
                        LogMsg(TEST_EXTRA_LINE_ERR, lpTIB->lTestNum, lpszExtraInfo);
                        sprintf(lpszExtraInfo, "Does not match the data in the buffer at offset=%d\0", lpCMB->lSubjectCurrPos);
                        LogMsg(TEST_EXTRA_LINE_ERR, lpTIB->lTestNum, lpszExtraInfo);
                        lDisplayLen = lpCMB->lpBIB->lDataLen - lpCMB->lSubjectCurrPos;
                        if(0 > lDisplayLen)
                        {
                            lDisplayLen = 1;
                        }
                        if(48 < lDisplayLen)
                        {
                            lDisplayLen = 48;
                        }
                        DisplayData(kpszDataAtOffset, lpszExtraInfo, EXTRA_MSG_INFO_LEN, lpCMB->lpBIB->lpszBuff + lpCMB->lSubjectCurrPos, lDisplayLen);
                        LogMsg(TEST_EXTRA_LINE_ERR, lpTIB->lTestNum, lpszExtraInfo);
                    }
                    else
                    {
                        sprintf(lpszExtraInfo, "Unable to determine exact position of mismatch. Probably first or last character\0");
                        LogMsg(TEST_EXTRA_LINE_ERR, lpTIB->lTestNum, lpszExtraInfo);
                        sprintf(lpszExtraInfo, "If possible anchor the start of the regular expression with a Caret(^)\0");
                        LogMsg(TEST_EXTRA_LINE_ERR, lpTIB->lTestNum, lpszExtraInfo);
                    }
                }
                else
                {
                    sprintf(lpszExtraInfo, "Unexpected pcre_exec() error code=%d\0", lPcreRC);
                    LogMsg(TEST_EXTRA_LINE_ERR, lpTIB->lTestNum, lpszExtraInfo);
                }
                kpMCB->bConcurrencyWait = FALSE;
                /* Set codes and increment counters to indicate the match failed */
                SetTIBCodes(lpTIB, MTCC_FAIL, MTRC_RUN_MATCH_FAIL);
                lpTIB->lTestFailedCompare++;
                kpMCB->lScriptFailedCompare++;
                /* If log and continue has been requested then command completion */
                /* is regarded as successful with only the counts and codes       */
                /* indicating otherwise                                           */
                if(TRUE == lpCMB->bLogAndContinue)
                {
                    LogMsg(TEST_EXTRA_LINE_ERR, lpTIB->lTestNum, kpszLOGANDCONTINUESUPPRESS);
                    lpCMB->eCommandState = S_COMPLETE;
                    return SUCCESS;
                }
                lpCMB->eCommandState = S_FAILURE;
                return FAILURE;
            }
        }

        if(NULL != lpCMB->lpCompiledRegex)
        {
            pcre_free(lpCMB->lpCompiledRegex);
        }

        /* All done */
        kpMCB->bConcurrencyWait = FALSE;
        SetTIBCodes(lpTIB, MTCC_OK, MTRC_NONE);
        lpTIB->lTestSuccessfulCompare++;
        kpMCB->lScriptSuccessfulCompare++;
        lpCMB->eCommandState = S_COMPLETE;
        return SUCCESS;
        break;
    case S_COMPLETE:
        LogMsg(38, lpTIB->lTestNum, lpszCurrCmdName, CalcCmdExecTime(lpTIB));
        kpMCB->bConcurrencyWait = FALSE;
        lpCMB->eCommandState = S_NEXT;
        return SUCCESS;
        break;
    case S_FAILURE:
        LogMsg(51, lpTIB->lTestNum, lpszCurrCmdName, CalcCmdExecTime(lpTIB));
        kpMCB->bConcurrencyWait = FALSE;
        lpCMB->eCommandState = S_NEXT;
        return FAILURE;
        break;
    }
    /* Should never get here so its a logic error terminate immediately */
    SetTIBCodes(lpTIB, MTCC_FAIL, MTRC_LOGIC_FAIL);
    lpCMB->eCommandState = S_FAILURE;
    kpMCB->lProcessing = FAILURE;
    LogMsg(69, lpTIB->lTestNum, "ExecuteCompareCmd\0");
    return FAILURE;
}


/*--------------------------------------------------------------------------*/
long
ExecuteCommitCmd(TestInfoBlk* lpTIB, CommandCtrlBlk* lpCCB)
{
    CommitBlk*      lpCOB;
    IfStartBlk*     lpIFSCheck;
    CommandCtrlBlk* lpCCBCheckIf;
    char*           lpszCurrCmdName;
    char            lpszExtraInfo[EXTRA_MSG_INFO_LEN + 4];
    MQLONG          lCC;
    MQLONG          lRC;

    /* Initialise common use local variables */
    lpCOB = (CommitBlk*)lpCCB;
    lpszCurrCmdName = kpszCOMMIT;
    memset(lpszExtraInfo, 0x00, EXTRA_MSG_INFO_LEN + 4);

    /* Process according to current command state */
    switch(lpCOB->eCommandState)
    {
    case S_INIT:
        LogMsg(44, lpTIB->lTestNum, lpszCurrCmdName, "\0");
        time(&lpCOB->oStartTime);
        lpCOB->oExpiryTime = lpCOB->oStartTime;
        lpCOB->oNextLogMsgTime = lpCOB->oStartTime;

        /* Running an initialisation so set concurrency wait false. */
        kpMCB->bConcurrencyWait = FALSE;

        /* Resolve the connection variable name */
        ResolveValue(lpTIB, &lpCOB->lpszResConnectionName, &lpCOB->lpszConnectionName, TRUE);
        if(FAILURE == lpTIB->bCmdResult)
        {
            SetTIBCodes(lpTIB, MTCC_FAIL, MTRC_INIT_RESOLVE_FAIL);
            lpCOB->eCommandState = S_FAILURE;
            return FAILURE;
        }

        /* Locate the connection definition block for this command */
        lpCOB->lpCDB = FindConnectionDefBlk(kpMCB->lpCDBHead, lpCOB->lpszResConnectionName);
        if(NULL == lpCOB->lpCDB)
        {
            LogMsg(194, lpCOB->lpszResConnectionName);
            SetTIBCodes(lpTIB, MTCC_FAIL, MTRC_INIT_FAIL);
            lpCOB->eCommandState = S_FAILURE;
            return FAILURE;
        }

        /* Ready to run */
        SetTIBCodes(lpTIB, MTCC_OK, MTRC_NONE);
        lpCOB->eCommandState = S_RUN;
        return SUCCESS;
        break;
    case S_RUN:
        LogMsg(45, lpTIB->lTestNum, lpszCurrCmdName, "\0");
        /****** Send the request message ******/

        /* Ok lets do it */
        MQCMIT(lpCOB->lpCDB->hConn, &lCC, &lRC);

        /* Check current reason code against BreakOnRC reason codes */
        if(0 < lpCOB->lBreakOnRCCount)
        {
            if(TRUE == FindRC(lpCOB->lBreakOnRCCount, lpCOB->lBreakOnRC, lRC))
            {
                if(lpCOB->lpBreakContinueFSB)
                {
                    LogMsg(118, lpTIB->lTestNum, kpszCOMMIT, lCC, lRC, "Ending For/ForEver/ForEach loop Name=\0", lpCOB->lpBreakContinueFSB->lpszForName);
                }
                else
                {
                    LogMsg(118, lpTIB->lTestNum, kpszCOMMIT, lCC, lRC, "Ending Test Name=\0", lpTIB->lpszTestName);
                }
                lpTIB->lpBreakContinueFSB = lpCOB->lpBreakContinueFSB;
                kpMCB->bConcurrencyWait = FALSE;
                SetTIBCodes(lpTIB, lCC, lRC);
                lpCOB->eCommandState = S_BREAK;
                return SUCCESS;
            }
        }

        /* Check current reason code against ContinueOnRC reason codes */
        if(0 < lpCOB->lContinueOnRCCount)
        {
            if(TRUE == FindRC(lpCOB->lContinueOnRCCount, lpCOB->lContinueOnRC, lRC))
            {
                if(lpCOB->lpBreakContinueFSB)
                {
                    LogMsg(119, lpTIB->lTestNum, kpszCOMMIT, lCC, lRC, "Continuing For/ForEver/ForEach loop Name=\0", lpCOB->lpBreakContinueFSB->lpszForName);
                }
                else
                {
                    LogMsg(119, lpTIB->lTestNum, kpszCOMMIT, lCC, lRC, "Ending Test Name=\0", lpTIB->lpszTestName);
                }
                lpTIB->lpBreakContinueFSB = lpCOB->lpBreakContinueFSB;
                kpMCB->bConcurrencyWait = FALSE;
                SetTIBCodes(lpTIB, lCC, lRC);
                lpCOB->eCommandState = S_CONTINUE;
                return SUCCESS;
            }
        }

        /* Check the current reason code against the suppression list */
        /* Suppression is done last as it changes the reason code     */
        if(0 < lpCOB->lSuppressRCCount)
        {
            if(TRUE == FindRC(lpCOB->lSuppressRCCount, lpCOB->lSuppressRC, lRC))
            {
                LogMsg(117, lpTIB->lTestNum, kpszCOMMIT, lCC, lRC);
                lCC = 0;
                lRC = 0;
            }
        }

        /* Check the result and log it */
        if(MQRC_NONE == lRC)
        {
            /* Log our success */
            if(FALSE == kpMCB->bLoggingSuppressed)
            {
                sprintf(lpszExtraInfo, "ConnQMgr=\"%s\" commit successful\0",
                        lpCOB->lpCDB->lpszConnQMgrName);
                LogMsg(TEST_EXTRA_LINE, lpTIB->lTestNum, lpszExtraInfo);
            }
            kpMCB->bConcurrencyWait = FALSE;
            SetTIBCodes(lpTIB, lCC, lRC);
            lpCOB->eCommandState = S_COMPLETE;
            return SUCCESS;
        }
        else
        {
            sprintf(lpszExtraInfo, "ConnQMgr=\"%s\" commit failed\0",
                    lpCOB->lpCDB->lpszConnQMgrName);
            LogMsg(TEST_EXTRA_LINE_ERR, lpTIB->lTestNum, lpszExtraInfo);
            sprintf(lpszExtraInfo, "MQCMIT CC=%d RC=%d\0", lCC, lRC);
            LogMsg(TEST_EXTRA_LINE_ERR, lpTIB->lTestNum, lpszExtraInfo);
            kpMCB->bConcurrencyWait = FALSE;
            SetTIBCodes(lpTIB, lCC, lRC);
            /* If the next command is an <If...> that contains a check of either */
            /* LastCC or LastRC then do not fail this command. Instead permit    */
            /* processing to continue at the <If...>                             */
            if(NULL != lpCCB->lpCCBNext)
            {
                lpCCBCheckIf = (CommandCtrlBlk*)lpCCB->lpCCBNext;
                if(C_IFSTART == lpCCBCheckIf->eCommandType)
                {
                    lpIFSCheck = (IfStartBlk*) lpCCBCheckIf;
                    if((TRUE == lpIFSCheck->bACondChecksLastCC) || (TRUE == lpIFSCheck->bACondChecksLastRC))
                    {
                        lpCOB->eCommandState = S_COMPLETE;
                        return SUCCESS;
                    }
                }
            }
            lpCOB->eCommandState = S_FAILURE;
            return FAILURE;
        }
        break;
    case S_COMPLETE:
        LogMsg(38, lpTIB->lTestNum, lpszCurrCmdName, CalcCmdExecTime(lpTIB));
        kpMCB->bConcurrencyWait = FALSE;
        lpCOB->eCommandState = S_NEXT;
        return SUCCESS;
        break;
    case S_FAILURE:
        LogMsg(51, lpTIB->lTestNum, lpszCurrCmdName, CalcCmdExecTime(lpTIB));
        kpMCB->bConcurrencyWait = FALSE;
        lpCOB->eCommandState = S_NEXT;
        return FAILURE;
        break;
    }
    /* Should never get here so its a logic error terminate immediately */
    lpCOB->eCommandState = S_FAILURE;
    SetTIBCodes(lpTIB, MTCC_FAIL, MTRC_LOGIC_FAIL);
    kpMCB->lProcessing = FAILURE;
    LogMsg(69, lpTIB->lTestNum, "ExecuteCommitCmd\0");
    return FAILURE;
}


/*--------------------------------------------------------------------------*/
long
ExecuteBackoutCmd(TestInfoBlk* lpTIB, CommandCtrlBlk* lpCCB)
{
    BackoutBlk*     lpBOB;
    IfStartBlk*     lpIFSCheck;
    CommandCtrlBlk* lpCCBCheckIf;
    char*           lpszCurrCmdName;
    char            lpszExtraInfo[EXTRA_MSG_INFO_LEN + 4];
    MQLONG          lCC;
    MQLONG          lRC;

    /* Initialise common use local variables */
    lpBOB = (BackoutBlk*)lpCCB;
    lpszCurrCmdName = kpszBACKOUT;
    memset(lpszExtraInfo, 0x00, EXTRA_MSG_INFO_LEN + 4);

    /* Process according to current command state */
    switch(lpBOB->eCommandState)
    {
    case S_INIT:
        LogMsg(44, lpTIB->lTestNum, lpszCurrCmdName, "\0");
        time(&lpBOB->oStartTime);
        lpBOB->oExpiryTime = lpBOB->oStartTime;
        lpBOB->oNextLogMsgTime = lpBOB->oStartTime;

        /* Running an initialisation so set concurrency wait false. */
        kpMCB->bConcurrencyWait = FALSE;

        /* Resolve the connection variable name */
        ResolveValue(lpTIB, &lpBOB->lpszResConnectionName, &lpBOB->lpszConnectionName, TRUE);
        if(FAILURE == lpTIB->bCmdResult)
        {
            SetTIBCodes(lpTIB, MTCC_FAIL, MTRC_INIT_RESOLVE_FAIL);
            lpBOB->eCommandState = S_FAILURE;
            return FAILURE;
        }

        /* Locate the connection definition block for this command */
        lpBOB->lpCDB = FindConnectionDefBlk(kpMCB->lpCDBHead, lpBOB->lpszResConnectionName);
        if(NULL == lpBOB->lpCDB)
        {
            LogMsg(194, lpBOB->lpszResConnectionName);
            SetTIBCodes(lpTIB, MTCC_FAIL, MTRC_INIT_FAIL);
            lpBOB->eCommandState = S_FAILURE;
            return FAILURE;
        }

        /* Ready to run */
        SetTIBCodes(lpTIB, MTCC_OK, MTRC_NONE);
        lpBOB->eCommandState = S_RUN;
        return SUCCESS;
        break;
    case S_RUN:
        LogMsg(45, lpTIB->lTestNum, lpszCurrCmdName, "\0");
        /****** Send the request message ******/

        /* Ok lets do it */
        MQBACK(lpBOB->lpCDB->hConn, &lCC, &lRC);

        /* Check current reason code against BreakOnRC reason codes */
        if(0 < lpBOB->lBreakOnRCCount)
        {
            if(TRUE == FindRC(lpBOB->lBreakOnRCCount, lpBOB->lBreakOnRC, lRC))
            {
                if(lpBOB->lpBreakContinueFSB)
                {
                    LogMsg(118, lpTIB->lTestNum, kpszBACKOUT, lCC, lRC, "Ending For/ForEver/ForEach loop Name=\0", lpBOB->lpBreakContinueFSB->lpszForName);
                }
                else
                {
                    LogMsg(118, lpTIB->lTestNum, kpszBACKOUT, lCC, lRC, "Ending Test Name=\0", lpTIB->lpszTestName);
                }
                lpTIB->lpBreakContinueFSB = lpBOB->lpBreakContinueFSB;
                kpMCB->bConcurrencyWait = FALSE;
                SetTIBCodes(lpTIB, lCC, lRC);
                lpBOB->eCommandState = S_BREAK;
                return SUCCESS;
            }
        }

        /* Check current reason code against ContinueOnRC reason codes */
        if(0 < lpBOB->lContinueOnRCCount)
        {
            if(TRUE == FindRC(lpBOB->lContinueOnRCCount, lpBOB->lContinueOnRC, lRC))
            {
                if(lpBOB->lpBreakContinueFSB)
                {
                    LogMsg(119, lpTIB->lTestNum, kpszBACKOUT, lCC, lRC, "Continuing For/ForEver/ForEach loop Name=\0", lpBOB->lpBreakContinueFSB->lpszForName);
                }
                else
                {
                    LogMsg(119, lpTIB->lTestNum, kpszBACKOUT, lCC, lRC, "Ending Test Name=\0", lpTIB->lpszTestName);
                }
                lpTIB->lpBreakContinueFSB = lpBOB->lpBreakContinueFSB;
                kpMCB->bConcurrencyWait = FALSE;
                SetTIBCodes(lpTIB, lCC, lRC);
                lpBOB->eCommandState = S_CONTINUE;
                return SUCCESS;
            }
        }

        /* Check the current reason code against the suppression list */
        /* Suppression is done last as it changes the reason code     */
        if(0 < lpBOB->lSuppressRCCount)
        {
            if(TRUE == FindRC(lpBOB->lSuppressRCCount, lpBOB->lSuppressRC, lRC))
            {
                LogMsg(117, lpTIB->lTestNum, kpszBACKOUT, lCC, lRC);
                lCC = 0;
                lRC = 0;
            }
        }

        /* Check the result and log it */
        if(MQRC_NONE == lRC)
        {
            /* Log our success */
            if(FALSE == kpMCB->bLoggingSuppressed)
            {
                sprintf(lpszExtraInfo, "ConnQMgr=\"%s\" backout successful\0",
                        lpBOB->lpCDB->lpszConnQMgrName);
                LogMsg(TEST_EXTRA_LINE, lpTIB->lTestNum, lpszExtraInfo);
            }
            kpMCB->bConcurrencyWait = FALSE;
            SetTIBCodes(lpTIB, lCC, lRC);
            lpBOB->eCommandState = S_COMPLETE;
            return SUCCESS;
        }
        else
        {
            sprintf(lpszExtraInfo, "ConnQMgr=\"%s\" backout failed\0",
                    lpBOB->lpCDB->lpszConnQMgrName);
            LogMsg(TEST_EXTRA_LINE_ERR, lpTIB->lTestNum, lpszExtraInfo);
            sprintf(lpszExtraInfo, "MQCMIT CC=%d RC=%d\0", lCC, lRC);
            LogMsg(TEST_EXTRA_LINE_ERR, lpTIB->lTestNum, lpszExtraInfo);
            kpMCB->bConcurrencyWait = FALSE;
            SetTIBCodes(lpTIB, lCC, lRC);
            /* If the next command is an <If...> that contains a check of either */
            /* LastCC or LastRC then do not fail this command. Instead permit    */
            /* processing to continue at the <If...>                             */
            if(NULL != lpCCB->lpCCBNext)
            {
                lpCCBCheckIf = (CommandCtrlBlk*)lpCCB->lpCCBNext;
                if(C_IFSTART == lpCCBCheckIf->eCommandType)
                {
                    lpIFSCheck = (IfStartBlk*) lpCCBCheckIf;
                    if((TRUE == lpIFSCheck->bACondChecksLastCC) || (TRUE == lpIFSCheck->bACondChecksLastRC))
                    {
                        lpBOB->eCommandState = S_COMPLETE;
                        return SUCCESS;
                    }
                }
            }
            lpBOB->eCommandState = S_FAILURE;
            return FAILURE;
        }
        break;
    case S_COMPLETE:
        LogMsg(38, lpTIB->lTestNum, lpszCurrCmdName, CalcCmdExecTime(lpTIB));
        kpMCB->bConcurrencyWait = FALSE;
        lpBOB->eCommandState = S_NEXT;
        return SUCCESS;
        break;
    case S_FAILURE:
        LogMsg(51, lpTIB->lTestNum, lpszCurrCmdName, CalcCmdExecTime(lpTIB));
        kpMCB->bConcurrencyWait = FALSE;
        lpBOB->eCommandState = S_NEXT;
        return FAILURE;
        break;
    }
    /* Should never get here so its a logic error terminate immediately */
    lpBOB->eCommandState = S_FAILURE;
    SetTIBCodes(lpTIB, MTCC_FAIL, MTRC_LOGIC_FAIL);
    kpMCB->lProcessing = FAILURE;
    LogMsg(69, lpTIB->lTestNum, "ExecuteBackoutCmd\0");
    return FAILURE;
}


/*--------------------------------------------------------------------------*/
long
ExecuteSystemCmd(TestInfoBlk* lpTIB, CommandCtrlBlk* lpCCB)
{
    ControlInfoBlk* lpCIB;
    SystemBlk*      lpSYB;
    IfStartBlk*     lpIFSCheck;
    CommandCtrlBlk* lpCCBCheckIf;
    char*           lpszCurrCmdName;
    char            lpszExtraInfo[EXTRA_MSG_INFO_LEN + 4];
    long            lCommandRC;

    /* Initialise common use local variables */
    lpCIB = kpMCB->lpCIB;
    lpSYB = (SystemBlk*)lpCCB;
    lpszCurrCmdName = kpszSYSTEM;
    memset(lpszExtraInfo, 0x00, EXTRA_MSG_INFO_LEN + 4);

    /* Process according to current command state */
    switch(lpSYB->eCommandState)
    {
    case S_INIT:
        /* Display command initialisation info */
        sprintf(lpszExtraInfo, " Command=%s\0", lpSYB->lpszCommand);
        LogMsg(44, lpTIB->lTestNum, lpszCurrCmdName, lpszExtraInfo);

        /* Running an initialisation so set concurrency wait false. */
        kpMCB->bConcurrencyWait = FALSE;

        /* Resolve command */
        ResolveValue(lpTIB, &lpSYB->lpszResCommand,
                     &lpSYB->lpszCommand, TRUE);
        if(FAILURE == lpTIB->bCmdResult)
        {
            SetTIBCodes(lpTIB, MTCC_FAIL, MTRC_INIT_RESOLVE_FAIL);
            lpSYB->eCommandState = S_FAILURE;
            return FAILURE;
        }

        /* Set up start, expiry and next log message times */
        time(&lpSYB->oStartTime);
        lpSYB->oExpiryTime = lpSYB->oStartTime;
        lpSYB->oNextLogMsgTime = lpSYB->oStartTime;

        /* Ready to run */
        SetTIBCodes(lpTIB, MTCC_OK, MTRC_NONE);
        lpSYB->eCommandState = S_RUN;
        return SUCCESS;
        break;
    case S_RUN:
        sprintf(lpszExtraInfo, " Command=%s\0", lpSYB->lpszResCommand);
        LogMsg(45, lpTIB->lTestNum, lpszCurrCmdName, lpszExtraInfo);
        
        lCommandRC = system(lpSYB->lpszResCommand);

        /* Did the call work */
        if(0 == lCommandRC)
        {
            if(FALSE == kpMCB->bLoggingSuppressed)
            {
                sprintf(lpszExtraInfo, "Command execution successful. RC=%d\0",
                        lCommandRC);
                LogMsg(TEST_EXTRA_LINE, lpTIB->lTestNum, lpszExtraInfo);
            }
            kpMCB->bConcurrencyWait = FALSE;
            SetTIBCodes(lpTIB, MTCC_OK, MTRC_NONE);
            lpSYB->eCommandState = S_COMPLETE;
            return SUCCESS;
        }

        /* Have we been told to ignore the return code */
        if(TRUE == lpSYB->bIgnoreRC)
        {
            if(FALSE == kpMCB->bLoggingSuppressed)
            {
                sprintf(lpszExtraInfo, "Command execution complete. Non-zero RC=%d ignored\0",
                        lCommandRC);
                LogMsg(TEST_EXTRA_LINE, lpTIB->lTestNum, lpszExtraInfo);
            }
            kpMCB->bConcurrencyWait = FALSE;
            SetTIBCodes(lpTIB, MTCC_OK, MTRC_NONE);
            lpSYB->eCommandState = S_COMPLETE;
            return SUCCESS;
        }

        /* System command failed */
        sprintf(lpszExtraInfo, "Command execution failed. RC=%d\0",
                lCommandRC);
        LogMsg(TEST_EXTRA_LINE_ERR, lpTIB->lTestNum, lpszExtraInfo);
        SetTIBCodes(lpTIB, MTCC_FAIL, lCommandRC);
        /* If the next command is an <If...> that contains a check of either */
        /* LastCC or LastRC then do not fail this command. Instead permit    */
        /* processing to continue at the <If...>                             */
        if(NULL != lpCCB->lpCCBNext)
        {
            lpCCBCheckIf = (CommandCtrlBlk*)lpCCB->lpCCBNext;
            if(C_IFSTART == lpCCBCheckIf->eCommandType)
            {
                lpIFSCheck = (IfStartBlk*) lpCCBCheckIf;
                if((TRUE == lpIFSCheck->bACondChecksLastCC) || (TRUE == lpIFSCheck->bACondChecksLastRC))
                {
                    lpSYB->eCommandState = S_COMPLETE;
                    return SUCCESS;
                }
            }
        }
        lpSYB->eCommandState = S_FAILURE;
        return FAILURE;
        break;
    case S_COMPLETE:
        LogMsg(38, lpTIB->lTestNum, lpszCurrCmdName, CalcCmdExecTime(lpTIB));
        kpMCB->bConcurrencyWait = FALSE;
        lpSYB->eCommandState = S_NEXT;
        return SUCCESS;
        break;
    case S_FAILURE:
        LogMsg(51, lpTIB->lTestNum, lpszCurrCmdName, CalcCmdExecTime(lpTIB));
        kpMCB->bConcurrencyWait = FALSE;
        lpSYB->eCommandState = S_NEXT;
        return FAILURE;
        break;
    }
    /* Should never get here so its a logic error terminate immediately */
    SetTIBCodes(lpTIB, MTCC_FAIL, MTRC_LOGIC_FAIL);
    lpSYB->eCommandState = S_FAILURE;
    kpMCB->lProcessing = FAILURE;
    LogMsg(69, lpTIB->lTestNum, "ExecuteSystemCmd\0");
    return FAILURE;
}


/*--------------------------------------------------------------------------*/
long
ExecuteMqscCommandCmd(TestInfoBlk* lpTIB, CommandCtrlBlk* lpCCB)
{
    ControlInfoBlk* lpCIB;
    MqscCommandBlk* lpSCB;
    IfStartBlk*     lpIFSCheck;
    CommandCtrlBlk* lpCCBCheckIf;
    MQMD            oMQMDDefault = {MQMD_DEFAULT};
    MQMD            oMsgDescPut;
    MQMD            oMsgDescGet;
    MQPMO           oPutOpts = {MQPMO_DEFAULT};
    MQGMO           oMQGMODefault = {MQGMO_DEFAULT};
    MQGMO           oGetOpts;
    MQCFH           oCFHDefault = {MQCFH_DEFAULT};
    MQCFIN          oCFINDefault = {MQCFIN_DEFAULT};
    MQCFST          oCFSTDefault = {MQCFST_DEFAULT};
    MQCFH*          lpCFH;
    MQCFIN*         lpCFIN;
    MQCFST*         lpCFST;
    long            lMqscCommandLen;
    long            lCfstStrucLen;
    char*           lpszCurrCmdName;
    char*           lpszOldBuff;
    char            lpszExtraInfo[EXTRA_MSG_INFO_LEN + 4];
    char            lpszWorkBuff[WORK_BUFF_LEN + 4];
    char*           lpszLocalBuff;
    long            lLocalBuffLen;
    long            lCheckLen;
    long            lOldDataLen;
    long            lBuffMax;
    long            lPCFMsgLen;
    long            lPCFReplyMsgLen;
    long            lCmdMaxWait;
    long            bForEver;
    long            bBreak;
    long            bContinue;
    long            lIdx;
    long            lJdx;
    char*           lpszCurrParameter;
    long            lCurrStringSegLen;
    char*           lpszCurrStringSeg;
    char*           lpszCurrChar;
    char*           lpszCurrBuffPos;
    MQLONG          lCC;
    MQLONG          lRC;
    MQLONG          lPcfCC;
    MQLONG          lPcfRC;
    MQLONG          lBreakPcfCC;
    MQLONG          lBreakPcfRC;
    MQLONG          lContinuePcfCC;
    MQLONG          lContinuePcfRC;
    MQLONG          lMaxPcfCC;
    MQLONG          lMaxPcfRC;
    MQLONG          lGetDataLen;
    MQLONG*         lplType;
    MQLONG*         lplStrucLength;

    /* Initialise common use local variables */
    lpCIB = kpMCB->lpCIB;
    lpSCB = (MqscCommandBlk*)lpCCB;
    lpszCurrCmdName = kpszMQSCCOMMAND;
    memset(lpszExtraInfo, 0x00, EXTRA_MSG_INFO_LEN + 4);
    memset(lpszWorkBuff, 0x00, WORK_BUFF_LEN + 4);
    lpszLocalBuff = NULL;
    lCfstStrucLen = 0;
    lLocalBuffLen = 0;

    /* Process according to current command state */
    switch(lpSCB->eCommandState)
    {
    case S_INIT:
        /* Display command initialisation info */
        sprintf(lpszExtraInfo, " MqscCommand=%s\0", lpSCB->lpszCommand);
        LogMsg(44, lpTIB->lTestNum, lpszCurrCmdName, lpszExtraInfo);
        lpTIB->lLastDataLen = 0;

        /* Running an initialisation so set concurrency wait false. */
        kpMCB->bConcurrencyWait = FALSE;

        /* Resolve buffer name */
        ResolveValue(lpTIB, &lpSCB->lpszResBuffName,
                     &lpSCB->lpszBuffName, TRUE);
        if(FAILURE == lpTIB->bCmdResult)
        {
            SetTIBCodes(lpTIB, MTCC_FAIL, MTRC_INIT_RESOLVE_FAIL);
            lpSCB->eCommandState = S_FAILURE;
            return FAILURE;
        }

        /* Obtain a pointer to the buffer info block for this command */
        lpSCB->lpBIB = CheckAndAddBIB(lpTIB, lpSCB->lpszResBuffName);
        if(NULL == lpSCB->lpBIB)
        {
            /* No buffer to receive the PCF string into. Report the problem and fail */
            sprintf(lpszExtraInfo, "Unable to locate/allocate Buffer=%s\0",
                    lpSCB->lpszResBuffName);
            LogMsg(TEST_EXTRA_LINE_ERR, lpTIB->lTestNum, lpszExtraInfo);
            SetTIBCodes(lpTIB, MTCC_FAIL, MTRC_INIT_BUFF_FAIL);
            lpSCB->eCommandState = S_FAILURE;
            return FAILURE;
        }

        /* If we dont yet have a buffer allocate one */
        if(NULL == lpSCB->lpBIB->lpszBuff)
        {
            lpSCB->lpBIB->lpszBuff = malloc(INITIAL_BUFF_LEN + 8);
            if(NULL != lpSCB->lpBIB->lpszBuff)
            {
                /* Clear the new buffer and report its allocation */
                memset(lpSCB->lpBIB->lpszBuff, 0x00, INITIAL_BUFF_LEN + 8);
                lpSCB->lpBIB->lDataLen = 0;
                lpSCB->lpBIB->lBuffLen = INITIAL_BUFF_LEN;
                if(FALSE == kpMCB->bLoggingSuppressed)
                {
                    sprintf(lpszExtraInfo, "Buffer=%s BuffLen=%d bytes allocated\0",
                            lpSCB->lpBIB->lpszBuffName,
                            lpSCB->lpBIB->lBuffLen);
                    LogMsg(TEST_EXTRA_LINE, lpTIB->lTestNum, lpszExtraInfo);
                }
            }
            else
            {
                /* Couldn't obtain a buffer log the problem and fail the test */
                sprintf(lpszExtraInfo, "Buffer=%s BuffLen=%d malloc() failed.\0",
                        lpSCB->lpBIB->lpszBuffName,
                        INITIAL_BUFF_LEN);
                LogMsg(TEST_EXTRA_LINE_ERR, lpTIB->lTestNum, lpszExtraInfo);
                SetTIBCodes(lpTIB, MTCC_FAIL, MTRC_INIT_BUFF_FAIL);
                lpSCB->eCommandState = S_FAILURE;
                return FAILURE;
            }
        }

        /* Resolve values */
        ResolveValue(lpTIB, &lpSCB->lpszResConnectionName, &lpSCB->lpszConnectionName, TRUE);
        ResolveValue(lpTIB, &lpSCB->lpszResQName, &lpSCB->lpszQName, TRUE);
        ResolveValue(lpTIB, &lpSCB->lpszResMqscReplyDynamicQName, &lpSCB->lpszMqscReplyDynamicQName, TRUE);
        ResolveValue(lpTIB, &lpSCB->lpszResCommand, &lpSCB->lpszCommand, TRUE);
        ResolveValue(lpTIB, &lpSCB->lpszResCmdMaxWait, &lpSCB->lpszCmdMaxWait, TRUE);
        if(FAILURE == lpTIB->bCmdResult)
        {
            SetTIBCodes(lpTIB, MTCC_FAIL, MTRC_INIT_RESOLVE_FAIL);
            lpSCB->eCommandState = S_FAILURE;
            return FAILURE;
        }

        /* Locate the connection definition block for this command */
        lpSCB->lpCDB = FindConnectionDefBlk(kpMCB->lpCDBHead, lpSCB->lpszResConnectionName);
        if(NULL == lpSCB->lpCDB)
        {
            LogMsg(194, lpSCB->lpszResConnectionName);
            SetTIBCodes(lpTIB, MTCC_FAIL, MTRC_INIT_FAIL);
            lpTIB->lTestFailedGetMsg++;
            kpMCB->lScriptFailedGetMsg++;
            lpSCB->eCommandState = S_FAILURE;
            return FAILURE;
        }

        /* Determine the maximum wait time */
        lCmdMaxWait = ConvNum(lpTIB, lpSCB->lpszResCmdMaxWait, "CmdMaxWait");
        if(FAILURE == lpTIB->bCmdResult)
        {
            sprintf(lpszExtraInfo, "CmdMaxWait=%s not numeric\0",
                    lpSCB->lpszResCmdMaxWait);
            LogMsg(TEST_EXTRA_LINE_ERR, lpTIB->lTestNum, lpszExtraInfo);
            SetTIBCodes(lpTIB, MTCC_FAIL, MTRC_INIT_CONVNUM_FAIL);
            lpSCB->eCommandState = S_FAILURE;
            return FAILURE;
        }
        if(-1 == lCmdMaxWait)
        {
            lpSCB->lMaxWait = 30;
        }
        else
        {
            lpSCB->lMaxWait = lCmdMaxWait;
        }

        /* Set up start, expiry and next log message times */
        time(&lpSCB->oStartTime);
        lpSCB->oExpiryTime = lpSCB->oStartTime;
        lpSCB->oNextLogMsgTime = lpSCB->oStartTime;

        /* Try to open the command queue */
        lpSCB->lpQIB = OpenQueue(lpTIB, lpSCB->lpCDB, lpTIB->lpQIBHead,
                                 lpSCB->lpszResQName, kpszEmptyString,
                                 kpszEmptyString, TRUE);
        if(! lpSCB->lpQIB)
        {
            /* Couldn't open the queue log the problem and fail the test */
            sprintf(lpszExtraInfo, "TargQ=\"%s\" TargQMgr=\"%s\" ConnQMgr=\"%s\" open failed\0",
                    lpSCB->lpszResQName,
                    kpszEmptyString,
                    lpSCB->lpCDB->lpszConnQMgrName);
            LogMsg(TEST_EXTRA_LINE_ERR, lpTIB->lTestNum, lpszExtraInfo);
            SetTIBCodes(lpTIB, MTCC_FAIL, MTRC_INIT_FAIL);
            lpSCB->eCommandState = S_FAILURE;
            return FAILURE;
        }

        /* Try to open the command reply queue */
        lpSCB->lpQIBMR = OpenQueue(lpTIB, lpSCB->lpCDB, lpTIB->lpQIBHead,
                                   lpSCB->lpszMqscReplyQName, kpszEmptyString,
                                   lpSCB->lpszMqscReplyDynamicQName, FALSE);
        if(! lpSCB->lpQIBMR)
        {
            /* Couldn't open the queue log the problem and fail the test */
            sprintf(lpszExtraInfo, "TargQ=\"%s\" TargQMgr=\"%s\" DynamicQ=\"%s\" ConnQMgr=\"%s\" open failed\0",
                    lpSCB->lpszResQName,
                    kpszEmptyString,
                    lpSCB->lpszMqscReplyDynamicQName,
                    lpSCB->lpCDB->lpszConnQMgrName);
            LogMsg(TEST_EXTRA_LINE_ERR, lpTIB->lTestNum, lpszExtraInfo);
            SetTIBCodes(lpTIB, MTCC_FAIL, MTRC_INIT_FAIL);
            lpSCB->eCommandState = S_FAILURE;
            return FAILURE;
        }

        /* Ready to run */
        SetTIBCodes(lpTIB, MTCC_OK, MTRC_NONE);
        lpSCB->eCommandState = S_RUN;
        return SUCCESS;
        break;
    case S_RUN:
        sprintf(lpszExtraInfo, " MqscCommand=%s\0", lpSCB->lpszResCommand);
        LogMsg(45, lpTIB->lTestNum, lpszCurrCmdName, lpszExtraInfo);

        /* Allocate a buffer and PCF information to the command */
        /* The MQCFST structure length needs to a a multiple of */
        /* 4 bytes work out how many padding bytes are needed   */
        lMqscCommandLen = StrlenNull(lpSCB->lpszResCommand);
        switch(lMqscCommandLen % 4)
        {
        case 0:
            lCfstStrucLen = MQCFST_STRUC_LENGTH_FIXED + lMqscCommandLen;
            break;
        case 1:
            lCfstStrucLen = MQCFST_STRUC_LENGTH_FIXED + lMqscCommandLen + 3;
            break;
        case 2:
            lCfstStrucLen = MQCFST_STRUC_LENGTH_FIXED + lMqscCommandLen + 2;
            break;
        case 3:
            lCfstStrucLen = MQCFST_STRUC_LENGTH_FIXED + lMqscCommandLen + 1;
            break;
        }
        lPCFMsgLen = MQCFH_STRUC_LENGTH + MQCFIN_STRUC_LENGTH + lCfstStrucLen;
        lLocalBuffLen = (((lPCFMsgLen + 16) / 16) + 1) * 16;
        lpszLocalBuff = malloc(lLocalBuffLen);

        /* Check the result of the allocation */
        if(! lpszLocalBuff)
        {
            /* If we have run out of memory its fatal */
            LogMsg(3, lPCFMsgLen, "MqscCommandLocalBuffer", __LINE__, __FILE__);
            kpMCB->lProcessing = FAILURE;
            kpMCB->bConcurrencyWait = FALSE;
            SetTIBCodes(lpTIB, MTCC_FAIL, MTRC_RUN_BUFF_FAIL);
            lpSCB->eCommandState = S_FAILURE;
            return FAILURE;
        }

        /* Clear the buffer */
        memset(lpszLocalBuff, 0x00, lLocalBuffLen);
        
        /* Initialise the various structure pointers */
        lpCFH = (MQCFH*)lpszLocalBuff;
        lpCFIN = (MQCFIN*)(lpszLocalBuff + MQCFH_STRUC_LENGTH);
        lpCFST = (MQCFST*)(lpszLocalBuff + MQCFH_STRUC_LENGTH + MQCFIN_STRUC_LENGTH);

        /* Copy the default structure values into the buffer */
        memcpy(lpCFH, &oCFHDefault, MQCFH_STRUC_LENGTH);
        memcpy(lpCFIN, &oCFINDefault, MQCFIN_STRUC_LENGTH);
        memcpy(lpCFST, &oCFSTDefault, MQCFST_STRUC_LENGTH_FIXED);

        /* Now set the non-default values in each of the structures */
        lpCFH->Command = MQCMD_ESCAPE;
        lpCFH->ParameterCount = 2; /* MQCFIN and MQCFST */
        lpCFIN->Parameter = MQIACF_ESCAPE_TYPE;
        lpCFIN->Value = MQET_MQSC;
        lpCFST->StrucLength = lCfstStrucLen;
        lpCFST->Parameter = MQCACF_ESCAPE_TEXT;
        lpCFST->StringLength = lMqscCommandLen;
        memcpy(lpCFST->String, lpSCB->lpszResCommand, lMqscCommandLen);

        /* And the values in the MQMD */
        memcpy(&oMsgDescPut, &oMQMDDefault, sizeof(MQMD));
        oMsgDescPut.MsgType = MQMT_REQUEST;
        oMsgDescPut.Expiry = 600; /* Give it a minute. Don't want strays around forever */
        memcpy(&oMsgDescPut.Format, MQFMT_ADMIN, MQ_FORMAT_LENGTH);
        memset(&oMsgDescPut.ReplyToQ, 0x00, MQ_Q_NAME_LENGTH);
        strncpy(oMsgDescPut.ReplyToQ, lpSCB->lpQIBMR->lpszResolvedQName, MQ_Q_NAME_LENGTH);

        /* And the put options */
        oPutOpts.Options = MQPMO_NO_SYNCPOINT | MQPMO_FAIL_IF_QUIESCING;

        /* Ok lets do it */
        MQPUT(lpSCB->lpQIB->hConn, lpSCB->lpQIB->hQ, &oMsgDescPut, &oPutOpts, 
              lPCFMsgLen, lpszLocalBuff, &lCC, &lRC);

        /* Done with the local buffer */
        FreeIfNotNull((void**)&lpszLocalBuff);

        /* Check the result and log it */
        if(MQRC_NONE == lRC)
        {
            /* Log the MsgId and CorrelId */
            LogMsgCorrelAndGroupIds(lpTIB, &oMsgDescPut);

            /* Log our success */
            sprintf(lpszExtraInfo, "MQPUT-TargQ=\"%s\" ConnQMgr=\"%s\" PMO.Options=0x%08x message put successful\0",
                    lpSCB->lpszResQName,
                    lpSCB->lpCDB->lpszConnQMgrName,
                    oPutOpts.Options);
            LogMsg(TEST_EXTRA_LINE, lpTIB->lTestNum, lpszExtraInfo);
        }
        else
        {
            sprintf(lpszExtraInfo, "MQPUT-TargQ=\"%s\" ConnQMgr=\"%s\" PMO.Options=0x%08x message put failed\0",
                    lpSCB->lpszResQName,
                    lpSCB->lpCDB->lpszConnQMgrName,
                    oPutOpts.Options);
            LogMsg(TEST_EXTRA_LINE_ERR, lpTIB->lTestNum, lpszExtraInfo);
            sprintf(lpszExtraInfo, "MQPUT-CC=%d RC=%d\0", lCC, lRC);
            LogMsg(TEST_EXTRA_LINE_ERR, lpTIB->lTestNum, lpszExtraInfo);
            kpMCB->bConcurrencyWait = FALSE;
            SetTIBCodes(lpTIB, lCC, lRC);
            /* If the next command is an <If...> that contains a check of either */
            /* LastCC or LastRC then do not fail this command. Instead permit    */
            /* processing to continue at the <If...>                             */
            if(NULL != lpCCB->lpCCBNext)
            {
                lpCCBCheckIf = (CommandCtrlBlk*)lpCCB->lpCCBNext;
                if(C_IFSTART == lpCCBCheckIf->eCommandType)
                {
                    lpIFSCheck = (IfStartBlk*) lpCCBCheckIf;
                    if((TRUE == lpIFSCheck->bACondChecksLastCC) || (TRUE == lpIFSCheck->bACondChecksLastRC))
                    {
                        lpSCB->eCommandState = S_COMPLETE;
                        return SUCCESS;
                    }
                }
            }
            lpSCB->eCommandState = S_FAILURE;
            return FAILURE;
        }

        /* Now get all the replies */
        lBreakPcfCC = 0;
        lBreakPcfRC = 0;
        lContinuePcfCC = 0;
        lContinuePcfRC = 0;
        lMaxPcfCC = 0;
        lMaxPcfRC = 0;
        bBreak = FALSE;
        bContinue = FALSE;
        bForEver = TRUE; /* Prevent compiler warning on constant in the loop */
        while(bForEver)
        {
            /* Set the values in the MQMD */
            memcpy(&oMsgDescGet, &oMQMDDefault, sizeof(MQMD));
            memcpy(&oMsgDescGet.MsgId, MQMI_NONE, MQ_MSG_ID_LENGTH);
            memcpy(&oMsgDescGet.CorrelId, &oMsgDescPut.MsgId, MQ_MSG_ID_LENGTH);

            /* And the get options */
            memcpy(&oGetOpts, &oMQGMODefault, sizeof(MQGMO));
            oGetOpts.Version = MQGMO_VERSION_2;
            oGetOpts.MatchOptions = MQMO_MATCH_CORREL_ID;
            oGetOpts.Options = MQGMO_WAIT | MQGMO_CONVERT | MQGMO_NO_SYNCPOINT | MQGMO_FAIL_IF_QUIESCING;
            oGetOpts.WaitInterval = lpSCB->lMaxWait * 1000;

            /* Ok lets do it */
            lGetDataLen = 0;
            MQGET(lpSCB->lpQIBMR->hConn, lpSCB->lpQIBMR->hQ, &oMsgDescGet, &oGetOpts,
                  kpMCB->lMqscReplyBuffLen, kpMCB->lpszMqscReplyBuff,
                  &lGetDataLen, &lCC, &lRC);

            /* Check the result of the MQGET */
            if(MQRC_NONE == lRC)
            {
                /* Hold the length of the data we just got. */
                /* Terminate message with trailing nulls.   */
                /* Should be safe as we do a malloc of +8   */
                /* which we dont let MQ know about.         */
                lPCFReplyMsgLen = lGetDataLen;
                memset(kpMCB->lpszMqscReplyBuff + lPCFReplyMsgLen, 0x00, 4);
                lpCFH = (MQCFH*)kpMCB->lpszMqscReplyBuff;
                lPcfCC = lpCFH->CompCode;
                lPcfRC = lpCFH->Reason;

                /* Got a message so log it */
                if(FALSE == kpMCB->bLoggingSuppressed)
                {
                    LogMsgCorrelAndGroupIds(lpTIB, &oMsgDescGet);

                    sprintf(lpszExtraInfo, "MQGET-TargQ=\"%s\" ConnQMgr=\"%s\" GMO.Options=0x%08x message get successful\0",
                            lpSCB->lpQIBMR->lpszResolvedQName,
                            lpSCB->lpCDB->lpszConnQMgrName,
                            oGetOpts.Options);
                    LogMsg(TEST_EXTRA_LINE, lpTIB->lTestNum, lpszExtraInfo);
                    if(MQCFC_LAST == lpCFH->Control)
                    {
                        sprintf(lpszExtraInfo, "PCF-Header Control=MQCFC_LAST CC=%d RC=%d\0", lPcfCC, lPcfRC);
                    }
                    else
                    {
                        sprintf(lpszExtraInfo, "PCF-Header Control=MQCFC_NOT_LAST CC=%d RC=%d\0", lPcfCC, lPcfRC);
                    }
                    LogMsg(TEST_EXTRA_LINE, lpTIB->lTestNum, lpszExtraInfo);
                }

                /* Only check for Break or Continue conditions if none have been detected so far */
                if((FALSE == bBreak) && (FALSE == bContinue))
                {
                    /* Check current reason code against BreakOnRC reason codes */
                    if(0 < lpSCB->lBreakOnRCCount)
                    {
                        if(TRUE == FindRC(lpSCB->lBreakOnRCCount, lpSCB->lBreakOnRC, lPcfRC))
                        {
                            if(lpSCB->lpBreakContinueFSB)
                            {
                                LogMsg(118, lpTIB->lTestNum, kpszMQSCCOMMAND, lPcfCC, lPcfRC, "Ending For/ForEver/ForEach loop Name=\0", lpSCB->lpBreakContinueFSB->lpszForName);
                            }
                            else
                            {
                                LogMsg(118, lpTIB->lTestNum, kpszMQSCCOMMAND, lPcfCC, lPcfRC, "Ending Test Name=\0", lpTIB->lpszTestName);
                            }
                            lBreakPcfCC = lPcfCC;
                            lBreakPcfRC = lPcfRC;
                            bBreak = TRUE;
                        }
                    }
                }

                /* Only check for Break or Continue conditions if none have been detected so far */
                if((FALSE == bBreak) && (FALSE == bContinue))
                {
                    /* Check current reason code against ContinueOnRC reason codes */
                    if(0 < lpSCB->lContinueOnRCCount)
                    {
                        if(TRUE == FindRC(lpSCB->lContinueOnRCCount, lpSCB->lContinueOnRC, lPcfRC))
                        {
                            if(lpSCB->lpBreakContinueFSB)
                            {
                                LogMsg(119, lpTIB->lTestNum, kpszMQSCCOMMAND, lPcfCC, lPcfRC, "Continuing For/ForEver/ForEach loop Name=\0", lpSCB->lpBreakContinueFSB->lpszForName);
                            }
                            else
                            {
                                LogMsg(119, lpTIB->lTestNum, kpszMQSCCOMMAND, lPcfCC, lPcfRC, "Ending Test Name=\0", lpTIB->lpszTestName);
                            }
                            lContinuePcfCC = lPcfCC;
                            lContinuePcfRC = lPcfRC;
                            bContinue = TRUE;
                        }
                    }
                }

                /* Check the current reason code against the suppression list */
                /* Suppression is done last as it changes the reason code     */
                if(0 < lpSCB->lSuppressRCCount)
                {
                    if(TRUE == FindRC(lpSCB->lSuppressRCCount, lpSCB->lSuppressRC, lPcfRC))
                    {
                        LogMsg(117, lpTIB->lTestNum, kpszMQSCCOMMAND, lPcfCC, lPcfRC);
                        if(MQCC_FAILED == lPcfCC)
                        {
                            lGetDataLen = 0;
                        }
                        lPcfCC = 0;
                        lPcfRC = 0;
                    }
                }

                /* Retain the first of the worst  */
                if(lPcfCC > lMaxPcfCC)
                {
                    lMaxPcfCC = lPcfCC;
                    lMaxPcfRC = lPcfRC;
                }

                /* Data */
                lpszCurrParameter = (char*)lpCFH + lpCFH->StrucLength;
                for(lIdx = 0; lIdx < lpCFH->ParameterCount; lIdx++)
                {
                    lplType = (long*)lpszCurrParameter;
                    lplStrucLength = (long*)(lpszCurrParameter + 4);
                    switch(*lplType)
                    {
                    /* Display contents of a PCF Integer Parameter */
                    case MQCFT_INTEGER:
                        lpCFIN = (MQCFIN*)lpszCurrParameter;
                        if((MQIACF_ESCAPE_TYPE == lpCFIN->Parameter) && (MQET_MQSC == lpCFIN->Value))
                        {
                            sprintf(lpszExtraInfo, "Parm-%04d PCF Integer Parameter=MQIACF_ESCAPE_TYPE Value=MQET_MQSC\0", lIdx);
                            LogMsg(TEST_EXTRA_LINE, lpTIB->lTestNum, lpszExtraInfo);
                        }
                        else
                        {
                            sprintf(lpszExtraInfo, "Parm-%04d PCF Integer Parameter=%d Value=%d\0", lIdx, lpCFIN->Parameter, lpCFIN->Value);
                            LogMsg(TEST_EXTRA_LINE, lpTIB->lTestNum, lpszExtraInfo);
                        }
                        lpszCurrParameter += lpCFIN->StrucLength;
                        break;
                    /* Display the content of a PCF String Parameter */
                    case MQCFT_STRING:
                        lpCFST = (MQCFST*)lpszCurrParameter;
                        sprintf(lpszExtraInfo, "Parm-%04d PCF String StringLength=%d\0", lIdx, lpCFST->StringLength);
                        LogMsg(TEST_EXTRA_LINE, lpTIB->lTestNum, lpszExtraInfo);
                        /* Check for an overflow condition and reallocate buffer if necessary */
                        lCheckLen = lpSCB->lpBIB->lDataLen + lpCFST->StringLength;
                        lBuffMax = lpSCB->lpBIB->lBuffLen - 4;
                        if(lCheckLen > lBuffMax)
                        {
                            /* Retain a pointer to the buffer if it existed */
                            lpszOldBuff = lpSCB->lpBIB->lpszBuff;
                            lOldDataLen = lpSCB->lpBIB->lDataLen;

                            /* Allocate a new buffer on a 16 byte boundary */
                            /* rounding up by at least 16 bytes            */
                            lpSCB->lpBIB->lBuffLen = lpSCB->lpBIB->lBuffLen + MQSC_EXTEND_LEN;
                            lpSCB->lpBIB->lpszBuff = malloc(lpSCB->lpBIB->lBuffLen + 8);
                            if(! lpSCB->lpBIB->lpszBuff)
                            {
                                /* Couldn't get a buffer report the problem and fail the test */
                                sprintf(lpszExtraInfo, "Buffer=%s BuffLen=%d malloc() failed.\0",
                                        lpSCB->lpBIB->lpszBuffName,
                                        lpSCB->lpBIB->lBuffLen);
                                LogMsg(TEST_EXTRA_LINE_ERR, lpTIB->lTestNum, lpszExtraInfo);
                                SetTIBCodes(lpTIB, MTCC_FAIL, MTRC_RUN_BUFF_FAIL);
                                lpSCB->eCommandState = S_FAILURE;
                                return FAILURE;
                            }
            
                            /* Clear the new buffer and report its allocation */
                            memset(lpSCB->lpBIB->lpszBuff, 0x00, lpSCB->lpBIB->lBuffLen + 8);
                            if(FALSE == kpMCB->bLoggingSuppressed)
                            {
                                sprintf(lpszExtraInfo, "Buffer=%s BuffLen=%d bytes reallocated\0",
                                        lpSCB->lpBIB->lpszBuffName,
                                        lpSCB->lpBIB->lBuffLen);
                                LogMsg(TEST_EXTRA_LINE, lpTIB->lTestNum, lpszExtraInfo);
                            }
    
                            /* If we already had a buffer then copy any data it contained */
                            /* before freeing it                                          */
                            if(NULL != lpszOldBuff)
                            {
                                memcpy(lpSCB->lpBIB->lpszBuff, lpszOldBuff, lOldDataLen);
                                FreeIfNotNull((void**)&lpszOldBuff);
                            }
                        }

                        /* Copy the message contents to our buffer */
                        lpszCurrBuffPos = lpSCB->lpBIB->lpszBuff + lpSCB->lpBIB->lDataLen;
                        memcpy(lpszCurrBuffPos, lpCFST->String, lpCFST->StringLength);
                        lpSCB->lpBIB->lDataLen += lpCFST->StringLength;
                        lpTIB->lLastDataLen = lpSCB->lpBIB->lDataLen;

                        /* Break up the contents of the string into segments at the line feed characters */
                        lCurrStringSegLen = 0;
                        lpszCurrStringSeg = lpCFST->String;
                        lpszCurrChar = lpCFST->String;
                        for(lJdx = 0; lJdx < lpCFST->StringLength; lJdx++)
                        {
                            if(0x0d == *lpszCurrChar)
                            {
                                *lpszCurrChar = 0x00;
                            }
                            else if(0x0a == *lpszCurrChar)
                            {
                                *lpszCurrChar = 0x00;
                                LogMsg(TEST_EXTRA_LINE_PCF, lpTIB->lTestNum, lpszCurrStringSeg);
                                lCurrStringSegLen = 0;
                                lpszCurrStringSeg = lpszCurrChar + 1;
                            }
                            else
                            {
                                lCurrStringSegLen++;
                            }
                            lpszCurrChar++;
                        }
                        if (0 < lCurrStringSegLen)
                        {
                            LogMsg(TEST_EXTRA_LINE_PCF, lpTIB->lTestNum, lpszCurrStringSeg);
                        }
                        lpszCurrParameter += lpCFST->StrucLength;
                        break;
                    /* Unhandled parameter type. Just skip past it */
                    default:
                        sprintf(lpszExtraInfo, "Parm-%04d Unhandled parameter Type=%d StrucLength=%d\0", lIdx, *lplType, *lplStrucLength);
                        LogMsg(TEST_EXTRA_LINE, lpTIB->lTestNum, lpszExtraInfo);
                        lpszCurrParameter += *lplStrucLength;
                        break;
                    }
                }

                /* Got the last reply message now work out the next command state */
                if(MQCFC_LAST == lpCFH->Control)
                {
                    /* Report the maximum completion and reason codes */
                    if(FALSE == kpMCB->bLoggingSuppressed)
                    {
                        sprintf(lpszExtraInfo, "MqscCommand PCF Maximum(FirstOfTheWorst) CC=%d RC=%d\0", lMaxPcfCC, lMaxPcfRC);
                        LogMsg(TEST_EXTRA_LINE, lpTIB->lTestNum, lpszExtraInfo);
                    }

                    /* If a BreakOnRC condition was detected then transition to S_BREAK */
                    if(TRUE == bBreak)
                    {
                        lpTIB->lpBreakContinueFSB = lpSCB->lpBreakContinueFSB;
                        kpMCB->bConcurrencyWait = FALSE;
                        SetTIBCodes(lpTIB, lBreakPcfCC, lBreakPcfRC);
                        lpSCB->eCommandState = S_BREAK;
                        return SUCCESS;
                    }

                    /* If a ContinueOnRC condition was detected then transition to S_CONTINUE */
                    if(TRUE == bContinue)
                    {
                        lpTIB->lpBreakContinueFSB = lpSCB->lpBreakContinueFSB;
                        kpMCB->bConcurrencyWait = FALSE;
                        SetTIBCodes(lpTIB, lContinuePcfCC, lContinuePcfRC);
                        lpSCB->eCommandState = S_CONTINUE;
                        return SUCCESS;
                    }

                    /* If everything was work alright return SUCCESS otherwise FAILURE */
                    if(MQCC_OK == lMaxPcfCC)
                    {
                        kpMCB->bConcurrencyWait = FALSE;
                        SetTIBCodes(lpTIB, lMaxPcfCC, lMaxPcfRC);
                        lpSCB->eCommandState = S_COMPLETE;
                        return SUCCESS;
                    }
                    else
                    {
                        kpMCB->bConcurrencyWait = FALSE;
                        SetTIBCodes(lpTIB, lMaxPcfCC, lMaxPcfRC);
                        /* If the next command is an <If...> that contains a check of either */
                        /* LastCC or LastRC then do not fail this command. Instead permit    */
                        /* processing to continue at the <If...>                             */
                        if(NULL != lpCCB->lpCCBNext)
                        {
                            lpCCBCheckIf = (CommandCtrlBlk*)lpCCB->lpCCBNext;
                            if(C_IFSTART == lpCCBCheckIf->eCommandType)
                            {
                                lpIFSCheck = (IfStartBlk*) lpCCBCheckIf;
                                if((TRUE == lpIFSCheck->bACondChecksLastCC) || (TRUE == lpIFSCheck->bACondChecksLastRC))
                                {
                                    lpSCB->eCommandState = S_COMPLETE;
                                    return SUCCESS;
                                }
                            }
                        }
                        lpSCB->eCommandState = S_FAILURE;
                        return FAILURE;
                    }
                }
            }
            else
            {
                sprintf(lpszExtraInfo, "MQGET-TargQ=\"%s\" ConnQMgr=\"%s\" GMO.Options=0x%08x message get failed\0",
                        lpSCB->lpQIBMR->lpszResolvedQName,
                        lpSCB->lpCDB->lpszConnQMgrName,
                        oGetOpts.Options);
                LogMsg(TEST_EXTRA_LINE_ERR, lpTIB->lTestNum, lpszExtraInfo);
                sprintf(lpszExtraInfo, "MQGET-CC=%d RC=%d\0", lCC, lRC);
                LogMsg(TEST_EXTRA_LINE_ERR, lpTIB->lTestNum, lpszExtraInfo);
                kpMCB->bConcurrencyWait = FALSE;
                SetTIBCodes(lpTIB, lCC, lRC);
                lpSCB->eCommandState = S_FAILURE;
                return FAILURE;
            }
        }
        break;
    case S_COMPLETE:
        LogMsg(38, lpTIB->lTestNum, lpszCurrCmdName, CalcCmdExecTime(lpTIB));
        kpMCB->bConcurrencyWait = FALSE;
        lpSCB->eCommandState = S_NEXT;
        return SUCCESS;
        break;
    case S_FAILURE:
        LogMsg(51, lpTIB->lTestNum, lpszCurrCmdName, CalcCmdExecTime(lpTIB));
        kpMCB->bConcurrencyWait = FALSE;
        lpSCB->eCommandState = S_NEXT;
        return FAILURE;
        break;
    }
    /* Should never get here so its a logic error terminate immediately */
    SetTIBCodes(lpTIB, MTCC_FAIL, MTRC_LOGIC_FAIL);
    lpSCB->eCommandState = S_FAILURE;
    kpMCB->lProcessing = FAILURE;
    LogMsg(69, lpTIB->lTestNum, "ExecuteMqscCommandCmd\0");
    return FAILURE;
}


/*--------------------------------------------------------------------------*/
long
ExecuteForStartCmd(TestInfoBlk* lpTIB, CommandCtrlBlk* lpCCB)
{
    ControlInfoBlk*     lpCIB;
    ForStartBlk*        lpFSB;
    VarInfoBlk*         lpVIBLIB;
    ListInfoBlk*        lpLIB;
    char*               lpszCurrCmdName;
    char                lpszExtraInfo[EXTRA_MSG_INFO_LEN + 4];
    char                lpszWorkBuff[WORK_BUFF_LEN + 4];

    /* Initialise common use local variables */
    lpCIB = kpMCB->lpCIB;
    lpFSB = (ForStartBlk*)lpCCB;
    lpszCurrCmdName = kpszFORUNKNOWN;
    switch(lpFSB->eForType)
    {
    case F_FOR:
        lpszCurrCmdName = kpszFORSTART;
        break;
    case F_FOREVER:
        lpszCurrCmdName = kpszFOREVERSTART;
        break;
    case F_FOREACH:
        lpszCurrCmdName = kpszFOREACHSTART;
        break;
    }
    memset(lpszExtraInfo, 0x00, EXTRA_MSG_INFO_LEN + 4);

    /* Process according to current command state */
    switch(lpFSB->eCommandState)
    {
    case S_INIT:
        /* Running an initialisation so set concurrency wait false. */
        kpMCB->bConcurrencyWait = FALSE;

        /* Set up start, expiry and next log message times */
        time(&lpFSB->oStartTime);
        lpFSB->oExpiryTime = lpFSB->oStartTime;
        lpFSB->oNextLogMsgTime = lpFSB->oStartTime;

        switch(lpFSB->eForType)
        {
        case F_FOR:
        case F_FOREVER:
            /* Log the initial values */
            if(FALSE == kpMCB->bLoggingSuppressed)
            {
                sprintf(lpszExtraInfo, " Name=\"%s\" %s:%s:%s\0",
                        lpFSB->lpszForName, lpFSB->lpszFrom,
                        lpFSB->lpszTo, lpFSB->lpszIncr);
                LogMsg(44, lpTIB->lTestNum, lpszCurrCmdName, lpszExtraInfo);
            }
            /* Resolve variables */
            ResolveValue(lpTIB, &lpFSB->lpszResFrom, &lpFSB->lpszFrom, TRUE);
            ResolveValue(lpTIB, &lpFSB->lpszResTo, &lpFSB->lpszTo, TRUE);
            ResolveValue(lpTIB, &lpFSB->lpszResIncr, &lpFSB->lpszIncr, TRUE);
            if(FAILURE == lpTIB->bCmdResult)
            {
                lpFSB->eCommandState = S_FAILURE;
                return FAILURE;
            }

            /* Convert to numeric values */
            lpFSB->lFrom = ConvNum(lpTIB, lpFSB->lpszResFrom, "From");
            lpFSB->lTo = ConvNum(lpTIB, lpFSB->lpszResTo, "To");
            lpFSB->lIncr = ConvNum(lpTIB, lpFSB->lpszResIncr, "Incr");
            if(FAILURE == lpTIB->bCmdResult)
            {
                LogMsg(131, lpTIB->lTestNum, lpFSB->lpszForName, lpFSB->lpszResFrom,
                       lpFSB->lpszResTo, lpFSB->lpszResIncr);
                lpFSB->eCommandState = S_FAILURE;
                return FAILURE;
            }

            /* Initialise the current for loop counter value */
            lpFSB->lCurrent = lpFSB->lFrom;
            memset(lpszWorkBuff, 0x00, WORK_BUFF_LEN + 4);
            sprintf(lpszWorkBuff, lpFSB->lpVIB->lpszVarFormat, lpFSB->lCurrent);
            FreeIfNotNull((void**)&lpFSB->lpVIB->lpszCurrStrValue);
            lpFSB->lpVIB->lpszCurrStrValue = CloneString(lpszWorkBuff);

            /* Check to see if termination condition has already occured */
            lpFSB->bCompleteDuringInit = FALSE;
            if(0 < lpFSB->lIncr)
            {
                /* Increment is positive so check using GTEQ */
                if(lpFSB->lCurrent > lpFSB->lTo)
                {
                    /* Termination condition already reached so skip */
                    /* to the ForEnd for consistent log behaviour    */ 
                    lpFSB->bCompleteDuringInit = TRUE;
                    lpTIB->lpCCBCurr = (CommandCtrlBlk*)lpFSB->lpForEndCmd; 
                    return SUCCESS;                }
            }
            else
            {
                /* Increment is negative so check using LTEQ */
                if(lpFSB->lCurrent < lpFSB->lTo)
                {
                    /* Termination condition already reached so skip */
                    /* to the ForEnd for consistent log behaviour    */ 
                    lpFSB->bCompleteDuringInit = TRUE;
                    lpTIB->lpCCBCurr = (CommandCtrlBlk*)lpFSB->lpForEndCmd; 
                    return SUCCESS;                }
            }
            break;
        case F_FOREACH:
            /* Find the var info block for the named list */
            lpVIBLIB = FindVarInfoBlk(lpTIB->lpVIBHead, lpFSB->lpszList);
            if(NULL == lpVIBLIB)
            {
                LogMsg(182, lpTIB->lTestNum, lpFSB->lpszForName, lpFSB->lpszList);
                lpFSB->eCommandState = S_FAILURE;
                return FAILURE;
            }
            if(V_LIST != lpVIBLIB->eVarType) 
            {
                LogMsg(183, lpTIB->lTestNum, lpFSB->lpszForName, lpFSB->lpszList);
                lpFSB->eCommandState = S_FAILURE;
                return FAILURE;
            }

            /* Initialise the current for loop counter value */
            lpLIB = (ListInfoBlk*) lpVIBLIB->lpCtrlBlk;
            lpFSB->lpCurrLEB = lpLIB->lpLEBHead;
            if(NULL == lpFSB->lpCurrLEB)
            {
                /* Empty list so no value to extract */
                FreeIfNotNull((void**)&lpFSB->lpVIB->lpszCurrStrValue);
                lpFSB->lpVIB->lpszCurrStrValue = CloneString(kpszEmptyString);
            }
            else
            {
                memset(lpszWorkBuff, 0x00, WORK_BUFF_LEN + 4);
                sprintf(lpszWorkBuff, lpFSB->lpVIB->lpszVarFormat, lpFSB->lpCurrLEB->lpszListElementValue);
                FreeIfNotNull((void**)&lpFSB->lpVIB->lpszCurrStrValue);
                lpFSB->lpVIB->lpszCurrStrValue = CloneString(lpszWorkBuff);
            }

            /* Check to see if termination condition has already occured */
            if(NULL == lpFSB->lpCurrLEB)
            {
                /* Log the initial values */
                if(FALSE == kpMCB->bLoggingSuppressed)
                {
                    sprintf(lpszExtraInfo, " Name=\"%s\" List=\"%s\"\0",
                            lpFSB->lpszForName, lpFSB->lpszList);
                    LogMsg(44, lpTIB->lTestNum, lpszCurrCmdName, lpszExtraInfo);
                }
                /* Termination condition already reached so skip */
                /* to the ForEnd for consistent log behaviour    */ 
                lpFSB->bCompleteDuringInit = TRUE;
                lpTIB->lpCCBCurr = (CommandCtrlBlk*)lpFSB->lpForEndCmd; 
                return SUCCESS;
            }
            else
            {
                if(FALSE == kpMCB->bLoggingSuppressed)
                {
                    sprintf(lpszExtraInfo, " Name=\"%s\" List=\"%s\"\0",
                            lpFSB->lpszForName, lpFSB->lpszList);
                    LogMsg(44, lpTIB->lTestNum, lpszCurrCmdName, lpszExtraInfo);
                }
            }
            break;
        }

        /* Ready to run */
        lpFSB->eCommandState = S_RUN;
        return SUCCESS;
        break;
    case S_RUN:
        switch(lpFSB->eForType)
        {
        case F_FOR:
        case F_FOREVER:
            if(FALSE == kpMCB->bLoggingSuppressed)
            {
                sprintf(lpszExtraInfo, " Name=\"%s\" %d:%d:%d:%d\0",
                        lpFSB->lpszForName, lpFSB->lFrom,
                        lpFSB->lTo, lpFSB->lIncr, lpFSB->lCurrent);
                LogMsg(45, lpTIB->lTestNum, lpszCurrCmdName, lpszExtraInfo);
            }
            break;
        case F_FOREACH:
            if(FALSE == kpMCB->bLoggingSuppressed)
            {
                memset(lpszWorkBuff, 0x00, WORK_BUFF_LEN + 4);
                DisplayData(kpszData, lpszWorkBuff, WORK_BUFF_LEN,
                            lpFSB->lpCurrLEB->lpszListElementValue,
                            StrlenNull(lpFSB->lpCurrLEB->lpszListElementValue));
                sprintf(lpszExtraInfo, " Name=\"%s\" %s\0",
                        lpFSB->lpszForName, lpszWorkBuff);
                LogMsg(45, lpTIB->lTestNum, lpszCurrCmdName, lpszExtraInfo);
            }
            break;
        }

        /* Completed ForStart */
        kpMCB->bConcurrencyWait = FALSE;
        lpFSB->eCommandState = S_NEXT;
        return SUCCESS;
        break;
    case S_FAILURE:
        LogMsg(51, lpTIB->lTestNum, lpszCurrCmdName, CalcCmdExecTime(lpTIB));
        kpMCB->bConcurrencyWait = FALSE;
        lpFSB->eCommandState = S_NEXT;
        return FAILURE;
        break;
    }
    /* Should never get here so its a logic error terminate immediately */
    lpFSB->eCommandState = S_FAILURE;
    kpMCB->lProcessing = FAILURE;
    LogMsg(69, lpTIB->lTestNum, "ExecuteForStartCmd\0");
    return FAILURE;
}


/*--------------------------------------------------------------------------*/
long
ExecuteForEndCmd(TestInfoBlk* lpTIB, CommandCtrlBlk* lpCCB)
{
    ControlInfoBlk* lpCIB;
    ForEndBlk*      lpFEB;
    ForStartBlk*    lpFSB;
    char*           lpszCurrCmdName;
    char            lpszExtraInfo[EXTRA_MSG_INFO_LEN + 4];
    char            lpszWorkBuff[WORK_BUFF_LEN + 4];

    /* Initialise common use local variables */
    lpCIB = kpMCB->lpCIB;
    lpFEB = (ForEndBlk*)lpCCB;
    lpszCurrCmdName = kpszFORUNKNOWN;
    lpFSB = (ForStartBlk*)lpFEB->lpForStartCmd;
    switch(lpFSB->eForType)
    {
    case F_FOR:
        lpszCurrCmdName = kpszFOREND;
        break;
    case F_FOREVER:
        lpszCurrCmdName = kpszFOREVEREND;
        break;
    case F_FOREACH:
        lpszCurrCmdName = kpszFOREACHEND;
        break;
    }
    memset(lpszExtraInfo, 0x00, EXTRA_MSG_INFO_LEN + 4);

    /* Process according to current command state */
    switch(lpFEB->eCommandState)
    {
    case S_INIT:
        /* Running an initialisation so set concurrency wait false. */
        kpMCB->bConcurrencyWait = FALSE;

        /* Set up start, expiry and next log message times */
        time(&lpFEB->oStartTime);
        lpFEB->oExpiryTime = lpFEB->oStartTime;
        lpFEB->oNextLogMsgTime = lpFEB->oStartTime;

        /* Ready to run */
        lpFEB->eCommandState = S_RUN;
        return SUCCESS;
        break;
    case S_RUN:
        switch(lpFSB->eForType)
        {
        case F_FOR:
        case F_FOREVER:
            if(FALSE == kpMCB->bLoggingSuppressed)
            {
                sprintf(lpszExtraInfo, " Name=\"%s\" %d:%d:%d:%d\0",
                        lpFEB->lpszForName, lpFSB->lFrom,
                        lpFSB->lTo, lpFSB->lIncr, lpFSB->lCurrent);
                LogMsg(45, lpTIB->lTestNum, lpszCurrCmdName, lpszExtraInfo);
            }
            break;
        case F_FOREACH:
            if(FALSE == kpMCB->bLoggingSuppressed)
            {
                if(NULL == lpFSB->lpCurrLEB)
                {
                    sprintf(lpszExtraInfo, " Name=\"%s\" Data=\"%s\"\0",
                            lpFSB->lpszForName, "None - List is empty\0");
                }
                else
                {
                    memset(lpszWorkBuff, 0x00, WORK_BUFF_LEN + 4);
                    DisplayData(kpszData, lpszWorkBuff, WORK_BUFF_LEN, lpFSB->lpCurrLEB->lpszListElementValue,
                                StrlenNull(lpFSB->lpCurrLEB->lpszListElementValue));
                    sprintf(lpszExtraInfo, " Name=\"%s\" %s\0",
                            lpFSB->lpszForName, lpszWorkBuff);
                }
                LogMsg(45, lpTIB->lTestNum, lpszCurrCmdName, lpszExtraInfo);
            }
            break;
        }

        /* Perform loop increment but only if we didn't complete */
        /* during ExecuteForStartCmd S_INIT processing           */
        if(FALSE == lpFSB->bCompleteDuringInit)
        {
            switch(lpFSB->eForType)
            {
            case F_FOR:
            case F_FOREVER:
                /* Increment the for loop variable */
                lpFSB->lCurrent += lpFSB->lIncr;
                /* If we are about to wrap over to a negative number */
                /* at the 2 gig mark reset to zero                   */ 
                if(2147483647 == lpFSB->lCurrent)
                {
                    lpFSB->lCurrent = 0;
                    LogMsg(113, lpTIB->lTestNum, lpFSB->lpVIB->lpszVarName);
                    ReportMsg(113, lpTIB->lTestNum, lpFSB->lpVIB->lpszVarName);
                }
        
                /* Set the for loop variable to the current value */
                memset(lpszWorkBuff, 0x00, WORK_BUFF_LEN + 4);
                sprintf(lpszWorkBuff, lpFSB->lpVIB->lpszVarFormat, lpFSB->lCurrent);
                FreeIfNotNull((void**)&lpFSB->lpVIB->lpszCurrStrValue);
                lpFSB->lpVIB->lpszCurrStrValue = CloneString(lpszWorkBuff);
                break;
            case F_FOREACH:
                lpFSB->lpCurrLEB = (ListElementInfoBlk*)lpFSB->lpCurrLEB->lpLEBNext;
                if(NULL == lpFSB->lpCurrLEB)
                {
                    /* End of the list so no value to extract */
                    FreeIfNotNull((void**)&lpFSB->lpVIB->lpszCurrStrValue);
                    lpFSB->lpVIB->lpszCurrStrValue = CloneString(kpszEmptyString);
                }
                else
                {
                    memset(lpszWorkBuff, 0x00, WORK_BUFF_LEN + 4);
                    sprintf(lpszWorkBuff, lpFSB->lpVIB->lpszVarFormat, lpFSB->lpCurrLEB->lpszListElementValue);
                    FreeIfNotNull((void**)&lpFSB->lpVIB->lpszCurrStrValue);
                    lpFSB->lpVIB->lpszCurrStrValue = CloneString(lpszWorkBuff);
                }
                break;
            }
        }

        /* Check how the for loop is progressing if we have reached */
        /* the end then set the state of this command to complete   */
        /* otherwise change the current command pointer back to the */
        /* start of this loop. If its a forever loop then don't     */
        /* check anything                                           */
        switch(lpFSB->eForType)
        {
        case F_FOR:
            if(0 < lpFSB->lIncr)
            {
                /* Increment is positive so check using GTEQ */
                if(lpFSB->lCurrent > lpFSB->lTo)
                {
                    kpMCB->bConcurrencyWait = FALSE;
                    lpFEB->eCommandState = S_COMPLETE;
                    return SUCCESS;
                }
            }
            else
            {
                /* Increment is negative so check using LTEQ */
                if(lpFSB->lCurrent < lpFSB->lTo)
                {
                    kpMCB->bConcurrencyWait = FALSE;
                    lpFEB->eCommandState = S_COMPLETE;
                    return SUCCESS;
                }
            }
            break;
        case F_FOREACH:
            /* Handle being at end condition immediately */
            if(NULL == lpFSB->lpCurrLEB)
            {
                    kpMCB->bConcurrencyWait = FALSE;
                    lpFEB->eCommandState = S_COMPLETE;
                    return SUCCESS;
            }
            /* Normal check to see if we finished */
            if(NULL == lpFSB->lpCurrLEB)
            {
                    kpMCB->bConcurrencyWait = FALSE;
                    lpFEB->eCommandState = S_COMPLETE;
                    return SUCCESS;
            }
            break;
        }

        /* For loop still going so change current CCB pointer */
        kpMCB->bConcurrencyWait = FALSE;
        lpFSB->eCommandState = S_RUN;
        lpTIB->lpCCBCurr = (CommandCtrlBlk*)lpFEB->lpForStartCmd;
        return SUCCESS;
        break;
    case S_COMPLETE:
        sprintf(lpszExtraInfo, "%s Name=\"%s\"\0", lpszCurrCmdName, lpFEB->lpszForName);
        LogMsg(38, lpTIB->lTestNum, lpszExtraInfo);
        kpMCB->bConcurrencyWait = FALSE;
        lpFEB->eCommandState = S_NEXT;
        return SUCCESS;
        break;
    case S_FAILURE:
        sprintf(lpszExtraInfo, "%s Name=\"%s\"\0", lpszCurrCmdName, lpFEB->lpszForName);
        LogMsg(51, lpTIB->lTestNum, lpszExtraInfo);
        kpMCB->bConcurrencyWait = FALSE;
        lpFEB->eCommandState = S_NEXT;
        return FAILURE;
        break;
    }
    /* Should never get here so its a logic error terminate immediately */
    lpFEB->eCommandState = S_FAILURE;
    kpMCB->lProcessing = FAILURE;
    LogMsg(69, lpTIB->lTestNum, "ExecuteForEndCmd\0");
    return FAILURE;
}


/*--------------------------------------------------------------------------*/
long
ExecuteIfStartCmd(TestInfoBlk* lpTIB, CommandCtrlBlk* lpCCB)
{
    ControlInfoBlk* lpCIB;
    IfStartBlk*     lpIFS;
    char*           lpszCurrCmdName;
    char            lpszExtraInfo[EXTRA_MSG_INFO_LEN + 4];
    long            bTrueFalseUnknown;

    /* Initialise common use local variables */
    lpCIB = kpMCB->lpCIB;
    lpIFS = (IfStartBlk*)lpCCB;
    lpszCurrCmdName = kpszIFSTART;
    memset(lpszExtraInfo, 0x00, EXTRA_MSG_INFO_LEN + 4);

    /* Process according to current command state */
    switch(lpIFS->eCommandState)
    {
    case S_INIT:
        sprintf(lpszExtraInfo, " Cond=\"%s\"\0", lpIFS->lpszCond);
        LogMsg(44, lpTIB->lTestNum, lpszCurrCmdName, lpszExtraInfo);
        /* Running an initialisation so set concurrency wait false. */
        kpMCB->bConcurrencyWait = FALSE;

        /* Set up start, expiry and next log message times */
        time(&lpIFS->oStartTime);
        lpIFS->oExpiryTime = lpIFS->oStartTime;
        lpIFS->oNextLogMsgTime = lpIFS->oStartTime;

        /* Resolve variables */
        ResolveValue(lpTIB, &lpIFS->lpszResCond, &lpIFS->lpszCond, FALSE);
        if(FAILURE == lpTIB->bCmdResult)
        {
            lpIFS->eCommandState = S_FAILURE;
            return FAILURE;
        }

        /* Ready to run */
        lpIFS->eCommandState = S_RUN;
        return SUCCESS;
        break;
    case S_RUN:
        if(FALSE == kpMCB->bLoggingSuppressed)
        {
            sprintf(lpszExtraInfo, " Resolved Cond=\"%s\"\0", lpIFS->lpszResCond);
            LogMsg(45, lpTIB->lTestNum, lpszCurrCmdName, lpszExtraInfo);
        }

        /* Evaluate the condition */
        bTrueFalseUnknown = EvaluateCondition(lpTIB, lpIFS->lpszResCond, TRUE);
        
        /* Was the condition TRUE */
        if(TRUE == bTrueFalseUnknown)
        {
            /* Condition was TRUE so continue execution with the next command */
            lpIFS->bGotATrueCondition = TRUE;
            kpMCB->bConcurrencyWait = FALSE;
            lpIFS->eCommandState = S_NEXT;
            return SUCCESS;
        }
        
        /* Was the condition FALSE */
        if(FALSE == bTrueFalseUnknown)
        {
            /* Condition was FALSE need to change current the CCB pointer to the */
            /* next element of the If Group <ElseIf...>, <Else/> or </If>        */
            kpMCB->bConcurrencyWait = FALSE;
            lpIFS->eCommandState = S_INIT; /* Reset for loops */
            lpTIB->lpCCBCurr = (CommandCtrlBlk*)lpIFS->lpIFGNext;
            return SUCCESS;
        }

        /* UNKNOWN is very bad report it as a logic error and give up */
        SetTIBCodes(lpTIB, MTCC_FAIL, MTRC_LOGIC_FAIL);
        lpIFS->eCommandState = S_FAILURE;
        kpMCB->lProcessing = FAILURE;
        LogMsg(69, lpTIB->lTestNum, "ExecuteIfStartCmd\0");
        return FAILURE;
        break;
    case S_FAILURE:
        LogMsg(51, lpTIB->lTestNum, lpszCurrCmdName, CalcCmdExecTime(lpTIB));
        kpMCB->bConcurrencyWait = FALSE;
        lpIFS->eCommandState = S_NEXT;
        return FAILURE;
        break;
    }
    /* Should never get here so its a logic error terminate immediately */
    lpIFS->eCommandState = S_FAILURE;
    kpMCB->lProcessing = FAILURE;
    LogMsg(69, lpTIB->lTestNum, "ExecuteIfStartCmd\0");
    return FAILURE;
}


/*--------------------------------------------------------------------------*/
long
ExecuteElseIfCmd(TestInfoBlk* lpTIB, CommandCtrlBlk* lpCCB)
{
    ControlInfoBlk* lpCIB;
    ElseIfBlk*      lpELI;
    IfStartBlk*     lpIFS;
    char*           lpszCurrCmdName;
    char            lpszExtraInfo[EXTRA_MSG_INFO_LEN + 4];
    long            bTrueFalseUnknown;

    /* Initialise common use local variables */
    lpCIB = kpMCB->lpCIB;
    lpELI = (ElseIfBlk*)lpCCB;
    lpszCurrCmdName = kpszELSEIF;
    memset(lpszExtraInfo, 0x00, EXTRA_MSG_INFO_LEN + 4);

    /* Process according to current command state */
    switch(lpELI->eCommandState)
    {
    case S_INIT:
        /* If a prior condition was TRUE skip to the end of the <If...> that */
        /* this <ElseIf...> forms part of by moving the CCB accordingly      */
        lpIFS = (IfStartBlk*)lpELI->lpIFS;
        if(TRUE == lpIFS->bGotATrueCondition)
        {
            sprintf(lpszExtraInfo, " Cond=\"%s\"\0", lpELI->lpszCond);
            LogMsg(258, lpTIB->lTestNum, lpszCurrCmdName, lpszExtraInfo);
            lpTIB->lpCCBCurr = (CommandCtrlBlk*)lpELI->lpIFE;
            return SUCCESS;
            break;
        }

        sprintf(lpszExtraInfo, " Cond=\"%s\"\0", lpELI->lpszCond);
        LogMsg(44, lpTIB->lTestNum, lpszCurrCmdName, lpszExtraInfo);
        /* Running an initialisation so set concurrency wait false. */
        kpMCB->bConcurrencyWait = FALSE;

        /* Set up start, expiry and next log message times */
        time(&lpELI->oStartTime);
        lpELI->oExpiryTime = lpELI->oStartTime;
        lpELI->oNextLogMsgTime = lpELI->oStartTime;

        /* Resolve variables */
        ResolveValue(lpTIB, &lpELI->lpszResCond, &lpELI->lpszCond, FALSE);
        if(FAILURE == lpTIB->bCmdResult)
        {
            lpELI->eCommandState = S_FAILURE;
            return FAILURE;
        }

        /* Ready to run */
        lpELI->eCommandState = S_RUN;
        return SUCCESS;
        break;
    case S_RUN:
        if(FALSE == kpMCB->bLoggingSuppressed)
        {
            sprintf(lpszExtraInfo, " Resolved Cond=\"%s\"\0", lpELI->lpszResCond);
            LogMsg(45, lpTIB->lTestNum, lpszCurrCmdName, lpszExtraInfo);
        }
        
        /* Evaluate the condition */
        bTrueFalseUnknown = EvaluateCondition(lpTIB, lpELI->lpszResCond, TRUE);
        
        /* Was the condition TRUE */
        if(TRUE == bTrueFalseUnknown)
        {
            /* Update the got a true condition flag in the related <If...> */
            lpIFS = (IfStartBlk*)lpELI->lpIFS;
            lpIFS->bGotATrueCondition = TRUE;
            /* Condition was TRUE so continue execution with the next command */
            kpMCB->bConcurrencyWait = FALSE;
            lpELI->eCommandState = S_NEXT;
            return SUCCESS;
        }
        
        /* Was the condition FALSE */
        if(FALSE == bTrueFalseUnknown)
        {
            /* Condition was FALSE need to change current the CCB pointer to the */
            /* next element of the If Group <ElseIf...>, <Else/> or </If>        */
            kpMCB->bConcurrencyWait = FALSE;
            lpELI->eCommandState = S_INIT; /* Reset for loops */
            lpTIB->lpCCBCurr = (CommandCtrlBlk*)lpELI->lpIFGNext;
            return SUCCESS;
        }

        /* UNKNOWN is very bad report it as a logic error and give up */
        SetTIBCodes(lpTIB, MTCC_FAIL, MTRC_LOGIC_FAIL);
        lpELI->eCommandState = S_FAILURE;
        kpMCB->lProcessing = FAILURE;
        LogMsg(69, lpTIB->lTestNum, "ExecuteElseIfCmd\0");
        return FAILURE;
    case S_FAILURE:
        LogMsg(51, lpTIB->lTestNum, lpszCurrCmdName, CalcCmdExecTime(lpTIB));
        kpMCB->bConcurrencyWait = FALSE;
        lpELI->eCommandState = S_NEXT;
        return FAILURE;
        break;
    }
    /* Should never get here so its a logic error terminate immediately */
    lpELI->eCommandState = S_FAILURE;
    kpMCB->lProcessing = FAILURE;
    LogMsg(69, lpTIB->lTestNum, "ExecuteElseIfCmd\0");
    return FAILURE;
}


/*--------------------------------------------------------------------------*/
long
ExecuteElseCmd(TestInfoBlk* lpTIB, CommandCtrlBlk* lpCCB)
{
    ControlInfoBlk* lpCIB;
    ElseBlk*        lpELS;
    IfStartBlk*     lpIFS;
    char*           lpszCurrCmdName;

    /* Initialise common use local variables */
    lpCIB = kpMCB->lpCIB;
    lpELS = (ElseBlk*)lpCCB;
    lpszCurrCmdName = kpszELSE;

    /* Process according to current command state */
    switch(lpELS->eCommandState)
    {
    case S_INIT:
        /* If a prior condition was TRUE skip to the end of the <If...> that */
        /* this <Else/>> forms part of by moving the CCB accordingly         */
        lpIFS = (IfStartBlk*)lpELS->lpIFS;
        if(TRUE == lpIFS->bGotATrueCondition)
        {
            LogMsg(258, lpTIB->lTestNum, lpszCurrCmdName, "\0");
            lpTIB->lpCCBCurr = (CommandCtrlBlk*)lpELS->lpIFE;
            return SUCCESS;
            break;
        }

        LogMsg(44, lpTIB->lTestNum, lpszCurrCmdName, "\0");
        /* Running an initialisation so set concurrency wait false. */
        kpMCB->bConcurrencyWait = FALSE;
        /* Set up start, expiry and next log message times */
        time(&lpELS->oStartTime);
        lpELS->oExpiryTime = lpELS->oStartTime;
        lpELS->oNextLogMsgTime = lpELS->oStartTime;

        /* Ready to run */
        lpELS->eCommandState = S_RUN;
        return SUCCESS;
        break;
    case S_RUN:
        LogMsg(45, lpTIB->lTestNum, lpszCurrCmdName, "\0");

        /* Else does nothing except act as a targer so transition to the next command */
        kpMCB->bConcurrencyWait = FALSE;
        lpELS->eCommandState = S_NEXT;
        return SUCCESS;
        break;
    }
    /* Should never get here so its a logic error terminate immediately */
    lpELS->eCommandState = S_FAILURE;
    kpMCB->lProcessing = FAILURE;
    LogMsg(69, lpTIB->lTestNum, "ExecuteElseCmd\0");
    return FAILURE;
}


/*--------------------------------------------------------------------------*/
long
ExecuteIfEndCmd(TestInfoBlk* lpTIB, CommandCtrlBlk* lpCCB)
{
    ControlInfoBlk* lpCIB;
    IfEndBlk*       lpIFE;
    IfStartBlk*     lpIFS;
    char*           lpszCurrCmdName;

    /* Initialise common use local variables */
    lpCIB = kpMCB->lpCIB;
    lpIFE = (IfEndBlk*)lpCCB;
    lpszCurrCmdName = kpszIFEND;

    /* Process according to current command state */
    switch(lpIFE->eCommandState)
    {
    case S_INIT:
        LogMsg(44, lpTIB->lTestNum, lpszCurrCmdName, "\0");
        /* Running an initialisation so set concurrency wait false. */
        kpMCB->bConcurrencyWait = FALSE;
        /* Set up start, expiry and next log message times */
        time(&lpIFE->oStartTime);
        lpIFE->oExpiryTime = lpIFE->oStartTime;
        lpIFE->oNextLogMsgTime = lpIFE->oStartTime;

        /* IfEnd is just a marker so transition to complete */
        lpIFE->eCommandState = S_COMPLETE;
        return SUCCESS;
        break;
    case S_COMPLETE:
        /* Reset the GotATrueCondition flag for loops */
        lpIFS = (IfStartBlk*)lpIFE->lpIFS;
        lpIFS->bGotATrueCondition = FALSE;
        LogMsg(38, lpTIB->lTestNum, lpszCurrCmdName, CalcCmdExecTime(lpTIB));
        kpMCB->bConcurrencyWait = FALSE;
        lpIFE->eCommandState = S_NEXT;
        return SUCCESS;
        break;
    }
    /* Should never get here so its a logic error terminate immediately */
    lpIFE->eCommandState = S_FAILURE;
    kpMCB->lProcessing = FAILURE;
    LogMsg(69, lpTIB->lTestNum, "ExecuteIfEndCmd\0");
    return FAILURE;
}


/*--------------------------------------------------------------------------*/
long
ExecuteContinueCmd(TestInfoBlk* lpTIB, CommandCtrlBlk* lpCCB)
{
    ControlInfoBlk* lpCIB;
    ContinueBlk*       lpCNB;
    char*           lpszCurrCmdName;

    /* Initialise common use local variables */
    lpCIB = kpMCB->lpCIB;
    lpCNB = (ContinueBlk*)lpCCB;
    lpszCurrCmdName = kpszCONTINUE;

    /* Process according to current command state */
    switch(lpCNB->eCommandState)
    {
    case S_INIT:
        LogMsg(44, lpTIB->lTestNum, lpszCurrCmdName, "\0");
        /* Running an initialisation so set concurrency wait false. */
        kpMCB->bConcurrencyWait = FALSE;
        /* Set up start, expiry and next log message times */
        time(&lpCNB->oStartTime);
        lpCNB->oExpiryTime = lpCNB->oStartTime;
        lpCNB->oNextLogMsgTime = lpCNB->oStartTime;

        /* Continue is just a marker so transition to complete */
        lpCNB->eCommandState = S_RUN;
        return SUCCESS;
        break;
    case S_RUN:
        if(lpCNB->lpBreakContinueFSB)
        {
            LogMsg(259, lpTIB->lTestNum, kpszCONTINUE, "Continuing For/ForEver/ForEach loop Name=\0", lpCNB->lpBreakContinueFSB->lpszForName);
        }
        else
        {
            LogMsg(259, lpTIB->lTestNum, kpszCONTINUE, "Ending Test Name=\0", lpTIB->lpszTestName);
        }
        lpTIB->lpBreakContinueFSB = lpCNB->lpBreakContinueFSB;
        kpMCB->bConcurrencyWait = FALSE;
        lpCNB->eCommandState = S_CONTINUE;
        return SUCCESS;
        break;
    }
    /* Should never get here so its a logic error terminate immediately */
    lpCNB->eCommandState = S_FAILURE;
    kpMCB->lProcessing = FAILURE;
    LogMsg(69, lpTIB->lTestNum, "ExecuteContinueCmd\0");
    return FAILURE;
}


/*--------------------------------------------------------------------------*/
long
ExecuteBreakCmd(TestInfoBlk* lpTIB, CommandCtrlBlk* lpCCB)
{
    ControlInfoBlk* lpCIB;
    BreakBlk*       lpBRB;
    char*           lpszCurrCmdName;

    /* Initialise common use local variables */
    lpCIB = kpMCB->lpCIB;
    lpBRB = (BreakBlk*)lpCCB;
    lpszCurrCmdName = kpszBREAK;

    /* Process according to current command state */
    switch(lpBRB->eCommandState)
    {
    case S_INIT:
        LogMsg(44, lpTIB->lTestNum, lpszCurrCmdName, "\0");
        /* Running an initialisation so set concurrency wait false. */
        kpMCB->bConcurrencyWait = FALSE;
        /* Set up start, expiry and next log message times */
        time(&lpBRB->oStartTime);
        lpBRB->oExpiryTime = lpBRB->oStartTime;
        lpBRB->oNextLogMsgTime = lpBRB->oStartTime;

        /* Break is just a marker so transition to complete */
        lpBRB->eCommandState = S_RUN;
        return SUCCESS;
        break;
    case S_RUN:
        if(lpBRB->lpBreakContinueFSB)
        {
            LogMsg(259, lpTIB->lTestNum, kpszBREAK, "Continuing For/ForEver/ForEach loop Name=\0", lpBRB->lpBreakContinueFSB->lpszForName);
        }
        else
        {
            LogMsg(259, lpTIB->lTestNum, kpszBREAK, "Ending Test Name=\0", lpTIB->lpszTestName);
        }
        lpTIB->lpBreakContinueFSB = lpBRB->lpBreakContinueFSB;
        kpMCB->bConcurrencyWait = FALSE;
        lpBRB->eCommandState = S_BREAK;
        return SUCCESS;
        break;
    }
    /* Should never get here so its a logic error terminate immediately */
    lpBRB->eCommandState = S_FAILURE;
    kpMCB->lProcessing = FAILURE;
    LogMsg(69, lpTIB->lTestNum, "ExecuteBreakCmd\0");
    return FAILURE;
}


/*--------------------------------------------------------------------------*/
long
ExecuteExitTestCmd(TestInfoBlk* lpTIB, CommandCtrlBlk* lpCCB)
{
    ControlInfoBlk* lpCIB;
    ExitTestBlk*    lpETB;
    char*           lpszCurrCmdName;

    /* Initialise common use local variables */
    lpCIB = kpMCB->lpCIB;
    lpETB = (ExitTestBlk*)lpCCB;
    lpszCurrCmdName = kpszEXITTEST;

    /* Process according to current command state */
    switch(lpETB->eCommandState)
    {
    case S_INIT:
        LogMsg(44, lpTIB->lTestNum, lpszCurrCmdName, "\0");
        /* Running an initialisation so set concurrency wait false. */
        kpMCB->bConcurrencyWait = FALSE;
        /* Set up start, expiry and next log message times */
        time(&lpETB->oStartTime);
        lpETB->oExpiryTime = lpETB->oStartTime;
        lpETB->oNextLogMsgTime = lpETB->oStartTime;

        /* ExitTest is just a marker so transition to complete */
        lpETB->eCommandState = S_RUN;
        return SUCCESS;
        break;
    case S_RUN:
        LogMsg(259, lpTIB->lTestNum, kpszEXITTEST, "Ending Test Name=\0", lpTIB->lpszTestName);
        lpTIB->lpBreakContinueFSB = NULL; /* Forces exit from test via Finally if specified */
        kpMCB->bConcurrencyWait = FALSE;
        lpETB->eCommandState = S_BREAK;
        return SUCCESS;
        break;
    }
    /* Should never get here so its a logic error terminate immediately */
    lpETB->eCommandState = S_FAILURE;
    kpMCB->lProcessing = FAILURE;
    LogMsg(69, lpTIB->lTestNum, "ExecuteExitTestCmd\0");
    return FAILURE;
}


/*--------------------------------------------------------------------------*/
long
ExecuteFailTestCmd(TestInfoBlk* lpTIB, CommandCtrlBlk* lpCCB)
{
    ControlInfoBlk* lpCIB;
    FailTestBlk*    lpFTB;
    char*           lpszCurrCmdName;

    /* Initialise common use local variables */
    lpCIB = kpMCB->lpCIB;
    lpFTB = (FailTestBlk*)lpCCB;
    lpszCurrCmdName = kpszFAILTEST;

    /* Process according to current command state */
    switch(lpFTB->eCommandState)
    {
    case S_INIT:
        LogMsg(44, lpTIB->lTestNum, lpszCurrCmdName, "\0");
        /* Running an initialisation so set concurrency wait false. */
        kpMCB->bConcurrencyWait = FALSE;
        /* Set up start, expiry and next log message times */
        time(&lpFTB->oStartTime);
        lpFTB->oExpiryTime = lpFTB->oStartTime;
        lpFTB->oNextLogMsgTime = lpFTB->oStartTime;

        /* FailTest is just a marker so transition to complete */
        lpFTB->eCommandState = S_RUN;
        return SUCCESS;
        break;
    case S_RUN:
        LogMsg(259, lpTIB->lTestNum, kpszFAILTEST, "Ending Test Name=\0", lpTIB->lpszTestName);
        lpTIB->lpBreakContinueFSB = NULL; /* Forces exit from test via Finally if specified */
        kpMCB->bConcurrencyWait = FALSE;
        lpFTB->eCommandState = S_FAILURE;
        return FAILURE;
        break;
    case S_FAILURE:
        LogMsg(51, lpTIB->lTestNum, lpszCurrCmdName, CalcCmdExecTime(lpTIB));
        kpMCB->bConcurrencyWait = FALSE;
        lpFTB->eCommandState = S_NEXT;
        return FAILURE;
        break;
    }
    /* Should never get here so its a logic error terminate immediately */
    lpFTB->eCommandState = S_FAILURE;
    kpMCB->lProcessing = FAILURE;
    LogMsg(69, lpTIB->lTestNum, "ExecuteFailTestCmd\0");
    return FAILURE;
}


/*--------------------------------------------------------------------------*/
long
ExecuteFinallyStartCmd(TestInfoBlk* lpTIB, CommandCtrlBlk* lpCCB)
{
    ControlInfoBlk*     lpCIB;
    FinallyStartBlk*    lpYSB;
    char*               lpszCurrCmdName;

    /* Initialise common use local variables */
    lpCIB = kpMCB->lpCIB;
    lpYSB = (FinallyStartBlk*)lpCCB;
    lpszCurrCmdName = kpszFINALLYSTART;

    /* Process according to current command state */
    switch(lpYSB->eCommandState)
    {
    case S_INIT:
        /* Running an initialisation so set concurrency wait false. */
        kpMCB->bConcurrencyWait = FALSE;
        /* Set up start, expiry and next log message times */
        time(&lpYSB->oStartTime);
        lpYSB->oExpiryTime = lpYSB->oStartTime;
        lpYSB->oNextLogMsgTime = lpYSB->oStartTime;

        LogMsg(44, lpTIB->lTestNum, lpszCurrCmdName, "\0");

        /* Ready to run */
        lpYSB->eCommandState = S_RUN;
        return SUCCESS;
        break;
    case S_RUN:
        LogMsg(45, lpTIB->lTestNum, lpszCurrCmdName, "\0");

        /* Completed FinallyStart */
        kpMCB->bConcurrencyWait = FALSE;
        lpYSB->eCommandState = S_NEXT;
        return SUCCESS;
        break;
    case S_FAILURE:
        LogMsg(51, lpTIB->lTestNum, lpszCurrCmdName, CalcCmdExecTime(lpTIB));
        kpMCB->bConcurrencyWait = FALSE;
        lpYSB->eCommandState = S_NEXT;
        return FAILURE;
        break;
    }
    /* Should never get here so its a logic error terminate immediately */
    lpYSB->eCommandState = S_FAILURE;
    kpMCB->lProcessing = FAILURE;
    LogMsg(69, lpTIB->lTestNum, "ExecuteFinallyStartCmd\0");
    return FAILURE;
}


/*--------------------------------------------------------------------------*/
long
ExecuteFinallyEndCmd(TestInfoBlk* lpTIB, CommandCtrlBlk* lpCCB)
{
    ControlInfoBlk*     lpCIB;
    FinallyEndBlk*      lpYEB;
    char*               lpszCurrCmdName;

    /* Initialise common use local variables */
    lpCIB = kpMCB->lpCIB;
    lpYEB = (FinallyEndBlk*)lpCCB;
    lpszCurrCmdName = kpszFINALLYEND;

    /* Process according to current command state */
    switch(lpYEB->eCommandState)
    {
    case S_INIT:
        /* Running an initialisation so set concurrency wait false. */
        kpMCB->bConcurrencyWait = FALSE;
        /* Set up start, expiry and next log message times */
        time(&lpYEB->oStartTime);
        lpYEB->oExpiryTime = lpYEB->oStartTime;
        lpYEB->oNextLogMsgTime = lpYEB->oStartTime;

        LogMsg(44, lpTIB->lTestNum, lpszCurrCmdName, "\0");

        /* Ready to run */
        lpYEB->eCommandState = S_RUN;
        return SUCCESS;
        break;
    case S_RUN:
        LogMsg(45, lpTIB->lTestNum, lpszCurrCmdName, "\0");

        /* Completed FinallyEnd */
        kpMCB->bConcurrencyWait = FALSE;
        lpYEB->eCommandState = S_NEXT;
        return SUCCESS;
        break;
    case S_FAILURE:
        LogMsg(51, lpTIB->lTestNum, lpszCurrCmdName, CalcCmdExecTime(lpTIB));
        kpMCB->bConcurrencyWait = FALSE;
        lpYEB->eCommandState = S_NEXT;
        return FAILURE;
        break;
    }
    /* Should never get here so its a logic error terminate immediately */
    lpYEB->eCommandState = S_FAILURE;
    kpMCB->lProcessing = FAILURE;
    LogMsg(69, lpTIB->lTestNum, "ExecuteFinallyEndCmd\0");
    return FAILURE;
}


/*--------------------------------------------------------------------------*/
long
ExecuteIntervalStartCmd(TestInfoBlk* lpTIB, CommandCtrlBlk* lpCCB)
{
    ControlInfoBlk*   lpCIB;
    IntervalStartBlk* lpISB;
    char*             lpszCurrCmdName;
    char              lpszExtraInfo[EXTRA_MSG_INFO_LEN + 4];

    /* Initialise common use local variables */
    lpCIB = kpMCB->lpCIB;
    lpISB = (IntervalStartBlk*)lpCCB;
    lpszCurrCmdName = kpszINTERVALSTART;
    memset(lpszExtraInfo, 0x00, EXTRA_MSG_INFO_LEN + 4);

    /* Process according to current command state */
    switch(lpISB->eCommandState)
    {
    case S_INIT:
        /* Interval commands never cause a wait so set bConcurrency to FALSE. */
        kpMCB->bConcurrencyWait = FALSE;
        if(FALSE == kpMCB->bLoggingSuppressed)
        {
            sprintf(lpszExtraInfo, " Name=\"%s\"\0", lpISB->lpIIB->lpszIntervalName);
            LogMsg(45, lpTIB->lTestNum, lpszCurrCmdName, lpszExtraInfo);
        }

        /* Set the start time in the IIR */
        AddOrUpdateIIR(lpISB->lpIIB, I_START);
        if(FAILURE == kpMCB->lProcessing)
        {
            lpISB->eCommandState = S_FAILURE;
            return FAILURE;
        }

        /* Completed IntervalStart */
        lpISB->eCommandState = S_NEXT;
        return SUCCESS;
        break;
    }
    /* Should never get here so its a logic error terminate immediately */
    lpISB->eCommandState = S_FAILURE;
    kpMCB->lProcessing = FAILURE;
    LogMsg(69, lpTIB->lTestNum, "ExecuteIntervalStartCmd\0");
    return FAILURE;
}


/*--------------------------------------------------------------------------*/
long
ExecuteIntervalEndCmd(TestInfoBlk* lpTIB, CommandCtrlBlk* lpCCB)
{
    ControlInfoBlk* lpCIB;
    IntervalEndBlk* lpIEB;
    char*           lpszCurrCmdName;
    char            lpszExtraInfo[EXTRA_MSG_INFO_LEN + 4];

    /* Initialise common use local variables */
    lpCIB = kpMCB->lpCIB;
    lpIEB = (IntervalEndBlk*)lpCCB;
    lpszCurrCmdName = kpszINTERVALEND;
    memset(lpszExtraInfo, 0x00, EXTRA_MSG_INFO_LEN + 4);

    /* Process according to current command state */
    switch(lpIEB->eCommandState)
    {
    case S_INIT:
        /* Interval commands never cause a wait so set bConcurrency to FALSE. */
        kpMCB->bConcurrencyWait = FALSE;
        if(FALSE == kpMCB->bLoggingSuppressed)
        {
            sprintf(lpszExtraInfo, " Name=\"%s\"\0", lpIEB->lpIIB->lpszIntervalName);
            LogMsg(45, lpTIB->lTestNum, lpszCurrCmdName, lpszExtraInfo);
        }

        /* Set the start time in the IIR */
        AddOrUpdateIIR(lpIEB->lpIIB, I_END);
        if(FAILURE == kpMCB->lProcessing)
        {
            lpIEB->eCommandState = S_FAILURE;
            return FAILURE;
        }

        /* Completed IntervalEnd */
        lpIEB->eCommandState = S_NEXT;
        return SUCCESS;
        break;
    }
    /* Should never get here so its a logic error terminate immediately */
    lpIEB->eCommandState = S_FAILURE;
    kpMCB->lProcessing = FAILURE;
    LogMsg(69, lpTIB->lTestNum, "ExecuteIntervalEndCmd\0");
    return FAILURE;
}


/*--------------------------------------------------------------------------*/
long
ExecuteVarCmd(TestInfoBlk* lpTIB, CommandCtrlBlk* lpCCB)
{
    ControlInfoBlk*     lpCIB;
    VarBlk*             lpVRB;
    VarInfoBlk*         lpVIB;
    ListInfoBlk*        lpLIBVIB;
    ListInfoBlk*        lpLIBVRB;
    ListInfoBlk*        lpLIBParsed;
    ListElementInfoBlk* lpLEB;
    ListElementInfoBlk* lpLEBFree;
    MQMDInfoBlk*        lpMIBVIB;
    MQMDInfoBlk*        lpMIBVRB;
    MQMDInfoBlk*        lpMIBParsed;
    RFH2InfoBlk*        lpRIBVIB;
    RFH2InfoBlk*        lpRIBVRB;
    RFH2InfoBlk*        lpRIBParsed;
    char*               lpszCurrCmdName;
    char                lpszExtraInfo[EXTRA_MSG_INFO_LEN + 4];
    char*               lpszResBuff;
    char                lpszFmtBuff[RESOLVE_BUFF_LEN + 4];
    char                lpszVarValueFmtBuff[WORK_BUFF_LEN + 4];
    time_t              oCurrTime;
    long                lNewNum;
    long                lSeedNum;
    double              dNewDouble;
    double              dRandomValue;
    double              dRandomMultiplier;

    /* Initialise common use local variables */
    lpCIB = kpMCB->lpCIB;
    lpVRB = (VarBlk*)lpCCB;

    /* Which type of variable are we executing for */
    lpszCurrCmdName = kpszUNKNOWNVARCMD;
    switch(lpVRB->eVarType)
    {
    case V_NUM:
        lpszCurrCmdName = kpszNUM;
        break;
    case V_DOUBLE:
        lpszCurrCmdName = kpszDOUBLE;
        break;
    case V_STR:
        lpszCurrCmdName = kpszSTR;
        break;
    case V_RANDOMNUM:
        lpszCurrCmdName = kpszRANDOMNUM;
        break;
    case V_LIST:
        lpszCurrCmdName = kpszLIST;
        break;
    case V_MQMD:
        lpszCurrCmdName = kpszMQMD;
        break;
    case V_RFH2:
        lpszCurrCmdName = kpszRFH2;
        break;
    }

    /* Variable name as extra info */
    memset(lpszExtraInfo, 0x00, EXTRA_MSG_INFO_LEN + 4);
    sprintf(lpszExtraInfo, " Name=\"%s\" ResName=\"%s\"\0",
            lpVRB->lpszVarName, lpVRB->lpszResVarName);
    
    /* Process according to current command state */
    switch(lpVRB->eCommandState)
    {
    case S_INIT:
        LogMsg(44, lpTIB->lTestNum, lpszCurrCmdName, lpszExtraInfo);
        /* Don't use times so just set them all the same */
        time(&lpVRB->oStartTime);
        lpVRB->oExpiryTime = lpVRB->oStartTime;
        lpVRB->oNextLogMsgTime = lpVRB->oStartTime;

        /* Resolve any subscripts before proceeding */
        ResolveSubscript(lpTIB, &lpVRB->lpszResVarName,
                         &lpVRB->lpszVarName, TRUE);
        if(FAILURE == lpTIB->bCmdResult)
        {
            lpVRB->eCommandState = S_FAILURE;
            return FAILURE;
        }

        /* See if we can find the VIB on the TIB chain if not */
        /* then we need to create one                         */
        lpVRB->lpVIB = CheckAndAddVIB(lpTIB, lpVRB->eVarType,
                                      lpVRB->lpszVarName,
                                      lpVRB->lpszResVarName,
                                      lpVRB->lpszVarFormat);
        if(FAILURE == lpTIB->bCmdResult)
        {
            lpVRB->eCommandState = S_FAILURE;
            return FAILURE;
        }

        /* Handle initialisation of RandomNum From and To values */
        if(V_RANDOMNUM == lpVRB->eVarType)
        {
            /* Resolve the From and To values for RandomNum */
            ResolveValue(lpTIB, &lpVRB->lpszResRandomNumFrom, &lpVRB->lpszRandomNumFrom, TRUE);
            ResolveValue(lpTIB, &lpVRB->lpszResRandomNumTo, &lpVRB->lpszRandomNumTo, TRUE);
            if(FAILURE == lpTIB->bCmdResult)
            {
                lpVRB->eCommandState = S_FAILURE;
                return FAILURE;
            }
            /* Convert the From and To values and check them */
            lpVRB->lRandomNumFrom = ConvNum(lpTIB, lpVRB->lpszResRandomNumFrom, lpVRB->lpszVarName);
            lpVRB->lRandomNumTo = ConvNum(lpTIB, lpVRB->lpszResRandomNumTo, lpVRB->lpszVarName);
            if(FAILURE == lpTIB->bCmdResult)
            {
                lpVRB->eCommandState = S_FAILURE;
                return FAILURE;
            }
            /* Check the From value is not greater than the To value */
            if(lpVRB->lRandomNumFrom >= lpVRB->lRandomNumTo)
            {
                LogMsg(116, lpTIB->lTestNum, lpVRB->lpszVarName, lpVRB->lRandomNumFrom, lpVRB->lRandomNumTo);
                lpTIB->bCmdResult = FAILURE;
                lpVRB->eCommandState = S_FAILURE;
                return FAILURE;
            }
        }

        /* Ready to run */
        kpMCB->bConcurrencyWait = FALSE;
        lpVRB->eCommandState = S_RUN;
        return SUCCESS;
        break;
    case S_RUN:
        LogMsg(45, lpTIB->lTestNum, lpszCurrCmdName, lpszExtraInfo);

        /* Clear the formatting buffer */
        memset(lpszFmtBuff, 0x00, RESOLVE_BUFF_LEN + 4);

        /* Copy the VIB pointer for local use */
        lpVIB = lpVRB->lpVIB;

        switch(lpVRB->eVarType)
        {
        case V_NUM:
            /* Variable resolution */
            lpszResBuff = NULL;
            ResolveValue(lpTIB, &lpszResBuff, &lpVRB->lpszNewStrValue, TRUE);
            /* Check the number is numeric by calling ConvNum */
            lNewNum = ConvNum(lpTIB, lpszResBuff, lpVRB->lpszResVarName);
            if(FAILURE == lpTIB->bCmdResult)
            {
                memset(lpszExtraInfo, 0x00, EXTRA_MSG_INFO_LEN + 4);
                sprintf(lpszExtraInfo, "%%%s%% is not numeric \"%s\"\0",
                        lpVRB->lpszResVarName, lpszResBuff);
                LogMsg(TEST_EXTRA_LINE_ERR, lpTIB->lTestNum, lpszExtraInfo);
                lpVRB->eCommandState = S_FAILURE;
                FreeIfNotNull((void**)&lpszResBuff);
                return FAILURE;
            }
            FreeIfNotNull((void**)&lpszResBuff);
            /* Release the old value if any */
            FreeIfNotNull((void**)&lpVIB->lpszCurrStrValue);
            /* Format the new value */
            sprintf(lpszFmtBuff, lpVIB->lpszVarFormat, lNewNum);
            /* Copy the new value to the VIB */
            lpVIB->lpszCurrStrValue = CloneString(lpszFmtBuff);
            /* Now log what we have done */
            if(FALSE == kpMCB->bLoggingSuppressed)
            {
                memset(lpszExtraInfo, 0x00, EXTRA_MSG_INFO_LEN + 4);
                memset(lpszVarValueFmtBuff, 0x00, WORK_BUFF_LEN + 4);
                strcpy(lpszVarValueFmtBuff, "%%%s%% number was assigned the value \"");
                strcat(lpszVarValueFmtBuff, lpVIB->lpszVarFormat);
                strcat(lpszVarValueFmtBuff, "\" Format=\"%s\"\0");
                sprintf(lpszExtraInfo, lpszVarValueFmtBuff, lpVIB->lpszVarName,
                        lNewNum, lpVIB->lpszVarFormat);
                LogMsg(TEST_EXTRA_LINE, lpTIB->lTestNum, lpszExtraInfo);
            }
            break;
        case V_DOUBLE:
            /* Variable resolution */
            lpszResBuff = NULL;
            ResolveValue(lpTIB, &lpszResBuff, &lpVRB->lpszNewStrValue, TRUE);
            /* Check the number is numeric by calling ConvDouble */
            dNewDouble = ConvDouble(lpTIB, lpszResBuff, lpVRB->lpszResVarName);
            if(FAILURE == lpTIB->bCmdResult)
            {
                memset(lpszExtraInfo, 0x00, EXTRA_MSG_INFO_LEN + 4);
                sprintf(lpszExtraInfo, "%%%s%% is not numeric \"%s\"\0",
                        lpVRB->lpszResVarName, lpszResBuff);
                LogMsg(TEST_EXTRA_LINE_ERR, lpTIB->lTestNum, lpszExtraInfo);
                lpVRB->eCommandState = S_FAILURE;
                FreeIfNotNull((void**)&lpszResBuff);
                return FAILURE;
            }
            FreeIfNotNull((void**)&lpszResBuff);
            /* Release the old value if any */
            FreeIfNotNull((void**)&lpVIB->lpszCurrStrValue);
            /* Format the new value */
            sprintf(lpszFmtBuff, lpVIB->lpszVarFormat, dNewDouble);
            /* Copy the new value to the VIB */
            lpVIB->lpszCurrStrValue = CloneString(lpszFmtBuff);
            /* Now log what we have done */
            if(FALSE == kpMCB->bLoggingSuppressed)
            {
                memset(lpszExtraInfo, 0x00, EXTRA_MSG_INFO_LEN + 4);
                memset(lpszVarValueFmtBuff, 0x00, WORK_BUFF_LEN + 4);
                strcpy(lpszVarValueFmtBuff, "%%%s%% number was assigned the value \"");
                strcat(lpszVarValueFmtBuff, lpVIB->lpszVarFormat);
                strcat(lpszVarValueFmtBuff, "\" Format=\"%s\"\0");
                sprintf(lpszExtraInfo, lpszVarValueFmtBuff, lpVIB->lpszVarName,
                        dNewDouble, lpVIB->lpszVarFormat);
                LogMsg(TEST_EXTRA_LINE, lpTIB->lTestNum, lpszExtraInfo);
            }
            break;
        case V_STR:
            /* Variable resolution */
            lpszResBuff = NULL;
            ResolveValue(lpTIB, &lpszResBuff, &lpVRB->lpszNewStrValue, TRUE);
            /* Check to see if this is an automatic variable needing an update */
            if(0 == StrlenNull(lpszResBuff)) /* If its empty check auto vars    */
            {
                if((0 == memcmp(kpszYEAR4, lpVIB->lpszVarName, strlen(kpszYEAR4) + 1)) ||
                   (0 == memcmp(kpszYEAR2, lpVIB->lpszVarName, strlen(kpszYEAR2) + 1)) ||
                   (0 == memcmp(kpszMONTH3, lpVIB->lpszVarName, strlen(kpszMONTH3) + 1)) || 
                   (0 == memcmp(kpszMONTH2, lpVIB->lpszVarName, strlen(kpszMONTH2) + 1)) ||
                   (0 == memcmp(kpszDAY3, lpVIB->lpszVarName, strlen(kpszDAY3) + 1)) ||
                   (0 == memcmp(kpszDAY2, lpVIB->lpszVarName, strlen(kpszDAY2) + 1)) ||
                   (0 == memcmp(kpszHOURS, lpVIB->lpszVarName, strlen(kpszHOURS) + 1)) ||
                   (0 == memcmp(kpszMINUTES, lpVIB->lpszVarName, strlen(kpszMINUTES) + 1)) ||
                   (0 == memcmp(kpszSECONDS, lpVIB->lpszVarName, strlen(kpszSECONDS) + 1)))
                {
                    /* Get the current time value */
                    time(&oCurrTime);
                    SetAutoVar(lpTIB, lpTIB->lpVIBHead,
                               lpVIB->lpszVarName, &oCurrTime);
                }
                else
                {
                    /* No its not a time automatic var so its an empty string */
                    /* Release the old value if any */
                    FreeIfNotNull((void**)&lpVIB->lpszCurrStrValue);
                    /* Whilst the string may be empty the format can still */
                    /* have an effect if its not also an empty string      */
                    if(0 < StrlenNull(lpVIB->lpszVarFormat))
                    {
                        /* Format the new value */
                        sprintf(lpszFmtBuff, lpVIB->lpszVarFormat, lpszResBuff);
                    }
                    /* Copy the new value to the VIB */
                    lpVIB->lpszCurrStrValue = CloneString(lpszFmtBuff);
                }
            }
            else
            {
                /* Release the old value if any */
                FreeIfNotNull((void**)&lpVIB->lpszCurrStrValue);
                /* Format the new value */
                sprintf(lpszFmtBuff, lpVIB->lpszVarFormat, lpszResBuff);
                /* Copy the new value to the VIB */
                lpVIB->lpszCurrStrValue = CloneString(lpszFmtBuff);
            }
            FreeIfNotNull((void**)&lpszResBuff);
            /* Now log what we have done */
            if(FALSE == kpMCB->bLoggingSuppressed)
            {
                memset(lpszExtraInfo, 0x00, EXTRA_MSG_INFO_LEN + 4);
                sprintf(lpszExtraInfo, "%%%s%% string was assigned the value \"%s\"\0",
                        lpVIB->lpszVarName,
                        lpVIB->lpszCurrStrValue);
                LogMsg(TEST_EXTRA_LINE, lpTIB->lTestNum, lpszExtraInfo);
            }
            break;
        case V_RANDOMNUM:
            /* If this is the first time through seed the random number */
            if(! lpVRB->bRandomNumSeeded)
            {
                lpVRB->bRandomNumSeeded = TRUE;
                /* Variable resolution of seed value */
                lpszResBuff = NULL;
                ResolveValue(lpTIB, &lpszResBuff, &lpVRB->lpszNewStrValue, TRUE);
                /* If no seed value was supplied use the time instead */
                if(0 == StrlenNull(lpszResBuff))
                {
                    lSeedNum = (long)time(NULL);
                }
                else
                {
                    /* Check the number is numeric by calling ConvNum */
                    lSeedNum = ConvNum(lpTIB, lpszResBuff, lpVRB->lpszResVarName);
                    if(FAILURE == lpTIB->bCmdResult)
                    {
                        memset(lpszExtraInfo, 0x00, EXTRA_MSG_INFO_LEN + 4);
                        sprintf(lpszExtraInfo, "%%%s%% seed value is not numeric \"%s\"\0",
                                lpVRB->lpszResVarName, lpszResBuff);
                        LogMsg(TEST_EXTRA_LINE_ERR, lpTIB->lTestNum, lpszExtraInfo);
                        lpVRB->eCommandState = S_FAILURE;
                        FreeIfNotNull((void**)&lpszResBuff);
                        return FAILURE;
                    }
                    FreeIfNotNull((void**)&lpszResBuff);
                }
                /* Set the seed value and report it */
                srand(lSeedNum);
                rand(); /* Some implementations seem to return the seed value the first time */
                if(FALSE == kpMCB->bLoggingSuppressed)
                {
                    memset(lpszExtraInfo, 0x00, EXTRA_MSG_INFO_LEN + 4);
                    memset(lpszVarValueFmtBuff, 0x00, WORK_BUFF_LEN + 4);
                    strcpy(lpszVarValueFmtBuff, "%%%s%% random number with range From=\"%d\" To=\"%d\" was assigned the seed value \"");
                    strcat(lpszVarValueFmtBuff, lpVIB->lpszVarFormat);
                    strcat(lpszVarValueFmtBuff, "\" Format=\"%s\"\0");
                    sprintf(lpszExtraInfo, lpszVarValueFmtBuff, lpVIB->lpszVarName,
                            lpVRB->lRandomNumFrom, lpVRB->lRandomNumTo,
                            lSeedNum, lpVIB->lpszVarFormat);
                    LogMsg(TEST_EXTRA_LINE, lpTIB->lTestNum, lpszExtraInfo);
                }
            }
            /* Generate a random number */
            dRandomValue = ((double) rand()) / ((double) RAND_MAX);
            dRandomMultiplier = lpVRB->lRandomNumTo - lpVRB->lRandomNumFrom + 1;
            lNewNum = (long)(dRandomValue * dRandomMultiplier);
            lNewNum += lpVRB->lRandomNumFrom;
            /* Doubles can be ever so slightly bigger or smaller than 1 so make sure bounds are not exceeded */
            if(lNewNum > lpVRB->lRandomNumTo)
            {
                lNewNum = lpVRB->lRandomNumTo;
            }
            if(lNewNum < lpVRB->lRandomNumFrom)
            {
                lNewNum = lpVRB->lRandomNumFrom;
            }
            /* Release the old value if any */
            FreeIfNotNull((void**)&lpVIB->lpszCurrStrValue);
            /* Format the new value */
            sprintf(lpszFmtBuff, lpVIB->lpszVarFormat, lNewNum);
            /* Copy the new value to the VIB */
            lpVIB->lpszCurrStrValue = CloneString(lpszFmtBuff);
            /* Now log what we have done */
            if(FALSE == kpMCB->bLoggingSuppressed)
            {
                memset(lpszExtraInfo, 0x00, EXTRA_MSG_INFO_LEN + 4);
                memset(lpszVarValueFmtBuff, 0x00, WORK_BUFF_LEN + 4);
                strcpy(lpszVarValueFmtBuff, "%%%s%% random number was assigned the value \"");
                strcat(lpszVarValueFmtBuff, lpVIB->lpszVarFormat);
                strcat(lpszVarValueFmtBuff, "\" Format=\"%s\"\0");
                sprintf(lpszExtraInfo, lpszVarValueFmtBuff, lpVIB->lpszVarName,
                        lNewNum, lpVIB->lpszVarFormat);
                LogMsg(TEST_EXTRA_LINE, lpTIB->lTestNum, lpszExtraInfo);
            }
            break;
        case V_LIST:
            lpLIBVIB = lpVIB->lpCtrlBlk;
            lpLIBVRB = lpVRB->lpNewCtrlBlk;
            if(lpLIBVRB)
            {
                /* Work out the ListFile name if any */
                ResolveValue(lpTIB, &lpLIBVRB->lpszResListFileName,
                             &lpLIBVRB->lpszListFileName, TRUE);
                ResolveValue(lpTIB, &lpLIBVRB->lpszResDir, &lpLIBVRB->lpszDir, TRUE);
                if(FAILURE == lpTIB->bCmdResult)
                {
                    lpVRB->eCommandState = S_FAILURE;
                    return FAILURE;
                }
                if(TRUE == lpVRB->bClear)
                {
                    /* Free ListElements if any */
                    lpLEB = lpLIBVIB->lpLEBHead;
                    while(NULL != lpLEB)
                    {
                        lpLEBFree = lpLEB;
                        lpLEB = (ListElementInfoBlk*)lpLEB->lpLEBNext;
                        FreeLEB(&lpLEBFree);
                    }
                    lpLIBVIB->lpLEBHead = NULL;
                    lpLIBVIB->lpLEBTail = NULL;
                }
                if(0 == StrlenNull(lpLIBVRB->lpszResListFileName))
                {
                    /* If the VRB LIB doesnt have a ListFile to load */
                    /* override the current LIB with the VRB values  */
                    OverrideLIB(lpLIBVIB, lpLIBVRB);
                }
                else
                {
                    /* Load a LIB with the values in the ListFile */
                    lpLIBParsed = NULL;
                    LoadLIBFromFile(lpTIB, &lpLIBParsed,
                                    lpLIBVRB->lpszResListFileName,
                                    lpLIBVRB->lpszResDir);
                    if(FAILURE == lpTIB->bCmdResult)
                    {
                        lpVRB->eCommandState = S_FAILURE;
                        return FAILURE;
                    }
                    /* Override the current LIB with the ListFile values */
                    OverrideLIB(lpLIBVIB, lpLIBParsed);
                    /* Done with the parsed LIB so free it */
                    FreeLIB(&lpLIBParsed);
                    /* Override the current LIB with the VRB values  */
                    OverrideLIB(lpLIBVIB, lpLIBVRB);
                }
            }
            break;
        case V_MQMD:
            lpMIBVIB = lpVIB->lpCtrlBlk;
            lpMIBVRB = lpVRB->lpNewCtrlBlk;
            if(lpMIBVRB)
            {
                /* Work out the MQMDFile name if any */
                ResolveValue(lpTIB, &lpMIBVRB->lpszResMQMDFileName,
                             &lpMIBVRB->lpszMQMDFileName, TRUE);
                ResolveValue(lpTIB, &lpMIBVRB->lpszResDir, &lpMIBVRB->lpszDir, TRUE);
                if(FAILURE == lpTIB->bCmdResult)
                {
                    lpVRB->eCommandState = S_FAILURE;
                    return FAILURE;
                }
                if(0 == StrlenNull(lpMIBVRB->lpszResMQMDFileName))
                {
                    /* If the VRB MIB doesnt have a MQMDFile to load */
                    /* override the current MIB with the VRB values  */
                    OverrideMIB(lpMIBVIB, lpMIBVRB);
                }
                else
                {
                    /* Load a MIB with the values in the MQMDFile */
                    lpMIBParsed = NULL;
                    LoadMIBFromFile(lpTIB, &lpMIBParsed,
                                    lpMIBVRB->lpszResMQMDFileName,
                                    lpMIBVRB->lpszResDir);
                    if(FAILURE == lpTIB->bCmdResult)
                    {
                        lpVRB->eCommandState = S_FAILURE;
                        return FAILURE;
                    }
                    /* Override the current MIB with the MQMDFile values */
                    OverrideMIB(lpMIBVIB, lpMIBParsed);
                    /* Done with the parsed MIB so free it */
                    FreeMIB(&lpMIBParsed);
                    /* Override the current MIB with the VRB values  */
                    OverrideMIB(lpMIBVIB, lpMIBVRB);
                }
            }
            break;
        case V_RFH2:
            lpRIBVIB = lpVIB->lpCtrlBlk;
            lpRIBVRB = lpVRB->lpNewCtrlBlk;
            if(lpRIBVRB)
            {
                /* Work out the RFH2File name if any */
                ResolveValue(lpTIB, &lpRIBVRB->lpszResRFH2FileName,
                             &lpRIBVRB->lpszRFH2FileName, TRUE);
                ResolveValue(lpTIB, &lpRIBVRB->lpszResDir, &lpRIBVRB->lpszDir, TRUE);
                if(FAILURE == lpTIB->bCmdResult)
                {
                    lpVRB->eCommandState = S_FAILURE;
                    return FAILURE;
                }
                if(0 == StrlenNull(lpRIBVRB->lpszResRFH2FileName))
                {
                    /* If the VRB RIB doesnt have a RFH2File to load */
                    /* override the current RIB with the VRB values  */
                    OverrideRIB(lpRIBVIB, lpRIBVRB);
                }
                else
                {
                    /* Load a RIB with the values in the RFH2File */
                    lpRIBParsed = NULL;
                    LoadRIBFromFile(lpTIB, &lpRIBParsed,
                                    lpRIBVRB->lpszResRFH2FileName,
                                    lpRIBVRB->lpszResDir);
                    if(FAILURE == lpTIB->bCmdResult)
                    {
                        lpVRB->eCommandState = S_FAILURE;
                        return FAILURE;
                    }
                    if(FALSE == kpMCB->bLoggingSuppressed)
                    {
                        sprintf(lpszExtraInfo, "RFH2FolderCount=%d RFH2FolderDataLen=%d RFH2Len=%d\0",
                                lpRIBParsed->lRFH2FolderCount,
                                lpRIBParsed->lRFH2FolderDataLen,
                                lpRIBParsed->lRFH2FolderDataLen + MQRFH_STRUC_LENGTH_FIXED_2);
                        LogMsg(TEST_EXTRA_LINE, lpTIB->lTestNum, lpszExtraInfo);
                    }
                    /* Override the current RIB with the RFH2File values */
                    OverrideRIB(lpRIBVIB, lpRIBParsed);
                    /* Done with the parsed RIB so free it */
                    FreeRIB(&lpRIBParsed);
                    /* Override the current RIB with the VRB values  */
                    OverrideRIB(lpRIBVIB, lpRIBVRB);
                }
            }
            break;
        }

        /* All done */
        kpMCB->bConcurrencyWait = FALSE;
        lpVRB->eCommandState = S_COMPLETE;
        return SUCCESS;
        break;
    case S_COMPLETE:
        LogMsg(38, lpTIB->lTestNum, lpszCurrCmdName, CalcCmdExecTime(lpTIB));
        kpMCB->bConcurrencyWait = FALSE;
        lpVRB->eCommandState = S_NEXT;
        return SUCCESS;
        break;
    case S_FAILURE:
        LogMsg(51, lpTIB->lTestNum, lpszCurrCmdName, CalcCmdExecTime(lpTIB));
        kpMCB->bConcurrencyWait = FALSE;
        lpVRB->eCommandState = S_NEXT;
        return FAILURE;
        break;
    }
    kpMCB->lProcessing = FAILURE;
    LogMsg(69, lpTIB->lTestNum, "ExecuteVarCmd\0");
    return FAILURE;
}


/*--------------------------------------------------------------------------*/
long
ExecuteMathCmd(TestInfoBlk* lpTIB, CommandCtrlBlk* lpCCB)
{
    MathFunctionBlk* lpMFB;
    char*            lpszCurrCmdName;
    char*            lpszCurrCmdOp;
    char             lpszExtraInfo[EXTRA_MSG_INFO_LEN + 4];
    char*            lpszResBuff;
    char             lpszFmtBuff[RESOLVE_BUFF_LEN + 4];
    long             lVarNum;
    long             lValueNum;
    long             lCalcNum;
    long             lRemNum;
    double           dVarDouble;
    double           dValueDouble;
    double           dCalcDouble;
    double           dRemDouble;
    long             bVarIsDouble;
    long             bRemIsDouble;
    long             bCalculateRem;
    VarInfoBlk*      lpVIB;
    VarInfoBlk*      lpVIBRem;

    /* Initialise common use local variables */
    lpMFB = (MathFunctionBlk*)lpCCB;

    /* Which type of math function are we executing */
    lpszCurrCmdName = kpszUNKNOWN;
    lpszCurrCmdOp = kpszUNKNOWN;
    switch(lpMFB->eMathFunctionType)
    {
    case A_ADD:
        lpszCurrCmdName = kpszADD;
        lpszCurrCmdOp = kpszADDOP;
        break;
    case A_SUBTRACT:
        lpszCurrCmdName = kpszSUBTRACT;
        lpszCurrCmdOp = kpszSUBTRACTOP;
        break;
    case A_MULTIPLY:
        lpszCurrCmdName = kpszMULTIPLY;
        lpszCurrCmdOp = kpszMULTIPLYOP;
        break;
    case A_DIVIDE:
        lpszCurrCmdName = kpszDIVIDE;
        lpszCurrCmdOp = kpszDIVIDEOP;
        break;
    case A_EVAL:
        lpszCurrCmdName = kpszEVAL;
        lpszCurrCmdOp = kpszEVALOP;
        break;
    }

    /* Process according to current command state */
    switch(lpMFB->eCommandState)
    {
    case S_INIT:
        LogMsg(44, lpTIB->lTestNum, lpszCurrCmdName, kpszEmptyString);
        /* Don't use times so just set them all the same */
        time(&lpMFB->oStartTime);
        lpMFB->oExpiryTime = lpMFB->oStartTime;
        lpMFB->oNextLogMsgTime = lpMFB->oStartTime;

        /* Resolve any variable names including subscripts before proceeding */
        ResolveSubscript(lpTIB, &lpMFB->lpszResVarName,
                         &lpMFB->lpszVarName, TRUE);
        if(0 < StrlenNull(lpMFB->lpszRemName))
        {
            ResolveSubscript(lpTIB, &lpMFB->lpszResRemName,
                             &lpMFB->lpszRemName, TRUE);
        }
        if(FAILURE == lpTIB->bCmdResult)
        {
            lpMFB->eCommandState = S_FAILURE;
            return FAILURE;
        }

        /* See if we can find the VIB on the TIB chain if not */
        /* its an error                                       */
        lpMFB->lpVIB = FindVarInfoBlk(lpTIB->lpVIBHead,
                                      lpMFB->lpszResVarName);
        if(NULL == lpMFB->lpVIB)
        {
            LogMsg(161, lpTIB->lTestNum, lpszCurrCmdName, lpMFB->lpszResVarName);
            lpMFB->eCommandState = S_FAILURE;
            return FAILURE;
        }

        /* If necessary locate or create a VIB for the remainder */
        if(0 < StrlenNull(lpMFB->lpszResRemName))
        {
            lpMFB->lpVIBRem = CheckAndAddVIB(lpTIB, lpMFB->lpVIB->eVarType,
                                             lpMFB->lpszRemName,
                                             lpMFB->lpszResRemName,
                                             NULL);
            if(FAILURE == lpTIB->bCmdResult)
            {
                lpMFB->eCommandState = S_FAILURE;
                return FAILURE;
            }
        }

        /* Ready to run */
        kpMCB->bConcurrencyWait = FALSE;
        lpMFB->eCommandState = S_RUN;
        return SUCCESS;
        break;
    case S_RUN:
        LogMsg(45, lpTIB->lTestNum, lpszCurrCmdName, kpszEmptyString);

        /* Clear the formatting buffer */
        memset(lpszFmtBuff, 0x00, RESOLVE_BUFF_LEN + 4);

        /* Copy the VIB pointers for local use */
        lpVIB = lpMFB->lpVIB;
        lpVIBRem = lpMFB->lpVIBRem;

        /* Determine the type of variable being operated on */
        /* specifically if its a double                     */
        bVarIsDouble = FALSE;
        if(V_DOUBLE == lpVIB->eVarType)
        {
            bVarIsDouble = TRUE;
        }

        bCalculateRem = FALSE;
        bRemIsDouble = FALSE;
        if(NULL != lpVIBRem)
        {
            bCalculateRem = TRUE;
            if(V_DOUBLE == lpVIBRem->eVarType)
            {
                bRemIsDouble = TRUE;
            }
        }

        /* Initialise variables */
        lVarNum = 0;
        lValueNum = 0;
        lCalcNum = 0;
        lRemNum = 0;
        dVarDouble = 0;
        dValueDouble = 0;
        dCalcDouble = 0;
        dRemDouble = 0;

        /* Resolve the value to be added, subtracted, multiplied by or divided by */
        ResolveValue(lpTIB, &lpMFB->lpszResValue, &lpMFB->lpszValue, TRUE);
        if(FAILURE == lpTIB->bCmdResult)
        {
            SetTIBCodes(lpTIB, MTCC_FAIL, MTRC_RUN_FAIL);
            lpMFB->eCommandState = S_FAILURE;
            return FAILURE;
        }

        /* If its not an Eval request then get the value */
        /* of the Name= variable and convert it          */
        if(A_EVAL != lpMFB->eMathFunctionType)
        {
            /* Get the value of the Name= variable */
            lpszResBuff = NULL;
            ResolveValue(lpTIB, &lpszResBuff, &lpVIB->lpszCurrStrValue, TRUE);

            /* Check the number is numeric by calling ConvNum */
            if(TRUE == bVarIsDouble)
            {
                dVarDouble = ConvDouble(lpTIB, lpszResBuff, lpMFB->lpszResVarName);
            }
            else
            {
                lVarNum = ConvNum(lpTIB, lpszResBuff, lpMFB->lpszResVarName);
            }
            if(FAILURE == lpTIB->bCmdResult)
            {
                memset(lpszExtraInfo, 0x00, EXTRA_MSG_INFO_LEN + 4);
                sprintf(lpszExtraInfo, "%%%s%% is not numeric \"%s\"\0",
                        lpMFB->lpszResVarName, lpszResBuff);
                LogMsg(TEST_EXTRA_LINE_ERR, lpTIB->lTestNum, lpszExtraInfo);
                FreeIfNotNull((void**)&lpszResBuff);
                lpMFB->eCommandState = S_FAILURE;
                return FAILURE;
            }
            FreeIfNotNull((void**)&lpszResBuff);

            /* Check the number is numeric by calling ConvDouble or ConvNum */
            if(TRUE == bVarIsDouble)
            {
                dValueDouble = ConvDouble(lpTIB, lpMFB->lpszResValue, lpszCurrCmdName);
            }
            else
            {
                lValueNum = ConvNum(lpTIB, lpMFB->lpszResValue, lpszCurrCmdName);
            }
            if(FAILURE == lpTIB->bCmdResult)
            {
                memset(lpszExtraInfo, 0x00, EXTRA_MSG_INFO_LEN + 4);
                sprintf(lpszExtraInfo, "\"%s\" is not numeric\0",
                        lpMFB->lpszResValue);
                LogMsg(TEST_EXTRA_LINE_ERR, lpTIB->lTestNum, lpszExtraInfo);
                lpMFB->eCommandState = S_FAILURE;
                return FAILURE;
            }
        }

        /* Perform the requested math function */
        if(TRUE == bVarIsDouble)
        {
            memset(lpszExtraInfo, 0x00, EXTRA_MSG_INFO_LEN + 4);
            switch(lpMFB->eMathFunctionType)
            {
            case A_ADD:
                dCalcDouble = dVarDouble + dValueDouble;
                break;
            case A_SUBTRACT:
                dCalcDouble = dVarDouble - dValueDouble;
                break;
            case A_MULTIPLY:
                dCalcDouble = dVarDouble * dValueDouble;
                break;
            case A_DIVIDE:
                dCalcDouble = dVarDouble / dValueDouble;
                if(TRUE == bCalculateRem)
                {
                    if(TRUE == bRemIsDouble)
                    {
                        lVarNum = (long)dVarDouble;
                        lValueNum = (long)dValueDouble;
                        dRemDouble = (double)(lVarNum % lValueNum);
                    }
                    else
                    {
                        lVarNum = (long)dVarDouble;
                        lValueNum = (long)dValueDouble;
                        lRemNum = lVarNum % lValueNum;
                    }
                }
                break;
            case A_EVAL:
                EvaluateMathExpression(lpTIB, lpMFB->lpszResValue, V_DOUBLE, &dCalcDouble);
                break;
            }
        }
        else
        {
            memset(lpszExtraInfo, 0x00, EXTRA_MSG_INFO_LEN + 4);
            switch(lpMFB->eMathFunctionType)
            {
            case A_ADD:
                lCalcNum = lVarNum + lValueNum;
                break;
            case A_SUBTRACT:
                lCalcNum = lVarNum - lValueNum;
                break;
            case A_MULTIPLY:
                lCalcNum = lVarNum * lValueNum;
                break;
            case A_DIVIDE:
                lCalcNum = lVarNum / lValueNum;
                if(TRUE == bCalculateRem)
                {
                    if(TRUE == bRemIsDouble)
                    {
                        dCalcDouble = ((double)lVarNum) / ((double)lValueNum);
                        dRemDouble = dCalcDouble - floor(dCalcDouble);
                    }
                    else
                    {
                        lRemNum = lVarNum % lValueNum;
                    }
                }
                break;
            case A_EVAL:
                EvaluateMathExpression(lpTIB, lpMFB->lpszResValue, V_NUM, &lCalcNum);
                break;
            }
        }

        /* Release the old value if any */
        FreeIfNotNull((void**)&lpVIB->lpszCurrStrValue);

        /* Format the new value */
        if(TRUE == bVarIsDouble)
        {
            sprintf(lpszFmtBuff, lpVIB->lpszVarFormat, dCalcDouble);
            if(A_EVAL == lpMFB->eMathFunctionType)
            {
                sprintf(lpszExtraInfo, "%%%s%% was assigned the value \"%s\" after <%s> of %s Format=\"%s\"\0",
                        lpVIB->lpszVarName, lpszFmtBuff, lpszCurrCmdName, lpMFB->lpszResValue, lpVIB->lpszVarFormat);
            }
            else
            {
                sprintf(lpszExtraInfo, "%%%s%% was assigned the value \"%s\" after <%s> of %lf %s %lf Format=\"%s\"\0",
                        lpVIB->lpszVarName, lpszFmtBuff, lpszCurrCmdName, dVarDouble, lpszCurrCmdOp, dValueDouble, lpVIB->lpszVarFormat);
            }
        }
        else
        {
            sprintf(lpszFmtBuff, lpVIB->lpszVarFormat, lCalcNum);
            if(A_EVAL == lpMFB->eMathFunctionType)
            {
                sprintf(lpszExtraInfo, "%%%s%% was assigned the value \"%s\" after <%s> of %s Format=\"%s\"\0",
                        lpVIB->lpszVarName, lpszFmtBuff, lpszCurrCmdName, lpMFB->lpszResValue, lpVIB->lpszVarFormat);
            }
            else
            {
                sprintf(lpszExtraInfo, "%%%s%% was assigned the value \"%s\" after <%s> of %d %s %d Format=\"%s\"\0",
                        lpVIB->lpszVarName, lpszFmtBuff, lpszCurrCmdName, lVarNum, lpszCurrCmdOp, lValueNum, lpVIB->lpszVarFormat);
            }
        }
        
        /* Copy the new value to the VIB */
        lpVIB->lpszCurrStrValue = CloneString(lpszFmtBuff);
        /* Now log what we have done */
        LogMsg(TEST_EXTRA_LINE, lpTIB->lTestNum, lpszExtraInfo);

        /* Now repeat for the remainder if requested */
        if(TRUE == bCalculateRem)
        {
            /* Release the old value if any */
            FreeIfNotNull((void**)&lpVIBRem->lpszCurrStrValue);

            /* Format the new value */
            if(TRUE == bVarIsDouble)
            {
                sprintf(lpszFmtBuff, lpVIBRem->lpszVarFormat, dRemDouble);
                sprintf(lpszExtraInfo, "%%%s%% was assigned the remainder \"%s\" after <%s> of %lf %s %lf Format=\"%s\"\0",
                        lpVIBRem->lpszVarName, lpszFmtBuff, lpszCurrCmdName, dVarDouble, lpszCurrCmdOp, dValueDouble, lpVIBRem->lpszVarFormat);
            }
            else
            {
                sprintf(lpszFmtBuff, lpVIBRem->lpszVarFormat, lRemNum);
                sprintf(lpszExtraInfo, "%%%s%% was assigned the remainder \"%s\" after <%s> of %d %s %d Format=\"%s\"\0",
                        lpVIBRem->lpszVarName, lpszFmtBuff, lpszCurrCmdName, lVarNum, lpszCurrCmdOp, lValueNum, lpVIBRem->lpszVarFormat);
            }
        
            /* Copy the new value to the VIB */
            lpVIBRem->lpszCurrStrValue = CloneString(lpszFmtBuff);
            /* Now log what we have done */
            LogMsg(TEST_EXTRA_LINE, lpTIB->lTestNum, lpszExtraInfo);
        }

        /* All done */
        kpMCB->bConcurrencyWait = FALSE;
        lpMFB->eCommandState = S_COMPLETE;
        return SUCCESS;
        break;
    case S_COMPLETE:
        LogMsg(38, lpTIB->lTestNum, lpszCurrCmdName, CalcCmdExecTime(lpTIB));
        kpMCB->bConcurrencyWait = FALSE;
        lpMFB->eCommandState = S_NEXT;
        return SUCCESS;
        break;
    case S_FAILURE:
        LogMsg(51, lpTIB->lTestNum, lpszCurrCmdName, CalcCmdExecTime(lpTIB));
        kpMCB->bConcurrencyWait = FALSE;
        lpMFB->eCommandState = S_NEXT;
        return FAILURE;
        break;
    }
    kpMCB->lProcessing = FAILURE;
    LogMsg(69, lpTIB->lTestNum, "ExecuteMathCmd\0");
    return FAILURE;
}


/*--------------------------------------------------------------------------*/
long
ExecuteLengthCmd(TestInfoBlk* lpTIB, CommandCtrlBlk* lpCCB)
{
    LengthBlk*       lpLNB;
    char*            lpszCurrCmdName;
    char             lpszLengthBuff[NUM_BUFF_LEN + 4];
    VarInfoBlk*      lpVarNameVIB;
    VarInfoBlk*      lpOfVIB;
    BuffInfoBlk*     lpOfBIB;
    char*            lpszLengthType;
    long             lLength;

    /* Initialise common use local variables */
    lpLNB = (LengthBlk*)lpCCB;
    lpszCurrCmdName = kpszLENGTH;
    memset(lpszLengthBuff, 0x00, NUM_BUFF_LEN + 4);

    /* Process according to current command state */
    switch(lpLNB->eCommandState)
    {
    case S_INIT:
        LogMsg(44, lpTIB->lTestNum, lpszCurrCmdName, kpszEmptyString);
        /* Don't use times so just set them all the same */
        time(&lpLNB->oStartTime);
        lpLNB->oExpiryTime = lpLNB->oStartTime;
        lpLNB->oNextLogMsgTime = lpLNB->oStartTime;

        /* Resolve any variable name subscripts before proceeding */
        ResolveSubscript(lpTIB, &lpLNB->lpszResVarName,
                         &lpLNB->lpszVarName, TRUE);
        ResolveSubscript(lpTIB, &lpLNB->lpszResOf,
                         &lpLNB->lpszOf, TRUE);
        if(FAILURE == lpTIB->bCmdResult)
        {
            lpLNB->eCommandState = S_FAILURE;
            return FAILURE;
        }

        /* Ready to run */
        kpMCB->bConcurrencyWait = FALSE;
        lpLNB->eCommandState = S_RUN;
        return SUCCESS;
        break;
    case S_RUN:
        LogMsg(45, lpTIB->lTestNum, lpszCurrCmdName, kpszEmptyString);

        /* See if we can find the VIB we are to put the length into */
        /* on the TIB chain if not then we need to create one       */
        lpVarNameVIB = CheckAndAddVIB(lpTIB, V_NUM,
                                      lpLNB->lpszVarName,
                                      lpLNB->lpszResVarName,
                                      NULL);
        if(FAILURE == lpTIB->bCmdResult)
        {
            lpLNB->eCommandState = S_FAILURE;
            return FAILURE;
        }

        /* Free the current value if any */
        FreeIfNotNull((void**)&lpVarNameVIB->lpszCurrStrValue);

        /* A length of -1 signifies we were unable to find the named variable or buffer */
        lLength = -1;
        lpszLengthType = kpszUNKNOWN;
        
        /* See if we can find a variable with the resolved Of name */
        /* if so then resolve its value and take its length        */
        lpOfVIB = FindVarInfoBlk(lpTIB->lpVIBHead, lpLNB->lpszResOf);
        if(lpOfVIB)
        {
            /* Now take its length and set the value accordingly */
            lLength = StrlenNull(lpOfVIB->lpszCurrStrValue);
            lpszLengthType = kpszVARIABLE;
        }
        else
        {
            /* Try the default variables */
            lpOfVIB = FindVarInfoBlk(kpMCB->lpDIB->lpVIBHead, lpLNB->lpszResOf);
            if(lpOfVIB)
            {
                /* Now take its length and set the value accordingly */
                lLength = StrlenNull(lpOfVIB->lpszCurrStrValue);
                lpszLengthType = kpszVARIABLE;
            }
            else
            {
                /* Try the program invocation variables */
                lpOfVIB = FindVarInfoBlk(kpMCB->lpVIBHead, lpLNB->lpszResOf);
                if(lpOfVIB)
                {
                    /* Now take its length and set the value accordingly */
                    lLength = StrlenNull(lpOfVIB->lpszCurrStrValue);
                    lpszLengthType = kpszVARIABLE;
                }
                else
                {
                    /* Finally see if we can find a buffer with the resolved Of attrbute name */
                    /* instead. If so the assign the buffers length to our length variable    */
                    lpOfBIB = FindBuffInfoBlk(lpTIB->lpBIBHead, lpLNB->lpszResOf);
                    if(lpOfBIB)
                    {
                        lLength = lpOfBIB->lDataLen;
                        lpszLengthType = kpszBUFFER;
                    }
                }
            }
        }

        /* Now set the value of the current string in the VIB */
        sprintf(lpszLengthBuff, lpVarNameVIB->lpszVarFormat, lLength);
        lpVarNameVIB->lpszCurrStrValue = CloneString(lpszLengthBuff);
        LogMsg(266, lpTIB->lTestNum, lpLNB->lpszResVarName, lpLNB->lpszResOf, lLength, lpszLengthType);

        /* All done */
        kpMCB->bConcurrencyWait = FALSE;
        lpLNB->eCommandState = S_COMPLETE;
        return SUCCESS;
        break;
    case S_COMPLETE:
        LogMsg(38, lpTIB->lTestNum, lpszCurrCmdName, CalcCmdExecTime(lpTIB));
        kpMCB->bConcurrencyWait = FALSE;
        lpLNB->eCommandState = S_NEXT;
        return SUCCESS;
        break;
    case S_FAILURE:
        LogMsg(51, lpTIB->lTestNum, lpszCurrCmdName, CalcCmdExecTime(lpTIB));
        kpMCB->bConcurrencyWait = FALSE;
        lpLNB->eCommandState = S_NEXT;
        return FAILURE;
        break;
    }
    kpMCB->lProcessing = FAILURE;
    LogMsg(69, lpTIB->lTestNum, "ExecuteLengthCmd\0");
    return FAILURE;
}


/*--------------------------------------------------------------------------*/
long
ExecutePositionCmd(TestInfoBlk* lpTIB, CommandCtrlBlk* lpCCB)
{
    PositionBlk*     lpPSB;
    char*            lpszCurrCmdName;
    char             lpszPositionBuff[NUM_BUFF_LEN + 4];
    VarInfoBlk*      lpVarNameVIB;
    VarInfoBlk*      lpInVIB;
    BuffInfoBlk*     lpInBIB;
    char*            lpszInStart;
    char*            lpszPositionType;
    long             lInLength;
    long             lOfLength;
    long             lPosition;
    char*            lpszCurr;
    long             lSearchLen;
    long             lIdx;

    /* Initialise common use local variables */
    lpPSB = (PositionBlk*)lpCCB;
    lpszCurrCmdName = kpszPOSITION;
    memset(lpszPositionBuff, 0x00, NUM_BUFF_LEN + 4);

    /* Process according to current command state */
    switch(lpPSB->eCommandState)
    {
    case S_INIT:
        LogMsg(44, lpTIB->lTestNum, lpszCurrCmdName, kpszEmptyString);
        /* Don't use times so just set them all the same */
        time(&lpPSB->oStartTime);
        lpPSB->oExpiryTime = lpPSB->oStartTime;
        lpPSB->oNextLogMsgTime = lpPSB->oStartTime;

        /* Resolve any variable name subscripts and values before proceeding */
        ResolveSubscript(lpTIB, &lpPSB->lpszResVarName,
                         &lpPSB->lpszVarName, TRUE);
        ResolveValue(lpTIB, &lpPSB->lpszResOf,
                         &lpPSB->lpszOf, TRUE);
        ResolveValue(lpTIB, &lpPSB->lpszResIn,
                         &lpPSB->lpszIn, TRUE);
        ResolveValue(lpTIB, &lpPSB->lpszResFrom,
                         &lpPSB->lpszFrom, TRUE);
        if(FAILURE == lpTIB->bCmdResult)
        {
            lpPSB->eCommandState = S_FAILURE;
            return FAILURE;
        }

        lpPSB->lFrom = ConvNum(lpTIB, lpPSB->lpszResFrom, "From");
        if((FAILURE == lpTIB->bCmdResult) || (0 >= lpPSB->lFrom))
        {
            LogMsg(267, lpTIB->lTestNum, lpPSB->lpszResVarName, lpPSB->lpszOf, lpPSB->lpszResIn, lpPSB->lpszResFrom);
            SetTIBCodes(lpTIB, MTCC_FAIL, MTRC_INIT_CONVNUM_FAIL);
            lpPSB->eCommandState = S_FAILURE;
            return FAILURE;
        }

        /* Ready to run */
        kpMCB->bConcurrencyWait = FALSE;
        lpPSB->eCommandState = S_RUN;
        return SUCCESS;
        break;
    case S_RUN:
        LogMsg(45, lpTIB->lTestNum, lpszCurrCmdName, kpszEmptyString);

        /* See if we can find the VIB we are to put the position into */
        /* on the TIB chain if not then we need to create one       */
        lpVarNameVIB = CheckAndAddVIB(lpTIB, V_NUM,
                                      lpPSB->lpszVarName,
                                      lpPSB->lpszResVarName,
                                      NULL);
        if(FAILURE == lpTIB->bCmdResult)
        {
            lpPSB->eCommandState = S_FAILURE;
            return FAILURE;
        }

        /* Free the current value if any */
        FreeIfNotNull((void**)&lpVarNameVIB->lpszCurrStrValue);

        /* A position of -4 signifies we were unable to find the named variable or buffer */
        lInLength = 0;
        lPosition = -4;
        lpszInStart = NULL;
        lpszPositionType = kpszUNKNOWN;
        
        /* See if we can find a variable with the resolved In name */
        /* if so then resolve its value and take its length        */
        lpInVIB = FindVarInfoBlk(lpTIB->lpVIBHead, lpPSB->lpszResIn);
        if(lpInVIB)
        {
            lInLength = StrlenNull(lpInVIB->lpszCurrStrValue);
            lpszInStart = lpInVIB->lpszCurrStrValue;
            lpszPositionType = kpszVARIABLE;
        }
        else
        {
            /* Try the default variables */
            lpInVIB = FindVarInfoBlk(kpMCB->lpDIB->lpVIBHead, lpPSB->lpszResIn);
            if(lpInVIB)
            {
                lInLength = StrlenNull(lpInVIB->lpszCurrStrValue);
                lpszInStart = lpInVIB->lpszCurrStrValue;
                lpszPositionType = kpszVARIABLE;
            }
            else
            {
                /* Try the program invocation variables */
                lpInVIB = FindVarInfoBlk(kpMCB->lpVIBHead, lpPSB->lpszResIn);
                if(lpInVIB)
                {
                    lInLength = StrlenNull(lpInVIB->lpszCurrStrValue);
                    lpszInStart = lpInVIB->lpszCurrStrValue;
                    lpszPositionType = kpszVARIABLE;
                }
                else
                {
                    /* Finally see if we can find a buffer with the resolved In attrbute name */
                    lpInBIB = FindBuffInfoBlk(lpTIB->lpBIBHead, lpPSB->lpszResIn);
                    if(lpInBIB)
                    {
                        lInLength = lpInBIB->lDataLen;
                        lpszInStart = lpInBIB->lpszBuff;
                        lpszPositionType = kpszBUFFER;
                    }
                }
            }
        }

        /* If we found an In value to search go for it */
        if(NULL != lpszInStart)
        {
            /* A position of -3 indicates a zero length Of string */
            lPosition = -3;
            lOfLength = StrlenNull(lpPSB->lpszResOf);
            if(0 < lOfLength)
            {
                /* A position of -2 indicates the From offset */
                /* plus the Of length overun the In value     */
                lPosition = -2;
                if((lpPSB->lFrom + lOfLength - 1) <= lInLength)
                {
                    /* A positon of -1 indicates the Of value could not be found */
                    lPosition = -1;
                    lpszCurr = lpszInStart + lpPSB->lFrom - 1;
                    lSearchLen = lInLength - lOfLength;
                    for(lIdx = 0; lIdx <= lSearchLen; lIdx++)
                    {
                        /* Try to find a match */
                        if(0 == memcmp(lpszCurr, lpPSB->lpszResOf, lOfLength))
                        {
                            lPosition = lpPSB->lFrom + lIdx;
                            break;
                        }
                        lpszCurr++;
                    }
                }
            }
        }

        /* Now set the value of the current string in the VIB */
        sprintf(lpszPositionBuff, lpVarNameVIB->lpszVarFormat, lPosition);
        lpVarNameVIB->lpszCurrStrValue = CloneString(lpszPositionBuff);
        LogMsg(268, lpTIB->lTestNum, lpPSB->lpszResVarName, lpPSB->lpszOf, lpPSB->lpszResIn, lpPSB->lpszResFrom, lPosition, lpszPositionType);

        /* All done */
        kpMCB->bConcurrencyWait = FALSE;
        lpPSB->eCommandState = S_COMPLETE;
        return SUCCESS;
        break;
    case S_COMPLETE:
        LogMsg(38, lpTIB->lTestNum, lpszCurrCmdName, CalcCmdExecTime(lpTIB));
        kpMCB->bConcurrencyWait = FALSE;
        lpPSB->eCommandState = S_NEXT;
        return SUCCESS;
        break;
    case S_FAILURE:
        LogMsg(51, lpTIB->lTestNum, lpszCurrCmdName, CalcCmdExecTime(lpTIB));
        kpMCB->bConcurrencyWait = FALSE;
        lpPSB->eCommandState = S_NEXT;
        return FAILURE;
        break;
    }
    kpMCB->lProcessing = FAILURE;
    LogMsg(69, lpTIB->lTestNum, "ExecutePositionCmd\0");
    return FAILURE;
}


/*--------------------------------------------------------------------------*/
long
ExecuteStdInCmd(TestInfoBlk* lpTIB, CommandCtrlBlk* lpCCB)
{
    ControlInfoBlk* lpCIB;
    StdInBlk*       lpSIB;
    char*           lpszCurrCmdName;
    char            lpszExtraInfo[EXTRA_MSG_INFO_LEN + 4];
    char            lpszFmtBuff[RESOLVE_BUFF_LEN + 4];
    char            lpszStdInBuff[STDIN_BUFF_LEN + 4];
    long            lNewNum;
    long            lInputLen;
    double          dNewDouble;

    /* Initialise common use local variables */
    lpCIB = kpMCB->lpCIB;
    lpSIB = (StdInBlk*)lpCCB;
    lpszCurrCmdName = kpszSTDIN;
    memset(lpszExtraInfo, 0x00, EXTRA_MSG_INFO_LEN + 4);

    /* Process according to current command state */
    switch(lpSIB->eCommandState)
    {
    case S_INIT:
        LogMsg(44, lpTIB->lTestNum, lpszCurrCmdName, "\0");
        /* Running an initialisation so set concurrency wait false. */
        kpMCB->bConcurrencyWait = FALSE;

        /* Resolve the variable name before proceeding */
        ResolveSubscript(lpTIB, &lpSIB->lpszResVarName,
                         &lpSIB->lpszVarName, TRUE);
        if(FAILURE == lpTIB->bCmdResult)
        {
            lpSIB->eCommandState = S_FAILURE;
            return FAILURE;
        }

        /* Try to find a var info block if we can't then add one */
        lpSIB->lpVIB = FindVarInfoBlk(lpTIB->lpVIBHead, lpSIB->lpszResVarName);
        if(NULL == lpSIB->lpVIB)
        {
            lpSIB->lpVIB = CheckAndAddVIB(lpTIB, V_STR,
                                          lpSIB->lpszVarName,
                                          lpSIB->lpszResVarName,
                                          kpszSTRFMT);
            if(FAILURE == lpTIB->bCmdResult)
            {
                lpSIB->eCommandState = S_FAILURE;
                return FAILURE;
            }
        }

        /* Ready to run */
        lpSIB->eCommandState = S_RUN;
        return SUCCESS;
        break;
    case S_RUN:
        LogMsg(45, lpTIB->lTestNum, lpszCurrCmdName, "\0");

        printf("<=== ");
        memset(lpszStdInBuff, 0x00, STDIN_BUFF_LEN + 4);
        fgets(lpszStdInBuff, STDIN_BUFF_LEN, stdin);
        lInputLen = StrlenNull(lpszStdInBuff);
        if(lInputLen > 0)
        {
            /* Remove CR at the end */
            if(lpszStdInBuff[lInputLen - 1] <= ' ')
            {
                lpszStdInBuff[lInputLen - 1] = 0x00;
            }
        }
        
        switch(lpSIB->lpVIB->eVarType)
        {
        case V_NUM:
            /* Check the number is numeric by calling ConvNum */
            lNewNum = ConvNum(lpTIB, lpszStdInBuff, lpSIB->lpszResVarName);
            if(FAILURE == lpTIB->bCmdResult)
            {
                memset(lpszExtraInfo, 0x00, EXTRA_MSG_INFO_LEN + 4);
                sprintf(lpszExtraInfo, "%%%s%% is not numeric \"%s\"\0",
                        lpSIB->lpszResVarName, lpszStdInBuff);
                LogMsg(TEST_EXTRA_LINE_ERR, lpTIB->lTestNum, lpszExtraInfo);
                lpSIB->eCommandState = S_FAILURE;
                return FAILURE;
            }
            /* Release the old value if any */
            FreeIfNotNull((void**)&lpSIB->lpVIB->lpszCurrStrValue);
            /* Format the new value */
            sprintf(lpszFmtBuff, lpSIB->lpVIB->lpszVarFormat, lNewNum);
            /* Copy the new value to the VIB */
            lpSIB->lpVIB->lpszCurrStrValue = CloneString(lpszFmtBuff);
            /* Now log what we have done */
            if(FALSE == kpMCB->bLoggingSuppressed)
            {
                memset(lpszExtraInfo, 0x00, EXTRA_MSG_INFO_LEN + 4);
                sprintf(lpszExtraInfo, "%%%s%% number was assigned the value \"%d\" Format=\"%s\"\0",
                        lpSIB->lpVIB->lpszVarName, lNewNum, lpSIB->lpVIB->lpszVarFormat);
                LogMsg(TEST_EXTRA_LINE, lpTIB->lTestNum, lpszExtraInfo);
            }
            break;
        case V_DOUBLE:
            /* Check the number is numeric by calling ConvDouble */
            dNewDouble = ConvDouble(lpTIB, lpszStdInBuff, lpSIB->lpszResVarName);
            if(FAILURE == lpTIB->bCmdResult)
            {
                memset(lpszExtraInfo, 0x00, EXTRA_MSG_INFO_LEN + 4);
                sprintf(lpszExtraInfo, "%%%s%% is not numeric \"%s\"\0",
                        lpSIB->lpszResVarName, lpszStdInBuff);
                LogMsg(TEST_EXTRA_LINE_ERR, lpTIB->lTestNum, lpszExtraInfo);
                lpSIB->eCommandState = S_FAILURE;
                return FAILURE;
            }
            /* Release the old value if any */
            FreeIfNotNull((void**)&lpSIB->lpVIB->lpszCurrStrValue);
            /* Format the new value */
            sprintf(lpszFmtBuff, lpSIB->lpVIB->lpszVarFormat, dNewDouble);
            /* Copy the new value to the VIB */
            lpSIB->lpVIB->lpszCurrStrValue = CloneString(lpszFmtBuff);
            /* Now log what we have done */
            if(FALSE == kpMCB->bLoggingSuppressed)
            {
                memset(lpszExtraInfo, 0x00, EXTRA_MSG_INFO_LEN + 4);
                sprintf(lpszExtraInfo, "%%%s%% number was assigned the value \"%lf\" Format=\"%s\"\0",
                        lpSIB->lpVIB->lpszVarName, dNewDouble, lpSIB->lpVIB->lpszVarFormat);
                LogMsg(TEST_EXTRA_LINE, lpTIB->lTestNum, lpszExtraInfo);
            }
            break;
        case V_STR:
            /* Release the old value if any */
            FreeIfNotNull((void**)&lpSIB->lpVIB->lpszCurrStrValue);
            /* Format the new value */
            sprintf(lpszFmtBuff, lpSIB->lpVIB->lpszVarFormat, lpszStdInBuff);
            /* Copy the new value to the VIB */
            lpSIB->lpVIB->lpszCurrStrValue = CloneString(lpszFmtBuff);
            /* Now log what we have done */
            if(FALSE == kpMCB->bLoggingSuppressed)
            {
                memset(lpszExtraInfo, 0x00, EXTRA_MSG_INFO_LEN + 4);
                sprintf(lpszExtraInfo, "%%%s%% string was assigned the value \"%s\"\0",
                        lpSIB->lpVIB->lpszVarName,
                        lpSIB->lpVIB->lpszCurrStrValue);
                LogMsg(TEST_EXTRA_LINE, lpTIB->lTestNum, lpszExtraInfo);
            }
            break;
        default:
            LogMsg(159, lpSIB->lpszResVarName);
            lpSIB->eCommandState = S_FAILURE;
            return FAILURE;
            break;
        }

        if(FALSE == kpMCB->bLoggingSuppressed)
        {
            sprintf(lpszExtraInfo, "Command execution complete\0");
            LogMsg(TEST_EXTRA_LINE, lpTIB->lTestNum, lpszExtraInfo);
        }
        kpMCB->bConcurrencyWait = FALSE;
        lpSIB->eCommandState = S_COMPLETE;
        return SUCCESS;
        break;
    case S_COMPLETE:
        LogMsg(38, lpTIB->lTestNum, lpszCurrCmdName, CalcCmdExecTime(lpTIB));
        kpMCB->bConcurrencyWait = FALSE;
        lpSIB->eCommandState = S_NEXT;
        return SUCCESS;
        break;
    case S_FAILURE:
        LogMsg(51, lpTIB->lTestNum, lpszCurrCmdName, CalcCmdExecTime(lpTIB));
        kpMCB->bConcurrencyWait = FALSE;
        lpSIB->eCommandState = S_NEXT;
        return FAILURE;
        break;
    }
    /* Should never get here so its a logic error terminate immediately */
    lpSIB->eCommandState = S_FAILURE;
    kpMCB->lProcessing = FAILURE;
    LogMsg(69, lpTIB->lTestNum, "ExecuteStdInCmd\0");
    return FAILURE;
}


/*--------------------------------------------------------------------------*/
long
ExecuteStdOutCmd(TestInfoBlk* lpTIB, CommandCtrlBlk* lpCCB)
{
    ControlInfoBlk* lpCIB;
    StdOutBlk*       lpSOB;
    char*           lpszCurrCmdName;
    char            lpszExtraInfo[EXTRA_MSG_INFO_LEN + 4];

    /* Initialise common use local variables */
    lpCIB = kpMCB->lpCIB;
    lpSOB = (StdOutBlk*)lpCCB;
    lpszCurrCmdName = kpszSTDOUT;
    memset(lpszExtraInfo, 0x00, EXTRA_MSG_INFO_LEN + 4);

    /* Process according to current command state */
    switch(lpSOB->eCommandState)
    {
    case S_INIT:
        LogMsg(44, lpTIB->lTestNum, lpszCurrCmdName, "\0");
        /* Running an initialisation so set concurrency wait false. */
        kpMCB->bConcurrencyWait = FALSE;

        /* Ready to run */
        lpSOB->eCommandState = S_RUN;
        return SUCCESS;
        break;
    case S_RUN:
        sprintf(lpszExtraInfo, ". %s",  lpSOB->lpszTextOut);
        LogMsg(45, lpTIB->lTestNum, lpszCurrCmdName, lpszExtraInfo);

        /* Resolve any variables in the text and print to stdout */
        ResolveValue(lpTIB, &lpSOB->lpszResTextOut, &lpSOB->lpszTextOut, TRUE);
        printf("===> %s\n", lpSOB->lpszResTextOut);
        if(FAILURE == lpTIB->bCmdResult)
        {
            SetTIBCodes(lpTIB, MTCC_FAIL, MTRC_RUN_FAIL);
            lpSOB->eCommandState = S_FAILURE;
            return FAILURE;
        }
        
        if(FALSE == kpMCB->bLoggingSuppressed)
        {
            sprintf(lpszExtraInfo, "Command execution complete\0");
            LogMsg(TEST_EXTRA_LINE, lpTIB->lTestNum, lpszExtraInfo);
        }
        kpMCB->bConcurrencyWait = FALSE;
        lpSOB->eCommandState = S_COMPLETE;
        return SUCCESS;
        break;
    case S_COMPLETE:
        LogMsg(38, lpTIB->lTestNum, lpszCurrCmdName, CalcCmdExecTime(lpTIB));
        kpMCB->bConcurrencyWait = FALSE;
        lpSOB->eCommandState = S_NEXT;
        return SUCCESS;
        break;
    case S_FAILURE:
        LogMsg(51, lpTIB->lTestNum, lpszCurrCmdName, CalcCmdExecTime(lpTIB));
        kpMCB->bConcurrencyWait = FALSE;
        lpSOB->eCommandState = S_NEXT;
        return FAILURE;
        break;
    }
    /* Should never get here so its a logic error terminate immediately */
    lpSOB->eCommandState = S_FAILURE;
    kpMCB->lProcessing = FAILURE;
    LogMsg(69, lpTIB->lTestNum, "ExecuteStdOutCmd\0");
    return FAILURE;
}


/*--------------------------------------------------------------------------*/
long
ExecuteUserLogCmd(TestInfoBlk* lpTIB, CommandCtrlBlk* lpCCB)
{
    ControlInfoBlk* lpCIB;
    UserLogBlk*     lpULB;
    char*           lpszCurrCmdName;
    char            lpszExtraInfo[EXTRA_MSG_INFO_LEN + 4];
    char            lpszTimeBuff[LOG_BUFF_LEN + 4];
    time_t          oTimeT;
    struct tm*      poTimeTm ;

    /* Initialise common use local variables */
    lpCIB = kpMCB->lpCIB;
    lpULB = (UserLogBlk*)lpCCB;
    lpszCurrCmdName = kpszUSERLOG;
    memset(lpszExtraInfo, 0x00, EXTRA_MSG_INFO_LEN + 4);

    /* Process according to current command state */
    switch(lpULB->eCommandState)
    {
    case S_INIT:
        LogMsg(44, lpTIB->lTestNum, lpszCurrCmdName, "\0");
        /* Running an initialisation so set concurrency wait false. */
        kpMCB->bConcurrencyWait = FALSE;

        /* Ready to run */
        lpULB->eCommandState = S_RUN;
        return SUCCESS;
        break;
    case S_RUN:
        LogMsg(45, lpTIB->lTestNum, lpszCurrCmdName, "\0");

        /* Resolve any variables in the text */
        /* NOTE. If it does not resolve we get BADBADBAD in the log */
        ResolveValue(lpTIB, &lpULB->lpszResTextOut, &lpULB->lpszTextOut, TRUE);

        /* If there is no user log file then write the entry to */
        /* the <TestLog> log file using message #160            */
        if(kpMCB->lpCIB->lpTestUserLogFile)
        {
            /* Use strftime to format the time value into our buffer   */
            time(&oTimeT);
            poTimeTm = localtime(&oTimeT);
            memset(lpszTimeBuff, 0x00, TIME_BUFF_LEN + 4);
            strftime(lpszTimeBuff, TIME_BUFF_LEN, "%H:%M:%S ", poTimeTm );
            fprintf(kpMCB->lpCIB->lpTestUserLogFile, "%s%s\n", lpszTimeBuff, lpULB->lpszResTextOut);
        }
        else
        {
            LogMsg(160, lpULB->lpszResTextOut);
        }
        
        if(FALSE == kpMCB->bLoggingSuppressed)
        {
            sprintf(lpszExtraInfo, "Command execution complete\0");
            LogMsg(TEST_EXTRA_LINE, lpTIB->lTestNum, lpszExtraInfo);
        }
        kpMCB->bConcurrencyWait = FALSE;
        lpULB->eCommandState = S_COMPLETE;
        return SUCCESS;
        break;
    case S_COMPLETE:
        LogMsg(38, lpTIB->lTestNum, lpszCurrCmdName, CalcCmdExecTime(lpTIB));
        kpMCB->bConcurrencyWait = FALSE;
        lpULB->eCommandState = S_NEXT;
        return SUCCESS;
        break;
    case S_FAILURE:
        LogMsg(51, lpTIB->lTestNum, lpszCurrCmdName, CalcCmdExecTime(lpTIB));
        kpMCB->bConcurrencyWait = FALSE;
        lpULB->eCommandState = S_NEXT;
        return FAILURE;
        break;
    }
    /* Should never get here so its a logic error terminate immediately */
    lpULB->eCommandState = S_FAILURE;
    kpMCB->lProcessing = FAILURE;
    LogMsg(69, lpTIB->lTestNum, "ExecuteUserLogCmd\0");
    return FAILURE;
}

/*--------------------------------------------------------------------------*/
void
IfNextCmdIsUserLogThenExecute(TestInfoBlk* lpTIB)
{
    CommandCtrlBlk* lpCCBWork;
    long            bLocalTestResult;
    long            bHoldCurrTestResult;

    lpCCBWork = (CommandCtrlBlk*)lpTIB->lpCCBCurr->lpCCBNext;
    if(NULL != lpCCBWork)
    {
        /* If the next command is a user log command then execute it */
        if(C_USERLOG == lpCCBWork->eCommandType)
        {
            /* Hold the current test result for restoration after */
            /* executing the user log command as we temporarily   */
            /* need to reset the <Test>'s state to SUCCESS while  */
            /* executing the user log command                     */
            bHoldCurrTestResult = lpTIB->bCmdResult;
            lpTIB->bCmdResult = SUCCESS;
             /* UserLog initialisation S_INIT */
            bLocalTestResult = ExecuteUserLogCmd(lpTIB, lpCCBWork);
            if(SUCCESS == bLocalTestResult)
            {
                /* UserLog run S_RUN */
                bLocalTestResult = ExecuteUserLogCmd(lpTIB, lpCCBWork);
            }
            if(SUCCESS == bLocalTestResult)
            {
                /* UserLog run S_COMPLETE */
                bLocalTestResult = ExecuteUserLogCmd(lpTIB, lpCCBWork);
            }
            /* Restore previous state */
            lpTIB->bCmdResult = bHoldCurrTestResult;
        }
    }
}

/*--------------------------------------------------------------------------*/
CommandCtrlBlk*
FindFinallyCmd(TestInfoBlk* lpTIB)
{
    CommandCtrlBlk* lpCCBCurr;
    CommandCtrlBlk* lpCCBWork;

    /* Run the list of remaining commands looking for the start  */
    /* of a <Finally> clause.                                    */
    lpCCBCurr = (CommandCtrlBlk*)lpTIB->lpCCBCurr;
    lpCCBWork = (CommandCtrlBlk*)lpTIB->lpCCBCurr->lpCCBNext;
    while(NULL != lpCCBWork)
    {
        if(C_FINALLYSTART == lpCCBWork->eCommandType)
        {
            /* Reset the TestResult to SUCCESS so that the commands */
            /* in the <Finally> clause can be executed. But set     */
            /* and indicator that we have done so so that the final */
            /* log message for the test is correct but only if the  */
            /* current test has failed                              */
            if(FAILURE == lpTIB->bCmdResult)
            {
                lpTIB->bFinallyResetFailedTest = TRUE;
            }
            lpTIB->bCmdResult = SUCCESS;
            return lpCCBWork;
        }
        lpCCBWork = (CommandCtrlBlk*)lpCCBWork->lpCCBNext;
    }

    return NULL;
}


/*==========================================================================*/
/* FUNCTION:                                                                */
/*     LogMsgCorrelAndGroupIds                                              */
/*                                                                          */
/* PURPOSE:                                                                 */
/*     Write the MsgId, CorrelId and GroupId to the log                     */
/*                                                                          */
/* INPUT PARAMETERS                                                         */
/*     lpMsgDesc       Pointer to a MQ Message Descriptor                   */
/*                                                                          */
/* RETURN VALUE                                                             */
/*     N/A                                                                  */
/*==========================================================================*/
void
LogMsgCorrelAndGroupIds(TestInfoBlk* lpTIB, MQMD* lpMsgDesc)
{
    char lpszExtraInfo[EXTRA_MSG_INFO_LEN + 4];
    char lpszWorkBuff[WORK_BUFF_LEN + 4];

    if(FALSE == kpMCB->bLoggingSuppressed)
    {
        GenByte24Str(lpszWorkBuff, (char*)lpMsgDesc->MsgId, FALSE);
        sprintf(lpszExtraInfo, "MsgId=%s\0", lpszWorkBuff);
        LogMsg(TEST_EXTRA_LINE, lpTIB->lTestNum, lpszExtraInfo);
        GenByte24Str(lpszWorkBuff, (char*)lpMsgDesc->CorrelId, FALSE);
        sprintf(lpszExtraInfo, "CorrelId=%s\0", lpszWorkBuff);
        LogMsg(TEST_EXTRA_LINE, lpTIB->lTestNum, lpszExtraInfo);
        if(0 != memcmp(kpszNULLS, lpMsgDesc->GroupId, MQ_GROUP_ID_LENGTH))
        {
            GenByte24Str(lpszWorkBuff, (char*)lpMsgDesc->GroupId, FALSE);
            sprintf(lpszExtraInfo, "GroupId=%s\0", lpszWorkBuff);
            LogMsg(TEST_EXTRA_LINE, lpTIB->lTestNum, lpszExtraInfo);
        }
    }
}
